/*
 * Copyright 2018 Google Inc.
 *
 * Use of this source code is governed by a BSD-style license that can be
 * found in the LICENSE file.
 */

/**************************************************************************************************
 *** This file was autogenerated from GrDualIntervalGradientColorizer.fp; do not modify.
 **************************************************************************************************/
#ifndef GrDualIntervalGradientColorizer_DEFINED
#define GrDualIntervalGradientColorizer_DEFINED
#include "SkTypes.h"
#include "GrFragmentProcessor.h"
#include "GrCoordTransform.h"
class GrDualIntervalGradientColorizer : public GrFragmentProcessor {
public:
    const GrColor4f& scale01() const { return fScale01; }
    const GrColor4f& bias01() const { return fBias01; }
    const GrColor4f& scale23() const { return fScale23; }
    const GrColor4f& bias23() const { return fBias23; }
    float threshold() const { return fThreshold; }

    static std::unique_ptr<GrFragmentProcessor> Make(const GrColor4f& c0, const GrColor4f& c1,
                                                     const GrColor4f& c2, const GrColor4f& c3,
                                                     float threshold);
    GrDualIntervalGradientColorizer(const GrDualIntervalGradientColorizer& src);
    std::unique_ptr<GrFragmentProcessor> clone() const override;
    const char* name() const override { return "DualIntervalGradientColorizer"; }

private:
    GrDualIntervalGradientColorizer(GrColor4f scale01, GrColor4f bias01, GrColor4f scale23,
                                    GrColor4f bias23, float threshold)
            : INHERITED(kGrDualIntervalGradientColorizer_ClassID, kNone_OptimizationFlags)
            , fScale01(scale01)
            , fBias01(bias01)
            , fScale23(scale23)
            , fBias23(bias23)
            , fThreshold(threshold) {}
    GrGLSLFragmentProcessor* onCreateGLSLInstance() const override;
    void onGetGLSLProcessorKey(const GrShaderCaps&, GrProcessorKeyBuilder*) const override;
    bool onIsEqual(const GrFragmentProcessor&) const override;
    GR_DECLARE_FRAGMENT_PROCESSOR_TEST
    GrColor4f fScale01;
    GrColor4f fBias01;
    GrColor4f fScale23;
    GrColor4f fBias23;
    float fThreshold;
    typedef GrFragmentProcessor INHERITED;
};
#endif
