/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/. */

#ifndef mozilla_ServoStyleConsts_h
#define mozilla_ServoStyleConsts_h

/* Generated with cbindgen:0.6.8 */

/* DO NOT MODIFY THIS MANUALLY! This file was generated using cbindgen.
 * To generate this file:
 *   1. Get the latest cbindgen using `cargo install --force cbindgen`
 *      a. Alternatively, you can clone `https://github.com/eqrion/cbindgen` and use a tagged release
 *   2. Run `rustup run nightly cbindgen toolkit/library/rust/ --lockfile Cargo.lock --crate style -o layout/style/ServoStyleConsts.h`
 */
class nsAtom;
namespace mozilla {
  namespace css {
    struct URLValue;
  }
  // Work-around weird cbindgen renaming.
  typedef css::URLValue StyleURLValue;
  typedef nsAtom StylensAtom;
}


#include <cstdarg>
#include <cstdint>
#include <cstdlib>

namespace mozilla {

/// The value for the `appearance` property.
/// https://developer.mozilla.org/en-US/docs/Web/CSS/-moz-appearance
enum class StyleAppearance : uint8_t {
  /// No appearance at all.
  None,
  /// A typical dialog button.
  Button,
  /// Various arrows that go in buttons
  ButtonArrowDown,
  ButtonArrowNext,
  ButtonArrowPrevious,
  ButtonArrowUp,
  /// A rectangular button that contains complex content
  /// like images (e.g. HTML <button> elements)
  ButtonBevel,
  /// The focus outline box inside of a button.
  ButtonFocus,
  /// The caret of a text area
  Caret,
  /// A dual toolbar button (e.g., a Back button with a dropdown)
  Dualbutton,
  /// A groupbox.
  Groupbox,
  /// A inner-spin button.
  InnerSpinButton,
  /// List boxes.
  Listbox,
  /// A listbox item.
  Listitem,
  /// Menu Bar background
  Menubar,
  /// <menu> and <menuitem> appearances
  Menuitem,
  Checkmenuitem,
  Radiomenuitem,
  /// For text on non-iconic menuitems only
  Menuitemtext,
  /// A dropdown list.
  Menulist,
  /// The dropdown button(s) that open up a dropdown list.
  MenulistButton,
  /// The text part of a dropdown list, to left of button.
  MenulistText,
  /// An editable textfield with a dropdown list (a combobox).
  MenulistTextfield,
  /// Menu Popup background.
  Menupopup,
  /// menu checkbox/radio appearances
  Menucheckbox,
  Menuradio,
  Menuseparator,
  Menuarrow,
  /// An image in the menu gutter, like in bookmarks or history.
  Menuimage,
  /// A horizontal meter bar.
  Meter,
  /// The meter bar's meter indicator.
  Meterchunk,
  /// The "arrowed" part of the dropdown button that open up a dropdown list.
  MozMenulistButton,
  /// For HTML's <input type=number>
  NumberInput,
  /// A horizontal progress bar.
  ProgressBar,
  /// The progress bar's progress indicator
  Progresschunk,
  /// A vertical progress bar.
  ProgressbarVertical,
  /// A checkbox element.
  Checkbox,
  /// A radio element within a radio group.
  Radio,
  /// A generic container that always repaints on state changes. This is a
  /// hack to make XUL checkboxes and radio buttons work.
  CheckboxContainer,
  RadioContainer,
  /// The label part of a checkbox or radio button, used for painting a focus
  /// outline.
  CheckboxLabel,
  RadioLabel,
  /// nsRangeFrame and its subparts
  Range,
  RangeThumb,
  /// The resizer background area in a status bar for the resizer widget in
  /// the corner of a window.
  Resizerpanel,
  /// The resizer itself.
  Resizer,
  /// A slider.
  ScaleHorizontal,
  ScaleVertical,
  /// A slider's thumb.
  ScalethumbHorizontal,
  ScalethumbVertical,
  /// If the platform supports it, the left/right chunks of the slider thumb.
  Scalethumbstart,
  Scalethumbend,
  /// The ticks for a slider.
  Scalethumbtick,
  /// A scrollbar.
  Scrollbar,
  /// A small scrollbar.
  ScrollbarSmall,
  /// The scrollbar slider
  ScrollbarHorizontal,
  ScrollbarVertical,
  /// A scrollbar button (up/down/left/right).
  /// Keep these in order (some code casts these values to `int` in order to
  /// compare them against each other).
  ScrollbarbuttonUp,
  ScrollbarbuttonDown,
  ScrollbarbuttonLeft,
  ScrollbarbuttonRight,
  /// The scrollbar thumb.
  ScrollbarthumbHorizontal,
  ScrollbarthumbVertical,
  /// The scrollbar track.
  ScrollbartrackHorizontal,
  ScrollbartrackVertical,
  /// The scroll corner
  Scrollcorner,
  /// A searchfield.
  Searchfield,
  /// A separator.  Can be horizontal or vertical.
  Separator,
  /// A spin control (up/down control for time/date pickers).
  Spinner,
  /// The up button of a spin control.
  SpinnerUpbutton,
  /// The down button of a spin control.
  SpinnerDownbutton,
  /// The textfield of a spin control
  SpinnerTextfield,
  /// A splitter.  Can be horizontal or vertical.
  Splitter,
  /// A status bar in a main application window.
  Statusbar,
  /// A single pane of a status bar.
  Statusbarpanel,
  /// A single tab in a tab widget.
  Tab,
  /// A single pane (inside the tabpanels container).
  Tabpanel,
  /// The tab panels container.
  Tabpanels,
  /// The tabs scroll arrows (left/right).
  TabScrollArrowBack,
  TabScrollArrowForward,
  /// A multi-line text field, e.g. HTML <textarea>.
  Textarea,
  /// A single-line text field, e.g. HTML <input type=text>.
  Textfield,
  /// A toolbar in an application window.
  Toolbar,
  /// A single toolbar button (with no associated dropdown).
  Toolbarbutton,
  /// The dropdown portion of a toolbar button
  ToolbarbuttonDropdown,
  /// The gripper for a toolbar.
  Toolbargripper,
  /// The toolbox that contains the toolbars.
  Toolbox,
  /// A tooltip.
  Tooltip,
  /// A listbox or tree widget header
  Treeheader,
  /// An individual header cell
  Treeheadercell,
  /// The sort arrow for a header.
  Treeheadersortarrow,
  /// A tree item.
  Treeitem,
  /// A tree widget branch line
  Treeline,
  /// A tree widget twisty.
  Treetwisty,
  /// Open tree widget twisty.
  Treetwistyopen,
  /// A tree widget.
  Treeview,
  /// Window and dialog backgrounds.
  Window,
  Dialog,
  /// Vista Rebars.
  MozWinCommunicationsToolbox,
  MozWinMediaToolbox,
  MozWinBrowsertabbarToolbox,
  /// Vista glass.
  MozWinGlass,
  MozWinBorderlessGlass,
  /// -moz-apperance style used in setting proper glass margins.
  MozWinExcludeGlass,
  /// Titlebar elements on the Mac.
  MozMacFullscreenButton,
  /// Mac help button.
  MozMacHelpButton,
  /// Windows themed window frame elements.
  MozWindowButtonBox,
  MozWindowButtonBoxMaximized,
  MozWindowButtonClose,
  MozWindowButtonMaximize,
  MozWindowButtonMinimize,
  MozWindowButtonRestore,
  MozWindowFrameBottom,
  MozWindowFrameLeft,
  MozWindowFrameRight,
  MozWindowTitlebar,
  MozWindowTitlebarMaximized,
  MozGtkInfoBar,
  MozMacActiveSourceListSelection,
  MozMacDisclosureButtonClosed,
  MozMacDisclosureButtonOpen,
  MozMacSourceList,
  MozMacSourceListSelection,
  MozMacVibrancyDark,
  MozMacVibrancyLight,
  MozMacVibrantTitlebarDark,
  MozMacVibrantTitlebarLight,
  /// A non-disappearing scrollbar.
  ScrollbarNonDisappearing,
  /// A themed focus outline (for outline:auto).
  /// This isn't exposed to CSS at all, just here for convenience.
  FocusOutline,
  /// A dummy variant that should be last to let the GTK widget do hackery.
  Count,
};

/// A specified value for a single side of a `border-style` property.
/// The order here corresponds to the integer values from the border conflict
/// resolution rules in CSS 2.1 § 17.6.2.1. Higher values override lower values.
enum class StyleBorderStyle : uint8_t {
  Hidden,
  None,
  Inset,
  Groove,
  Outset,
  Ridge,
  Dotted,
  Dashed,
  Solid,
  Double,
};

/// A kind of break between two boxes.
/// https://drafts.csswg.org/css-break/#break-between
enum class StyleBreakBetween : uint8_t {
  Always,
  Auto,
  Page,
  Avoid,
  Left,
  Right,
};

/// A kind of break within a box.
/// https://drafts.csswg.org/css-break/#break-within
enum class StyleBreakWithin : uint8_t {
  Auto,
  Avoid,
};

/// The keywords allowed in the Cursor property.
/// https://drafts.csswg.org/css-ui-4/#propdef-cursor
enum class StyleCursorKind : uint8_t {
  None,
  Default,
  Pointer,
  ContextMenu,
  Help,
  Progress,
  Wait,
  Cell,
  Crosshair,
  Text,
  VerticalText,
  Alias,
  Copy,
  Move,
  NoDrop,
  NotAllowed,
  Grab,
  Grabbing,
  EResize,
  NResize,
  NeResize,
  NwResize,
  SResize,
  SeResize,
  SwResize,
  WResize,
  EwResize,
  NsResize,
  NeswResize,
  NwseResize,
  ColResize,
  RowResize,
  AllScroll,
  ZoomIn,
  ZoomOut,
  Auto,
  MozGrab,
  MozGrabbing,
  MozZoomIn,
  MozZoomOut,
};

/// Defines an element’s display type, which consists of
/// the two basic qualities of how an element generates boxes
/// <https://drafts.csswg.org/css-display/#propdef-display>
/// NOTE(emilio): Order is important in Gecko!
/// If you change it, make sure to take a look at the
/// FrameConstructionDataByDisplay stuff (both the XUL and non-XUL version), and
/// ensure it's still correct!
enum class StyleDisplay : uint8_t {
  None = 0,
  Block,
  FlowRoot,
  Inline,
  InlineBlock,
  ListItem,
  Table,
  InlineTable,
  TableRowGroup,
  TableColumn,
  TableColumnGroup,
  TableHeaderGroup,
  TableFooterGroup,
  TableRow,
  TableCell,
  TableCaption,
  Flex,
  InlineFlex,
  Grid,
  InlineGrid,
  Ruby,
  RubyBase,
  RubyBaseContainer,
  RubyText,
  RubyTextContainer,
  Contents,
  WebkitBox,
  WebkitInlineBox,
  MozBox,
  MozInlineBox,
  MozGrid,
  MozInlineGrid,
  MozGridGroup,
  MozGridLine,
  MozStack,
  MozInlineStack,
  MozDeck,
  MozGroupbox,
  MozPopup,
};

/// Values for the display-mode media feature.
enum class StyleDisplayMode : uint8_t {
  Browser = 0,
  MinimalUi,
  Standalone,
  Fullscreen,
};

/// A type for possible values for min- and max- flavors of width, height,
/// block-size, and inline-size.
enum class StyleExtremumLength : uint8_t {
  MaxContent,
  MinContent,
  MozFitContent,
  MozAvailable,
};

enum class StyleFillRule : uint8_t {
  Nonzero,
  Evenodd,
};

/// A computed value for the `float` property.
enum class StyleFloat : uint8_t {
  Left,
  Right,
  None,
};

/// A font-display value for a @font-face rule.
/// The font-display descriptor determines how a font face is displayed based
/// on whether and when it is downloaded and ready to use.
enum class StyleFontDisplay : uint8_t {
  Auto,
  Block,
  Swap,
  Fallback,
  Optional,
};

/// The path command absolute type.
enum class StyleIsAbsolute : uint8_t {
  Yes,
  No,
};

/// The value for the `overflow-x` / `overflow-y` properties.
enum class StyleOverflow : uint8_t {
  Visible,
  Hidden,
  Scroll,
  Auto,
  MozHiddenUnscrollable,
};

enum class StyleOverflowAnchor : uint8_t {
  Auto,
  None,
};

enum class StyleOverflowClipBox : uint8_t {
  PaddingBox,
  ContentBox,
};

/// Values for the `overflow-wrap` property.
enum class StyleOverflowWrap : uint8_t {
  Normal,
  BreakWord,
  Anywhere,
};

enum class StyleOverscrollBehavior : uint8_t {
  Auto,
  Contain,
  None,
};

/// A computed value for the `resize` property.
enum class StyleResize : uint8_t {
  None,
  Both,
  Horizontal,
  Vertical,
};

enum class StyleScrollSnapType : uint8_t {
  None,
  Mandatory,
  Proximity,
};

enum class StyleStepPosition : uint8_t {
  JumpStart,
  JumpEnd,
  JumpNone,
  JumpBoth,
  Start,
  End,
};

enum class StyleTimingKeyword : uint8_t {
  Linear,
  Ease,
  EaseIn,
  EaseOut,
  EaseInOut,
};

/// The specified value for the `user-select` property.
/// https://drafts.csswg.org/css-ui-4/#propdef-user-select
enum class StyleUserSelect : uint8_t {
  Auto,
  Text,
  None,
  /// Force selection of all children.
  All,
};

/// <https://drafts.csswg.org/css-ui/#propdef-outline-style>
struct StyleOutlineStyle {
  enum class Tag : uint8_t {
    /// auto
    Auto,
    /// <border-style>
    BorderStyle,
  };

  struct StyleBorderStyle_Body {
    StyleBorderStyle _0;

    bool operator==(const StyleBorderStyle_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleBorderStyle_Body& other) const {
      return _0 != other._0;
    }
  };

  Tag tag;
  union {
    StyleBorderStyle_Body border_style;
  };

  static StyleOutlineStyle Auto() {
    StyleOutlineStyle result;
    result.tag = Tag::Auto;
    return result;
  }

  static StyleOutlineStyle BorderStyle(const StyleBorderStyle &a0) {
    StyleOutlineStyle result;
    result.border_style._0 = a0;
    result.tag = Tag::BorderStyle;
    return result;
  }

  bool IsAuto() const {
    return tag == Tag::Auto;
  }

  bool IsBorderStyle() const {
    return tag == Tag::BorderStyle;
  }

  bool operator==(const StyleOutlineStyle& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::BorderStyle: return border_style == other.border_style;
      default: return true;
    }
  }

  bool operator!=(const StyleOutlineStyle& other) const {
    return !(*this == other);
  }
};

/// The computed representation of the above, so that
/// Gecko can read them easily.
struct StyleComputedFontStretchRange {
  float _0;
  float _1;

  bool operator==(const StyleComputedFontStretchRange& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StyleComputedFontStretchRange& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// The computed representation of the above, with angles in degrees, so that
/// Gecko can read them easily.
union StyleComputedFontStyleDescriptor {
  enum class Tag : uint8_t {
    Normal,
    Italic,
    Oblique,
  };

  struct Oblique_Body {
    Tag tag;
    float _0;
    float _1;

    bool operator==(const Oblique_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const Oblique_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  struct {
    Tag tag;
  };
  Oblique_Body oblique;

  static StyleComputedFontStyleDescriptor Normal() {
    StyleComputedFontStyleDescriptor result;
    result.tag = Tag::Normal;
    return result;
  }

  static StyleComputedFontStyleDescriptor Italic() {
    StyleComputedFontStyleDescriptor result;
    result.tag = Tag::Italic;
    return result;
  }

  static StyleComputedFontStyleDescriptor Oblique(const float &a0,
                                                  const float &a1) {
    StyleComputedFontStyleDescriptor result;
    result.oblique._0 = a0;
    result.oblique._1 = a1;
    result.tag = Tag::Oblique;
    return result;
  }

  bool IsNormal() const {
    return tag == Tag::Normal;
  }

  bool IsItalic() const {
    return tag == Tag::Italic;
  }

  bool IsOblique() const {
    return tag == Tag::Oblique;
  }

  bool operator==(const StyleComputedFontStyleDescriptor& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Oblique: return oblique == other.oblique;
      default: return true;
    }
  }

  bool operator!=(const StyleComputedFontStyleDescriptor& other) const {
    return !(*this == other);
  }
};

/// The computed representation of the above so Gecko can read them easily.
/// This one is needed because cbindgen doesn't know how to generate
/// specified::Number.
struct StyleComputedFontWeightRange {
  float _0;
  float _1;

  bool operator==(const StyleComputedFontWeightRange& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StyleComputedFontWeightRange& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// A CSS integer value.
using StyleCSSInteger = int32_t;

/// A `<integer>` value.
using StyleInteger = StyleCSSInteger;

/// A CSS float value.
using StyleCSSFloat = float;

/// A `<number>` value.
using StyleNumber = StyleCSSFloat;

/// A generic easing function.
template<typename Integer, typename Number>
struct StyleTimingFunction {
  enum class Tag : uint8_t {
    /// `linear | ease | ease-in | ease-out | ease-in-out`
    Keyword,
    /// `cubic-bezier(<number>, <number>, <number>, <number>)`
    CubicBezier,
    /// `step-start | step-end | steps(<integer>, [ <step-position> ]?)`
    /// `<step-position> = jump-start | jump-end | jump-none | jump-both | start | end`
    Steps,
  };

  struct StyleKeyword_Body {
    StyleTimingKeyword _0;

    bool operator==(const StyleKeyword_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const StyleKeyword_Body& other) const {
      return _0 != other._0;
    }
  };

  struct StyleCubicBezier_Body {
    Number x1;
    Number y1;
    Number x2;
    Number y2;

    bool operator==(const StyleCubicBezier_Body& other) const {
      return x1 == other.x1 &&
             y1 == other.y1 &&
             x2 == other.x2 &&
             y2 == other.y2;
    }
    bool operator!=(const StyleCubicBezier_Body& other) const {
      return x1 != other.x1 ||
             y1 != other.y1 ||
             x2 != other.x2 ||
             y2 != other.y2;
    }
  };

  struct StyleSteps_Body {
    Integer _0;
    StyleStepPosition _1;

    bool operator==(const StyleSteps_Body& other) const {
      return _0 == other._0 &&
             _1 == other._1;
    }
    bool operator!=(const StyleSteps_Body& other) const {
      return _0 != other._0 ||
             _1 != other._1;
    }
  };

  Tag tag;
  union {
    StyleKeyword_Body keyword;
    StyleCubicBezier_Body cubic_bezier;
    StyleSteps_Body steps;
  };

  static StyleTimingFunction Keyword(const StyleTimingKeyword &a0) {
    StyleTimingFunction result;
    result.keyword._0 = a0;
    result.tag = Tag::Keyword;
    return result;
  }

  static StyleTimingFunction CubicBezier(const Number &aX1,
                                         const Number &aY1,
                                         const Number &aX2,
                                         const Number &aY2) {
    StyleTimingFunction result;
    result.cubic_bezier.x1 = aX1;
    result.cubic_bezier.y1 = aY1;
    result.cubic_bezier.x2 = aX2;
    result.cubic_bezier.y2 = aY2;
    result.tag = Tag::CubicBezier;
    return result;
  }

  static StyleTimingFunction Steps(const Integer &a0,
                                   const StyleStepPosition &a1) {
    StyleTimingFunction result;
    result.steps._0 = a0;
    result.steps._1 = a1;
    result.tag = Tag::Steps;
    return result;
  }

  bool IsKeyword() const {
    return tag == Tag::Keyword;
  }

  bool IsCubicBezier() const {
    return tag == Tag::CubicBezier;
  }

  bool IsSteps() const {
    return tag == Tag::Steps;
  }

  bool operator==(const StyleTimingFunction& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Keyword: return keyword == other.keyword;
      case Tag::CubicBezier: return cubic_bezier == other.cubic_bezier;
      case Tag::Steps: return steps == other.steps;
      default: return true;
    }
  }

  bool operator!=(const StyleTimingFunction& other) const {
    return !(*this == other);
  }
};

/// A computed timing function.
using StyleComputedTimingFunction = StyleTimingFunction<StyleInteger, StyleNumber>;

/// A POD representation for Gecko. All pointers here are non-owned and as such
/// can't outlive the rule they came from, but we can't enforce that via C++.
/// All the strings are of course utf8.
union StyleFontFaceSourceListComponent {
  enum class Tag : uint8_t {
    Url,
    Local,
    FormatHint,
  };

  struct Url_Body {
    Tag tag;
    const StyleURLValue *_0;

    bool operator==(const Url_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const Url_Body& other) const {
      return _0 != other._0;
    }
  };

  struct Local_Body {
    Tag tag;
    StylensAtom *_0;

    bool operator==(const Local_Body& other) const {
      return _0 == other._0;
    }
    bool operator!=(const Local_Body& other) const {
      return _0 != other._0;
    }
  };

  struct FormatHint_Body {
    Tag tag;
    uintptr_t length;
    const uint8_t *utf8_bytes;

    bool operator==(const FormatHint_Body& other) const {
      return length == other.length &&
             utf8_bytes == other.utf8_bytes;
    }
    bool operator!=(const FormatHint_Body& other) const {
      return length != other.length ||
             utf8_bytes != other.utf8_bytes;
    }
  };

  struct {
    Tag tag;
  };
  Url_Body url;
  Local_Body local;
  FormatHint_Body format_hint;

  static StyleFontFaceSourceListComponent Url(const StyleURLValue *const &a0) {
    StyleFontFaceSourceListComponent result;
    result.url._0 = a0;
    result.tag = Tag::Url;
    return result;
  }

  static StyleFontFaceSourceListComponent Local(StylensAtom *const &a0) {
    StyleFontFaceSourceListComponent result;
    result.local._0 = a0;
    result.tag = Tag::Local;
    return result;
  }

  static StyleFontFaceSourceListComponent FormatHint(const uintptr_t &aLength,
                                                     const uint8_t *const &aUtf8Bytes) {
    StyleFontFaceSourceListComponent result;
    result.format_hint.length = aLength;
    result.format_hint.utf8_bytes = aUtf8Bytes;
    result.tag = Tag::FormatHint;
    return result;
  }

  bool IsUrl() const {
    return tag == Tag::Url;
  }

  bool IsLocal() const {
    return tag == Tag::Local;
  }

  bool IsFormatHint() const {
    return tag == Tag::FormatHint;
  }

  bool operator==(const StyleFontFaceSourceListComponent& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::Url: return url == other.url;
      case Tag::Local: return local == other.local;
      case Tag::FormatHint: return format_hint == other.format_hint;
      default: return true;
    }
  }

  bool operator!=(const StyleFontFaceSourceListComponent& other) const {
    return !(*this == other);
  }
};

/// font-language-override can only have a single three-letter
/// OpenType "language system" tag, so we should be able to compute
/// it and store it as a 32-bit integer
/// (see http://www.microsoft.com/typography/otspec/languagetags.htm).
struct StyleFontLanguageOverride {
  uint32_t _0;

  bool operator==(const StyleFontLanguageOverride& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleFontLanguageOverride& other) const {
    return _0 != other._0;
  }
};

/// The path coord type.
struct StyleCoordPair {
  StyleCSSFloat _0;
  StyleCSSFloat _1;

  bool operator==(const StyleCoordPair& other) const {
    return _0 == other._0 &&
           _1 == other._1;
  }
  bool operator!=(const StyleCoordPair& other) const {
    return _0 != other._0 ||
           _1 != other._1;
  }
};

/// The EllipticalArc flag type.
struct StyleArcFlag {
  bool _0;

  bool operator==(const StyleArcFlag& other) const {
    return _0 == other._0;
  }
  bool operator!=(const StyleArcFlag& other) const {
    return _0 != other._0;
  }
};

/// The SVG path command.
/// The fields of these commands are self-explanatory, so we skip the documents.
/// Note: the index of the control points, e.g. control1, control2, are mapping to the control
/// points of the Bézier curve in the spec.
/// https://www.w3.org/TR/SVG11/paths.html#PathData
struct StylePathCommand {
  enum class Tag : uint8_t {
    /// The unknown type.
    /// https://www.w3.org/TR/SVG/paths.html#__svg__SVGPathSeg__PATHSEG_UNKNOWN
    Unknown,
    /// The "moveto" command.
    MoveTo,
    /// The "lineto" command.
    LineTo,
    /// The horizontal "lineto" command.
    HorizontalLineTo,
    /// The vertical "lineto" command.
    VerticalLineTo,
    /// The cubic Bézier curve command.
    CurveTo,
    /// The smooth curve command.
    SmoothCurveTo,
    /// The quadratic Bézier curve command.
    QuadBezierCurveTo,
    /// The smooth quadratic Bézier curve command.
    SmoothQuadBezierCurveTo,
    /// The elliptical arc curve command.
    EllipticalArc,
    /// The "closepath" command.
    ClosePath,
  };

  struct StyleMoveTo_Body {
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleMoveTo_Body& other) const {
      return point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleMoveTo_Body& other) const {
      return point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleLineTo_Body {
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleLineTo_Body& other) const {
      return point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleLineTo_Body& other) const {
      return point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleHorizontalLineTo_Body {
    StyleCSSFloat x;
    StyleIsAbsolute absolute;

    bool operator==(const StyleHorizontalLineTo_Body& other) const {
      return x == other.x &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleHorizontalLineTo_Body& other) const {
      return x != other.x ||
             absolute != other.absolute;
    }
  };

  struct StyleVerticalLineTo_Body {
    StyleCSSFloat y;
    StyleIsAbsolute absolute;

    bool operator==(const StyleVerticalLineTo_Body& other) const {
      return y == other.y &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleVerticalLineTo_Body& other) const {
      return y != other.y ||
             absolute != other.absolute;
    }
  };

  struct StyleCurveTo_Body {
    StyleCoordPair control1;
    StyleCoordPair control2;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleCurveTo_Body& other) const {
      return control1 == other.control1 &&
             control2 == other.control2 &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleCurveTo_Body& other) const {
      return control1 != other.control1 ||
             control2 != other.control2 ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleSmoothCurveTo_Body {
    StyleCoordPair control2;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleSmoothCurveTo_Body& other) const {
      return control2 == other.control2 &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleSmoothCurveTo_Body& other) const {
      return control2 != other.control2 ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleQuadBezierCurveTo_Body {
    StyleCoordPair control1;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleQuadBezierCurveTo_Body& other) const {
      return control1 == other.control1 &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleQuadBezierCurveTo_Body& other) const {
      return control1 != other.control1 ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleSmoothQuadBezierCurveTo_Body {
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleSmoothQuadBezierCurveTo_Body& other) const {
      return point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleSmoothQuadBezierCurveTo_Body& other) const {
      return point != other.point ||
             absolute != other.absolute;
    }
  };

  struct StyleEllipticalArc_Body {
    StyleCSSFloat rx;
    StyleCSSFloat ry;
    StyleCSSFloat angle;
    StyleArcFlag large_arc_flag;
    StyleArcFlag sweep_flag;
    StyleCoordPair point;
    StyleIsAbsolute absolute;

    bool operator==(const StyleEllipticalArc_Body& other) const {
      return rx == other.rx &&
             ry == other.ry &&
             angle == other.angle &&
             large_arc_flag == other.large_arc_flag &&
             sweep_flag == other.sweep_flag &&
             point == other.point &&
             absolute == other.absolute;
    }
    bool operator!=(const StyleEllipticalArc_Body& other) const {
      return rx != other.rx ||
             ry != other.ry ||
             angle != other.angle ||
             large_arc_flag != other.large_arc_flag ||
             sweep_flag != other.sweep_flag ||
             point != other.point ||
             absolute != other.absolute;
    }
  };

  Tag tag;
  union {
    StyleMoveTo_Body move_to;
    StyleLineTo_Body line_to;
    StyleHorizontalLineTo_Body horizontal_line_to;
    StyleVerticalLineTo_Body vertical_line_to;
    StyleCurveTo_Body curve_to;
    StyleSmoothCurveTo_Body smooth_curve_to;
    StyleQuadBezierCurveTo_Body quad_bezier_curve_to;
    StyleSmoothQuadBezierCurveTo_Body smooth_quad_bezier_curve_to;
    StyleEllipticalArc_Body elliptical_arc;
  };

  static StylePathCommand Unknown() {
    StylePathCommand result;
    result.tag = Tag::Unknown;
    return result;
  }

  static StylePathCommand MoveTo(const StyleCoordPair &aPoint,
                                 const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    result.move_to.point = aPoint;
    result.move_to.absolute = aAbsolute;
    result.tag = Tag::MoveTo;
    return result;
  }

  static StylePathCommand LineTo(const StyleCoordPair &aPoint,
                                 const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    result.line_to.point = aPoint;
    result.line_to.absolute = aAbsolute;
    result.tag = Tag::LineTo;
    return result;
  }

  static StylePathCommand HorizontalLineTo(const StyleCSSFloat &aX,
                                           const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    result.horizontal_line_to.x = aX;
    result.horizontal_line_to.absolute = aAbsolute;
    result.tag = Tag::HorizontalLineTo;
    return result;
  }

  static StylePathCommand VerticalLineTo(const StyleCSSFloat &aY,
                                         const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    result.vertical_line_to.y = aY;
    result.vertical_line_to.absolute = aAbsolute;
    result.tag = Tag::VerticalLineTo;
    return result;
  }

  static StylePathCommand CurveTo(const StyleCoordPair &aControl1,
                                  const StyleCoordPair &aControl2,
                                  const StyleCoordPair &aPoint,
                                  const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    result.curve_to.control1 = aControl1;
    result.curve_to.control2 = aControl2;
    result.curve_to.point = aPoint;
    result.curve_to.absolute = aAbsolute;
    result.tag = Tag::CurveTo;
    return result;
  }

  static StylePathCommand SmoothCurveTo(const StyleCoordPair &aControl2,
                                        const StyleCoordPair &aPoint,
                                        const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    result.smooth_curve_to.control2 = aControl2;
    result.smooth_curve_to.point = aPoint;
    result.smooth_curve_to.absolute = aAbsolute;
    result.tag = Tag::SmoothCurveTo;
    return result;
  }

  static StylePathCommand QuadBezierCurveTo(const StyleCoordPair &aControl1,
                                            const StyleCoordPair &aPoint,
                                            const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    result.quad_bezier_curve_to.control1 = aControl1;
    result.quad_bezier_curve_to.point = aPoint;
    result.quad_bezier_curve_to.absolute = aAbsolute;
    result.tag = Tag::QuadBezierCurveTo;
    return result;
  }

  static StylePathCommand SmoothQuadBezierCurveTo(const StyleCoordPair &aPoint,
                                                  const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    result.smooth_quad_bezier_curve_to.point = aPoint;
    result.smooth_quad_bezier_curve_to.absolute = aAbsolute;
    result.tag = Tag::SmoothQuadBezierCurveTo;
    return result;
  }

  static StylePathCommand EllipticalArc(const StyleCSSFloat &aRx,
                                        const StyleCSSFloat &aRy,
                                        const StyleCSSFloat &aAngle,
                                        const StyleArcFlag &aLargeArcFlag,
                                        const StyleArcFlag &aSweepFlag,
                                        const StyleCoordPair &aPoint,
                                        const StyleIsAbsolute &aAbsolute) {
    StylePathCommand result;
    result.elliptical_arc.rx = aRx;
    result.elliptical_arc.ry = aRy;
    result.elliptical_arc.angle = aAngle;
    result.elliptical_arc.large_arc_flag = aLargeArcFlag;
    result.elliptical_arc.sweep_flag = aSweepFlag;
    result.elliptical_arc.point = aPoint;
    result.elliptical_arc.absolute = aAbsolute;
    result.tag = Tag::EllipticalArc;
    return result;
  }

  static StylePathCommand ClosePath() {
    StylePathCommand result;
    result.tag = Tag::ClosePath;
    return result;
  }

  bool IsUnknown() const {
    return tag == Tag::Unknown;
  }

  bool IsMoveTo() const {
    return tag == Tag::MoveTo;
  }

  bool IsLineTo() const {
    return tag == Tag::LineTo;
  }

  bool IsHorizontalLineTo() const {
    return tag == Tag::HorizontalLineTo;
  }

  bool IsVerticalLineTo() const {
    return tag == Tag::VerticalLineTo;
  }

  bool IsCurveTo() const {
    return tag == Tag::CurveTo;
  }

  bool IsSmoothCurveTo() const {
    return tag == Tag::SmoothCurveTo;
  }

  bool IsQuadBezierCurveTo() const {
    return tag == Tag::QuadBezierCurveTo;
  }

  bool IsSmoothQuadBezierCurveTo() const {
    return tag == Tag::SmoothQuadBezierCurveTo;
  }

  bool IsEllipticalArc() const {
    return tag == Tag::EllipticalArc;
  }

  bool IsClosePath() const {
    return tag == Tag::ClosePath;
  }

  bool operator==(const StylePathCommand& other) const {
    if (tag != other.tag) {
      return false;
    }
    switch (tag) {
      case Tag::MoveTo: return move_to == other.move_to;
      case Tag::LineTo: return line_to == other.line_to;
      case Tag::HorizontalLineTo: return horizontal_line_to == other.horizontal_line_to;
      case Tag::VerticalLineTo: return vertical_line_to == other.vertical_line_to;
      case Tag::CurveTo: return curve_to == other.curve_to;
      case Tag::SmoothCurveTo: return smooth_curve_to == other.smooth_curve_to;
      case Tag::QuadBezierCurveTo: return quad_bezier_curve_to == other.quad_bezier_curve_to;
      case Tag::SmoothQuadBezierCurveTo: return smooth_quad_bezier_curve_to == other.smooth_quad_bezier_curve_to;
      case Tag::EllipticalArc: return elliptical_arc == other.elliptical_arc;
      default: return true;
    }
  }

  bool operator!=(const StylePathCommand& other) const {
    return !(*this == other);
  }
};

/// One contiguous range of code points.
/// Can not be empty. Can represent a single code point when start == end.
struct StyleUnicodeRange {
  /// Inclusive start of the range. In [0, end].
  uint32_t start;
  /// Inclusive end of the range. In [0, 0x10FFFF].
  uint32_t end;

  bool operator==(const StyleUnicodeRange& other) const {
    return start == other.start &&
           end == other.end;
  }
  bool operator!=(const StyleUnicodeRange& other) const {
    return start != other.start ||
           end != other.end;
  }
};

} // namespace mozilla

#endif // mozilla_ServoStyleConsts_h
