//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PrefsTypes.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union PrefValue|
//
namespace mozilla {
namespace dom {
auto PrefValue::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TnsCString:
        {
            (ptr_nsCString())->~nsCString__tdef();
            break;
        }
    case Tint32_t:
        {
            (ptr_int32_t())->~int32_t__tdef();
            break;
        }
    case Tbool:
        {
            (ptr_bool())->~bool__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT PrefValue::PrefValue(const nsCString& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsCString()) nsCString(aOther);
    mType = TnsCString;
}

MOZ_IMPLICIT PrefValue::PrefValue(nsCString&& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsCString()) nsCString(std::move(aOther));
    mType = TnsCString;
}

MOZ_IMPLICIT PrefValue::PrefValue(const int32_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(aOther);
    mType = Tint32_t;
}

MOZ_IMPLICIT PrefValue::PrefValue(int32_t&& aOther)
{
    new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(std::move(aOther));
    mType = Tint32_t;
}

MOZ_IMPLICIT PrefValue::PrefValue(const bool& aOther)
{
    new (mozilla::KnownNotNull, ptr_bool()) bool(aOther);
    mType = Tbool;
}

MOZ_IMPLICIT PrefValue::PrefValue(bool&& aOther)
{
    new (mozilla::KnownNotNull, ptr_bool()) bool(std::move(aOther));
    mType = Tbool;
}

MOZ_IMPLICIT PrefValue::PrefValue(const PrefValue& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TnsCString:
        {
            new (mozilla::KnownNotNull, ptr_nsCString()) nsCString((aOther).get_nsCString());
            break;
        }
    case Tint32_t:
        {
            new (mozilla::KnownNotNull, ptr_int32_t()) int32_t((aOther).get_int32_t());
            break;
        }
    case Tbool:
        {
            new (mozilla::KnownNotNull, ptr_bool()) bool((aOther).get_bool());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT PrefValue::PrefValue(PrefValue&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TnsCString:
        {
            new (mozilla::KnownNotNull, ptr_nsCString()) nsCString(std::move((aOther).get_nsCString()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tint32_t:
        {
            new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(std::move((aOther).get_int32_t()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tbool:
        {
            new (mozilla::KnownNotNull, ptr_bool()) bool(std::move((aOther).get_bool()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

PrefValue::~PrefValue()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto PrefValue::operator=(const nsCString& aRhs) -> PrefValue&
{
    if (MaybeDestroy(TnsCString)) {
        new (mozilla::KnownNotNull, ptr_nsCString()) nsCString;
    }
    (*(ptr_nsCString())) = aRhs;
    mType = TnsCString;
    return (*(this));
}

auto PrefValue::operator=(nsCString&& aRhs) -> PrefValue&
{
    if (MaybeDestroy(TnsCString)) {
        new (mozilla::KnownNotNull, ptr_nsCString()) nsCString;
    }
    (*(ptr_nsCString())) = std::move(aRhs);
    mType = TnsCString;
    return (*(this));
}

auto PrefValue::operator=(const int32_t& aRhs) -> PrefValue&
{
    if (MaybeDestroy(Tint32_t)) {
        new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
    }
    (*(ptr_int32_t())) = aRhs;
    mType = Tint32_t;
    return (*(this));
}

auto PrefValue::operator=(int32_t&& aRhs) -> PrefValue&
{
    if (MaybeDestroy(Tint32_t)) {
        new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
    }
    (*(ptr_int32_t())) = std::move(aRhs);
    mType = Tint32_t;
    return (*(this));
}

auto PrefValue::operator=(const bool& aRhs) -> PrefValue&
{
    if (MaybeDestroy(Tbool)) {
        new (mozilla::KnownNotNull, ptr_bool()) bool;
    }
    (*(ptr_bool())) = aRhs;
    mType = Tbool;
    return (*(this));
}

auto PrefValue::operator=(bool&& aRhs) -> PrefValue&
{
    if (MaybeDestroy(Tbool)) {
        new (mozilla::KnownNotNull, ptr_bool()) bool;
    }
    (*(ptr_bool())) = std::move(aRhs);
    mType = Tbool;
    return (*(this));
}

auto PrefValue::operator=(const PrefValue& aRhs) -> PrefValue&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsCString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsCString()) nsCString;
            }
            (*(ptr_nsCString())) = (aRhs).get_nsCString();
            break;
        }
    case Tint32_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
            }
            (*(ptr_int32_t())) = (aRhs).get_int32_t();
            break;
        }
    case Tbool:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_bool()) bool;
            }
            (*(ptr_bool())) = (aRhs).get_bool();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto PrefValue::operator=(PrefValue&& aRhs) -> PrefValue&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsCString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsCString()) nsCString;
            }
            (*(ptr_nsCString())) = std::move((aRhs).get_nsCString());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tint32_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
            }
            (*(ptr_int32_t())) = std::move((aRhs).get_int32_t());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tbool:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_bool()) bool;
            }
            (*(ptr_bool())) = std::move((aRhs).get_bool());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto PrefValue::operator==(const nsCString& aRhs) const -> bool
{
    return (get_nsCString()) == (aRhs);
}

auto PrefValue::operator==(const int32_t& aRhs) const -> bool
{
    return (get_int32_t()) == (aRhs);
}

auto PrefValue::operator==(const bool& aRhs) const -> bool
{
    return (get_bool()) == (aRhs);
}

auto PrefValue::operator==(const PrefValue& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TnsCString:
        {
            return (get_nsCString()) == ((aRhs).get_nsCString());
        }
    case Tint32_t:
        {
            return (get_int32_t()) == ((aRhs).get_int32_t());
        }
    case Tbool:
        {
            return (get_bool()) == ((aRhs).get_bool());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto PrefValue::get(nsCString* aOutValue) const -> void
{
    (*(aOutValue)) = get_nsCString();
}

auto PrefValue::get(int32_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_int32_t();
}

auto PrefValue::get(bool* aOutValue) const -> void
{
    (*(aOutValue)) = get_bool();
}

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::PrefValue>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    typedef mozilla::dom::PrefValue union__;
    int type;
    type = (aVar).type();
    WriteIPDLParam(aMsg, aActor, type);
    // Sentinel = 'PrefValue'
    (aMsg)->WriteSentinel(4174929935);

    switch (type) {
    case union__::TnsCString:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_nsCString());
            // Sentinel = 'TnsCString'
            (aMsg)->WriteSentinel(2427411293);
            return;
        }
    case union__::Tint32_t:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_int32_t());
            // Sentinel = 'Tint32_t'
            (aMsg)->WriteSentinel(4219052577);
            return;
        }
    case union__::Tbool:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_bool());
            // Sentinel = 'Tbool'
            (aMsg)->WriteSentinel(1958350201);
            return;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return;
        }
    }
}

auto IPDLParamTraits<mozilla::dom::PrefValue>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    typedef mozilla::dom::PrefValue union__;
    int type;
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&(type)))))) {
        (aActor)->FatalError("Error deserializing type of union PrefValue");
        return false;
    }
    // Sentinel = 'PrefValue'
    if ((!((aMsg)->ReadSentinel(aIter, 4174929935)))) {
        mozilla::ipc::SentinelReadError("Error deserializing type of union PrefValue");
        return false;
    }

    switch (type) {
    case union__::TnsCString:
        {
            nsCString tmp = nsCString();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_nsCString())))))) {
                (aActor)->FatalError("Error deserializing variant TnsCString of union PrefValue");
                return false;
            }
            // Sentinel = 'TnsCString'
            if ((!((aMsg)->ReadSentinel(aIter, 2427411293)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TnsCString of union PrefValue");
                return false;
            }
            return true;
        }
    case union__::Tint32_t:
        {
            int32_t tmp = int32_t();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_int32_t())))))) {
                (aActor)->FatalError("Error deserializing variant Tint32_t of union PrefValue");
                return false;
            }
            // Sentinel = 'Tint32_t'
            if ((!((aMsg)->ReadSentinel(aIter, 4219052577)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant Tint32_t of union PrefValue");
                return false;
            }
            return true;
        }
    case union__::Tbool:
        {
            bool tmp = bool();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_bool())))))) {
                (aActor)->FatalError("Error deserializing variant Tbool of union PrefValue");
                return false;
            }
            // Sentinel = 'Tbool'
            if ((!((aMsg)->ReadSentinel(aIter, 1958350201)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant Tbool of union PrefValue");
                return false;
            }
            return true;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return false;
        }
    }
}

} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union MaybePrefValue|
//
namespace mozilla {
namespace dom {
auto MaybePrefValue::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TPrefValue:
        {
            (ptr_PrefValue())->~PrefValue__tdef();
            break;
        }
    case Tnull_t:
        {
            (ptr_null_t())->~null_t__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT MaybePrefValue::MaybePrefValue(const PrefValue& aOther)
{
    new (mozilla::KnownNotNull, ptr_PrefValue()) PrefValue(aOther);
    mType = TPrefValue;
}

MOZ_IMPLICIT MaybePrefValue::MaybePrefValue(PrefValue&& aOther)
{
    new (mozilla::KnownNotNull, ptr_PrefValue()) PrefValue(std::move(aOther));
    mType = TPrefValue;
}

MOZ_IMPLICIT MaybePrefValue::MaybePrefValue(const null_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_null_t()) null_t(aOther);
    mType = Tnull_t;
}

MOZ_IMPLICIT MaybePrefValue::MaybePrefValue(null_t&& aOther)
{
    new (mozilla::KnownNotNull, ptr_null_t()) null_t(std::move(aOther));
    mType = Tnull_t;
}

MOZ_IMPLICIT MaybePrefValue::MaybePrefValue(const MaybePrefValue& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TPrefValue:
        {
            new (mozilla::KnownNotNull, ptr_PrefValue()) PrefValue((aOther).get_PrefValue());
            break;
        }
    case Tnull_t:
        {
            new (mozilla::KnownNotNull, ptr_null_t()) null_t((aOther).get_null_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT MaybePrefValue::MaybePrefValue(MaybePrefValue&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TPrefValue:
        {
            new (mozilla::KnownNotNull, ptr_PrefValue()) PrefValue(std::move((aOther).get_PrefValue()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tnull_t:
        {
            new (mozilla::KnownNotNull, ptr_null_t()) null_t(std::move((aOther).get_null_t()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

MaybePrefValue::~MaybePrefValue()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto MaybePrefValue::operator=(const PrefValue& aRhs) -> MaybePrefValue&
{
    if (MaybeDestroy(TPrefValue)) {
        new (mozilla::KnownNotNull, ptr_PrefValue()) PrefValue;
    }
    (*(ptr_PrefValue())) = aRhs;
    mType = TPrefValue;
    return (*(this));
}

auto MaybePrefValue::operator=(PrefValue&& aRhs) -> MaybePrefValue&
{
    if (MaybeDestroy(TPrefValue)) {
        new (mozilla::KnownNotNull, ptr_PrefValue()) PrefValue;
    }
    (*(ptr_PrefValue())) = std::move(aRhs);
    mType = TPrefValue;
    return (*(this));
}

auto MaybePrefValue::operator=(const null_t& aRhs) -> MaybePrefValue&
{
    if (MaybeDestroy(Tnull_t)) {
        new (mozilla::KnownNotNull, ptr_null_t()) null_t;
    }
    (*(ptr_null_t())) = aRhs;
    mType = Tnull_t;
    return (*(this));
}

auto MaybePrefValue::operator=(null_t&& aRhs) -> MaybePrefValue&
{
    if (MaybeDestroy(Tnull_t)) {
        new (mozilla::KnownNotNull, ptr_null_t()) null_t;
    }
    (*(ptr_null_t())) = std::move(aRhs);
    mType = Tnull_t;
    return (*(this));
}

auto MaybePrefValue::operator=(const MaybePrefValue& aRhs) -> MaybePrefValue&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TPrefValue:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_PrefValue()) PrefValue;
            }
            (*(ptr_PrefValue())) = (aRhs).get_PrefValue();
            break;
        }
    case Tnull_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_null_t()) null_t;
            }
            (*(ptr_null_t())) = (aRhs).get_null_t();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto MaybePrefValue::operator=(MaybePrefValue&& aRhs) -> MaybePrefValue&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TPrefValue:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_PrefValue()) PrefValue;
            }
            (*(ptr_PrefValue())) = std::move((aRhs).get_PrefValue());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tnull_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_null_t()) null_t;
            }
            (*(ptr_null_t())) = std::move((aRhs).get_null_t());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto MaybePrefValue::operator==(const PrefValue& aRhs) const -> bool
{
    return (get_PrefValue()) == (aRhs);
}

auto MaybePrefValue::operator==(const null_t& aRhs) const -> bool
{
    return (get_null_t()) == (aRhs);
}

auto MaybePrefValue::operator==(const MaybePrefValue& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TPrefValue:
        {
            return (get_PrefValue()) == ((aRhs).get_PrefValue());
        }
    case Tnull_t:
        {
            return (get_null_t()) == ((aRhs).get_null_t());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto MaybePrefValue::get(PrefValue* aOutValue) const -> void
{
    (*(aOutValue)) = get_PrefValue();
}

auto MaybePrefValue::get(null_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_null_t();
}

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::MaybePrefValue>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    typedef mozilla::dom::MaybePrefValue union__;
    int type;
    type = (aVar).type();
    WriteIPDLParam(aMsg, aActor, type);
    // Sentinel = 'MaybePrefValue'
    (aMsg)->WriteSentinel(1713533748);

    switch (type) {
    case union__::TPrefValue:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_PrefValue());
            // Sentinel = 'TPrefValue'
            (aMsg)->WriteSentinel(1238906536);
            return;
        }
    case union__::Tnull_t:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_null_t());
            // Sentinel = 'Tnull_t'
            (aMsg)->WriteSentinel(3731137201);
            return;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return;
        }
    }
}

auto IPDLParamTraits<mozilla::dom::MaybePrefValue>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    typedef mozilla::dom::MaybePrefValue union__;
    int type;
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&(type)))))) {
        (aActor)->FatalError("Error deserializing type of union MaybePrefValue");
        return false;
    }
    // Sentinel = 'MaybePrefValue'
    if ((!((aMsg)->ReadSentinel(aIter, 1713533748)))) {
        mozilla::ipc::SentinelReadError("Error deserializing type of union MaybePrefValue");
        return false;
    }

    switch (type) {
    case union__::TPrefValue:
        {
            mozilla::dom::PrefValue tmp = mozilla::dom::PrefValue();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_PrefValue())))))) {
                (aActor)->FatalError("Error deserializing variant TPrefValue of union MaybePrefValue");
                return false;
            }
            // Sentinel = 'TPrefValue'
            if ((!((aMsg)->ReadSentinel(aIter, 1238906536)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TPrefValue of union MaybePrefValue");
                return false;
            }
            return true;
        }
    case union__::Tnull_t:
        {
            mozilla::null_t tmp = mozilla::null_t();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_null_t())))))) {
                (aActor)->FatalError("Error deserializing variant Tnull_t of union MaybePrefValue");
                return false;
            }
            // Sentinel = 'Tnull_t'
            if ((!((aMsg)->ReadSentinel(aIter, 3731137201)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant Tnull_t of union MaybePrefValue");
                return false;
            }
            return true;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return false;
        }
    }
}

} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct Pref|
//
namespace mozilla {
namespace dom {
auto Pref::operator==(const Pref& _o) const -> bool
{
    if ((!((name()) == ((_o).name())))) {
        return false;
    }
    if ((!((isLocked()) == ((_o).isLocked())))) {
        return false;
    }
    if ((!((defaultValue()) == ((_o).defaultValue())))) {
        return false;
    }
    if ((!((userValue()) == ((_o).userValue())))) {
        return false;
    }
    return true;
}

auto Pref::operator!=(const Pref& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::dom::Pref>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    WriteIPDLParam(aMsg, aActor, (aVar).name());
    // Sentinel = 'name'
    (aMsg)->WriteSentinel(15034981);
    WriteIPDLParam(aMsg, aActor, (aVar).isLocked());
    // Sentinel = 'isLocked'
    (aMsg)->WriteSentinel(3478708402);
    WriteIPDLParam(aMsg, aActor, (aVar).defaultValue());
    // Sentinel = 'defaultValue'
    (aMsg)->WriteSentinel(1929752362);
    WriteIPDLParam(aMsg, aActor, (aVar).userValue());
    // Sentinel = 'userValue'
    (aMsg)->WriteSentinel(727902553);
}

auto IPDLParamTraits<mozilla::dom::Pref>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->name())))))) {
        (aActor)->FatalError("Error deserializing 'name' (nsCString) member of 'Pref'");
        return false;
    }
    // Sentinel = 'name'
    if ((!((aMsg)->ReadSentinel(aIter, 15034981)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'name' (nsCString) member of 'Pref'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->isLocked())))))) {
        (aActor)->FatalError("Error deserializing 'isLocked' (bool) member of 'Pref'");
        return false;
    }
    // Sentinel = 'isLocked'
    if ((!((aMsg)->ReadSentinel(aIter, 3478708402)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'isLocked' (bool) member of 'Pref'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->defaultValue())))))) {
        (aActor)->FatalError("Error deserializing 'defaultValue' (MaybePrefValue) member of 'Pref'");
        return false;
    }
    // Sentinel = 'defaultValue'
    if ((!((aMsg)->ReadSentinel(aIter, 1929752362)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'defaultValue' (MaybePrefValue) member of 'Pref'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->userValue())))))) {
        (aActor)->FatalError("Error deserializing 'userValue' (MaybePrefValue) member of 'Pref'");
        return false;
    }
    // Sentinel = 'userValue'
    if ((!((aMsg)->ReadSentinel(aIter, 727902553)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'userValue' (MaybePrefValue) member of 'Pref'");
        return false;
    }
    return true;
}

} // namespace ipc
} // namespace mozilla
