//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PRemoteVideoDecoder_h
#define PRemoteVideoDecoder_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/PMediaDecoderParams.h"
#include "mozilla/layers/LayersSurfaces.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RemoteVideoDataIPDL|
//
namespace mozilla {
class RemoteVideoDataIPDL final
{
private:
    typedef mozilla::MediaDataIPDL MediaDataIPDL;
    typedef mozilla::gfx::IntSize IntSize;
    typedef mozilla::layers::SurfaceDescriptorBuffer SurfaceDescriptorBuffer;

public:
    MOZ_IMPLICIT RemoteVideoDataIPDL() :
        base_(),
        display_(),
        frameSize_(),
        sdBuffer_(),
        frameID_()
    {
    }

    MOZ_IMPLICIT RemoteVideoDataIPDL(
            const MediaDataIPDL& _base,
            const IntSize& _display,
            const IntSize& _frameSize,
            const SurfaceDescriptorBuffer& _sdBuffer,
            const int32_t& _frameID) :
        base_(_base),
        display_(_display),
        frameSize_(_frameSize),
        sdBuffer_(_sdBuffer),
        frameID_(_frameID)
    {
    }

    bool
    operator==(const RemoteVideoDataIPDL& _o) const;

    bool
    operator!=(const RemoteVideoDataIPDL& _o) const;

    MediaDataIPDL&
    base()
    {
        return base_;
    }
    const MediaDataIPDL&
    base() const
    {
        return base_;
    }

    IntSize&
    display()
    {
        return display_;
    }
    const IntSize&
    display() const
    {
        return display_;
    }

    IntSize&
    frameSize()
    {
        return frameSize_;
    }
    const IntSize&
    frameSize() const
    {
        return frameSize_;
    }

    SurfaceDescriptorBuffer&
    sdBuffer()
    {
        return sdBuffer_;
    }
    const SurfaceDescriptorBuffer&
    sdBuffer() const
    {
        return sdBuffer_;
    }

    int32_t&
    frameID()
    {
        return frameID_;
    }
    const int32_t&
    frameID() const
    {
        return frameID_;
    }

private:
    MediaDataIPDL base_;
    IntSize display_;
    IntSize frameSize_;
    SurfaceDescriptorBuffer sdBuffer_;
    int32_t frameID_;
};
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::RemoteVideoDataIPDL>
{
    typedef mozilla::RemoteVideoDataIPDL paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
class PRemoteVideoDecoderParent;
} // namespace mozilla
namespace mozilla {
class PRemoteVideoDecoderChild;
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PRemoteVideoDecoderChild and PRemoteVideoDecoderParent
//
namespace mozilla {
namespace PRemoteVideoDecoder {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::PRemoteVideoDecoderParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::PRemoteVideoDecoderChild>* aChild);

enum MessageType {
    PRemoteVideoDecoderStart = PRemoteVideoDecoderMsgStart << 16,
    Msg_Init__ID,
    Msg_Input__ID,
    Msg_Flush__ID,
    Msg_Drain__ID,
    Msg_Shutdown__ID,
    Msg_SetSeekThreshold__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_InitComplete__ID,
    Msg_InitFailed__ID,
    Msg_FlushComplete__ID,
    Msg_VideoOutput__ID,
    Msg_InputExhausted__ID,
    Msg_DrainComplete__ID,
    Msg_Error__ID,
    PRemoteVideoDecoderEnd
};

IPC::Message*
Msg_Init(int32_t routingId);

IPC::Message*
Msg_Input(int32_t routingId);

IPC::Message*
Msg_Flush(int32_t routingId);

IPC::Message*
Msg_Drain(int32_t routingId);

IPC::Message*
Msg_Shutdown(int32_t routingId);

IPC::Message*
Msg_SetSeekThreshold(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_InitComplete(int32_t routingId);

IPC::Message*
Msg_InitFailed(int32_t routingId);

IPC::Message*
Msg_FlushComplete(int32_t routingId);

IPC::Message*
Msg_VideoOutput(int32_t routingId);

IPC::Message*
Msg_InputExhausted(int32_t routingId);

IPC::Message*
Msg_DrainComplete(int32_t routingId);

IPC::Message*
Msg_Error(int32_t routingId);



} // namespace PRemoteVideoDecoder
} // namespace mozilla

#endif // ifndef PRemoteVideoDecoder_h
