//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PBackgroundLSDatabase_h
#define PBackgroundLSDatabase_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"

// Headers for typedefs
#include "mozilla/dom/LSSnapshot.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LSItemInfo|
//
namespace mozilla {
namespace dom {
class LSItemInfo final
{
private:

public:
    MOZ_IMPLICIT LSItemInfo() :
        key_(),
        value_()
    {
    }

    MOZ_IMPLICIT LSItemInfo(
            const nsString& _key,
            const nsString& _value) :
        key_(_key),
        value_(_value)
    {
    }

    bool
    operator==(const LSItemInfo& _o) const;

    bool
    operator!=(const LSItemInfo& _o) const;

    nsString&
    key()
    {
        return key_;
    }
    const nsString&
    key() const
    {
        return key_;
    }

    nsString&
    value()
    {
        return value_;
    }
    const nsString&
    value() const
    {
        return value_;
    }

private:
    nsString key_;
    nsString value_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::LSItemInfo>
{
    typedef mozilla::dom::LSItemInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LSSnapshotInitInfo|
//
namespace mozilla {
namespace dom {
class LSSnapshotInitInfo final
{
private:
    typedef mozilla::dom::LSItemInfo LSItemInfo;
    typedef mozilla::dom::LSSnapshot::LoadState LoadState;

public:
    MOZ_IMPLICIT LSSnapshotInitInfo() :
        itemInfos_(),
        totalLength_(),
        initialUsage_(),
        peakUsage_(),
        loadState_()
    {
    }

    MOZ_IMPLICIT LSSnapshotInitInfo(
            const nsTArray<LSItemInfo>& _itemInfos,
            const uint32_t& _totalLength,
            const int64_t& _initialUsage,
            const int64_t& _peakUsage,
            const LoadState& _loadState) :
        itemInfos_(_itemInfos),
        totalLength_(_totalLength),
        initialUsage_(_initialUsage),
        peakUsage_(_peakUsage),
        loadState_(_loadState)
    {
    }

    bool
    operator==(const LSSnapshotInitInfo& _o) const;

    bool
    operator!=(const LSSnapshotInitInfo& _o) const;

    nsTArray<LSItemInfo>&
    itemInfos()
    {
        return itemInfos_;
    }
    const nsTArray<LSItemInfo>&
    itemInfos() const
    {
        return itemInfos_;
    }

    uint32_t&
    totalLength()
    {
        return totalLength_;
    }
    const uint32_t&
    totalLength() const
    {
        return totalLength_;
    }

    int64_t&
    initialUsage()
    {
        return initialUsage_;
    }
    const int64_t&
    initialUsage() const
    {
        return initialUsage_;
    }

    int64_t&
    peakUsage()
    {
        return peakUsage_;
    }
    const int64_t&
    peakUsage() const
    {
        return peakUsage_;
    }

    LoadState&
    loadState()
    {
        return loadState_;
    }
    const LoadState&
    loadState() const
    {
        return loadState_;
    }

private:
    nsTArray<LSItemInfo> itemInfos_;
    uint32_t totalLength_;
    int64_t initialUsage_;
    int64_t peakUsage_;
    LoadState loadState_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::LSSnapshotInitInfo>
{
    typedef mozilla::dom::LSSnapshotInitInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBackgroundLSDatabaseParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBackgroundLSDatabaseChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PBackgroundLSDatabaseChild and PBackgroundLSDatabaseParent
//
namespace mozilla {
namespace dom {
namespace PBackgroundLSDatabase {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PBackgroundLSDatabaseParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PBackgroundLSDatabaseChild>* aChild);

enum MessageType {
    PBackgroundLSDatabaseStart = PBackgroundLSDatabaseMsgStart << 16,
    Msg_DeleteMe__ID,
    Msg_AllowToClose__ID,
    Msg_PBackgroundLSSnapshotConstructor__ID,
    Reply_PBackgroundLSSnapshotConstructor__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_RequestAllowToClose__ID,
    PBackgroundLSDatabaseEnd
};

IPC::Message*
Msg_DeleteMe(int32_t routingId);

IPC::Message*
Msg_AllowToClose(int32_t routingId);

IPC::Message*
Msg_PBackgroundLSSnapshotConstructor(int32_t routingId);
IPC::Message*
Reply_PBackgroundLSSnapshotConstructor(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_RequestAllowToClose(int32_t routingId);



} // namespace PBackgroundLSDatabase
} // namespace dom
} // namespace mozilla

#endif // ifndef PBackgroundLSDatabase_h
