//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSocketProcessChild_h
#define PSocketProcessChild_h

#include "mozilla/net/PSocketProcess.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

#include "mozilla/ipc/ProtocolUtils.h"

// Headers for things that cannot be forward declared
#include "base/process.h"
#include "mozilla/TelemetryComms.h"
#include "mozilla/dom/TabMessageUtils.h"

namespace mozilla {
namespace net {
class PSocketProcessBridgeChild;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PSocketProcessBridgeParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
class PProfilerChild;
} // namespace mozilla
namespace mozilla {
class PProfilerParent;
} // namespace mozilla

namespace mozilla {
namespace net {


class PSocketProcessChild :
    public mozilla::ipc::IToplevelProtocol
{
private:
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::Telemetry::ChildEventData ChildEventData;
    typedef mozilla::Telemetry::DiscardedData DiscardedData;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::Telemetry::HistogramAccumulation HistogramAccumulation;
    typedef mozilla::Telemetry::KeyedHistogramAccumulation KeyedHistogramAccumulation;
    typedef mozilla::Telemetry::KeyedScalarAction KeyedScalarAction;
    typedef mozilla::dom::MaybeFileDesc MaybeFileDesc;
    typedef mozilla::dom::MaybePrefValue MaybePrefValue;
    typedef mozilla::dom::MemoryReport MemoryReport;
    typedef mozilla::dom::NativeThreadId NativeThreadId;
    typedef mozilla::dom::Pref Pref;
    typedef mozilla::dom::PrefValue PrefValue;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::Telemetry::ScalarAction ScalarAction;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef mozilla::null_t null_t;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PSocketProcessBridgeChild PSocketProcessBridgeChild;
    typedef mozilla::net::PSocketProcessBridgeParent PSocketProcessBridgeParent;
    typedef mozilla::PProfilerChild PProfilerChild;
    typedef mozilla::PProfilerParent PProfilerParent;

protected:
    virtual mozilla::ipc::IPCResult
    RecvPreferenceUpdate(const Pref& pref) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestMemoryReport(
            const uint32_t& generation,
            const bool& anonymize,
            const bool& minimizeMemoryUsage,
            const MaybeFileDesc& DMDFile) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetOffline(const bool& offline) = 0;
    virtual mozilla::ipc::IPCResult
    RecvInitSocketProcessBridgeParent(
            const ProcessId& processId,
            Endpoint<mozilla::net::PSocketProcessBridgeParent>&& endpoint) = 0;
    virtual mozilla::ipc::IPCResult
    RecvInitProfiler(Endpoint<mozilla::PProfilerChild>&& aEndpoint) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSocketProcessTelemetryPing() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;
    void
    EnteredCxxStack() override;
    void
    ExitedCxxStack() override;
    void
    EnteredCall() override;
    void
    ExitedCall() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PSocketProcessChild();

    virtual ~PSocketProcessChild();

    bool
    SendInitCrashReporter(
            Shmem& shmem,
            const NativeThreadId& threadId);

    bool
    SendAddMemoryReport(const MemoryReport& aReport);

    bool
    SendFinishMemoryReport(const uint32_t& aGeneration);

    bool
    SendAccumulateChildHistograms(const nsTArray<HistogramAccumulation>& accumulations);

    bool
    SendAccumulateChildKeyedHistograms(const nsTArray<KeyedHistogramAccumulation>& accumulations);

    bool
    SendUpdateChildScalars(const nsTArray<ScalarAction>& actions);

    bool
    SendUpdateChildKeyedScalars(const nsTArray<KeyedScalarAction>& actions);

    bool
    SendRecordChildEvents(const nsTArray<ChildEventData>& events);

    bool
    SendRecordDiscardedData(const DiscardedData& data);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

    void
    OnChannelClose() override;

    void
    OnChannelError() override;

private:
    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPSocketProcessChild();

    mozilla::ipc::LivenessState mLivenessState;
};


} // namespace net
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::PSocketProcessChild>
{
    typedef mozilla::net::PSocketProcessChild* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PSocketProcessChild_h
