//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSocketProcessParent_h
#define PSocketProcessParent_h

#include "mozilla/net/PSocketProcess.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

#include "mozilla/ipc/ProtocolUtils.h"

class nsIFile;

// Headers for things that cannot be forward declared
#include "base/process.h"
#include "mozilla/TelemetryComms.h"
#include "mozilla/dom/TabMessageUtils.h"

namespace mozilla {
namespace net {
class PSocketProcessBridgeParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PSocketProcessBridgeChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
class PProfilerParent;
} // namespace mozilla
namespace mozilla {
class PProfilerChild;
} // namespace mozilla

namespace mozilla {
namespace net {


class PSocketProcessParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::Telemetry::ChildEventData ChildEventData;
    typedef mozilla::Telemetry::DiscardedData DiscardedData;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::Telemetry::HistogramAccumulation HistogramAccumulation;
    typedef mozilla::Telemetry::KeyedHistogramAccumulation KeyedHistogramAccumulation;
    typedef mozilla::Telemetry::KeyedScalarAction KeyedScalarAction;
    typedef mozilla::dom::MaybeFileDesc MaybeFileDesc;
    typedef mozilla::dom::MaybePrefValue MaybePrefValue;
    typedef mozilla::dom::MemoryReport MemoryReport;
    typedef mozilla::dom::NativeThreadId NativeThreadId;
    typedef mozilla::dom::Pref Pref;
    typedef mozilla::dom::PrefValue PrefValue;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::Telemetry::ScalarAction ScalarAction;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef mozilla::null_t null_t;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PSocketProcessBridgeParent PSocketProcessBridgeParent;
    typedef mozilla::net::PSocketProcessBridgeChild PSocketProcessBridgeChild;
    typedef mozilla::PProfilerParent PProfilerParent;
    typedef mozilla::PProfilerChild PProfilerChild;

protected:
    virtual mozilla::ipc::IPCResult
    RecvInitCrashReporter(
            Shmem&& shmem,
            const NativeThreadId& threadId) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAddMemoryReport(const MemoryReport& aReport) = 0;
    virtual mozilla::ipc::IPCResult
    RecvFinishMemoryReport(const uint32_t& aGeneration) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAccumulateChildHistograms(nsTArray<HistogramAccumulation>&& accumulations) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAccumulateChildKeyedHistograms(nsTArray<KeyedHistogramAccumulation>&& accumulations) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateChildScalars(nsTArray<ScalarAction>&& actions) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateChildKeyedScalars(nsTArray<KeyedScalarAction>&& actions) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRecordChildEvents(nsTArray<ChildEventData>&& events) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRecordDiscardedData(const DiscardedData& data) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;
    void
    EnteredCxxStack() override;
    void
    ExitedCxxStack() override;
    void
    EnteredCall() override;
    void
    ExitedCall() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PSocketProcessParent();

    virtual ~PSocketProcessParent();

    MOZ_MUST_USE bool
    SendPreferenceUpdate(const Pref& pref);

    MOZ_MUST_USE bool
    SendRequestMemoryReport(
            const uint32_t& generation,
            const bool& anonymize,
            const bool& minimizeMemoryUsage,
            const MaybeFileDesc& DMDFile);

    MOZ_MUST_USE bool
    SendSetOffline(const bool& offline);

    MOZ_MUST_USE bool
    SendInitSocketProcessBridgeParent(
            const ProcessId& processId,
            const Endpoint<mozilla::net::PSocketProcessBridgeParent>& endpoint);

    MOZ_MUST_USE bool
    SendInitProfiler(const Endpoint<mozilla::PProfilerChild>& aEndpoint);

    MOZ_MUST_USE bool
    SendSocketProcessTelemetryPing();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

    void
    OnChannelClose() override;

    void
    OnChannelError() override;

private:
    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPSocketProcessParent();

    mozilla::ipc::LivenessState mLivenessState;
};


} // namespace net
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::PSocketProcessParent>
{
    typedef mozilla::net::PSocketProcessParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#endif // ifndef PSocketProcessParent_h
