/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/. */

// `data` comes from components/style/properties.mako.rs; see build.rs for more details.




use crate::Atom;
use app_units::Au;
use crate::custom_properties::CustomPropertiesMap;
use crate::gecko_bindings::bindings;
use crate::gecko_bindings::structs::nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleBackground;
use crate::gecko_bindings::structs::nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleBorder;
use crate::gecko_bindings::structs::nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleDisplay;
use crate::gecko_bindings::structs::nsStyleColor;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleColor;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleColor;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleColor;
use crate::gecko_bindings::structs::nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleColumn;
use crate::gecko_bindings::structs::nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleContent;
use crate::gecko_bindings::structs::nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleEffects;
use crate::gecko_bindings::structs::nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleFont;
use crate::gecko_bindings::structs::nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleVisibility;
use crate::gecko_bindings::structs::nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTableBorder;
use crate::gecko_bindings::structs::nsStyleText;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleText;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleText;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleText;
use crate::gecko_bindings::structs::nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleUI;
use crate::gecko_bindings::structs::nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleSVG;
use crate::gecko_bindings::structs::nsStyleList;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleList;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleList;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleList;
use crate::gecko_bindings::structs::nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleMargin;
use crate::gecko_bindings::structs::nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleOutline;
use crate::gecko_bindings::structs::nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePadding;
use crate::gecko_bindings::structs::nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePosition;
use crate::gecko_bindings::structs::nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTable;
use crate::gecko_bindings::structs::nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTextReset;
use crate::gecko_bindings::structs::nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleUIReset;
use crate::gecko_bindings::structs::nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleSVGReset;
use crate::gecko_bindings::structs::nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_CopyCounterStyle;
use crate::gecko_bindings::bindings::Gecko_CopyCursorArrayFrom;
use crate::gecko_bindings::bindings::Gecko_CopyFontFamilyFrom;
use crate::gecko_bindings::bindings::Gecko_CopyImageValueFrom;
use crate::gecko_bindings::bindings::Gecko_CopyListStyleImageFrom;
use crate::gecko_bindings::bindings::Gecko_EnsureImageLayersLength;
use crate::gecko_bindings::bindings::Gecko_SetCursorArrayLength;
use crate::gecko_bindings::bindings::Gecko_SetCursorImageValue;
use crate::gecko_bindings::bindings::Gecko_NewCSSShadowArray;
use crate::gecko_bindings::bindings::Gecko_nsStyleFont_SetLang;
use crate::gecko_bindings::bindings::Gecko_nsStyleFont_CopyLangFrom;
use crate::gecko_bindings::bindings::Gecko_SetListStyleImageNone;
use crate::gecko_bindings::bindings::Gecko_SetListStyleImageImageValue;
use crate::gecko_bindings::bindings::Gecko_SetNullImageValue;
use crate::gecko_bindings::bindings::{Gecko_ResetFilters, Gecko_CopyFiltersFrom};
use crate::gecko_bindings::bindings::RawGeckoPresContextBorrowed;
use crate::gecko_bindings::structs;
use crate::gecko_bindings::structs::nsCSSPropertyID;
use crate::gecko_bindings::structs::mozilla::CSSPseudoElementType;
use crate::gecko_bindings::sugar::ns_style_coord::{CoordDataValue, CoordData, CoordDataMut};
use crate::gecko_bindings::sugar::refptr::RefPtr;
use crate::gecko::values::convert_nscolor_to_rgba;
use crate::gecko::values::convert_rgba_to_nscolor;
use crate::gecko::values::GeckoStyleCoordConvertible;
use crate::gecko::values::round_border_to_device_pixels;
use crate::logical_geometry::WritingMode;
use crate::media_queries::Device;
use crate::properties::computed_value_flags::*;
use crate::properties::longhands;
use crate::rule_tree::StrongRuleNode;
use crate::selector_parser::PseudoElement;
use servo_arc::{Arc, RawOffsetArc};
use std::marker::PhantomData;
use std::mem::{forget, uninitialized, transmute, zeroed};
use std::{cmp, ops, ptr};
use crate::values::{self, CustomIdent, Either, KeyframesName, None_};
use crate::values::computed::{NonNegativeLength, Percentage, TransitionProperty};
use crate::values::computed::BorderStyle;
use crate::values::computed::font::FontSize;
use crate::values::computed::effects::{BoxShadow, Filter, SimpleShadow};
use crate::values::generics::column::ColumnCount;
use crate::values::generics::position::ZIndex;
use crate::values::generics::text::MozTabSize;
use crate::values::generics::transform::TransformStyle;
use crate::values::generics::url::UrlOrNone;

pub mod style_structs {
    pub use super::GeckoBackground as Background;
    pub use super::GeckoBorder as Border;
    pub use super::GeckoBox as Box;
    pub use super::GeckoColor as Color;
    pub use super::GeckoColumn as Column;
    pub use super::GeckoCounters as Counters;
    pub use super::GeckoEffects as Effects;
    pub use super::GeckoFont as Font;
    pub use super::GeckoInheritedBox as InheritedBox;
    pub use super::GeckoInheritedTable as InheritedTable;
    pub use super::GeckoInheritedText as InheritedText;
    pub use super::GeckoInheritedUI as InheritedUI;
    pub use super::GeckoInheritedSVG as InheritedSVG;
    pub use super::GeckoList as List;
    pub use super::GeckoMargin as Margin;
    pub use super::GeckoOutline as Outline;
    pub use super::GeckoPadding as Padding;
    pub use super::GeckoPosition as Position;
    pub use super::GeckoTable as Table;
    pub use super::GeckoText as Text;
    pub use super::GeckoUI as UI;
    pub use super::GeckoSVG as SVG;
    pub use super::GeckoXUL as XUL;
}

/// FIXME(emilio): This is completely duplicated with the other properties code.
pub type ComputedValuesInner = crate::gecko_bindings::structs::ServoComputedData;

#[repr(C)]
pub struct ComputedValues(crate::gecko_bindings::structs::mozilla::ComputedStyle);

impl ComputedValues {
    pub fn new(
        device: &Device,
        pseudo: Option<&PseudoElement>,
        custom_properties: Option<Arc<CustomPropertiesMap>>,
        writing_mode: WritingMode,
        flags: ComputedValueFlags,
        rules: Option<StrongRuleNode>,
        visited_style: Option<Arc<ComputedValues>>,
        background: Arc<style_structs::Background>,
        border: Arc<style_structs::Border>,
        box_: Arc<style_structs::Box>,
        color: Arc<style_structs::Color>,
        column: Arc<style_structs::Column>,
        counters: Arc<style_structs::Counters>,
        effects: Arc<style_structs::Effects>,
        font: Arc<style_structs::Font>,
        inherited_box: Arc<style_structs::InheritedBox>,
        inherited_table: Arc<style_structs::InheritedTable>,
        inherited_text: Arc<style_structs::InheritedText>,
        inherited_ui: Arc<style_structs::InheritedUI>,
        inherited_svg: Arc<style_structs::InheritedSVG>,
        list: Arc<style_structs::List>,
        margin: Arc<style_structs::Margin>,
        outline: Arc<style_structs::Outline>,
        padding: Arc<style_structs::Padding>,
        position: Arc<style_structs::Position>,
        table: Arc<style_structs::Table>,
        text: Arc<style_structs::Text>,
        ui: Arc<style_structs::UI>,
        svg: Arc<style_structs::SVG>,
        xul: Arc<style_structs::XUL>,
    ) -> Arc<Self> {
        ComputedValuesInner::new(
            custom_properties,
            writing_mode,
            flags,
            rules,
            visited_style,
            background,
            border,
            box_,
            color,
            column,
            counters,
            effects,
            font,
            inherited_box,
            inherited_table,
            inherited_text,
            inherited_ui,
            inherited_svg,
            list,
            margin,
            outline,
            padding,
            position,
            table,
            text,
            ui,
            svg,
            xul,
        ).to_outer(
            device.pres_context(),
            pseudo.map(|p| p.pseudo_info())
        )
    }

    pub fn default_values(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        ComputedValuesInner::new(
            /* custom_properties = */ None,
            /* writing_mode = */ WritingMode::empty(), // FIXME(bz): This seems dubious
            ComputedValueFlags::empty(),
            /* rules = */ None,
            /* visited_style = */ None,
            style_structs::Background::default(pres_context),
            style_structs::Border::default(pres_context),
            style_structs::Box::default(pres_context),
            style_structs::Color::default(pres_context),
            style_structs::Column::default(pres_context),
            style_structs::Counters::default(pres_context),
            style_structs::Effects::default(pres_context),
            style_structs::Font::default(pres_context),
            style_structs::InheritedBox::default(pres_context),
            style_structs::InheritedTable::default(pres_context),
            style_structs::InheritedText::default(pres_context),
            style_structs::InheritedUI::default(pres_context),
            style_structs::InheritedSVG::default(pres_context),
            style_structs::List::default(pres_context),
            style_structs::Margin::default(pres_context),
            style_structs::Outline::default(pres_context),
            style_structs::Padding::default(pres_context),
            style_structs::Position::default(pres_context),
            style_structs::Table::default(pres_context),
            style_structs::Text::default(pres_context),
            style_structs::UI::default(pres_context),
            style_structs::SVG::default(pres_context),
            style_structs::XUL::default(pres_context),
        ).to_outer(pres_context, None)
    }

    pub fn pseudo(&self) -> Option<PseudoElement> {
        let atom = (self.0).mPseudoTag.mRawPtr;
        if atom.is_null() {
            return None;
        }

        let atom = unsafe { Atom::from_raw(atom) };
        PseudoElement::from_atom(&atom)
    }

    #[inline]
    fn get_pseudo_type(&self) -> CSSPseudoElementType {
        self.0.mPseudoType
    }

    #[inline]
    pub fn is_anon_box(&self) -> bool {
        let our_type = self.get_pseudo_type();
        return our_type == CSSPseudoElementType::InheritingAnonBox ||
               our_type == CSSPseudoElementType::NonInheritingAnonBox;
    }

    /// Returns true if the display property is changed from 'none' to others.
    pub fn is_display_property_changed_from_none(
        &self,
        old_values: Option<&ComputedValues>
    ) -> bool {
        use crate::properties::longhands::display::computed_value::T as Display;

        old_values.map_or(false, |old| {
            let old_display_style = old.get_box().clone_display();
            let new_display_style = self.get_box().clone_display();
            old_display_style == Display::None &&
            new_display_style != Display::None
        })
    }

}

impl Drop for ComputedValues {
    fn drop(&mut self) {
        unsafe {
            bindings::Gecko_ComputedStyle_Destroy(&mut self.0);
        }
    }
}

unsafe impl Sync for ComputedValues {}
unsafe impl Send for ComputedValues {}

impl Clone for ComputedValues {
    fn clone(&self) -> Self {
        unreachable!()
    }
}

impl Clone for ComputedValuesInner {
    fn clone(&self) -> Self {
        ComputedValuesInner {
                Background: self.Background.clone(),
                Border: self.Border.clone(),
                Display: self.Display.clone(),
                Color: self.Color.clone(),
                Column: self.Column.clone(),
                Content: self.Content.clone(),
                Effects: self.Effects.clone(),
                Font: self.Font.clone(),
                Visibility: self.Visibility.clone(),
                TableBorder: self.TableBorder.clone(),
                Text: self.Text.clone(),
                UI: self.UI.clone(),
                SVG: self.SVG.clone(),
                List: self.List.clone(),
                Margin: self.Margin.clone(),
                Outline: self.Outline.clone(),
                Padding: self.Padding.clone(),
                Position: self.Position.clone(),
                Table: self.Table.clone(),
                TextReset: self.TextReset.clone(),
                UIReset: self.UIReset.clone(),
                SVGReset: self.SVGReset.clone(),
                XUL: self.XUL.clone(),
            custom_properties: self.custom_properties.clone(),
            writing_mode: self.writing_mode.clone(),
            flags: self.flags.clone(),
            rules: self.rules.clone(),
            visited_style: self.visited_style.clone(),
        }
    }
}

type PseudoInfo = (*mut structs::nsAtom, structs::CSSPseudoElementType);

impl ComputedValuesInner {
    pub fn new(custom_properties: Option<Arc<CustomPropertiesMap>>,
               writing_mode: WritingMode,
               flags: ComputedValueFlags,
               rules: Option<StrongRuleNode>,
               visited_style: Option<Arc<ComputedValues>>,
               background: Arc<style_structs::Background>,
               border: Arc<style_structs::Border>,
               box_: Arc<style_structs::Box>,
               color: Arc<style_structs::Color>,
               column: Arc<style_structs::Column>,
               counters: Arc<style_structs::Counters>,
               effects: Arc<style_structs::Effects>,
               font: Arc<style_structs::Font>,
               inherited_box: Arc<style_structs::InheritedBox>,
               inherited_table: Arc<style_structs::InheritedTable>,
               inherited_text: Arc<style_structs::InheritedText>,
               inherited_ui: Arc<style_structs::InheritedUI>,
               inherited_svg: Arc<style_structs::InheritedSVG>,
               list: Arc<style_structs::List>,
               margin: Arc<style_structs::Margin>,
               outline: Arc<style_structs::Outline>,
               padding: Arc<style_structs::Padding>,
               position: Arc<style_structs::Position>,
               table: Arc<style_structs::Table>,
               text: Arc<style_structs::Text>,
               ui: Arc<style_structs::UI>,
               svg: Arc<style_structs::SVG>,
               xul: Arc<style_structs::XUL>,
    ) -> Self {
        ComputedValuesInner {
            custom_properties: custom_properties,
            writing_mode: writing_mode,
            rules: rules,
            visited_style: visited_style.map(|x| Arc::into_raw_offset(x)),
            flags: flags,
            Background: Arc::into_raw_offset(background),
            Border: Arc::into_raw_offset(border),
            Display: Arc::into_raw_offset(box_),
            Color: Arc::into_raw_offset(color),
            Column: Arc::into_raw_offset(column),
            Content: Arc::into_raw_offset(counters),
            Effects: Arc::into_raw_offset(effects),
            Font: Arc::into_raw_offset(font),
            Visibility: Arc::into_raw_offset(inherited_box),
            TableBorder: Arc::into_raw_offset(inherited_table),
            Text: Arc::into_raw_offset(inherited_text),
            UI: Arc::into_raw_offset(inherited_ui),
            SVG: Arc::into_raw_offset(inherited_svg),
            List: Arc::into_raw_offset(list),
            Margin: Arc::into_raw_offset(margin),
            Outline: Arc::into_raw_offset(outline),
            Padding: Arc::into_raw_offset(padding),
            Position: Arc::into_raw_offset(position),
            Table: Arc::into_raw_offset(table),
            TextReset: Arc::into_raw_offset(text),
            UIReset: Arc::into_raw_offset(ui),
            SVGReset: Arc::into_raw_offset(svg),
            XUL: Arc::into_raw_offset(xul),
        }
    }

    fn to_outer(
        self,
        pres_context: RawGeckoPresContextBorrowed,
        info: Option<PseudoInfo>
    ) -> Arc<ComputedValues> {
        let (tag, ty) = if let Some(info) = info {
            info
        } else {
            (ptr::null_mut(), structs::CSSPseudoElementType::NotPseudo)
        };

        unsafe { self.to_outer_helper(pres_context, ty, tag) }
    }

    unsafe fn to_outer_helper(
        self,
        pres_context: bindings::RawGeckoPresContextBorrowed,
        pseudo_ty: structs::CSSPseudoElementType,
        pseudo_tag: *mut structs::nsAtom
    ) -> Arc<ComputedValues> {
        let arc = {
            let arc: Arc<ComputedValues> = Arc::new(uninitialized());
            bindings::Gecko_ComputedStyle_Init(
                &arc.0 as *const _ as *mut _,
                pres_context,
                &self,
                pseudo_ty,
                pseudo_tag
            );
            // We're simulating a move by having C++ do a memcpy and then forgetting
            // it on this end.
            forget(self);
            arc
        };
        arc
    }
}

impl ops::Deref for ComputedValues {
    type Target = ComputedValuesInner;
    fn deref(&self) -> &ComputedValuesInner {
        &self.0.mSource
    }
}

impl ops::DerefMut for ComputedValues {
    fn deref_mut(&mut self) -> &mut ComputedValuesInner {
        &mut self.0.mSource
    }
}

impl ComputedValuesInner {
    /// Returns true if the value of the `content` property would make a
    /// pseudo-element not rendered.
    #[inline]
    pub fn ineffective_content_property(&self) -> bool {
        self.get_counters().ineffective_content_property()
    }

    #[inline]
    pub fn clone_background(&self) -> Arc<style_structs::Background> {
        Arc::from_raw_offset(self.Background.clone())
    }
    #[inline]
    pub fn get_background(&self) -> &style_structs::Background {
        &self.Background
    }


    pub fn background_arc(&self) -> &RawOffsetArc<style_structs::Background> {
        &self.Background
    }

    #[inline]
    pub fn mutate_background(&mut self) -> &mut style_structs::Background {
        RawOffsetArc::make_mut(&mut self.Background)
    }
    #[inline]
    pub fn clone_border(&self) -> Arc<style_structs::Border> {
        Arc::from_raw_offset(self.Border.clone())
    }
    #[inline]
    pub fn get_border(&self) -> &style_structs::Border {
        &self.Border
    }


    pub fn border_arc(&self) -> &RawOffsetArc<style_structs::Border> {
        &self.Border
    }

    #[inline]
    pub fn mutate_border(&mut self) -> &mut style_structs::Border {
        RawOffsetArc::make_mut(&mut self.Border)
    }
    #[inline]
    pub fn clone_box(&self) -> Arc<style_structs::Box> {
        Arc::from_raw_offset(self.Display.clone())
    }
    #[inline]
    pub fn get_box(&self) -> &style_structs::Box {
        &self.Display
    }


    pub fn box_arc(&self) -> &RawOffsetArc<style_structs::Box> {
        &self.Display
    }

    #[inline]
    pub fn mutate_box(&mut self) -> &mut style_structs::Box {
        RawOffsetArc::make_mut(&mut self.Display)
    }
    #[inline]
    pub fn clone_color(&self) -> Arc<style_structs::Color> {
        Arc::from_raw_offset(self.Color.clone())
    }
    #[inline]
    pub fn get_color(&self) -> &style_structs::Color {
        &self.Color
    }


    pub fn color_arc(&self) -> &RawOffsetArc<style_structs::Color> {
        &self.Color
    }

    #[inline]
    pub fn mutate_color(&mut self) -> &mut style_structs::Color {
        RawOffsetArc::make_mut(&mut self.Color)
    }
    #[inline]
    pub fn clone_column(&self) -> Arc<style_structs::Column> {
        Arc::from_raw_offset(self.Column.clone())
    }
    #[inline]
    pub fn get_column(&self) -> &style_structs::Column {
        &self.Column
    }


    pub fn column_arc(&self) -> &RawOffsetArc<style_structs::Column> {
        &self.Column
    }

    #[inline]
    pub fn mutate_column(&mut self) -> &mut style_structs::Column {
        RawOffsetArc::make_mut(&mut self.Column)
    }
    #[inline]
    pub fn clone_counters(&self) -> Arc<style_structs::Counters> {
        Arc::from_raw_offset(self.Content.clone())
    }
    #[inline]
    pub fn get_counters(&self) -> &style_structs::Counters {
        &self.Content
    }


    pub fn counters_arc(&self) -> &RawOffsetArc<style_structs::Counters> {
        &self.Content
    }

    #[inline]
    pub fn mutate_counters(&mut self) -> &mut style_structs::Counters {
        RawOffsetArc::make_mut(&mut self.Content)
    }
    #[inline]
    pub fn clone_effects(&self) -> Arc<style_structs::Effects> {
        Arc::from_raw_offset(self.Effects.clone())
    }
    #[inline]
    pub fn get_effects(&self) -> &style_structs::Effects {
        &self.Effects
    }


    pub fn effects_arc(&self) -> &RawOffsetArc<style_structs::Effects> {
        &self.Effects
    }

    #[inline]
    pub fn mutate_effects(&mut self) -> &mut style_structs::Effects {
        RawOffsetArc::make_mut(&mut self.Effects)
    }
    #[inline]
    pub fn clone_font(&self) -> Arc<style_structs::Font> {
        Arc::from_raw_offset(self.Font.clone())
    }
    #[inline]
    pub fn get_font(&self) -> &style_structs::Font {
        &self.Font
    }


    pub fn font_arc(&self) -> &RawOffsetArc<style_structs::Font> {
        &self.Font
    }

    #[inline]
    pub fn mutate_font(&mut self) -> &mut style_structs::Font {
        RawOffsetArc::make_mut(&mut self.Font)
    }
    #[inline]
    pub fn clone_inherited_box(&self) -> Arc<style_structs::InheritedBox> {
        Arc::from_raw_offset(self.Visibility.clone())
    }
    #[inline]
    pub fn get_inherited_box(&self) -> &style_structs::InheritedBox {
        &self.Visibility
    }


    pub fn inherited_box_arc(&self) -> &RawOffsetArc<style_structs::InheritedBox> {
        &self.Visibility
    }

    #[inline]
    pub fn mutate_inherited_box(&mut self) -> &mut style_structs::InheritedBox {
        RawOffsetArc::make_mut(&mut self.Visibility)
    }
    #[inline]
    pub fn clone_inherited_table(&self) -> Arc<style_structs::InheritedTable> {
        Arc::from_raw_offset(self.TableBorder.clone())
    }
    #[inline]
    pub fn get_inherited_table(&self) -> &style_structs::InheritedTable {
        &self.TableBorder
    }


    pub fn inherited_table_arc(&self) -> &RawOffsetArc<style_structs::InheritedTable> {
        &self.TableBorder
    }

    #[inline]
    pub fn mutate_inherited_table(&mut self) -> &mut style_structs::InheritedTable {
        RawOffsetArc::make_mut(&mut self.TableBorder)
    }
    #[inline]
    pub fn clone_inherited_text(&self) -> Arc<style_structs::InheritedText> {
        Arc::from_raw_offset(self.Text.clone())
    }
    #[inline]
    pub fn get_inherited_text(&self) -> &style_structs::InheritedText {
        &self.Text
    }


    pub fn inherited_text_arc(&self) -> &RawOffsetArc<style_structs::InheritedText> {
        &self.Text
    }

    #[inline]
    pub fn mutate_inherited_text(&mut self) -> &mut style_structs::InheritedText {
        RawOffsetArc::make_mut(&mut self.Text)
    }
    #[inline]
    pub fn clone_inherited_ui(&self) -> Arc<style_structs::InheritedUI> {
        Arc::from_raw_offset(self.UI.clone())
    }
    #[inline]
    pub fn get_inherited_ui(&self) -> &style_structs::InheritedUI {
        &self.UI
    }


    pub fn inherited_ui_arc(&self) -> &RawOffsetArc<style_structs::InheritedUI> {
        &self.UI
    }

    #[inline]
    pub fn mutate_inherited_ui(&mut self) -> &mut style_structs::InheritedUI {
        RawOffsetArc::make_mut(&mut self.UI)
    }
    #[inline]
    pub fn clone_inherited_svg(&self) -> Arc<style_structs::InheritedSVG> {
        Arc::from_raw_offset(self.SVG.clone())
    }
    #[inline]
    pub fn get_inherited_svg(&self) -> &style_structs::InheritedSVG {
        &self.SVG
    }


    pub fn inherited_svg_arc(&self) -> &RawOffsetArc<style_structs::InheritedSVG> {
        &self.SVG
    }

    #[inline]
    pub fn mutate_inherited_svg(&mut self) -> &mut style_structs::InheritedSVG {
        RawOffsetArc::make_mut(&mut self.SVG)
    }
    #[inline]
    pub fn clone_list(&self) -> Arc<style_structs::List> {
        Arc::from_raw_offset(self.List.clone())
    }
    #[inline]
    pub fn get_list(&self) -> &style_structs::List {
        &self.List
    }


    pub fn list_arc(&self) -> &RawOffsetArc<style_structs::List> {
        &self.List
    }

    #[inline]
    pub fn mutate_list(&mut self) -> &mut style_structs::List {
        RawOffsetArc::make_mut(&mut self.List)
    }
    #[inline]
    pub fn clone_margin(&self) -> Arc<style_structs::Margin> {
        Arc::from_raw_offset(self.Margin.clone())
    }
    #[inline]
    pub fn get_margin(&self) -> &style_structs::Margin {
        &self.Margin
    }


    pub fn margin_arc(&self) -> &RawOffsetArc<style_structs::Margin> {
        &self.Margin
    }

    #[inline]
    pub fn mutate_margin(&mut self) -> &mut style_structs::Margin {
        RawOffsetArc::make_mut(&mut self.Margin)
    }
    #[inline]
    pub fn clone_outline(&self) -> Arc<style_structs::Outline> {
        Arc::from_raw_offset(self.Outline.clone())
    }
    #[inline]
    pub fn get_outline(&self) -> &style_structs::Outline {
        &self.Outline
    }


    pub fn outline_arc(&self) -> &RawOffsetArc<style_structs::Outline> {
        &self.Outline
    }

    #[inline]
    pub fn mutate_outline(&mut self) -> &mut style_structs::Outline {
        RawOffsetArc::make_mut(&mut self.Outline)
    }
    #[inline]
    pub fn clone_padding(&self) -> Arc<style_structs::Padding> {
        Arc::from_raw_offset(self.Padding.clone())
    }
    #[inline]
    pub fn get_padding(&self) -> &style_structs::Padding {
        &self.Padding
    }


    pub fn padding_arc(&self) -> &RawOffsetArc<style_structs::Padding> {
        &self.Padding
    }

    #[inline]
    pub fn mutate_padding(&mut self) -> &mut style_structs::Padding {
        RawOffsetArc::make_mut(&mut self.Padding)
    }
    #[inline]
    pub fn clone_position(&self) -> Arc<style_structs::Position> {
        Arc::from_raw_offset(self.Position.clone())
    }
    #[inline]
    pub fn get_position(&self) -> &style_structs::Position {
        &self.Position
    }


    pub fn position_arc(&self) -> &RawOffsetArc<style_structs::Position> {
        &self.Position
    }

    #[inline]
    pub fn mutate_position(&mut self) -> &mut style_structs::Position {
        RawOffsetArc::make_mut(&mut self.Position)
    }
    #[inline]
    pub fn clone_table(&self) -> Arc<style_structs::Table> {
        Arc::from_raw_offset(self.Table.clone())
    }
    #[inline]
    pub fn get_table(&self) -> &style_structs::Table {
        &self.Table
    }


    pub fn table_arc(&self) -> &RawOffsetArc<style_structs::Table> {
        &self.Table
    }

    #[inline]
    pub fn mutate_table(&mut self) -> &mut style_structs::Table {
        RawOffsetArc::make_mut(&mut self.Table)
    }
    #[inline]
    pub fn clone_text(&self) -> Arc<style_structs::Text> {
        Arc::from_raw_offset(self.TextReset.clone())
    }
    #[inline]
    pub fn get_text(&self) -> &style_structs::Text {
        &self.TextReset
    }


    pub fn text_arc(&self) -> &RawOffsetArc<style_structs::Text> {
        &self.TextReset
    }

    #[inline]
    pub fn mutate_text(&mut self) -> &mut style_structs::Text {
        RawOffsetArc::make_mut(&mut self.TextReset)
    }
    #[inline]
    pub fn clone_ui(&self) -> Arc<style_structs::UI> {
        Arc::from_raw_offset(self.UIReset.clone())
    }
    #[inline]
    pub fn get_ui(&self) -> &style_structs::UI {
        &self.UIReset
    }


    pub fn ui_arc(&self) -> &RawOffsetArc<style_structs::UI> {
        &self.UIReset
    }

    #[inline]
    pub fn mutate_ui(&mut self) -> &mut style_structs::UI {
        RawOffsetArc::make_mut(&mut self.UIReset)
    }
    #[inline]
    pub fn clone_svg(&self) -> Arc<style_structs::SVG> {
        Arc::from_raw_offset(self.SVGReset.clone())
    }
    #[inline]
    pub fn get_svg(&self) -> &style_structs::SVG {
        &self.SVGReset
    }


    pub fn svg_arc(&self) -> &RawOffsetArc<style_structs::SVG> {
        &self.SVGReset
    }

    #[inline]
    pub fn mutate_svg(&mut self) -> &mut style_structs::SVG {
        RawOffsetArc::make_mut(&mut self.SVGReset)
    }
    #[inline]
    pub fn clone_xul(&self) -> Arc<style_structs::XUL> {
        Arc::from_raw_offset(self.XUL.clone())
    }
    #[inline]
    pub fn get_xul(&self) -> &style_structs::XUL {
        &self.XUL
    }


    pub fn xul_arc(&self) -> &RawOffsetArc<style_structs::XUL> {
        &self.XUL
    }

    #[inline]
    pub fn mutate_xul(&mut self) -> &mut style_structs::XUL {
        RawOffsetArc::make_mut(&mut self.XUL)
    }

    /// Gets the raw visited style. Useful for memory reporting.
    pub fn get_raw_visited_style(&self) -> &Option<RawOffsetArc<ComputedValues>> {
        &self.visited_style
    }

    #[allow(non_snake_case)]
    pub fn has_moz_binding(&self) -> bool {
        !self.get_box().gecko.mBinding.mRawPtr.is_null()
    }
}





























































fn set_single_transform_function(
    servo_value: &values::computed::TransformOperation,
    gecko_value: &mut structs::nsCSSValue /* output */
) {
    use crate::values::computed::TransformOperation;
    use crate::values::generics::transform::{Matrix, Matrix3D};

    let convert_to_ns_css_value = |item: &TransformOperation| -> structs::nsCSSValue {
        let mut value = structs::nsCSSValue::null();
        set_single_transform_function(item, &mut value);
        value
    };

    unsafe {
        match *servo_value {
                
    
    crate::values::generics::transform::TransformOperation::Matrix3D(Matrix3D { m11: number1, m12: number2, m13: number3, m14: number4, m21: number5, m22: number6, m23: number7, m24: number8, m31: number9, m32: number10, m33: number11, m34: number12, m41: number13, m42: number14, m43: number15, m44: number16 }) => {
            let len = 17;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_matrix3d
        );
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), number1);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2), number2);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 3), number3);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 4), number4);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 5), number5);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 6), number6);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 7), number7);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 8), number8);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 9), number9);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 10), number10);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 11), number11);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 12), number12);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 13), number13);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 14), number14);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 15), number15);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 16), number16);
    }

                
    
    crate::values::generics::transform::TransformOperation::Matrix(Matrix { a: number1, b: number2, c: number3, d: number4, e: number5, f: number6 }) => {
            let len = 7;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_matrix
        );
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), number1);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2), number2);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 3), number3);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 4), number4);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 5), number5);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 6), number6);
    }

                
    
    crate::values::generics::transform::TransformOperation::Translate(lp1, optional_lp2) => {
            let optional_present = optional_lp2.is_some();
            let len = if optional_present {
                3
            } else {
                2
            };
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_translate
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_length_percentage(lp1);
            
                if let Some(lp2) = optional_lp2 {
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2).set_length_percentage(lp2);
                }
    }

                
    
    crate::values::generics::transform::TransformOperation::Translate3D(lp1, lp2, length3) => {
            let len = 4;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_translate3d
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_length_percentage(lp1);
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2).set_length_percentage(lp2);
            
            bindings::Gecko_CSSValue_SetPixelLength(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 3), length3.px());
    }

                
    
    crate::values::generics::transform::TransformOperation::TranslateX(lp1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_translatex
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_length_percentage(lp1);
    }

                
    
    crate::values::generics::transform::TransformOperation::TranslateY(lp1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_translatey
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_length_percentage(lp1);
    }

                
    
    crate::values::generics::transform::TransformOperation::TranslateZ(length1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_translatez
        );
            
            bindings::Gecko_CSSValue_SetPixelLength(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), length1.px());
    }

                
    
    crate::values::generics::transform::TransformOperation::Scale3D(number1, number2, number3) => {
            let len = 4;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_scale3d
        );
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), number1);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2), number2);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 3), number3);
    }

                
    
    crate::values::generics::transform::TransformOperation::Scale(number1, optional_number2) => {
            let optional_present = optional_number2.is_some();
            let len = if optional_present {
                3
            } else {
                2
            };
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_scale
        );
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), number1);
            
                if let Some(number2) = optional_number2 {
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2), number2);
                }
    }

                
    
    crate::values::generics::transform::TransformOperation::ScaleX(number1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_scalex
        );
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), number1);
    }

                
    
    crate::values::generics::transform::TransformOperation::ScaleY(number1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_scaley
        );
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), number1);
    }

                
    
    crate::values::generics::transform::TransformOperation::ScaleZ(number1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_scalez
        );
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), number1);
    }

                
    
    crate::values::generics::transform::TransformOperation::Rotate(angle1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_rotate
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_angle(angle1);
    }

                
    
    crate::values::generics::transform::TransformOperation::Rotate3D(number1, number2, number3, angle4) => {
            let len = 5;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_rotate3d
        );
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), number1);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2), number2);
            
            bindings::Gecko_CSSValue_SetNumber(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 3), number3);
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 4).set_angle(angle4);
    }

                
    
    crate::values::generics::transform::TransformOperation::RotateX(angle1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_rotatex
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_angle(angle1);
    }

                
    
    crate::values::generics::transform::TransformOperation::RotateY(angle1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_rotatey
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_angle(angle1);
    }

                
    
    crate::values::generics::transform::TransformOperation::RotateZ(angle1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_rotatez
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_angle(angle1);
    }

                
    
    crate::values::generics::transform::TransformOperation::Skew(angle1, optional_angle2) => {
            let optional_present = optional_angle2.is_some();
            let len = if optional_present {
                3
            } else {
                2
            };
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_skew
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_angle(angle1);
            
                if let Some(angle2) = optional_angle2 {
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2).set_angle(angle2);
                }
    }

                
    
    crate::values::generics::transform::TransformOperation::SkewX(angle1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_skewx
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_angle(angle1);
    }

                
    
    crate::values::generics::transform::TransformOperation::SkewY(angle1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_skewy
        );
            
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_angle(angle1);
    }

                
    
    crate::values::generics::transform::TransformOperation::Perspective(length1) => {
            let len = 2;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_perspective
        );
            
            bindings::Gecko_CSSValue_SetPixelLength(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1), length1.px());
    }

                
    
    crate::values::generics::transform::TransformOperation::InterpolateMatrix { from_list: ref list1, to_list: ref list2, progress: percentage3 } => {
            let len = 4;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_interpolatematrix
        );
            
                debug_assert!(!list1.0.is_empty());
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_shared_list(list1.0.iter().map(&convert_to_ns_css_value));;
            
                debug_assert!(!list2.0.is_empty());
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2).set_shared_list(list2.0.iter().map(&convert_to_ns_css_value));;
            
            bindings::Gecko_CSSValue_SetPercentage(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 3), percentage3.0);
    }

                
    
    crate::values::generics::transform::TransformOperation::AccumulateMatrix { from_list: ref list1, to_list: ref list2, count: integer_to_percentage3 } => {
            let len = 4;
        bindings::Gecko_CSSValue_SetFunction(gecko_value, len);
        bindings::Gecko_CSSValue_SetKeyword(
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 0),
            structs::nsCSSKeyword::eCSSKeyword_accumulatematrix
        );
            
                debug_assert!(!list1.0.is_empty());
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 1).set_shared_list(list1.0.iter().map(&convert_to_ns_css_value));;
            
                debug_assert!(!list2.0.is_empty());
            bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 2).set_shared_list(list2.0.iter().map(&convert_to_ns_css_value));;
            
            bindings::Gecko_CSSValue_SetPercentage(bindings::Gecko_CSSValue_GetArrayItem(gecko_value, 3), integer_to_percentage3 as f32);
    }

        }
    }
}

pub fn convert_transform(
    input: &[values::computed::TransformOperation],
    output: &mut structs::root::RefPtr<structs::root::nsCSSValueSharedList>
) {
    use crate::gecko_bindings::sugar::refptr::RefPtr;

    unsafe { output.clear() };

    let list = unsafe {
        RefPtr::from_addrefed(bindings::Gecko_NewCSSValueSharedList(input.len() as u32))
    };
    let value_list = unsafe { list.mHead.as_mut() };
    if let Some(value_list) = value_list {
        for (gecko, servo) in value_list.into_iter().zip(input.into_iter()) {
            set_single_transform_function(servo, gecko);
        }
    }
    output.set_move(list);
}

fn clone_single_transform_function(
    gecko_value: &structs::nsCSSValue
) -> values::computed::TransformOperation {
    use crate::values::computed::{Length, Percentage, TransformOperation};
    use crate::values::generics::transform::{Matrix, Matrix3D};
    use crate::values::generics::transform::Transform;

    let convert_shared_list_to_operations = |value: &structs::nsCSSValue|
                                            -> Vec<TransformOperation> {
        debug_assert_eq!(value.mUnit, structs::nsCSSUnit::eCSSUnit_SharedList);
        let value_list = unsafe {
            value.mValue.mSharedList.as_ref()
                    .as_mut().expect("List pointer should be non-null").mHead.as_ref()
        };
        debug_assert!(value_list.is_some(), "An empty shared list is not allowed");
        value_list.unwrap().into_iter()
                            .map(|item| clone_single_transform_function(item))
                            .collect()
    };

    let transform_function = unsafe {
        bindings::Gecko_CSSValue_GetKeyword(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 0))
    };

    unsafe {
        match transform_function {
                
    
    structs::nsCSSKeyword::eCSSKeyword_matrix3d => {
        crate::values::generics::transform::TransformOperation::Matrix3D(Matrix3D {
                m11:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1))
,
                m12:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2))
,
                m13:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 3))
,
                m14:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 4))
,
                m21:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 5))
,
                m22:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 6))
,
                m23:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 7))
,
                m24:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 8))
,
                m31:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 9))
,
                m32:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 10))
,
                m33:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 11))
,
                m34:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 12))
,
                m41:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 13))
,
                m42:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 14))
,
                m43:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 15))
,
                m44:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 16))
,
        })
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_matrix => {
        crate::values::generics::transform::TransformOperation::Matrix(Matrix {
                a:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1))
,
                b:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2))
,
                c:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 3))
,
                d:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 4))
,
                e:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 5))
,
                f:
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 6))
,
        })
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_translate => {
        crate::values::generics::transform::TransformOperation::Translate(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_length_percentage()
,
            
                if (**gecko_value.mValue.mArray.as_ref()).mCount == 2 {
                    None
                } else {
                    Some(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2).get_length_percentage())
                }
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_translate3d => {
        crate::values::generics::transform::TransformOperation::Translate3D(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_length_percentage()
,
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2).get_length_percentage()
,
            
                Length::new(bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 3)))
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_translatex => {
        crate::values::generics::transform::TransformOperation::TranslateX(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_length_percentage()
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_translatey => {
        crate::values::generics::transform::TransformOperation::TranslateY(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_length_percentage()
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_translatez => {
        crate::values::generics::transform::TransformOperation::TranslateZ(
            
                Length::new(bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1)))
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_scale3d => {
        crate::values::generics::transform::TransformOperation::Scale3D(
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1))
,
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2))
,
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 3))
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_scale => {
        crate::values::generics::transform::TransformOperation::Scale(
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1))
,
            
                if (**gecko_value.mValue.mArray.as_ref()).mCount == 2 {
                    None
                } else {
                    Some(bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2)))
                }
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_scalex => {
        crate::values::generics::transform::TransformOperation::ScaleX(
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1))
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_scaley => {
        crate::values::generics::transform::TransformOperation::ScaleY(
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1))
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_scalez => {
        crate::values::generics::transform::TransformOperation::ScaleZ(
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1))
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_rotate => {
        crate::values::generics::transform::TransformOperation::Rotate(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_angle()
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_rotate3d => {
        crate::values::generics::transform::TransformOperation::Rotate3D(
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1))
,
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2))
,
            
                bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 3))
,
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 4).get_angle()
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_rotatex => {
        crate::values::generics::transform::TransformOperation::RotateX(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_angle()
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_rotatey => {
        crate::values::generics::transform::TransformOperation::RotateY(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_angle()
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_rotatez => {
        crate::values::generics::transform::TransformOperation::RotateZ(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_angle()
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_skew => {
        crate::values::generics::transform::TransformOperation::Skew(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_angle()
,
            
                if (**gecko_value.mValue.mArray.as_ref()).mCount == 2 {
                    None
                } else {
                    Some(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2).get_angle())
                }
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_skewx => {
        crate::values::generics::transform::TransformOperation::SkewX(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_angle()
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_skewy => {
        crate::values::generics::transform::TransformOperation::SkewY(
            
                bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1).get_angle()
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_perspective => {
        crate::values::generics::transform::TransformOperation::Perspective(
            
                Length::new(bindings::Gecko_CSSValue_GetNumber(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1)))
,
        )
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_interpolatematrix => {
        crate::values::generics::transform::TransformOperation::InterpolateMatrix {
                from_list:
            
                Transform(convert_shared_list_to_operations(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1)))
,
                to_list:
            
                Transform(convert_shared_list_to_operations(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2)))
,
                progress:
            
                Percentage(bindings::Gecko_CSSValue_GetPercentage(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 3)))
,
        }
    },

                
    
    structs::nsCSSKeyword::eCSSKeyword_accumulatematrix => {
        crate::values::generics::transform::TransformOperation::AccumulateMatrix {
                from_list:
            
                Transform(convert_shared_list_to_operations(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 1)))
,
                to_list:
            
                Transform(convert_shared_list_to_operations(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 2)))
,
                count:
            
                bindings::Gecko_CSSValue_GetPercentage(bindings::Gecko_CSSValue_GetArrayItemConst(gecko_value, 3)) as i32
,
        }
    },

            _ => panic!("unacceptable transform function"),
        }
    }
}

pub fn clone_transform_from_list(
    list: Option< &structs::root::nsCSSValueList>
) -> values::computed::Transform {
    use crate::values::generics::transform::Transform;

    let result = match list {
        Some(list) => {
            list.into_iter()
                .filter_map(|value| {
                    // Handle none transform.
                    if value.is_none() {
                        None
                    } else {
                        Some(clone_single_transform_function(value))
                    }
                })
                .collect::<Vec<_>>()
        },
        _ => vec![],
    };
    Transform(result)
}

















#[allow(dead_code)]
fn static_assert() {
    unsafe {
        transmute::<_, [u32; 0]>([1; structs::HalfCorner::eCornerTopLeftX as usize]);
        transmute::<_, [u32; 1]>([1; structs::HalfCorner::eCornerTopLeftY as usize]);
        transmute::<_, [u32; 2]>([1; structs::HalfCorner::eCornerTopRightX as usize]);
        transmute::<_, [u32; 3]>([1; structs::HalfCorner::eCornerTopRightY as usize]);
        transmute::<_, [u32; 4]>([1; structs::HalfCorner::eCornerBottomRightX as usize]);
        transmute::<_, [u32; 5]>([1; structs::HalfCorner::eCornerBottomRightY as usize]);
        transmute::<_, [u32; 6]>([1; structs::HalfCorner::eCornerBottomLeftX as usize]);
        transmute::<_, [u32; 7]>([1; structs::HalfCorner::eCornerBottomLeftY as usize]);
    }
    // Note: using the above technique with an enum hits a rust bug when |structs| is in a different crate.
    { const DETAIL: u32 = [0][(structs::Side::eSideTop as usize != 0) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideRight as usize != 1) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideBottom as usize != 2) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideLeft as usize != 3) as usize]; let _ = DETAIL; }
}






impl GeckoBorder {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_border_top_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[0] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.top = self.gecko.mBorder.top;
    }

    pub fn copy_border_top_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[0] = other.gecko.mBorderStyle[0];
        self.gecko.mComputedBorder.top = self.gecko.mBorder.top;
    }

    pub fn reset_border_top_style(&mut self, other: &Self) {
        self.copy_border_top_style_from(other);
    }

    #[inline]
    pub fn clone_border_top_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[0]
    }

    

    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_border_top_color(&mut self, v: longhands::border_top_color::computed_value::T) {
        self.gecko.mBorderTopColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_border_top_color_from(&mut self, other: &Self) {
        let color = other.gecko.mBorderTopColor;
        self.gecko.mBorderTopColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_top_color(&mut self, other: &Self) {
        self.copy_border_top_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_top_color(&self) -> longhands::border_top_color::computed_value::T {
        self.gecko.mBorderTopColor.into()
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_top_width(&mut self, v: longhands::border_top_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.top = value;
        self.gecko.mComputedBorder.top = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_top_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.top = other.gecko.mBorder.top;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.top = other.gecko.mBorder.top;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_top_width(&mut self, other: &Self) {
        self.copy_border_top_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_top_width(&self) -> longhands::border_top_width::computed_value::T {
        Au(self.gecko.mComputedBorder.top).into()
    }


    pub fn border_top_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.top != 0
    }
    pub fn set_border_right_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[1] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.right = self.gecko.mBorder.right;
    }

    pub fn copy_border_right_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[1] = other.gecko.mBorderStyle[1];
        self.gecko.mComputedBorder.right = self.gecko.mBorder.right;
    }

    pub fn reset_border_right_style(&mut self, other: &Self) {
        self.copy_border_right_style_from(other);
    }

    #[inline]
    pub fn clone_border_right_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[1]
    }

    

    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_border_right_color(&mut self, v: longhands::border_right_color::computed_value::T) {
        self.gecko.mBorderRightColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_border_right_color_from(&mut self, other: &Self) {
        let color = other.gecko.mBorderRightColor;
        self.gecko.mBorderRightColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_right_color(&mut self, other: &Self) {
        self.copy_border_right_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_right_color(&self) -> longhands::border_right_color::computed_value::T {
        self.gecko.mBorderRightColor.into()
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_right_width(&mut self, v: longhands::border_right_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.right = value;
        self.gecko.mComputedBorder.right = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_right_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.right = other.gecko.mBorder.right;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.right = other.gecko.mBorder.right;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_right_width(&mut self, other: &Self) {
        self.copy_border_right_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_right_width(&self) -> longhands::border_right_width::computed_value::T {
        Au(self.gecko.mComputedBorder.right).into()
    }


    pub fn border_right_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.right != 0
    }
    pub fn set_border_bottom_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[2] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.bottom = self.gecko.mBorder.bottom;
    }

    pub fn copy_border_bottom_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[2] = other.gecko.mBorderStyle[2];
        self.gecko.mComputedBorder.bottom = self.gecko.mBorder.bottom;
    }

    pub fn reset_border_bottom_style(&mut self, other: &Self) {
        self.copy_border_bottom_style_from(other);
    }

    #[inline]
    pub fn clone_border_bottom_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[2]
    }

    

    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_border_bottom_color(&mut self, v: longhands::border_bottom_color::computed_value::T) {
        self.gecko.mBorderBottomColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_border_bottom_color_from(&mut self, other: &Self) {
        let color = other.gecko.mBorderBottomColor;
        self.gecko.mBorderBottomColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_bottom_color(&mut self, other: &Self) {
        self.copy_border_bottom_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_bottom_color(&self) -> longhands::border_bottom_color::computed_value::T {
        self.gecko.mBorderBottomColor.into()
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_width(&mut self, v: longhands::border_bottom_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.bottom = value;
        self.gecko.mComputedBorder.bottom = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_bottom_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.bottom = other.gecko.mBorder.bottom;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.bottom = other.gecko.mBorder.bottom;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_bottom_width(&mut self, other: &Self) {
        self.copy_border_bottom_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_bottom_width(&self) -> longhands::border_bottom_width::computed_value::T {
        Au(self.gecko.mComputedBorder.bottom).into()
    }


    pub fn border_bottom_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.bottom != 0
    }
    pub fn set_border_left_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[3] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.left = self.gecko.mBorder.left;
    }

    pub fn copy_border_left_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[3] = other.gecko.mBorderStyle[3];
        self.gecko.mComputedBorder.left = self.gecko.mBorder.left;
    }

    pub fn reset_border_left_style(&mut self, other: &Self) {
        self.copy_border_left_style_from(other);
    }

    #[inline]
    pub fn clone_border_left_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[3]
    }

    

    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_border_left_color(&mut self, v: longhands::border_left_color::computed_value::T) {
        self.gecko.mBorderLeftColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_border_left_color_from(&mut self, other: &Self) {
        let color = other.gecko.mBorderLeftColor;
        self.gecko.mBorderLeftColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_left_color(&mut self, other: &Self) {
        self.copy_border_left_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_left_color(&self) -> longhands::border_left_color::computed_value::T {
        self.gecko.mBorderLeftColor.into()
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_left_width(&mut self, v: longhands::border_left_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.left = value;
        self.gecko.mComputedBorder.left = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_left_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.left = other.gecko.mBorder.left;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.left = other.gecko.mBorder.left;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_left_width(&mut self, other: &Self) {
        self.copy_border_left_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_left_width(&self) -> longhands::border_left_width::computed_value::T {
        Au(self.gecko.mComputedBorder.left).into()
    }


    pub fn border_left_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.left != 0
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_top_left_radius(&mut self, v: longhands::border_top_left_radius::computed_value::T) {
        v.0.width().to_gecko_style_coord(&mut self.gecko.mBorderRadius.data_at_mut(0));
        v.0.height().to_gecko_style_coord(&mut self.gecko.mBorderRadius.data_at_mut(1));
    }
    #[allow(non_snake_case)]
    pub fn copy_border_top_left_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.data_at_mut(0)
                  .copy_from(&other.gecko.mBorderRadius.data_at(0));
        self.gecko.mBorderRadius.data_at_mut(1)
                  .copy_from(&other.gecko.mBorderRadius.data_at(1));
    }
    #[allow(non_snake_case)]
    pub fn reset_border_top_left_radius(&mut self, other: &Self) {
        self.copy_border_top_left_radius_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_top_left_radius(&self) -> longhands::border_top_left_radius::computed_value::T {
        use crate::values::computed::border::BorderCornerRadius;
        let width = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mBorderRadius.data_at(0))
                        .expect("Failed to clone border_top_left_radius");
        let height = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mBorderRadius.data_at(1))
                        .expect("Failed to clone border_top_left_radius");
        BorderCornerRadius::new(width, height)
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_top_right_radius(&mut self, v: longhands::border_top_right_radius::computed_value::T) {
        v.0.width().to_gecko_style_coord(&mut self.gecko.mBorderRadius.data_at_mut(2));
        v.0.height().to_gecko_style_coord(&mut self.gecko.mBorderRadius.data_at_mut(3));
    }
    #[allow(non_snake_case)]
    pub fn copy_border_top_right_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.data_at_mut(2)
                  .copy_from(&other.gecko.mBorderRadius.data_at(2));
        self.gecko.mBorderRadius.data_at_mut(3)
                  .copy_from(&other.gecko.mBorderRadius.data_at(3));
    }
    #[allow(non_snake_case)]
    pub fn reset_border_top_right_radius(&mut self, other: &Self) {
        self.copy_border_top_right_radius_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_top_right_radius(&self) -> longhands::border_top_right_radius::computed_value::T {
        use crate::values::computed::border::BorderCornerRadius;
        let width = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mBorderRadius.data_at(2))
                        .expect("Failed to clone border_top_right_radius");
        let height = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mBorderRadius.data_at(3))
                        .expect("Failed to clone border_top_right_radius");
        BorderCornerRadius::new(width, height)
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_right_radius(&mut self, v: longhands::border_bottom_right_radius::computed_value::T) {
        v.0.width().to_gecko_style_coord(&mut self.gecko.mBorderRadius.data_at_mut(4));
        v.0.height().to_gecko_style_coord(&mut self.gecko.mBorderRadius.data_at_mut(5));
    }
    #[allow(non_snake_case)]
    pub fn copy_border_bottom_right_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.data_at_mut(4)
                  .copy_from(&other.gecko.mBorderRadius.data_at(4));
        self.gecko.mBorderRadius.data_at_mut(5)
                  .copy_from(&other.gecko.mBorderRadius.data_at(5));
    }
    #[allow(non_snake_case)]
    pub fn reset_border_bottom_right_radius(&mut self, other: &Self) {
        self.copy_border_bottom_right_radius_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_bottom_right_radius(&self) -> longhands::border_bottom_right_radius::computed_value::T {
        use crate::values::computed::border::BorderCornerRadius;
        let width = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mBorderRadius.data_at(4))
                        .expect("Failed to clone border_bottom_right_radius");
        let height = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mBorderRadius.data_at(5))
                        .expect("Failed to clone border_bottom_right_radius");
        BorderCornerRadius::new(width, height)
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_left_radius(&mut self, v: longhands::border_bottom_left_radius::computed_value::T) {
        v.0.width().to_gecko_style_coord(&mut self.gecko.mBorderRadius.data_at_mut(6));
        v.0.height().to_gecko_style_coord(&mut self.gecko.mBorderRadius.data_at_mut(7));
    }
    #[allow(non_snake_case)]
    pub fn copy_border_bottom_left_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.data_at_mut(6)
                  .copy_from(&other.gecko.mBorderRadius.data_at(6));
        self.gecko.mBorderRadius.data_at_mut(7)
                  .copy_from(&other.gecko.mBorderRadius.data_at(7));
    }
    #[allow(non_snake_case)]
    pub fn reset_border_bottom_left_radius(&mut self, other: &Self) {
        self.copy_border_bottom_left_radius_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_bottom_left_radius(&self) -> longhands::border_bottom_left_radius::computed_value::T {
        use crate::values::computed::border::BorderCornerRadius;
        let width = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mBorderRadius.data_at(6))
                        .expect("Failed to clone border_bottom_left_radius");
        let height = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mBorderRadius.data_at(7))
                        .expect("Failed to clone border_bottom_left_radius");
        BorderCornerRadius::new(width, height)
    }


    pub fn set_border_image_source(&mut self, image: longhands::border_image_source::computed_value::T) {
        unsafe {
            // Prevent leaking of the last elements we did set
            Gecko_SetNullImageValue(&mut self.gecko.mBorderImageSource);
        }

        if let Either::Second(image) = image {
            self.gecko.mBorderImageSource.set(image);
        }
    }

    pub fn copy_border_image_source_from(&mut self, other: &Self) {
        unsafe {
            Gecko_CopyImageValueFrom(&mut self.gecko.mBorderImageSource,
                                     &other.gecko.mBorderImageSource);
        }
    }

    pub fn reset_border_image_source(&mut self, other: &Self) {
        self.copy_border_image_source_from(other)
    }

    pub fn clone_border_image_source(&self) -> longhands::border_image_source::computed_value::T {
        use crate::values::None_;

        match unsafe { self.gecko.mBorderImageSource.into_image() } {
            Some(image) => Either::Second(image),
            None => Either::First(None_),
        }
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_border_image_outset(&mut self, v: longhands::border_image_outset::computed_value::T) {
        v.to_gecko_rect(&mut self.gecko.mBorderImageOutset);
    }

    
    
    #[allow(non_snake_case)]
    pub fn copy_border_image_outset_from(&mut self, other: &Self) {
            self.gecko.mBorderImageOutset.data_at_mut(0)
                .copy_from(&other.gecko.mBorderImageOutset.data_at(0));
            self.gecko.mBorderImageOutset.data_at_mut(1)
                .copy_from(&other.gecko.mBorderImageOutset.data_at(1));
            self.gecko.mBorderImageOutset.data_at_mut(2)
                .copy_from(&other.gecko.mBorderImageOutset.data_at(2));
            self.gecko.mBorderImageOutset.data_at_mut(3)
                .copy_from(&other.gecko.mBorderImageOutset.data_at(3));
        
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_outset(&mut self, other: &Self) {
        self.copy_border_image_outset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_outset(&self) -> longhands::border_image_outset::computed_value::T {
        longhands::border_image_outset::computed_value::T::from_gecko_rect(&self.gecko.mBorderImageOutset)
            .expect("clone for border_image_outset failed")
    }


    

    pub fn set_border_image_repeat(&mut self, v: longhands::border_image_repeat::computed_value::T) {
        use crate::values::specified::border::BorderImageRepeatKeyword;
        use crate::gecko_bindings::structs::StyleBorderImageRepeat;

            self.gecko.mBorderImageRepeatH = match v.0 {
                BorderImageRepeatKeyword::Stretch => StyleBorderImageRepeat::Stretch,
                BorderImageRepeatKeyword::Repeat => StyleBorderImageRepeat::Repeat,
                BorderImageRepeatKeyword::Round => StyleBorderImageRepeat::Round,
                BorderImageRepeatKeyword::Space => StyleBorderImageRepeat::Space,
            };
            self.gecko.mBorderImageRepeatV = match v.1 {
                BorderImageRepeatKeyword::Stretch => StyleBorderImageRepeat::Stretch,
                BorderImageRepeatKeyword::Repeat => StyleBorderImageRepeat::Repeat,
                BorderImageRepeatKeyword::Round => StyleBorderImageRepeat::Round,
                BorderImageRepeatKeyword::Space => StyleBorderImageRepeat::Space,
            };
    }

    pub fn copy_border_image_repeat_from(&mut self, other: &Self) {
        self.gecko.mBorderImageRepeatH = other.gecko.mBorderImageRepeatH;
        self.gecko.mBorderImageRepeatV = other.gecko.mBorderImageRepeatV;
    }

    pub fn reset_border_image_repeat(&mut self, other: &Self) {
        self.copy_border_image_repeat_from(other)
    }

    pub fn clone_border_image_repeat(&self) -> longhands::border_image_repeat::computed_value::T {
        use crate::values::specified::border::BorderImageRepeatKeyword;
        use crate::gecko_bindings::structs::StyleBorderImageRepeat;

        let servo_h = match self.gecko.mBorderImageRepeatH {
            StyleBorderImageRepeat::Stretch => BorderImageRepeatKeyword::Stretch,
            StyleBorderImageRepeat::Repeat => BorderImageRepeatKeyword::Repeat,
            StyleBorderImageRepeat::Round => BorderImageRepeatKeyword::Round,
            StyleBorderImageRepeat::Space => BorderImageRepeatKeyword::Space,
        };
        let servo_v = match self.gecko.mBorderImageRepeatV {
            StyleBorderImageRepeat::Stretch => BorderImageRepeatKeyword::Stretch,
            StyleBorderImageRepeat::Repeat => BorderImageRepeatKeyword::Repeat,
            StyleBorderImageRepeat::Round => BorderImageRepeatKeyword::Round,
            StyleBorderImageRepeat::Space => BorderImageRepeatKeyword::Space,
        };
        longhands::border_image_repeat::computed_value::T(servo_h, servo_v)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_border_image_width(&mut self, v: longhands::border_image_width::computed_value::T) {
        v.to_gecko_rect(&mut self.gecko.mBorderImageWidth);
    }

    
    
    #[allow(non_snake_case)]
    pub fn copy_border_image_width_from(&mut self, other: &Self) {
            self.gecko.mBorderImageWidth.data_at_mut(0)
                .copy_from(&other.gecko.mBorderImageWidth.data_at(0));
            self.gecko.mBorderImageWidth.data_at_mut(1)
                .copy_from(&other.gecko.mBorderImageWidth.data_at(1));
            self.gecko.mBorderImageWidth.data_at_mut(2)
                .copy_from(&other.gecko.mBorderImageWidth.data_at(2));
            self.gecko.mBorderImageWidth.data_at_mut(3)
                .copy_from(&other.gecko.mBorderImageWidth.data_at(3));
        
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_width(&mut self, other: &Self) {
        self.copy_border_image_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_width(&self) -> longhands::border_image_width::computed_value::T {
        longhands::border_image_width::computed_value::T::from_gecko_rect(&self.gecko.mBorderImageWidth)
            .expect("clone for border_image_width failed")
    }


    pub fn set_border_image_slice(&mut self, v: longhands::border_image_slice::computed_value::T) {
        use crate::gecko_bindings::structs::{NS_STYLE_BORDER_IMAGE_SLICE_NOFILL, NS_STYLE_BORDER_IMAGE_SLICE_FILL};

        v.offsets.to_gecko_rect(&mut self.gecko.mBorderImageSlice);

        let fill = if v.fill {
            NS_STYLE_BORDER_IMAGE_SLICE_FILL
        } else {
            NS_STYLE_BORDER_IMAGE_SLICE_NOFILL
        };
        self.gecko.mBorderImageFill = fill as u8;
    }

    
    
    #[allow(non_snake_case)]
    pub fn copy_border_image_slice_from(&mut self, other: &Self) {
            self.gecko.mBorderImageSlice.data_at_mut(0)
                .copy_from(&other.gecko.mBorderImageSlice.data_at(0));
            self.gecko.mBorderImageSlice.data_at_mut(1)
                .copy_from(&other.gecko.mBorderImageSlice.data_at(1));
            self.gecko.mBorderImageSlice.data_at_mut(2)
                .copy_from(&other.gecko.mBorderImageSlice.data_at(2));
            self.gecko.mBorderImageSlice.data_at_mut(3)
                .copy_from(&other.gecko.mBorderImageSlice.data_at(3));
        
        self.gecko.mBorderImageFill = other.gecko.mBorderImageFill;
    
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_slice(&mut self, other: &Self) {
        self.copy_border_image_slice_from(other)
    }


    pub fn clone_border_image_slice(&self) -> longhands::border_image_slice::computed_value::T {
        use crate::gecko_bindings::structs::NS_STYLE_BORDER_IMAGE_SLICE_FILL;
        use crate::values::computed::{BorderImageSlice, NonNegativeNumberOrPercentage};
        type NumberOrPercentageRect = crate::values::generics::rect::Rect<NonNegativeNumberOrPercentage>;

        BorderImageSlice {
            offsets:
                NumberOrPercentageRect::from_gecko_rect(&self.gecko.mBorderImageSlice)
                    .expect("mBorderImageSlice[V] could not convert to NumberOrPercentageRect"),
            fill: self.gecko.mBorderImageFill as u32 == NS_STYLE_BORDER_IMAGE_SLICE_FILL
        }
    }


    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for border-block-start-color given a writing mode.
    pub fn set_border_block_start_color(&mut self,
                                      v: longhands::border_block_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn copy_border_block_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn reset_border_block_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-color given a writing mode.
    pub fn clone_border_block_start_color(&self, wm: WritingMode)
        -> longhands::border_block_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-start-style given a writing mode.
    pub fn set_border_block_start_style(&mut self,
                                      v: longhands::border_block_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn copy_border_block_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn reset_border_block_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-style given a writing mode.
    pub fn clone_border_block_start_style(&self, wm: WritingMode)
        -> longhands::border_block_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-start-width given a writing mode.
    pub fn set_border_block_start_width(&mut self,
                                      v: longhands::border_block_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn copy_border_block_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn reset_border_block_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-width given a writing mode.
    pub fn clone_border_block_start_width(&self, wm: WritingMode)
        -> longhands::border_block_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-color given a writing mode.
    pub fn set_border_block_end_color(&mut self,
                                      v: longhands::border_block_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn copy_border_block_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn reset_border_block_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-color given a writing mode.
    pub fn clone_border_block_end_color(&self, wm: WritingMode)
        -> longhands::border_block_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-style given a writing mode.
    pub fn set_border_block_end_style(&mut self,
                                      v: longhands::border_block_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn copy_border_block_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn reset_border_block_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-style given a writing mode.
    pub fn clone_border_block_end_style(&self, wm: WritingMode)
        -> longhands::border_block_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-width given a writing mode.
    pub fn set_border_block_end_width(&mut self,
                                      v: longhands::border_block_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn copy_border_block_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn reset_border_block_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-width given a writing mode.
    pub fn clone_border_block_end_width(&self, wm: WritingMode)
        -> longhands::border_block_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-color given a writing mode.
    pub fn set_border_inline_start_color(&mut self,
                                      v: longhands::border_inline_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn copy_border_inline_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn reset_border_inline_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-color given a writing mode.
    pub fn clone_border_inline_start_color(&self, wm: WritingMode)
        -> longhands::border_inline_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-style given a writing mode.
    pub fn set_border_inline_start_style(&mut self,
                                      v: longhands::border_inline_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn copy_border_inline_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn reset_border_inline_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-style given a writing mode.
    pub fn clone_border_inline_start_style(&self, wm: WritingMode)
        -> longhands::border_inline_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-width given a writing mode.
    pub fn set_border_inline_start_width(&mut self,
                                      v: longhands::border_inline_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn copy_border_inline_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn reset_border_inline_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-width given a writing mode.
    pub fn clone_border_inline_start_width(&self, wm: WritingMode)
        -> longhands::border_inline_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-color given a writing mode.
    pub fn set_border_inline_end_color(&mut self,
                                      v: longhands::border_inline_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn copy_border_inline_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn reset_border_inline_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-color given a writing mode.
    pub fn clone_border_inline_end_color(&self, wm: WritingMode)
        -> longhands::border_inline_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-style given a writing mode.
    pub fn set_border_inline_end_style(&mut self,
                                      v: longhands::border_inline_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn copy_border_inline_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn reset_border_inline_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-style given a writing mode.
    pub fn clone_border_inline_end_style(&self, wm: WritingMode)
        -> longhands::border_inline_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-width given a writing mode.
    pub fn set_border_inline_end_width(&mut self,
                                      v: longhands::border_inline_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn copy_border_inline_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn reset_border_inline_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-width given a writing mode.
    pub fn clone_border_inline_end_width(&self, wm: WritingMode)
        -> longhands::border_inline_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-start-start-radius given a writing mode.
    pub fn set_border_start_start_radius(&mut self,
                                      v: longhands::border_start_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn copy_border_start_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn reset_border_start_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-start-radius given a writing mode.
    pub fn clone_border_start_start_radius(&self, wm: WritingMode)
        -> longhands::border_start_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-start-end-radius given a writing mode.
    pub fn set_border_start_end_radius(&mut self,
                                      v: longhands::border_start_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn copy_border_start_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn reset_border_start_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-end-radius given a writing mode.
    pub fn clone_border_start_end_radius(&self, wm: WritingMode)
        -> longhands::border_start_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-end-start-radius given a writing mode.
    pub fn set_border_end_start_radius(&mut self,
                                      v: longhands::border_end_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn copy_border_end_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn reset_border_end_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-start-radius given a writing mode.
    pub fn clone_border_end_start_radius(&self, wm: WritingMode)
        -> longhands::border_end_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-end-end-radius given a writing mode.
    pub fn set_border_end_end_radius(&mut self,
                                      v: longhands::border_end_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn copy_border_end_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn reset_border_end_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-end-radius given a writing mode.
    pub fn clone_border_end_end_radius(&self, wm: WritingMode)
        -> longhands::border_end_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_box_decoration_break(&mut self, v: longhands::box_decoration_break::computed_value::T) {
        use crate::properties::longhands::box_decoration_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Slice =>
                    structs::StyleBoxDecorationBreak::Slice ,
                Keyword::Clone =>
                    structs::StyleBoxDecorationBreak::Clone ,
        };
        self.gecko.mBoxDecorationBreak = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_box_decoration_break_from(&mut self, other: &Self) {
        self.gecko.mBoxDecorationBreak = other.gecko.mBoxDecorationBreak;
    }

    #[allow(non_snake_case)]
    pub fn reset_box_decoration_break(&mut self, other: &Self) {
        self.copy_box_decoration_break_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_box_decoration_break(&self) -> longhands::box_decoration_break::computed_value::T {
        use crate::properties::longhands::box_decoration_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxDecorationBreak {
            structs::StyleBoxDecorationBreak::Slice => Keyword::Slice,
            structs::StyleBoxDecorationBreak::Clone => Keyword::Clone,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_float_edge(&mut self, v: longhands::_moz_float_edge::computed_value::T) {
        use crate::properties::longhands::_moz_float_edge::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ContentBox =>
                    structs::StyleFloatEdge::ContentBox ,
                Keyword::MarginBox =>
                    structs::StyleFloatEdge::MarginBox ,
        };
        self.gecko.mFloatEdge = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_float_edge_from(&mut self, other: &Self) {
        self.gecko.mFloatEdge = other.gecko.mFloatEdge;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_float_edge(&mut self, other: &Self) {
        self.copy__moz_float_edge_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_float_edge(&self) -> longhands::_moz_float_edge::computed_value::T {
        use crate::properties::longhands::_moz_float_edge::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mFloatEdge {
            structs::StyleFloatEdge::ContentBox => Keyword::ContentBox,
            structs::StyleFloatEdge::MarginBox => Keyword::MarginBox,
        }
    }


}





impl GeckoMargin {
    /*
     * Manually-Implemented Methods.
     */
    

    
    #[allow(non_snake_case)]
    pub fn set_margin_top(&mut self, v: longhands::margin_top::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mMargin.data_at_mut(0));
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_top_from(&mut self, other: &Self) {
        self.gecko.mMargin.data_at_mut(0).copy_from(&other.gecko.mMargin.data_at(0));
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_top(&mut self, other: &Self) {
        self.copy_margin_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_top(&self) -> longhands::margin_top::computed_value::T {
        use crate::properties::longhands::margin_top::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mMargin.data_at(0))
            .expect("clone for margin_top failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_right(&mut self, v: longhands::margin_right::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mMargin.data_at_mut(1));
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_right_from(&mut self, other: &Self) {
        self.gecko.mMargin.data_at_mut(1).copy_from(&other.gecko.mMargin.data_at(1));
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_right(&mut self, other: &Self) {
        self.copy_margin_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_right(&self) -> longhands::margin_right::computed_value::T {
        use crate::properties::longhands::margin_right::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mMargin.data_at(1))
            .expect("clone for margin_right failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_bottom(&mut self, v: longhands::margin_bottom::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mMargin.data_at_mut(2));
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_bottom_from(&mut self, other: &Self) {
        self.gecko.mMargin.data_at_mut(2).copy_from(&other.gecko.mMargin.data_at(2));
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_bottom(&mut self, other: &Self) {
        self.copy_margin_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_bottom(&self) -> longhands::margin_bottom::computed_value::T {
        use crate::properties::longhands::margin_bottom::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mMargin.data_at(2))
            .expect("clone for margin_bottom failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_left(&mut self, v: longhands::margin_left::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mMargin.data_at_mut(3));
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_left_from(&mut self, other: &Self) {
        self.gecko.mMargin.data_at_mut(3).copy_from(&other.gecko.mMargin.data_at(3));
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_left(&mut self, other: &Self) {
        self.copy_margin_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_left(&self) -> longhands::margin_left::computed_value::T {
        use crate::properties::longhands::margin_left::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mMargin.data_at(3))
            .expect("clone for margin_left failed")
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for margin-block-start given a writing mode.
    pub fn set_margin_block_start(&mut self,
                                      v: longhands::margin_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn copy_margin_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn reset_margin_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-start given a writing mode.
    pub fn clone_margin_block_start(&self, wm: WritingMode)
        -> longhands::margin_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-block-end given a writing mode.
    pub fn set_margin_block_end(&mut self,
                                      v: longhands::margin_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn copy_margin_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn reset_margin_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-end given a writing mode.
    pub fn clone_margin_block_end(&self, wm: WritingMode)
        -> longhands::margin_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-inline-start given a writing mode.
    pub fn set_margin_inline_start(&mut self,
                                      v: longhands::margin_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn copy_margin_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn reset_margin_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-start given a writing mode.
    pub fn clone_margin_inline_start(&self, wm: WritingMode)
        -> longhands::margin_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-inline-end given a writing mode.
    pub fn set_margin_inline_end(&mut self,
                                      v: longhands::margin_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn copy_margin_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn reset_margin_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-end given a writing mode.
    pub fn clone_margin_inline_end(&self, wm: WritingMode)
        -> longhands::margin_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


}





impl GeckoPadding {
    /*
     * Manually-Implemented Methods.
     */
    

    
    #[allow(non_snake_case)]
    pub fn set_padding_top(&mut self, v: longhands::padding_top::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mPadding.data_at_mut(0));
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_top_from(&mut self, other: &Self) {
        self.gecko.mPadding.data_at_mut(0).copy_from(&other.gecko.mPadding.data_at(0));
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_top(&mut self, other: &Self) {
        self.copy_padding_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_top(&self) -> longhands::padding_top::computed_value::T {
        use crate::properties::longhands::padding_top::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mPadding.data_at(0))
            .expect("clone for padding_top failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_right(&mut self, v: longhands::padding_right::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mPadding.data_at_mut(1));
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_right_from(&mut self, other: &Self) {
        self.gecko.mPadding.data_at_mut(1).copy_from(&other.gecko.mPadding.data_at(1));
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_right(&mut self, other: &Self) {
        self.copy_padding_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_right(&self) -> longhands::padding_right::computed_value::T {
        use crate::properties::longhands::padding_right::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mPadding.data_at(1))
            .expect("clone for padding_right failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_bottom(&mut self, v: longhands::padding_bottom::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mPadding.data_at_mut(2));
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_bottom_from(&mut self, other: &Self) {
        self.gecko.mPadding.data_at_mut(2).copy_from(&other.gecko.mPadding.data_at(2));
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_bottom(&mut self, other: &Self) {
        self.copy_padding_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_bottom(&self) -> longhands::padding_bottom::computed_value::T {
        use crate::properties::longhands::padding_bottom::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mPadding.data_at(2))
            .expect("clone for padding_bottom failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_left(&mut self, v: longhands::padding_left::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mPadding.data_at_mut(3));
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_left_from(&mut self, other: &Self) {
        self.gecko.mPadding.data_at_mut(3).copy_from(&other.gecko.mPadding.data_at(3));
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_left(&mut self, other: &Self) {
        self.copy_padding_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_left(&self) -> longhands::padding_left::computed_value::T {
        use crate::properties::longhands::padding_left::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mPadding.data_at(3))
            .expect("clone for padding_left failed")
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for padding-block-start given a writing mode.
    pub fn set_padding_block_start(&mut self,
                                      v: longhands::padding_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn copy_padding_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn reset_padding_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-start given a writing mode.
    pub fn clone_padding_block_start(&self, wm: WritingMode)
        -> longhands::padding_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-block-end given a writing mode.
    pub fn set_padding_block_end(&mut self,
                                      v: longhands::padding_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn copy_padding_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn reset_padding_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-end given a writing mode.
    pub fn clone_padding_block_end(&self, wm: WritingMode)
        -> longhands::padding_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-inline-start given a writing mode.
    pub fn set_padding_inline_start(&mut self,
                                      v: longhands::padding_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn copy_padding_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn reset_padding_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-start given a writing mode.
    pub fn clone_padding_inline_start(&self, wm: WritingMode)
        -> longhands::padding_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-inline-end given a writing mode.
    pub fn set_padding_inline_end(&mut self,
                                      v: longhands::padding_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn copy_padding_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn reset_padding_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-end given a writing mode.
    pub fn clone_padding_inline_end(&self, wm: WritingMode)
        -> longhands::padding_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


}





impl GeckoPosition {
    /*
     * Manually-Implemented Methods.
     */
    
    
    #[allow(non_snake_case)]
    pub fn set_top(&mut self, v: longhands::top::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mOffset.data_at_mut(0));
    }
    #[allow(non_snake_case)]
    pub fn copy_top_from(&mut self, other: &Self) {
        self.gecko.mOffset.data_at_mut(0).copy_from(&other.gecko.mOffset.data_at(0));
    }
    #[allow(non_snake_case)]
    pub fn reset_top(&mut self, other: &Self) {
        self.copy_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_top(&self) -> longhands::top::computed_value::T {
        use crate::properties::longhands::top::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mOffset.data_at(0))
            .expect("clone for top failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_right(&mut self, v: longhands::right::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mOffset.data_at_mut(1));
    }
    #[allow(non_snake_case)]
    pub fn copy_right_from(&mut self, other: &Self) {
        self.gecko.mOffset.data_at_mut(1).copy_from(&other.gecko.mOffset.data_at(1));
    }
    #[allow(non_snake_case)]
    pub fn reset_right(&mut self, other: &Self) {
        self.copy_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_right(&self) -> longhands::right::computed_value::T {
        use crate::properties::longhands::right::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mOffset.data_at(1))
            .expect("clone for right failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_bottom(&mut self, v: longhands::bottom::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mOffset.data_at_mut(2));
    }
    #[allow(non_snake_case)]
    pub fn copy_bottom_from(&mut self, other: &Self) {
        self.gecko.mOffset.data_at_mut(2).copy_from(&other.gecko.mOffset.data_at(2));
    }
    #[allow(non_snake_case)]
    pub fn reset_bottom(&mut self, other: &Self) {
        self.copy_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_bottom(&self) -> longhands::bottom::computed_value::T {
        use crate::properties::longhands::bottom::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mOffset.data_at(2))
            .expect("clone for bottom failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_left(&mut self, v: longhands::left::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mOffset.data_at_mut(3));
    }
    #[allow(non_snake_case)]
    pub fn copy_left_from(&mut self, other: &Self) {
        self.gecko.mOffset.data_at_mut(3).copy_from(&other.gecko.mOffset.data_at(3));
    }
    #[allow(non_snake_case)]
    pub fn reset_left(&mut self, other: &Self) {
        self.copy_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_left(&self) -> longhands::left::computed_value::T {
        use crate::properties::longhands::left::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mOffset.data_at(3))
            .expect("clone for left failed")
    }


    pub fn set_z_index(&mut self, v: longhands::z_index::computed_value::T) {
        match v {
            ZIndex::Integer(n) => self.gecko.mZIndex.set_value(CoordDataValue::Integer(n)),
            ZIndex::Auto => self.gecko.mZIndex.set_value(CoordDataValue::Auto),
        }
    }

    pub fn copy_z_index_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleUnit;
        // z-index is never a calc(). If it were, we'd be leaking here, so
        // assert that it isn't.
        debug_assert_ne!(self.gecko.mZIndex.unit(), nsStyleUnit::eStyleUnit_Calc);
        unsafe {
            self.gecko.mZIndex.copy_from_unchecked(&other.gecko.mZIndex);
        }
    }

    pub fn reset_z_index(&mut self, other: &Self) {
        self.copy_z_index_from(other)
    }

    pub fn clone_z_index(&self) -> longhands::z_index::computed_value::T {
        return match self.gecko.mZIndex.as_value() {
            CoordDataValue::Integer(n) => ZIndex::Integer(n),
            CoordDataValue::Auto => ZIndex::Auto,
            _ => {
                debug_assert!(false);
                ZIndex::Integer(0)
            }
        }
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_align_content(&mut self, v: longhands::align_content::computed_value::T) {
        self.gecko.mAlignContent = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_align_content_from(&mut self, other: &Self) {
        self.gecko.mAlignContent = other.gecko.mAlignContent;
    }

    #[allow(non_snake_case)]
    pub fn reset_align_content(&mut self, other: &Self) {
        self.copy_align_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_content(&self) -> longhands::align_content::computed_value::T {
        From::from(self.gecko.mAlignContent)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_align_self(&mut self, v: longhands::align_self::computed_value::T) {
        self.gecko.mAlignSelf = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_align_self_from(&mut self, other: &Self) {
        self.gecko.mAlignSelf = other.gecko.mAlignSelf;
    }

    #[allow(non_snake_case)]
    pub fn reset_align_self(&mut self, other: &Self) {
        self.copy_align_self_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_self(&self) -> longhands::align_self::computed_value::T {
        From::from(self.gecko.mAlignSelf)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_justify_content(&mut self, v: longhands::justify_content::computed_value::T) {
        self.gecko.mJustifyContent = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_justify_content_from(&mut self, other: &Self) {
        self.gecko.mJustifyContent = other.gecko.mJustifyContent;
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_content(&mut self, other: &Self) {
        self.copy_justify_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_content(&self) -> longhands::justify_content::computed_value::T {
        From::from(self.gecko.mJustifyContent)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_justify_self(&mut self, v: longhands::justify_self::computed_value::T) {
        self.gecko.mJustifySelf = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_justify_self_from(&mut self, other: &Self) {
        self.gecko.mJustifySelf = other.gecko.mJustifySelf;
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_self(&mut self, other: &Self) {
        self.copy_justify_self_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_self(&self) -> longhands::justify_self::computed_value::T {
        From::from(self.gecko.mJustifySelf)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_align_items(&mut self, v: longhands::align_items::computed_value::T) {
        self.gecko.mAlignItems = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_align_items_from(&mut self, other: &Self) {
        self.gecko.mAlignItems = other.gecko.mAlignItems;
    }

    #[allow(non_snake_case)]
    pub fn reset_align_items(&mut self, other: &Self) {
        self.copy_align_items_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_items(&self) -> longhands::align_items::computed_value::T {
        From::from(self.gecko.mAlignItems)
    }


    pub fn set_justify_items(&mut self, v: longhands::justify_items::computed_value::T) {
        self.gecko.mSpecifiedJustifyItems = v.specified.into();
        self.set_computed_justify_items(v.computed);
    }

    pub fn set_computed_justify_items(&mut self, v: values::specified::JustifyItems) {
        debug_assert_ne!(v.0, crate::values::specified::align::AlignFlags::LEGACY);
        self.gecko.mJustifyItems = v.into();
    }

    pub fn reset_justify_items(&mut self, reset_style: &Self) {
        self.gecko.mJustifyItems = reset_style.gecko.mJustifyItems;
        self.gecko.mSpecifiedJustifyItems = reset_style.gecko.mSpecifiedJustifyItems;
    }

    pub fn copy_justify_items_from(&mut self, other: &Self) {
        self.gecko.mJustifyItems = other.gecko.mJustifyItems;
        self.gecko.mSpecifiedJustifyItems = other.gecko.mJustifyItems;
    }

    pub fn clone_justify_items(&self) -> longhands::justify_items::computed_value::T {
        longhands::justify_items::computed_value::T {
            computed: self.gecko.mJustifyItems.into(),
            specified: self.gecko.mSpecifiedJustifyItems.into(),
        }
    }

    pub fn set_order(&mut self, v: longhands::order::computed_value::T) {
        self.gecko.mOrder = v;
    }

    pub fn clone_order(&self) -> longhands::order::computed_value::T {
        self.gecko.mOrder
    }

    
    #[allow(non_snake_case)]
    pub fn copy_order_from(&mut self, other: &Self) {
        self.gecko.mOrder = other.gecko.mOrder;
    }

    #[allow(non_snake_case)]
    pub fn reset_order(&mut self, other: &Self) {
        self.copy_order_from(other)
    }


    pub fn set_grid_row_start(&mut self, v: longhands::grid_row_start::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        let ident = v.ident.as_ref().map_or(&[] as &[_], |ident| ident.0.as_slice());
        self.gecko.mGridRowStart.mLineName.assign(ident);
        self.gecko.mGridRowStart.mHasSpan = v.is_span;
        if let Some(integer) = v.line_num {
            // clamping the integer between a range
            self.gecko.mGridRowStart.mInteger = cmp::max(nsStyleGridLine_kMinLine,
                cmp::min(integer, nsStyleGridLine_kMaxLine));
        }
    }

    pub fn copy_grid_row_start_from(&mut self, other: &Self) {
        self.gecko.mGridRowStart.mHasSpan = other.gecko.mGridRowStart.mHasSpan;
        self.gecko.mGridRowStart.mInteger = other.gecko.mGridRowStart.mInteger;
        self.gecko.mGridRowStart.mLineName.assign(&*other.gecko.mGridRowStart.mLineName);
    }

    pub fn reset_grid_row_start(&mut self, other: &Self) {
        self.copy_grid_row_start_from(other)
    }

    pub fn clone_grid_row_start(&self) -> longhands::grid_row_start::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        longhands::grid_row_start::computed_value::T {
            is_span: self.gecko.mGridRowStart.mHasSpan,
            ident: {
                let name = self.gecko.mGridRowStart.mLineName.to_string();
                if name.len() == 0 {
                    None
                } else {
                    Some(CustomIdent(Atom::from(name)))
                }
            },
            line_num:
                if self.gecko.mGridRowStart.mInteger == 0 {
                    None
                } else {
                    debug_assert!(nsStyleGridLine_kMinLine <= self.gecko.mGridRowStart.mInteger);
                    debug_assert!(self.gecko.mGridRowStart.mInteger <= nsStyleGridLine_kMaxLine);
                    Some(self.gecko.mGridRowStart.mInteger)
                },
        }
    }
    pub fn set_grid_row_end(&mut self, v: longhands::grid_row_end::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        let ident = v.ident.as_ref().map_or(&[] as &[_], |ident| ident.0.as_slice());
        self.gecko.mGridRowEnd.mLineName.assign(ident);
        self.gecko.mGridRowEnd.mHasSpan = v.is_span;
        if let Some(integer) = v.line_num {
            // clamping the integer between a range
            self.gecko.mGridRowEnd.mInteger = cmp::max(nsStyleGridLine_kMinLine,
                cmp::min(integer, nsStyleGridLine_kMaxLine));
        }
    }

    pub fn copy_grid_row_end_from(&mut self, other: &Self) {
        self.gecko.mGridRowEnd.mHasSpan = other.gecko.mGridRowEnd.mHasSpan;
        self.gecko.mGridRowEnd.mInteger = other.gecko.mGridRowEnd.mInteger;
        self.gecko.mGridRowEnd.mLineName.assign(&*other.gecko.mGridRowEnd.mLineName);
    }

    pub fn reset_grid_row_end(&mut self, other: &Self) {
        self.copy_grid_row_end_from(other)
    }

    pub fn clone_grid_row_end(&self) -> longhands::grid_row_end::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        longhands::grid_row_end::computed_value::T {
            is_span: self.gecko.mGridRowEnd.mHasSpan,
            ident: {
                let name = self.gecko.mGridRowEnd.mLineName.to_string();
                if name.len() == 0 {
                    None
                } else {
                    Some(CustomIdent(Atom::from(name)))
                }
            },
            line_num:
                if self.gecko.mGridRowEnd.mInteger == 0 {
                    None
                } else {
                    debug_assert!(nsStyleGridLine_kMinLine <= self.gecko.mGridRowEnd.mInteger);
                    debug_assert!(self.gecko.mGridRowEnd.mInteger <= nsStyleGridLine_kMaxLine);
                    Some(self.gecko.mGridRowEnd.mInteger)
                },
        }
    }
    pub fn set_grid_column_start(&mut self, v: longhands::grid_column_start::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        let ident = v.ident.as_ref().map_or(&[] as &[_], |ident| ident.0.as_slice());
        self.gecko.mGridColumnStart.mLineName.assign(ident);
        self.gecko.mGridColumnStart.mHasSpan = v.is_span;
        if let Some(integer) = v.line_num {
            // clamping the integer between a range
            self.gecko.mGridColumnStart.mInteger = cmp::max(nsStyleGridLine_kMinLine,
                cmp::min(integer, nsStyleGridLine_kMaxLine));
        }
    }

    pub fn copy_grid_column_start_from(&mut self, other: &Self) {
        self.gecko.mGridColumnStart.mHasSpan = other.gecko.mGridColumnStart.mHasSpan;
        self.gecko.mGridColumnStart.mInteger = other.gecko.mGridColumnStart.mInteger;
        self.gecko.mGridColumnStart.mLineName.assign(&*other.gecko.mGridColumnStart.mLineName);
    }

    pub fn reset_grid_column_start(&mut self, other: &Self) {
        self.copy_grid_column_start_from(other)
    }

    pub fn clone_grid_column_start(&self) -> longhands::grid_column_start::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        longhands::grid_column_start::computed_value::T {
            is_span: self.gecko.mGridColumnStart.mHasSpan,
            ident: {
                let name = self.gecko.mGridColumnStart.mLineName.to_string();
                if name.len() == 0 {
                    None
                } else {
                    Some(CustomIdent(Atom::from(name)))
                }
            },
            line_num:
                if self.gecko.mGridColumnStart.mInteger == 0 {
                    None
                } else {
                    debug_assert!(nsStyleGridLine_kMinLine <= self.gecko.mGridColumnStart.mInteger);
                    debug_assert!(self.gecko.mGridColumnStart.mInteger <= nsStyleGridLine_kMaxLine);
                    Some(self.gecko.mGridColumnStart.mInteger)
                },
        }
    }
    pub fn set_grid_column_end(&mut self, v: longhands::grid_column_end::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        let ident = v.ident.as_ref().map_or(&[] as &[_], |ident| ident.0.as_slice());
        self.gecko.mGridColumnEnd.mLineName.assign(ident);
        self.gecko.mGridColumnEnd.mHasSpan = v.is_span;
        if let Some(integer) = v.line_num {
            // clamping the integer between a range
            self.gecko.mGridColumnEnd.mInteger = cmp::max(nsStyleGridLine_kMinLine,
                cmp::min(integer, nsStyleGridLine_kMaxLine));
        }
    }

    pub fn copy_grid_column_end_from(&mut self, other: &Self) {
        self.gecko.mGridColumnEnd.mHasSpan = other.gecko.mGridColumnEnd.mHasSpan;
        self.gecko.mGridColumnEnd.mInteger = other.gecko.mGridColumnEnd.mInteger;
        self.gecko.mGridColumnEnd.mLineName.assign(&*other.gecko.mGridColumnEnd.mLineName);
    }

    pub fn reset_grid_column_end(&mut self, other: &Self) {
        self.copy_grid_column_end_from(other)
    }

    pub fn clone_grid_column_end(&self) -> longhands::grid_column_end::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleGridLine_kMinLine, nsStyleGridLine_kMaxLine};

        longhands::grid_column_end::computed_value::T {
            is_span: self.gecko.mGridColumnEnd.mHasSpan,
            ident: {
                let name = self.gecko.mGridColumnEnd.mLineName.to_string();
                if name.len() == 0 {
                    None
                } else {
                    Some(CustomIdent(Atom::from(name)))
                }
            },
            line_num:
                if self.gecko.mGridColumnEnd.mInteger == 0 {
                    None
                } else {
                    debug_assert!(nsStyleGridLine_kMinLine <= self.gecko.mGridColumnEnd.mInteger);
                    debug_assert!(self.gecko.mGridColumnEnd.mInteger <= nsStyleGridLine_kMaxLine);
                    Some(self.gecko.mGridColumnEnd.mInteger)
                },
        }
    }

    pub fn set_grid_auto_rows(&mut self, v: longhands::grid_auto_rows::computed_value::T) {
        v.to_gecko_style_coords(&mut self.gecko.mGridAutoRowsMin,
                                &mut self.gecko.mGridAutoRowsMax)
    }

    pub fn copy_grid_auto_rows_from(&mut self, other: &Self) {
        self.gecko.mGridAutoRowsMin.copy_from(&other.gecko.mGridAutoRowsMin);
        self.gecko.mGridAutoRowsMax.copy_from(&other.gecko.mGridAutoRowsMax);
    }

    pub fn reset_grid_auto_rows(&mut self, other: &Self) {
        self.copy_grid_auto_rows_from(other)
    }

    pub fn clone_grid_auto_rows(&self) -> longhands::grid_auto_rows::computed_value::T {
        crate::values::generics::grid::TrackSize::from_gecko_style_coords(&self.gecko.mGridAutoRowsMin,
                                                                     &self.gecko.mGridAutoRowsMax)
    }

    pub fn set_grid_template_rows(&mut self, v: longhands::grid_template_rows::computed_value::T) {
        
        use crate::gecko_bindings::structs::{nsTArray, nsStyleGridLine_kMaxLine};
        use nsstring::nsStringRepr;
        use std::usize;
        use crate::values::CustomIdent;
        use crate::values::generics::grid::TrackListType::Auto;
        use crate::values::generics::grid::{GridTemplateComponent, RepeatCount};

        #[inline]
        fn set_line_names(servo_names: &[CustomIdent], gecko_names: &mut nsTArray<nsStringRepr>) {
            unsafe {
                bindings::Gecko_ResizeTArrayForStrings(gecko_names, servo_names.len() as u32);
            }

            for (servo_name, gecko_name) in servo_names.iter().zip(gecko_names.iter_mut()) {
                gecko_name.assign(servo_name.0.as_slice());
            }
        }

        let max_lines = nsStyleGridLine_kMaxLine as usize - 1;      // for accounting the final <line-names>

        let result = match v {
            GridTemplateComponent::None => ptr::null_mut(),
            GridTemplateComponent::TrackList(track) => {
                let mut num_values = track.values.len();
                if let Auto(_) = track.list_type {
                    num_values += 1;
                }

                num_values = cmp::min(num_values, max_lines);
                let value = unsafe {
                    bindings::Gecko_CreateStyleGridTemplate(num_values as u32,
                                                            (num_values + 1) as u32).as_mut().unwrap()
                };

                let mut auto_idx = usize::MAX;
                let mut auto_track_size = None;
                if let Auto(idx) = track.list_type {
                    auto_idx = idx as usize;
                    let auto_repeat = track.auto_repeat.as_ref().expect("expected <auto-track-repeat> value");

                    if auto_repeat.count == RepeatCount::AutoFill {
                        value.set_mIsAutoFill(true);
                    }

                    value.mRepeatAutoIndex = idx as i16;
                    // NOTE: Gecko supports only one set of values in <auto-repeat>
                    // i.e., it can only take repeat(auto-fill, [a] 10px [b]), and no more.
                    set_line_names(&auto_repeat.line_names[0], &mut value.mRepeatAutoLineNameListBefore);
                    set_line_names(&auto_repeat.line_names[1], &mut value.mRepeatAutoLineNameListAfter);
                    auto_track_size = Some(auto_repeat.track_sizes.get(0).unwrap().clone());
                } else {
                    unsafe {
                        bindings::Gecko_ResizeTArrayForStrings(
                            &mut value.mRepeatAutoLineNameListBefore, 0);
                        bindings::Gecko_ResizeTArrayForStrings(
                            &mut value.mRepeatAutoLineNameListAfter, 0);
                    }
                }

                let mut line_names = track.line_names.into_iter();
                let mut values_iter = track.values.into_iter();
                {
                    let min_max_iter = value.mMinTrackSizingFunctions.iter_mut()
                                            .zip(value.mMaxTrackSizingFunctions.iter_mut());
                    for (i, (gecko_min, gecko_max)) in min_max_iter.enumerate().take(max_lines) {
                        let name_list = line_names.next().expect("expected line-names");
                        set_line_names(&name_list, &mut value.mLineNameLists[i]);
                        if i == auto_idx {
                            let track_size = auto_track_size.take()
                                .expect("expected <track-size> for <auto-track-repeat>");
                            track_size.to_gecko_style_coords(gecko_min, gecko_max);
                            continue
                        }

                        let track_size = values_iter.next().expect("expected <track-size> value");
                        track_size.to_gecko_style_coords(gecko_min, gecko_max);
                    }
                }

                let final_names = line_names.next().unwrap();
                set_line_names(&final_names, value.mLineNameLists.last_mut().unwrap());

                value
            },
            GridTemplateComponent::Subgrid(list) => {
                let names_length = match list.fill_idx {
                    Some(_) => list.names.len() - 1,
                    None => list.names.len(),
                };
                let num_values = cmp::min(names_length, max_lines + 1);
                let value = unsafe {
                    bindings::Gecko_CreateStyleGridTemplate(0, num_values as u32).as_mut().unwrap()
                };
                value.set_mIsSubgrid(true);

                let mut names = list.names.into_vec();
                if let Some(idx) = list.fill_idx {
                    value.set_mIsAutoFill(true);
                    value.mRepeatAutoIndex = idx as i16;
                    set_line_names(&names.swap_remove(idx as usize),
                                   &mut value.mRepeatAutoLineNameListBefore);
                }

                for (servo_names, gecko_names) in names.iter().zip(value.mLineNameLists.iter_mut()) {
                    set_line_names(servo_names, gecko_names);
                }

                value
            },
        };

        unsafe { bindings::Gecko_SetStyleGridTemplate(&mut self.gecko.mGridTemplateRows, result); }
    }

    pub fn copy_grid_template_rows_from(&mut self, other: &Self) {
        unsafe {
            bindings::Gecko_CopyStyleGridTemplateValues(&mut self.gecko.mGridTemplateRows,
                                                        other.gecko.mGridTemplateRows.mPtr);
        }
    }

    pub fn reset_grid_template_rows(&mut self, other: &Self) {
        self.copy_grid_template_rows_from(other)
    }

    pub fn clone_grid_template_rows(&self) -> longhands::grid_template_rows::computed_value::T {
        
        use crate::gecko_bindings::structs::nsTArray;
        use nsstring::nsStringRepr;
        use crate::values::CustomIdent;
        use crate::values::generics::grid::{GridTemplateComponent, LineNameList, RepeatCount};
        use crate::values::generics::grid::{TrackList, TrackListType, TrackListValue, TrackRepeat, TrackSize};

        let value = match unsafe { self.gecko.mGridTemplateRows.mPtr.as_ref() } {
            None => return GridTemplateComponent::None,
            Some(value) => value,
        };

        #[inline]
        fn to_boxed_customident_slice(gecko_names: &nsTArray<nsStringRepr>) -> Box<[CustomIdent]> {
            let idents: Vec<CustomIdent> = gecko_names.iter().map(|gecko_name| {
                CustomIdent(Atom::from(gecko_name.to_string()))
            }).collect();
            idents.into_boxed_slice()
        }

        #[inline]
        fn to_line_names_vec(gecko_line_names: &nsTArray<nsTArray<nsStringRepr>>)
            -> Vec<Box<[CustomIdent]>> {
            gecko_line_names.iter().map(|gecko_names| {
                to_boxed_customident_slice(gecko_names)
            }).collect()
        }

        let repeat_auto_index = value.mRepeatAutoIndex as usize;
        if value.mIsSubgrid() {
            let mut names_vec = to_line_names_vec(&value.mLineNameLists);
            let fill_idx = if value.mIsAutoFill() {
                names_vec.insert(
                    repeat_auto_index,
                    to_boxed_customident_slice(&value.mRepeatAutoLineNameListBefore));
                Some(repeat_auto_index as u32)
            } else {
                None
            };
            let names = names_vec.into_boxed_slice();

            GridTemplateComponent::Subgrid(LineNameList{names, fill_idx})
        } else {
            let mut auto_repeat = None;
            let mut list_type = TrackListType::Normal;
            let line_names = to_line_names_vec(&value.mLineNameLists).into_boxed_slice();
            let mut values = Vec::with_capacity(value.mMinTrackSizingFunctions.len());

            let min_max_iter = value.mMinTrackSizingFunctions.iter()
                .zip(value.mMaxTrackSizingFunctions.iter());
            for (i, (gecko_min, gecko_max)) in min_max_iter.enumerate() {
                let track_size = TrackSize::from_gecko_style_coords(gecko_min, gecko_max);

                if i == repeat_auto_index {
                    list_type = TrackListType::Auto(repeat_auto_index as u16);

                    let count = if value.mIsAutoFill() {
                        RepeatCount::AutoFill
                    } else {
                        RepeatCount::AutoFit
                    };

                    let line_names = {
                        let mut vec: Vec<Box<[CustomIdent]>> = Vec::with_capacity(2);
                        vec.push(to_boxed_customident_slice(
                            &value.mRepeatAutoLineNameListBefore));
                        vec.push(to_boxed_customident_slice(
                            &value.mRepeatAutoLineNameListAfter));
                        vec.into_boxed_slice()
                    };

                    let track_sizes = vec!(track_size);

                    auto_repeat = Some(TrackRepeat{count, line_names, track_sizes});
                } else {
                    values.push(TrackListValue::TrackSize(track_size));
                }
            }

            GridTemplateComponent::TrackList(TrackList{list_type, values, line_names, auto_repeat})
        }
    }
    pub fn set_grid_auto_columns(&mut self, v: longhands::grid_auto_columns::computed_value::T) {
        v.to_gecko_style_coords(&mut self.gecko.mGridAutoColumnsMin,
                                &mut self.gecko.mGridAutoColumnsMax)
    }

    pub fn copy_grid_auto_columns_from(&mut self, other: &Self) {
        self.gecko.mGridAutoColumnsMin.copy_from(&other.gecko.mGridAutoColumnsMin);
        self.gecko.mGridAutoColumnsMax.copy_from(&other.gecko.mGridAutoColumnsMax);
    }

    pub fn reset_grid_auto_columns(&mut self, other: &Self) {
        self.copy_grid_auto_columns_from(other)
    }

    pub fn clone_grid_auto_columns(&self) -> longhands::grid_auto_columns::computed_value::T {
        crate::values::generics::grid::TrackSize::from_gecko_style_coords(&self.gecko.mGridAutoColumnsMin,
                                                                     &self.gecko.mGridAutoColumnsMax)
    }

    pub fn set_grid_template_columns(&mut self, v: longhands::grid_template_columns::computed_value::T) {
        
        use crate::gecko_bindings::structs::{nsTArray, nsStyleGridLine_kMaxLine};
        use nsstring::nsStringRepr;
        use std::usize;
        use crate::values::CustomIdent;
        use crate::values::generics::grid::TrackListType::Auto;
        use crate::values::generics::grid::{GridTemplateComponent, RepeatCount};

        #[inline]
        fn set_line_names(servo_names: &[CustomIdent], gecko_names: &mut nsTArray<nsStringRepr>) {
            unsafe {
                bindings::Gecko_ResizeTArrayForStrings(gecko_names, servo_names.len() as u32);
            }

            for (servo_name, gecko_name) in servo_names.iter().zip(gecko_names.iter_mut()) {
                gecko_name.assign(servo_name.0.as_slice());
            }
        }

        let max_lines = nsStyleGridLine_kMaxLine as usize - 1;      // for accounting the final <line-names>

        let result = match v {
            GridTemplateComponent::None => ptr::null_mut(),
            GridTemplateComponent::TrackList(track) => {
                let mut num_values = track.values.len();
                if let Auto(_) = track.list_type {
                    num_values += 1;
                }

                num_values = cmp::min(num_values, max_lines);
                let value = unsafe {
                    bindings::Gecko_CreateStyleGridTemplate(num_values as u32,
                                                            (num_values + 1) as u32).as_mut().unwrap()
                };

                let mut auto_idx = usize::MAX;
                let mut auto_track_size = None;
                if let Auto(idx) = track.list_type {
                    auto_idx = idx as usize;
                    let auto_repeat = track.auto_repeat.as_ref().expect("expected <auto-track-repeat> value");

                    if auto_repeat.count == RepeatCount::AutoFill {
                        value.set_mIsAutoFill(true);
                    }

                    value.mRepeatAutoIndex = idx as i16;
                    // NOTE: Gecko supports only one set of values in <auto-repeat>
                    // i.e., it can only take repeat(auto-fill, [a] 10px [b]), and no more.
                    set_line_names(&auto_repeat.line_names[0], &mut value.mRepeatAutoLineNameListBefore);
                    set_line_names(&auto_repeat.line_names[1], &mut value.mRepeatAutoLineNameListAfter);
                    auto_track_size = Some(auto_repeat.track_sizes.get(0).unwrap().clone());
                } else {
                    unsafe {
                        bindings::Gecko_ResizeTArrayForStrings(
                            &mut value.mRepeatAutoLineNameListBefore, 0);
                        bindings::Gecko_ResizeTArrayForStrings(
                            &mut value.mRepeatAutoLineNameListAfter, 0);
                    }
                }

                let mut line_names = track.line_names.into_iter();
                let mut values_iter = track.values.into_iter();
                {
                    let min_max_iter = value.mMinTrackSizingFunctions.iter_mut()
                                            .zip(value.mMaxTrackSizingFunctions.iter_mut());
                    for (i, (gecko_min, gecko_max)) in min_max_iter.enumerate().take(max_lines) {
                        let name_list = line_names.next().expect("expected line-names");
                        set_line_names(&name_list, &mut value.mLineNameLists[i]);
                        if i == auto_idx {
                            let track_size = auto_track_size.take()
                                .expect("expected <track-size> for <auto-track-repeat>");
                            track_size.to_gecko_style_coords(gecko_min, gecko_max);
                            continue
                        }

                        let track_size = values_iter.next().expect("expected <track-size> value");
                        track_size.to_gecko_style_coords(gecko_min, gecko_max);
                    }
                }

                let final_names = line_names.next().unwrap();
                set_line_names(&final_names, value.mLineNameLists.last_mut().unwrap());

                value
            },
            GridTemplateComponent::Subgrid(list) => {
                let names_length = match list.fill_idx {
                    Some(_) => list.names.len() - 1,
                    None => list.names.len(),
                };
                let num_values = cmp::min(names_length, max_lines + 1);
                let value = unsafe {
                    bindings::Gecko_CreateStyleGridTemplate(0, num_values as u32).as_mut().unwrap()
                };
                value.set_mIsSubgrid(true);

                let mut names = list.names.into_vec();
                if let Some(idx) = list.fill_idx {
                    value.set_mIsAutoFill(true);
                    value.mRepeatAutoIndex = idx as i16;
                    set_line_names(&names.swap_remove(idx as usize),
                                   &mut value.mRepeatAutoLineNameListBefore);
                }

                for (servo_names, gecko_names) in names.iter().zip(value.mLineNameLists.iter_mut()) {
                    set_line_names(servo_names, gecko_names);
                }

                value
            },
        };

        unsafe { bindings::Gecko_SetStyleGridTemplate(&mut self.gecko.mGridTemplateColumns, result); }
    }

    pub fn copy_grid_template_columns_from(&mut self, other: &Self) {
        unsafe {
            bindings::Gecko_CopyStyleGridTemplateValues(&mut self.gecko.mGridTemplateColumns,
                                                        other.gecko.mGridTemplateColumns.mPtr);
        }
    }

    pub fn reset_grid_template_columns(&mut self, other: &Self) {
        self.copy_grid_template_columns_from(other)
    }

    pub fn clone_grid_template_columns(&self) -> longhands::grid_template_columns::computed_value::T {
        
        use crate::gecko_bindings::structs::nsTArray;
        use nsstring::nsStringRepr;
        use crate::values::CustomIdent;
        use crate::values::generics::grid::{GridTemplateComponent, LineNameList, RepeatCount};
        use crate::values::generics::grid::{TrackList, TrackListType, TrackListValue, TrackRepeat, TrackSize};

        let value = match unsafe { self.gecko.mGridTemplateColumns.mPtr.as_ref() } {
            None => return GridTemplateComponent::None,
            Some(value) => value,
        };

        #[inline]
        fn to_boxed_customident_slice(gecko_names: &nsTArray<nsStringRepr>) -> Box<[CustomIdent]> {
            let idents: Vec<CustomIdent> = gecko_names.iter().map(|gecko_name| {
                CustomIdent(Atom::from(gecko_name.to_string()))
            }).collect();
            idents.into_boxed_slice()
        }

        #[inline]
        fn to_line_names_vec(gecko_line_names: &nsTArray<nsTArray<nsStringRepr>>)
            -> Vec<Box<[CustomIdent]>> {
            gecko_line_names.iter().map(|gecko_names| {
                to_boxed_customident_slice(gecko_names)
            }).collect()
        }

        let repeat_auto_index = value.mRepeatAutoIndex as usize;
        if value.mIsSubgrid() {
            let mut names_vec = to_line_names_vec(&value.mLineNameLists);
            let fill_idx = if value.mIsAutoFill() {
                names_vec.insert(
                    repeat_auto_index,
                    to_boxed_customident_slice(&value.mRepeatAutoLineNameListBefore));
                Some(repeat_auto_index as u32)
            } else {
                None
            };
            let names = names_vec.into_boxed_slice();

            GridTemplateComponent::Subgrid(LineNameList{names, fill_idx})
        } else {
            let mut auto_repeat = None;
            let mut list_type = TrackListType::Normal;
            let line_names = to_line_names_vec(&value.mLineNameLists).into_boxed_slice();
            let mut values = Vec::with_capacity(value.mMinTrackSizingFunctions.len());

            let min_max_iter = value.mMinTrackSizingFunctions.iter()
                .zip(value.mMaxTrackSizingFunctions.iter());
            for (i, (gecko_min, gecko_max)) in min_max_iter.enumerate() {
                let track_size = TrackSize::from_gecko_style_coords(gecko_min, gecko_max);

                if i == repeat_auto_index {
                    list_type = TrackListType::Auto(repeat_auto_index as u16);

                    let count = if value.mIsAutoFill() {
                        RepeatCount::AutoFill
                    } else {
                        RepeatCount::AutoFit
                    };

                    let line_names = {
                        let mut vec: Vec<Box<[CustomIdent]>> = Vec::with_capacity(2);
                        vec.push(to_boxed_customident_slice(
                            &value.mRepeatAutoLineNameListBefore));
                        vec.push(to_boxed_customident_slice(
                            &value.mRepeatAutoLineNameListAfter));
                        vec.into_boxed_slice()
                    };

                    let track_sizes = vec!(track_size);

                    auto_repeat = Some(TrackRepeat{count, line_names, track_sizes});
                } else {
                    values.push(TrackListValue::TrackSize(track_size));
                }
            }

            GridTemplateComponent::TrackList(TrackList{list_type, values, line_names, auto_repeat})
        }
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_grid_auto_flow(&mut self, v: longhands::grid_auto_flow::computed_value::T) {
        self.gecko.mGridAutoFlow = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_grid_auto_flow_from(&mut self, other: &Self) {
        self.gecko.mGridAutoFlow = other.gecko.mGridAutoFlow;
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_auto_flow(&mut self, other: &Self) {
        self.copy_grid_auto_flow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_auto_flow(&self) -> longhands::grid_auto_flow::computed_value::T {
        From::from(self.gecko.mGridAutoFlow)
    }


    pub fn set_grid_template_areas(&mut self, v: values::computed::position::GridTemplateAreas) {
        use crate::gecko_bindings::bindings::Gecko_NewGridTemplateAreasValue;
        use crate::gecko_bindings::sugar::refptr::UniqueRefPtr;

        let v = match v {
            Either::First(areas) => areas,
            Either::Second(_) => {
                unsafe { self.gecko.mGridTemplateAreas.clear() }
                return;
            },
        };

        let mut refptr = unsafe {
            UniqueRefPtr::from_addrefed(
                Gecko_NewGridTemplateAreasValue(v.0.areas.len() as u32, v.0.strings.len() as u32, v.0.width))
        };

        for (servo, gecko) in v.0.areas.into_iter().zip(refptr.mNamedAreas.iter_mut()) {
            gecko.mName.assign_str(&*servo.name);
            gecko.mColumnStart = servo.columns.start;
            gecko.mColumnEnd = servo.columns.end;
            gecko.mRowStart = servo.rows.start;
            gecko.mRowEnd = servo.rows.end;
        }

        for (servo, gecko) in v.0.strings.into_iter().zip(refptr.mTemplates.iter_mut()) {
            gecko.assign_str(&*servo);
        }

        self.gecko.mGridTemplateAreas.set_move(refptr.get())
    }

    pub fn copy_grid_template_areas_from(&mut self, other: &Self) {
        unsafe { self.gecko.mGridTemplateAreas.set(&other.gecko.mGridTemplateAreas) }
    }

    pub fn reset_grid_template_areas(&mut self, other: &Self) {
        self.copy_grid_template_areas_from(other)
    }

    pub fn clone_grid_template_areas(&self) -> values::computed::position::GridTemplateAreas {
        use std::ops::Range;
        use crate::values::None_;
        use crate::values::specified::position::{NamedArea, TemplateAreas, TemplateAreasArc};

        if self.gecko.mGridTemplateAreas.mRawPtr.is_null() {
            return Either::Second(None_);
        }

        let gecko_grid_template_areas = self.gecko.mGridTemplateAreas.mRawPtr;
        let areas = unsafe {
            let vec: Vec<NamedArea> =
                (*gecko_grid_template_areas).mNamedAreas.iter().map(|gecko_name_area| {
                    let name = gecko_name_area.mName.to_string().into_boxed_str();
                    let rows = Range {
                        start: gecko_name_area.mRowStart,
                        end: gecko_name_area.mRowEnd
                    };
                    let columns = Range {
                        start: gecko_name_area.mColumnStart,
                        end: gecko_name_area.mColumnEnd
                    };
                    NamedArea{ name, rows, columns }
                }).collect();
            vec.into_boxed_slice()
        };

        let strings = unsafe {
            let vec: Vec<Box<str>> =
                (*gecko_grid_template_areas).mTemplates.iter().map(|gecko_template| {
                    gecko_template.to_string().into_boxed_str()
                }).collect();
            vec.into_boxed_slice()
        };

        let width = unsafe {
            (*gecko_grid_template_areas).mNColumns
        };

        Either::First(TemplateAreasArc(Arc::new(TemplateAreas{ areas, strings, width })))
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for inset-block-start given a writing mode.
    pub fn set_inset_block_start(&mut self,
                                      v: longhands::inset_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn copy_inset_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn reset_inset_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-start given a writing mode.
    pub fn clone_inset_block_start(&self, wm: WritingMode)
        -> longhands::inset_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-block-end given a writing mode.
    pub fn set_inset_block_end(&mut self,
                                      v: longhands::inset_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn copy_inset_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn reset_inset_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-end given a writing mode.
    pub fn clone_inset_block_end(&self, wm: WritingMode)
        -> longhands::inset_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-inline-start given a writing mode.
    pub fn set_inset_inline_start(&mut self,
                                      v: longhands::inset_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn copy_inset_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn reset_inset_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-start given a writing mode.
    pub fn clone_inset_inline_start(&self, wm: WritingMode)
        -> longhands::inset_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-inline-end given a writing mode.
    pub fn set_inset_inline_end(&mut self,
                                      v: longhands::inset_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn copy_inset_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn reset_inset_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-end given a writing mode.
    pub fn clone_inset_inline_end(&self, wm: WritingMode)
        -> longhands::inset_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_flex_direction(&mut self, v: longhands::flex_direction::computed_value::T) {
        use crate::properties::longhands::flex_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Row =>
                    structs::NS_STYLE_FLEX_DIRECTION_ROW as u8,
                Keyword::RowReverse =>
                    structs::NS_STYLE_FLEX_DIRECTION_ROW_REVERSE as u8,
                Keyword::Column =>
                    structs::NS_STYLE_FLEX_DIRECTION_COLUMN as u8,
                Keyword::ColumnReverse =>
                    structs::NS_STYLE_FLEX_DIRECTION_COLUMN_REVERSE as u8,
        };
        self.gecko.mFlexDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_direction_from(&mut self, other: &Self) {
        self.gecko.mFlexDirection = other.gecko.mFlexDirection;
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_direction(&mut self, other: &Self) {
        self.copy_flex_direction_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_flex_direction(&self) -> longhands::flex_direction::computed_value::T {
        use crate::properties::longhands::flex_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_FLEX_DIRECTION_ROW : u8 =
            structs::NS_STYLE_FLEX_DIRECTION_ROW as u8;
        const U8_NS_STYLE_FLEX_DIRECTION_ROW_REVERSE : u8 =
            structs::NS_STYLE_FLEX_DIRECTION_ROW_REVERSE as u8;
        const U8_NS_STYLE_FLEX_DIRECTION_COLUMN : u8 =
            structs::NS_STYLE_FLEX_DIRECTION_COLUMN as u8;
        const U8_NS_STYLE_FLEX_DIRECTION_COLUMN_REVERSE : u8 =
            structs::NS_STYLE_FLEX_DIRECTION_COLUMN_REVERSE as u8;

        match self.gecko.mFlexDirection as u8 {
            U8_NS_STYLE_FLEX_DIRECTION_ROW => Keyword::Row,
            U8_NS_STYLE_FLEX_DIRECTION_ROW_REVERSE => Keyword::RowReverse,
            U8_NS_STYLE_FLEX_DIRECTION_COLUMN => Keyword::Column,
            U8_NS_STYLE_FLEX_DIRECTION_COLUMN_REVERSE => Keyword::ColumnReverse,
            _ => panic!("Found unexpected value in style struct for flex_direction property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_flex_wrap(&mut self, v: longhands::flex_wrap::computed_value::T) {
        use crate::properties::longhands::flex_wrap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Nowrap =>
                    structs::NS_STYLE_FLEX_WRAP_NOWRAP as u8,
                Keyword::Wrap =>
                    structs::NS_STYLE_FLEX_WRAP_WRAP as u8,
                Keyword::WrapReverse =>
                    structs::NS_STYLE_FLEX_WRAP_WRAP_REVERSE as u8,
        };
        self.gecko.mFlexWrap = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_wrap_from(&mut self, other: &Self) {
        self.gecko.mFlexWrap = other.gecko.mFlexWrap;
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_wrap(&mut self, other: &Self) {
        self.copy_flex_wrap_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_flex_wrap(&self) -> longhands::flex_wrap::computed_value::T {
        use crate::properties::longhands::flex_wrap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_FLEX_WRAP_NOWRAP : u8 =
            structs::NS_STYLE_FLEX_WRAP_NOWRAP as u8;
        const U8_NS_STYLE_FLEX_WRAP_WRAP : u8 =
            structs::NS_STYLE_FLEX_WRAP_WRAP as u8;
        const U8_NS_STYLE_FLEX_WRAP_WRAP_REVERSE : u8 =
            structs::NS_STYLE_FLEX_WRAP_WRAP_REVERSE as u8;

        match self.gecko.mFlexWrap as u8 {
            U8_NS_STYLE_FLEX_WRAP_NOWRAP => Keyword::Nowrap,
            U8_NS_STYLE_FLEX_WRAP_WRAP => Keyword::Wrap,
            U8_NS_STYLE_FLEX_WRAP_WRAP_REVERSE => Keyword::WrapReverse,
            _ => panic!("Found unexpected value in style struct for flex_wrap property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_flex_grow(&mut self, v: longhands::flex_grow::computed_value::T) {
        self.gecko.mFlexGrow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_grow_from(&mut self, other: &Self) {
        self.gecko.mFlexGrow = other.gecko.mFlexGrow;
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_grow(&mut self, other: &Self) {
        self.copy_flex_grow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_grow(&self) -> longhands::flex_grow::computed_value::T {
        From::from(self.gecko.mFlexGrow)
    }



    #[allow(non_snake_case)]
    pub fn set_flex_shrink(&mut self, v: longhands::flex_shrink::computed_value::T) {
        self.gecko.mFlexShrink = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_shrink_from(&mut self, other: &Self) {
        self.gecko.mFlexShrink = other.gecko.mFlexShrink;
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_shrink(&mut self, other: &Self) {
        self.copy_flex_shrink_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_shrink(&self) -> longhands::flex_shrink::computed_value::T {
        From::from(self.gecko.mFlexShrink)
    }


    #[allow(non_snake_case)]
    pub fn set_flex_basis(&mut self, v: longhands::flex_basis::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mFlexBasis);
    }
    #[allow(non_snake_case)]
    pub fn copy_flex_basis_from(&mut self, other: &Self) {
        self.gecko.mFlexBasis.copy_from(&other.gecko.mFlexBasis);
    }
    #[allow(non_snake_case)]
    pub fn reset_flex_basis(&mut self, other: &Self) {
        self.copy_flex_basis_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_flex_basis(&self) -> longhands::flex_basis::computed_value::T {
        use crate::properties::longhands::flex_basis::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mFlexBasis)
            .expect("clone for flex_basis failed")
    }

    #[allow(non_snake_case)]
    pub fn set_width(&mut self, v: longhands::width::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mWidth);
    }
    #[allow(non_snake_case)]
    pub fn copy_width_from(&mut self, other: &Self) {
        self.gecko.mWidth.copy_from(&other.gecko.mWidth);
    }
    #[allow(non_snake_case)]
    pub fn reset_width(&mut self, other: &Self) {
        self.copy_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_width(&self) -> longhands::width::computed_value::T {
        use crate::properties::longhands::width::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mWidth)
            .expect("clone for width failed")
    }

    #[allow(non_snake_case)]
    pub fn set_min_width(&mut self, v: longhands::min_width::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mMinWidth);
    }
    #[allow(non_snake_case)]
    pub fn copy_min_width_from(&mut self, other: &Self) {
        self.gecko.mMinWidth.copy_from(&other.gecko.mMinWidth);
    }
    #[allow(non_snake_case)]
    pub fn reset_min_width(&mut self, other: &Self) {
        self.copy_min_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_min_width(&self) -> longhands::min_width::computed_value::T {
        use crate::properties::longhands::min_width::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mMinWidth)
            .expect("clone for min_width failed")
    }

    #[allow(non_snake_case)]
    pub fn set_max_width(&mut self, v: longhands::max_width::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mMaxWidth);
    }
    #[allow(non_snake_case)]
    pub fn copy_max_width_from(&mut self, other: &Self) {
        self.gecko.mMaxWidth.copy_from(&other.gecko.mMaxWidth);
    }
    #[allow(non_snake_case)]
    pub fn reset_max_width(&mut self, other: &Self) {
        self.copy_max_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_max_width(&self) -> longhands::max_width::computed_value::T {
        use crate::properties::longhands::max_width::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mMaxWidth)
            .expect("clone for max_width failed")
    }

    #[allow(non_snake_case)]
    pub fn set_height(&mut self, v: longhands::height::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mHeight);
    }
    #[allow(non_snake_case)]
    pub fn copy_height_from(&mut self, other: &Self) {
        self.gecko.mHeight.copy_from(&other.gecko.mHeight);
    }
    #[allow(non_snake_case)]
    pub fn reset_height(&mut self, other: &Self) {
        self.copy_height_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_height(&self) -> longhands::height::computed_value::T {
        use crate::properties::longhands::height::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mHeight)
            .expect("clone for height failed")
    }

    #[allow(non_snake_case)]
    pub fn set_min_height(&mut self, v: longhands::min_height::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mMinHeight);
    }
    #[allow(non_snake_case)]
    pub fn copy_min_height_from(&mut self, other: &Self) {
        self.gecko.mMinHeight.copy_from(&other.gecko.mMinHeight);
    }
    #[allow(non_snake_case)]
    pub fn reset_min_height(&mut self, other: &Self) {
        self.copy_min_height_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_min_height(&self) -> longhands::min_height::computed_value::T {
        use crate::properties::longhands::min_height::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mMinHeight)
            .expect("clone for min_height failed")
    }

    #[allow(non_snake_case)]
    pub fn set_max_height(&mut self, v: longhands::max_height::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mMaxHeight);
    }
    #[allow(non_snake_case)]
    pub fn copy_max_height_from(&mut self, other: &Self) {
        self.gecko.mMaxHeight.copy_from(&other.gecko.mMaxHeight);
    }
    #[allow(non_snake_case)]
    pub fn reset_max_height(&mut self, other: &Self) {
        self.copy_max_height_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_max_height(&self) -> longhands::max_height::computed_value::T {
        use crate::properties::longhands::max_height::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mMaxHeight)
            .expect("clone for max_height failed")
    }

    
    /// Set the appropriate physical property for block-size given a writing mode.
    pub fn set_block_size(&mut self,
                                      v: longhands::block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_width(v)
            
        } else {
            
                self.set_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn copy_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_width_from(other)
            
        } else {
            
                self.copy_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn reset_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// block-size given a writing mode.
    pub fn clone_block_size(&self, wm: WritingMode)
        -> longhands::block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_width()
        
        } else {
            
            self.clone_height()
        
        }

    }


    
    /// Set the appropriate physical property for min-block-size given a writing mode.
    pub fn set_min_block_size(&mut self,
                                      v: longhands::min_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_width(v)
            
        } else {
            
                self.set_min_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn copy_min_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_width_from(other)
            
        } else {
            
                self.copy_min_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn reset_min_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-block-size given a writing mode.
    pub fn clone_min_block_size(&self, wm: WritingMode)
        -> longhands::min_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_width()
        
        } else {
            
            self.clone_min_height()
        
        }

    }


    
    /// Set the appropriate physical property for max-block-size given a writing mode.
    pub fn set_max_block_size(&mut self,
                                      v: longhands::max_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_width(v)
            
        } else {
            
                self.set_max_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn copy_max_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_width_from(other)
            
        } else {
            
                self.copy_max_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn reset_max_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-block-size given a writing mode.
    pub fn clone_max_block_size(&self, wm: WritingMode)
        -> longhands::max_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_width()
        
        } else {
            
            self.clone_max_height()
        
        }

    }


    
    /// Set the appropriate physical property for inline-size given a writing mode.
    pub fn set_inline_size(&mut self,
                                      v: longhands::inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_height(v)
            
        } else {
            
                self.set_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn copy_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_height_from(other)
            
        } else {
            
                self.copy_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn reset_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inline-size given a writing mode.
    pub fn clone_inline_size(&self, wm: WritingMode)
        -> longhands::inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_height()
        
        } else {
            
            self.clone_width()
        
        }

    }


    
    /// Set the appropriate physical property for min-inline-size given a writing mode.
    pub fn set_min_inline_size(&mut self,
                                      v: longhands::min_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_height(v)
            
        } else {
            
                self.set_min_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn copy_min_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_height_from(other)
            
        } else {
            
                self.copy_min_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn reset_min_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-inline-size given a writing mode.
    pub fn clone_min_inline_size(&self, wm: WritingMode)
        -> longhands::min_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_height()
        
        } else {
            
            self.clone_min_width()
        
        }

    }


    
    /// Set the appropriate physical property for max-inline-size given a writing mode.
    pub fn set_max_inline_size(&mut self,
                                      v: longhands::max_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_height(v)
            
        } else {
            
                self.set_max_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn copy_max_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_height_from(other)
            
        } else {
            
                self.copy_max_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn reset_max_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-inline-size given a writing mode.
    pub fn clone_max_inline_size(&self, wm: WritingMode)
        -> longhands::max_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_height()
        
        } else {
            
            self.clone_max_width()
        
        }

    }



    #[allow(non_snake_case)]
    pub fn set_box_sizing(&mut self, v: longhands::box_sizing::computed_value::T) {
        use crate::properties::longhands::box_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ContentBox =>
                    structs::StyleBoxSizing::Content ,
                Keyword::BorderBox =>
                    structs::StyleBoxSizing::Border ,
        };
        self.gecko.mBoxSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_box_sizing_from(&mut self, other: &Self) {
        self.gecko.mBoxSizing = other.gecko.mBoxSizing;
    }

    #[allow(non_snake_case)]
    pub fn reset_box_sizing(&mut self, other: &Self) {
        self.copy_box_sizing_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_box_sizing(&self) -> longhands::box_sizing::computed_value::T {
        use crate::properties::longhands::box_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxSizing {
            structs::StyleBoxSizing::Content => Keyword::ContentBox,
            structs::StyleBoxSizing::Border => Keyword::BorderBox,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_object_fit(&mut self, v: longhands::object_fit::computed_value::T) {
        use crate::properties::longhands::object_fit::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Fill =>
                    structs::NS_STYLE_OBJECT_FIT_FILL as u8,
                Keyword::Contain =>
                    structs::NS_STYLE_OBJECT_FIT_CONTAIN as u8,
                Keyword::Cover =>
                    structs::NS_STYLE_OBJECT_FIT_COVER as u8,
                Keyword::None =>
                    structs::NS_STYLE_OBJECT_FIT_NONE as u8,
                Keyword::ScaleDown =>
                    structs::NS_STYLE_OBJECT_FIT_SCALE_DOWN as u8,
        };
        self.gecko.mObjectFit = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_object_fit_from(&mut self, other: &Self) {
        self.gecko.mObjectFit = other.gecko.mObjectFit;
    }

    #[allow(non_snake_case)]
    pub fn reset_object_fit(&mut self, other: &Self) {
        self.copy_object_fit_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_object_fit(&self) -> longhands::object_fit::computed_value::T {
        use crate::properties::longhands::object_fit::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_OBJECT_FIT_FILL : u8 =
            structs::NS_STYLE_OBJECT_FIT_FILL as u8;
        const U8_NS_STYLE_OBJECT_FIT_CONTAIN : u8 =
            structs::NS_STYLE_OBJECT_FIT_CONTAIN as u8;
        const U8_NS_STYLE_OBJECT_FIT_COVER : u8 =
            structs::NS_STYLE_OBJECT_FIT_COVER as u8;
        const U8_NS_STYLE_OBJECT_FIT_NONE : u8 =
            structs::NS_STYLE_OBJECT_FIT_NONE as u8;
        const U8_NS_STYLE_OBJECT_FIT_SCALE_DOWN : u8 =
            structs::NS_STYLE_OBJECT_FIT_SCALE_DOWN as u8;

        match self.gecko.mObjectFit as u8 {
            U8_NS_STYLE_OBJECT_FIT_FILL => Keyword::Fill,
            U8_NS_STYLE_OBJECT_FIT_CONTAIN => Keyword::Contain,
            U8_NS_STYLE_OBJECT_FIT_COVER => Keyword::Cover,
            U8_NS_STYLE_OBJECT_FIT_NONE => Keyword::None,
            U8_NS_STYLE_OBJECT_FIT_SCALE_DOWN => Keyword::ScaleDown,
            _ => panic!("Found unexpected value in style struct for object_fit property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set_object_position(&mut self, v: longhands::object_position::computed_value::T) {
        self.gecko.mObjectPosition.mXPosition = v.horizontal.into();
        self.gecko.mObjectPosition.mYPosition = v.vertical.into();
    }
    
    #[allow(non_snake_case)]
    pub fn copy_object_position_from(&mut self, other: &Self) {
        self.gecko.mObjectPosition = other.gecko.mObjectPosition;
    }

    #[allow(non_snake_case)]
    pub fn reset_object_position(&mut self, other: &Self) {
        self.copy_object_position_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_object_position(&self) -> longhands::object_position::computed_value::T {
        longhands::object_position::computed_value::T {
            horizontal: self.gecko.mObjectPosition.mXPosition.into(),
            vertical: self.gecko.mObjectPosition.mYPosition.into(),
        }
    }

    #[allow(non_snake_case)]
    pub fn set_column_gap(&mut self, v: longhands::column_gap::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mColumnGap);
    }
    #[allow(non_snake_case)]
    pub fn copy_column_gap_from(&mut self, other: &Self) {
        self.gecko.mColumnGap.copy_from(&other.gecko.mColumnGap);
    }
    #[allow(non_snake_case)]
    pub fn reset_column_gap(&mut self, other: &Self) {
        self.copy_column_gap_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_column_gap(&self) -> longhands::column_gap::computed_value::T {
        use crate::properties::longhands::column_gap::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mColumnGap)
            .expect("clone for column_gap failed")
    }

    #[allow(non_snake_case)]
    pub fn set_row_gap(&mut self, v: longhands::row_gap::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mRowGap);
    }
    #[allow(non_snake_case)]
    pub fn copy_row_gap_from(&mut self, other: &Self) {
        self.gecko.mRowGap.copy_from(&other.gecko.mRowGap);
    }
    #[allow(non_snake_case)]
    pub fn reset_row_gap(&mut self, other: &Self) {
        self.copy_row_gap_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_row_gap(&self) -> longhands::row_gap::computed_value::T {
        use crate::properties::longhands::row_gap::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mRowGap)
            .expect("clone for row_gap failed")
    }

}





impl GeckoOutline {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_outline_style(&mut self, v: longhands::outline_style::computed_value::T) {
        self.gecko.mOutlineStyle = v;
        // NB: This is needed to correctly handling the initial value of
        // outline-width when outline-style changes, see the
        // update_border_left comment for more details.
        self.gecko.mActualOutlineWidth = self.gecko.mOutlineWidth;
    }

    pub fn copy_outline_style_from(&mut self, other: &Self) {
        // FIXME(emilio): Why doesn't this need to reset mActualOutlineWidth?
        // Looks fishy.
        self.gecko.mOutlineStyle = other.gecko.mOutlineStyle;
    }

    pub fn reset_outline_style(&mut self, other: &Self) {
        self.copy_outline_style_from(other)
    }

    pub fn clone_outline_style(&self) -> longhands::outline_style::computed_value::T {
        self.gecko.mOutlineStyle.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_outline_width(&mut self, v: longhands::outline_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mOutlineWidth = value;
        self.gecko.mActualOutlineWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_outline_width_from(&mut self, other: &Self) {
        self.gecko.mOutlineWidth = other.gecko.mOutlineWidth;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mActualOutlineWidth = other.gecko.mOutlineWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_width(&mut self, other: &Self) {
        self.copy_outline_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_outline_width(&self) -> longhands::outline_width::computed_value::T {
        Au(self.gecko.mActualOutlineWidth).into()
    }


    
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_topleft(&mut self, v: longhands::_moz_outline_radius_topleft::computed_value::T) {
        v.0.width().to_gecko_style_coord(&mut self.gecko.mOutlineRadius.data_at_mut(0));
        v.0.height().to_gecko_style_coord(&mut self.gecko.mOutlineRadius.data_at_mut(1));
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_outline_radius_topleft_from(&mut self, other: &Self) {
        self.gecko.mOutlineRadius.data_at_mut(0)
                  .copy_from(&other.gecko.mOutlineRadius.data_at(0));
        self.gecko.mOutlineRadius.data_at_mut(1)
                  .copy_from(&other.gecko.mOutlineRadius.data_at(1));
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_outline_radius_topleft(&mut self, other: &Self) {
        self.copy__moz_outline_radius_topleft_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_topleft(&self) -> longhands::_moz_outline_radius_topleft::computed_value::T {
        use crate::values::computed::border::BorderCornerRadius;
        let width = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mOutlineRadius.data_at(0))
                        .expect("Failed to clone _moz_outline_radius_topleft");
        let height = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mOutlineRadius.data_at(1))
                        .expect("Failed to clone _moz_outline_radius_topleft");
        BorderCornerRadius::new(width, height)
    }

    
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_topright(&mut self, v: longhands::_moz_outline_radius_topright::computed_value::T) {
        v.0.width().to_gecko_style_coord(&mut self.gecko.mOutlineRadius.data_at_mut(2));
        v.0.height().to_gecko_style_coord(&mut self.gecko.mOutlineRadius.data_at_mut(3));
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_outline_radius_topright_from(&mut self, other: &Self) {
        self.gecko.mOutlineRadius.data_at_mut(2)
                  .copy_from(&other.gecko.mOutlineRadius.data_at(2));
        self.gecko.mOutlineRadius.data_at_mut(3)
                  .copy_from(&other.gecko.mOutlineRadius.data_at(3));
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_outline_radius_topright(&mut self, other: &Self) {
        self.copy__moz_outline_radius_topright_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_topright(&self) -> longhands::_moz_outline_radius_topright::computed_value::T {
        use crate::values::computed::border::BorderCornerRadius;
        let width = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mOutlineRadius.data_at(2))
                        .expect("Failed to clone _moz_outline_radius_topright");
        let height = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mOutlineRadius.data_at(3))
                        .expect("Failed to clone _moz_outline_radius_topright");
        BorderCornerRadius::new(width, height)
    }

    
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_bottomright(&mut self, v: longhands::_moz_outline_radius_bottomright::computed_value::T) {
        v.0.width().to_gecko_style_coord(&mut self.gecko.mOutlineRadius.data_at_mut(4));
        v.0.height().to_gecko_style_coord(&mut self.gecko.mOutlineRadius.data_at_mut(5));
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_outline_radius_bottomright_from(&mut self, other: &Self) {
        self.gecko.mOutlineRadius.data_at_mut(4)
                  .copy_from(&other.gecko.mOutlineRadius.data_at(4));
        self.gecko.mOutlineRadius.data_at_mut(5)
                  .copy_from(&other.gecko.mOutlineRadius.data_at(5));
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_outline_radius_bottomright(&mut self, other: &Self) {
        self.copy__moz_outline_radius_bottomright_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_bottomright(&self) -> longhands::_moz_outline_radius_bottomright::computed_value::T {
        use crate::values::computed::border::BorderCornerRadius;
        let width = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mOutlineRadius.data_at(4))
                        .expect("Failed to clone _moz_outline_radius_bottomright");
        let height = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mOutlineRadius.data_at(5))
                        .expect("Failed to clone _moz_outline_radius_bottomright");
        BorderCornerRadius::new(width, height)
    }

    
    #[allow(non_snake_case)]
    pub fn set__moz_outline_radius_bottomleft(&mut self, v: longhands::_moz_outline_radius_bottomleft::computed_value::T) {
        v.0.width().to_gecko_style_coord(&mut self.gecko.mOutlineRadius.data_at_mut(6));
        v.0.height().to_gecko_style_coord(&mut self.gecko.mOutlineRadius.data_at_mut(7));
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_outline_radius_bottomleft_from(&mut self, other: &Self) {
        self.gecko.mOutlineRadius.data_at_mut(6)
                  .copy_from(&other.gecko.mOutlineRadius.data_at(6));
        self.gecko.mOutlineRadius.data_at_mut(7)
                  .copy_from(&other.gecko.mOutlineRadius.data_at(7));
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_outline_radius_bottomleft(&mut self, other: &Self) {
        self.copy__moz_outline_radius_bottomleft_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_outline_radius_bottomleft(&self) -> longhands::_moz_outline_radius_bottomleft::computed_value::T {
        use crate::values::computed::border::BorderCornerRadius;
        let width = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mOutlineRadius.data_at(6))
                        .expect("Failed to clone _moz_outline_radius_bottomleft");
        let height = GeckoStyleCoordConvertible::from_gecko_style_coord(
                        &self.gecko.mOutlineRadius.data_at(7))
                        .expect("Failed to clone _moz_outline_radius_bottomleft");
        BorderCornerRadius::new(width, height)
    }


    pub fn outline_has_nonzero_width(&self) -> bool {
        self.gecko.mActualOutlineWidth != 0
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_outline_color(&mut self, v: longhands::outline_color::computed_value::T) {
        self.gecko.mOutlineColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_outline_color_from(&mut self, other: &Self) {
        let color = other.gecko.mOutlineColor;
        self.gecko.mOutlineColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_color(&mut self, other: &Self) {
        self.copy_outline_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_outline_color(&self) -> longhands::outline_color::computed_value::T {
        self.gecko.mOutlineColor.into()
    }


    #[allow(non_snake_case)]
    pub fn set_outline_offset(&mut self, v: longhands::outline_offset::computed_value::T) {
        self.gecko.mOutlineOffset = v.to_i32_au();
    }
    
    #[allow(non_snake_case)]
    pub fn copy_outline_offset_from(&mut self, other: &Self) {
        self.gecko.mOutlineOffset = other.gecko.mOutlineOffset;
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_offset(&mut self, other: &Self) {
        self.copy_outline_offset_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_outline_offset(&self) -> longhands::outline_offset::computed_value::T {
        Au(self.gecko.mOutlineOffset).into()
    }

}





impl GeckoFont {
    /*
     * Manually-Implemented Methods.
     */
    

    // Negative numbers are invalid at parse time, but <integer> is still an
    // i32.
    
    

    pub fn set_font_feature_settings(&mut self, v: longhands::font_feature_settings::computed_value::T) {
        let iter = v.0.iter().map(|other| structs::gfxFontFeature {
            mTag: other.tag.0,
            mValue: other.value as u32,
        });
        self.gecko.mFont.fontFeatureSettings.assign_from_iter_pod(iter);
    }

    pub fn copy_font_feature_settings_from(&mut self, other: &Self) {
        let iter = other.gecko.mFont.fontFeatureSettings.iter().map(|s| *s);
        self.gecko.mFont.fontFeatureSettings.assign_from_iter_pod(iter);
    }

    pub fn reset_font_feature_settings(&mut self, other: &Self) {
        self.copy_font_feature_settings_from(other)
    }

    pub fn clone_font_feature_settings(&self) -> longhands::font_feature_settings::computed_value::T {
        use crate::values::generics::font::{FontSettings, FontTag, FeatureTagValue};

        FontSettings(
            self.gecko.mFont.fontFeatureSettings.iter().map(|gecko_font_setting| {
                FeatureTagValue {
                    tag: FontTag(gecko_font_setting.mTag),
                    value: gecko_font_setting.mValue as i32,
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }

    
    

    pub fn set_font_variation_settings(&mut self, v: longhands::font_variation_settings::computed_value::T) {
        let iter = v.0.iter().map(|other| structs::gfxFontVariation {
            mTag: other.tag.0,
            mValue: other.value as f32,
        });
        self.gecko.mFont.fontVariationSettings.assign_from_iter_pod(iter);
    }

    pub fn copy_font_variation_settings_from(&mut self, other: &Self) {
        let iter = other.gecko.mFont.fontVariationSettings.iter().map(|s| *s);
        self.gecko.mFont.fontVariationSettings.assign_from_iter_pod(iter);
    }

    pub fn reset_font_variation_settings(&mut self, other: &Self) {
        self.copy_font_variation_settings_from(other)
    }

    pub fn clone_font_variation_settings(&self) -> longhands::font_variation_settings::computed_value::T {
        use crate::values::generics::font::{FontSettings, FontTag, VariationValue};

        FontSettings(
            self.gecko.mFont.fontVariationSettings.iter().map(|gecko_font_setting| {
                VariationValue {
                    tag: FontTag(gecko_font_setting.mTag),
                    value: gecko_font_setting.mValue as f32,
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }


    pub fn fixup_none_generic(&mut self, device: &Device) {
        self.gecko.mFont.systemFont = false;
        unsafe {
            bindings::Gecko_nsStyleFont_FixupNoneGeneric(&mut self.gecko, device.pres_context())
        }
    }

    pub fn fixup_system(&mut self, default_font_type: structs::FontFamilyType) {
        self.gecko.mFont.systemFont = true;
        self.gecko.mGenericID = structs::kGenericFont_NONE;
        self.gecko.mFont.fontlist.mDefaultFontType = default_font_type;
    }

    pub fn set_font_family(&mut self, v: longhands::font_family::computed_value::T) {
        self.gecko.mGenericID = structs::kGenericFont_NONE;
        if let Some(generic) = v.0.single_generic() {
            self.gecko.mGenericID = generic;
        }
        self.gecko.mFont.fontlist.mFontlist.mBasePtr.set_move((v.0).0.clone());
    }

    pub fn copy_font_family_from(&mut self, other: &Self) {
        unsafe { Gecko_CopyFontFamilyFrom(&mut self.gecko.mFont, &other.gecko.mFont); }
        self.gecko.mGenericID = other.gecko.mGenericID;
        self.gecko.mFont.systemFont = other.gecko.mFont.systemFont;
    }

    pub fn reset_font_family(&mut self, other: &Self) {
        self.copy_font_family_from(other)
    }

    pub fn clone_font_family(&self) -> longhands::font_family::computed_value::T {
        use crate::gecko_bindings::structs::FontFamilyType;
        use crate::values::computed::font::{FontFamily, SingleFontFamily, FontFamilyList};

        let fontlist = &self.gecko.mFont.fontlist;
        let shared_fontlist = unsafe { fontlist.mFontlist.mBasePtr.to_safe() };

        if shared_fontlist.mNames.is_empty() {
            let default = fontlist.mDefaultFontType;
            let default = match default {
                FontFamilyType::eFamily_serif => {
                    SingleFontFamily::Generic(atom!("serif"))
                }
                _ => {
                    // This can break with some combinations of user prefs, see
                    // bug 1442195 for example. It doesn't really matter in this
                    // case...
                    //
                    // FIXME(emilio): Probably should be storing the whole
                    // default font name instead though.
                    debug_assert_eq!(
                        default,
                        FontFamilyType::eFamily_sans_serif,
                        "Default generic should be serif or sans-serif"
                    );
                    SingleFontFamily::Generic(atom!("sans-serif"))
                }
            };
            FontFamily(FontFamilyList::new(Box::new([default])))
        } else {
            FontFamily(FontFamilyList(shared_fontlist))
        }
    }

    pub fn unzoom_fonts(&mut self, device: &Device) {
        self.gecko.mSize = device.unzoom_text(Au(self.gecko.mSize)).0;
        self.gecko.mScriptUnconstrainedSize = device.unzoom_text(Au(self.gecko.mScriptUnconstrainedSize)).0;
        self.gecko.mFont.size = device.unzoom_text(Au(self.gecko.mFont.size)).0;
    }

    pub fn set_font_size(&mut self, v: FontSize) {
        use crate::values::generics::font::KeywordSize;
        self.gecko.mSize = v.size().0;
        self.gecko.mScriptUnconstrainedSize = v.size().0;
        if let Some(info) = v.keyword_info {
            self.gecko.mFontSizeKeyword = match info.kw {
                KeywordSize::XXSmall => structs::NS_STYLE_FONT_SIZE_XXSMALL,
                KeywordSize::XSmall => structs::NS_STYLE_FONT_SIZE_XSMALL,
                KeywordSize::Small => structs::NS_STYLE_FONT_SIZE_SMALL,
                KeywordSize::Medium => structs::NS_STYLE_FONT_SIZE_MEDIUM,
                KeywordSize::Large => structs::NS_STYLE_FONT_SIZE_LARGE,
                KeywordSize::XLarge => structs::NS_STYLE_FONT_SIZE_XLARGE,
                KeywordSize::XXLarge => structs::NS_STYLE_FONT_SIZE_XXLARGE,
                KeywordSize::XXXLarge => structs::NS_STYLE_FONT_SIZE_XXXLARGE,
            } as u8;
            self.gecko.mFontSizeFactor = info.factor;
            self.gecko.mFontSizeOffset = info.offset.0.to_i32_au();
        } else {
            self.gecko.mFontSizeKeyword = structs::NS_STYLE_FONT_SIZE_NO_KEYWORD as u8;
            self.gecko.mFontSizeFactor = 1.;
            self.gecko.mFontSizeOffset = 0;
        }
    }

    /// Set font size, taking into account scriptminsize and scriptlevel
    /// Returns Some(size) if we have to recompute the script unconstrained size
    pub fn apply_font_size(
        &mut self,
        v: FontSize,
        parent: &Self,
        device: &Device,
    ) -> Option<NonNegativeLength> {
        let (adjusted_size, adjusted_unconstrained_size) =
            self.calculate_script_level_size(parent, device);
        // In this case, we have been unaffected by scriptminsize, ignore it
        if parent.gecko.mSize == parent.gecko.mScriptUnconstrainedSize &&
           adjusted_size == adjusted_unconstrained_size {
            self.set_font_size(v);
            self.fixup_font_min_size(device);
            None
        } else {
            self.gecko.mSize = v.size().0;
            self.fixup_font_min_size(device);
            Some(Au(parent.gecko.mScriptUnconstrainedSize).into())
        }
    }

    pub fn fixup_font_min_size(&mut self, device: &Device) {
        unsafe { bindings::Gecko_nsStyleFont_FixupMinFontSize(&mut self.gecko, device.pres_context()) }
    }

    pub fn apply_unconstrained_font_size(&mut self, v: NonNegativeLength) {
        self.gecko.mScriptUnconstrainedSize = v.0.to_i32_au();
    }

    /// Calculates the constrained and unconstrained font sizes to be inherited
    /// from the parent.
    ///
    /// This is a port of Gecko's old ComputeScriptLevelSize function:
    /// https://searchfox.org/mozilla-central/rev/c05d9d61188d32b8/layout/style/nsRuleNode.cpp#3103
    ///
    /// scriptlevel is a property that affects how font-size is inherited. If scriptlevel is
    /// +1, for example, it will inherit as the script size multiplier times
    /// the parent font. This does not affect cases where the font-size is
    /// explicitly set.
    ///
    /// However, this transformation is not allowed to reduce the size below
    /// scriptminsize. If this inheritance will reduce it to below
    /// scriptminsize, it will be set to scriptminsize or the parent size,
    /// whichever is smaller (the parent size could be smaller than the min size
    /// because it was explicitly specified).
    ///
    /// Now, within a node that has inherited a font-size which was
    /// crossing scriptminsize once the scriptlevel was applied, a negative
    /// scriptlevel may be used to increase the size again.
    ///
    /// This should work, however if we have already been capped by the
    /// scriptminsize multiple times, this can lead to a jump in the size.
    ///
    /// For example, if we have text of the form:
    ///
    /// huge large medium small tiny reallytiny tiny small medium huge
    ///
    /// which is represented by progressive nesting and scriptlevel values of
    /// +1 till the center after which the scriptlevel is -1, the "tiny"s should
    /// be the same size, as should be the "small"s and "medium"s, etc.
    ///
    /// However, if scriptminsize kicked it at around "medium", then
    /// medium/tiny/reallytiny will all be the same size (the min size).
    /// A -1 scriptlevel change after this will increase the min size by the
    /// multiplier, making the second tiny larger than medium.
    ///
    /// Instead, we wish for the second "tiny" to still be capped by the script
    /// level, and when we reach the second "large", it should be the same size
    /// as the original one.
    ///
    /// We do this by cascading two separate font sizes. The font size (mSize)
    /// is the actual displayed font size. The unconstrained font size
    /// (mScriptUnconstrainedSize) is the font size in the situation where
    /// scriptminsize never applied.
    ///
    /// We calculate the proposed inherited font size based on scriptlevel and
    /// the parent unconstrained size, instead of using the parent font size.
    /// This is stored in the node's unconstrained size and will also be stored
    /// in the font size provided that it is above the min size.
    ///
    /// All of this only applies when inheriting. When the font size is
    /// manually set, scriptminsize does not apply, and both the real and
    /// unconstrained size are set to the explicit value. However, if the font
    /// size is manually set to an em or percent unit, the unconstrained size
    /// will be set to the value of that unit computed against the parent
    /// unconstrained size, whereas the font size will be set computing against
    /// the parent font size.
    pub fn calculate_script_level_size(&self, parent: &Self, device: &Device) -> (Au, Au) {
        use std::cmp;

        let delta = self.gecko.mScriptLevel.saturating_sub(parent.gecko.mScriptLevel);

        let parent_size = Au(parent.gecko.mSize);
        let parent_unconstrained_size = Au(parent.gecko.mScriptUnconstrainedSize);

        if delta == 0 {
            return (parent_size, parent_unconstrained_size)
        }


        let mut min = Au(parent.gecko.mScriptMinSize);
        if self.gecko.mAllowZoom {
            min = device.zoom_text(min);
        }

        let scale = (parent.gecko.mScriptSizeMultiplier as f32).powi(delta as i32);

        let new_size = parent_size.scale_by(scale);
        let new_unconstrained_size = parent_unconstrained_size.scale_by(scale);

        if scale < 1. {
            // The parent size can be smaller than scriptminsize,
            // e.g. if it was specified explicitly. Don't scale
            // in this case, but we don't want to set it to scriptminsize
            // either since that will make it larger.
            if parent_size < min {
                (parent_size, new_unconstrained_size)
            } else {
                (cmp::max(min, new_size), new_unconstrained_size)
            }
        } else {
            // If the new unconstrained size is larger than the min size,
            // this means we have escaped the grasp of scriptminsize
            // and can revert to using the unconstrained size.
            // However, if the new size is even larger (perhaps due to usage
            // of em units), use that instead.
            (cmp::min(new_size, cmp::max(new_unconstrained_size, min)),
             new_unconstrained_size)
        }
    }

    /// This function will also handle scriptminsize and scriptlevel
    /// so should not be called when you just want the font sizes to be copied.
    /// Hence the different name.
    pub fn inherit_font_size_from(&mut self, parent: &Self,
                                  kw_inherited_size: Option<NonNegativeLength>,
                                  device: &Device) {
        let (adjusted_size, adjusted_unconstrained_size)
            = self.calculate_script_level_size(parent, device);
        if adjusted_size.0 != parent.gecko.mSize ||
           adjusted_unconstrained_size.0 != parent.gecko.mScriptUnconstrainedSize {
            // FIXME(Manishearth): This is incorrect. When there is both a
            // keyword size being inherited and a scriptlevel change, we must
            // handle the keyword size the same way we handle em units. This
            // complicates things because we now have to keep track of the
            // adjusted and unadjusted ratios in the kw font size. This only
            // affects the use case of a generic font being used in MathML.
            //
            // If we were to fix this I would prefer doing it not doing
            // something like the ruletree walk that Gecko used to do in
            // nsRuleNode::SetGenericFont and instead using extra bookkeeping in
            // the mSize and mScriptUnconstrainedSize values, and reusing those
            // instead of font_size_keyword.

            // In the case that MathML has given us an adjusted size, apply it.
            // Keep track of the unconstrained adjusted size.
            self.gecko.mSize = adjusted_size.0;

            // Technically the MathML constrained size may also be keyword-derived
            // but we ignore this since it would be too complicated
            // to correctly track and it's mostly unnecessary.
            self.gecko.mFontSizeKeyword = structs::NS_STYLE_FONT_SIZE_NO_KEYWORD as u8;
            self.gecko.mFontSizeFactor = 1.;
            self.gecko.mFontSizeOffset = 0;

            self.gecko.mScriptUnconstrainedSize = adjusted_unconstrained_size.0;
        } else if let Some(size) = kw_inherited_size {
            // Parent element was a keyword-derived size.
            self.gecko.mSize = size.0.to_i32_au();
            // Copy keyword info over.
            self.gecko.mFontSizeFactor = parent.gecko.mFontSizeFactor;
            self.gecko.mFontSizeOffset = parent.gecko.mFontSizeOffset;
            self.gecko.mFontSizeKeyword = parent.gecko.mFontSizeKeyword;
            // MathML constraints didn't apply here, so we can ignore this.
            self.gecko.mScriptUnconstrainedSize = size.0.to_i32_au();
        } else {
            // MathML isn't affecting us, and our parent element does not
            // have a keyword-derived size. Set things normally.
            self.gecko.mSize = parent.gecko.mSize;
            // copy keyword info over
            self.gecko.mFontSizeKeyword = structs::NS_STYLE_FONT_SIZE_NO_KEYWORD as u8;
            self.gecko.mFontSizeFactor = 1.;
            self.gecko.mFontSizeOffset = 0;
            self.gecko.mScriptUnconstrainedSize = parent.gecko.mScriptUnconstrainedSize;
        }
        self.fixup_font_min_size(device);
    }

    pub fn clone_font_size(&self) -> FontSize {
        use crate::values::generics::font::{KeywordInfo, KeywordSize};
        let size = Au(self.gecko.mSize).into();
        let kw = match self.gecko.mFontSizeKeyword as u32 {
            structs::NS_STYLE_FONT_SIZE_XXSMALL => KeywordSize::XXSmall,
            structs::NS_STYLE_FONT_SIZE_XSMALL => KeywordSize::XSmall,
            structs::NS_STYLE_FONT_SIZE_SMALL => KeywordSize::Small,
            structs::NS_STYLE_FONT_SIZE_MEDIUM => KeywordSize::Medium,
            structs::NS_STYLE_FONT_SIZE_LARGE => KeywordSize::Large,
            structs::NS_STYLE_FONT_SIZE_XLARGE => KeywordSize::XLarge,
            structs::NS_STYLE_FONT_SIZE_XXLARGE => KeywordSize::XXLarge,
            structs::NS_STYLE_FONT_SIZE_XXXLARGE => KeywordSize::XXXLarge,
            structs::NS_STYLE_FONT_SIZE_NO_KEYWORD => {
                return FontSize {
                    size: size,
                    keyword_info: None,
                }
            }
            _ => unreachable!("mFontSizeKeyword should be an absolute keyword or NO_KEYWORD")
        };
        FontSize {
            size: size,
            keyword_info: Some(KeywordInfo {
                kw: kw,
                factor: self.gecko.mFontSizeFactor,
                offset: Au(self.gecko.mFontSizeOffset).into()
            })
        }
    }

    pub fn set_font_weight(&mut self, v: longhands::font_weight::computed_value::T) {
        unsafe { bindings::Gecko_FontWeight_SetFloat(&mut self.gecko.mFont.weight, v.0) };
    }
    
    #[allow(non_snake_case)]
    pub fn copy_font_weight_from(&mut self, other: &Self) {
        self.gecko.mFont.weight = other.gecko.mFont.weight;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_weight(&mut self, other: &Self) {
        self.copy_font_weight_from(other)
    }


    pub fn clone_font_weight(&self) -> longhands::font_weight::computed_value::T {
        let weight: f32 = unsafe {
            bindings::Gecko_FontWeight_ToFloat(self.gecko.mFont.weight)
        };
        longhands::font_weight::computed_value::T(weight)
    }

    pub fn set_font_stretch(&mut self, v: longhands::font_stretch::computed_value::T) {
        unsafe {
            bindings::Gecko_FontStretch_SetFloat(
                &mut self.gecko.mFont.stretch,
                v.value(),
            )
        };
    }
    
    #[allow(non_snake_case)]
    pub fn copy_font_stretch_from(&mut self, other: &Self) {
        self.gecko.mFont.stretch = other.gecko.mFont.stretch;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_stretch(&mut self, other: &Self) {
        self.copy_font_stretch_from(other)
    }

    pub fn clone_font_stretch(&self) -> longhands::font_stretch::computed_value::T {
        use crate::values::computed::font::FontStretch;
        use crate::values::computed::Percentage;
        use crate::values::generics::NonNegative;

        let stretch =
            unsafe { bindings::Gecko_FontStretch_ToFloat(self.gecko.mFont.stretch) };
        debug_assert!(stretch >= 0.);

        FontStretch(NonNegative(Percentage(stretch)))
    }

    pub fn set_font_style(&mut self, v: longhands::font_style::computed_value::T) {
        use crate::values::generics::font::FontStyle;
        let s = &mut self.gecko.mFont.style;
        unsafe {
            match v {
                FontStyle::Normal => bindings::Gecko_FontSlantStyle_SetNormal(s),
                FontStyle::Italic => bindings::Gecko_FontSlantStyle_SetItalic(s),
                FontStyle::Oblique(ref angle) => {
                    bindings::Gecko_FontSlantStyle_SetOblique(s, angle.0.degrees())
                }
            }
        }
    }
    
    #[allow(non_snake_case)]
    pub fn copy_font_style_from(&mut self, other: &Self) {
        self.gecko.mFont.style = other.gecko.mFont.style;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_style(&mut self, other: &Self) {
        self.copy_font_style_from(other)
    }

    pub fn clone_font_style(&self) -> longhands::font_style::computed_value::T {
        use crate::values::computed::font::FontStyle;
        FontStyle::from_gecko(self.gecko.mFont.style)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_font_synthesis(&mut self, v: longhands::font_synthesis::computed_value::T) {
        self.gecko.mFont.synthesis = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_synthesis_from(&mut self, other: &Self) {
        self.gecko.mFont.synthesis = other.gecko.mFont.synthesis;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_synthesis(&mut self, other: &Self) {
        self.copy_font_synthesis_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_synthesis(&self) -> longhands::font_synthesis::computed_value::T {
        From::from(self.gecko.mFont.synthesis)
    }


    pub fn set_font_size_adjust(&mut self, v: longhands::font_size_adjust::computed_value::T) {
        use crate::properties::longhands::font_size_adjust::computed_value::T;
        match v {
            T::None => self.gecko.mFont.sizeAdjust = -1.0 as f32,
            T::Number(n) => self.gecko.mFont.sizeAdjust = n,
        }
    }

    pub fn copy_font_size_adjust_from(&mut self, other: &Self) {
        self.gecko.mFont.sizeAdjust = other.gecko.mFont.sizeAdjust;
    }

    pub fn reset_font_size_adjust(&mut self, other: &Self) {
        self.copy_font_size_adjust_from(other)
    }

    pub fn clone_font_size_adjust(&self) -> longhands::font_size_adjust::computed_value::T {
        use crate::properties::longhands::font_size_adjust::computed_value::T;
        T::from_gecko_adjust(self.gecko.mFont.sizeAdjust)
    }

    #[allow(non_snake_case)]
    pub fn set__x_lang(&mut self, v: longhands::_x_lang::computed_value::T) {
        let ptr = v.0.as_ptr();
        forget(v);
        unsafe {
            Gecko_nsStyleFont_SetLang(&mut self.gecko, ptr);
        }
    }

    #[allow(non_snake_case)]
    pub fn copy__x_lang_from(&mut self, other: &Self) {
        unsafe {
            Gecko_nsStyleFont_CopyLangFrom(&mut self.gecko, &other.gecko);
        }
    }

    #[allow(non_snake_case)]
    pub fn reset__x_lang(&mut self, other: &Self) {
        self.copy__x_lang_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__x_lang(&self) -> longhands::_x_lang::computed_value::T {
        longhands::_x_lang::computed_value::T(unsafe {
            Atom::from_raw(self.gecko.mLanguage.mRawPtr)
        })
    }

    #[allow(non_snake_case)]
    pub fn set__x_text_zoom(&mut self, v: longhands::_x_text_zoom::computed_value::T) {
        self.gecko.mAllowZoom = v.0;
    }

    #[allow(non_snake_case)]
    pub fn copy__x_text_zoom_from(&mut self, other: &Self) {
        self.gecko.mAllowZoom = other.gecko.mAllowZoom;
    }

    #[allow(non_snake_case)]
    pub fn reset__x_text_zoom(&mut self, other: &Self) {
        self.copy__x_text_zoom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__x_text_zoom(&self) -> longhands::_x_text_zoom::computed_value::T {
        longhands::_x_text_zoom::computed_value::T(self.gecko.mAllowZoom)
    }

    

    #[allow(non_snake_case)]
    pub fn set__moz_script_level(&mut self, v: longhands::_moz_script_level::computed_value::T) {
        self.gecko.mScriptLevel = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_script_level_from(&mut self, other: &Self) {
        self.gecko.mScriptLevel = other.gecko.mScriptLevel;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_level(&mut self, other: &Self) {
        self.copy__moz_script_level_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_script_level(&self) -> longhands::_moz_script_level::computed_value::T {
        From::from(self.gecko.mScriptLevel)
    }


    
    

    #[allow(non_snake_case)]
    pub fn set_font_language_override(&mut self, v: longhands::font_language_override::computed_value::T) {
        self.gecko.mFont.languageOverride = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_language_override_from(&mut self, other: &Self) {
        self.gecko.mFont.languageOverride = other.gecko.mFont.languageOverride;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_language_override(&mut self, other: &Self) {
        self.copy_font_language_override_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_language_override(&self) -> longhands::font_language_override::computed_value::T {
        From::from(self.gecko.mFont.languageOverride)
    }


    pub fn set_font_variant_alternates(&mut self,
                                       v: values::computed::font::FontVariantAlternates,
                                       device: &Device) {
        use crate::gecko_bindings::bindings::{Gecko_ClearAlternateValues, Gecko_AppendAlternateValues};
        use crate::gecko_bindings::bindings::Gecko_nsFont_ResetFontFeatureValuesLookup;
        use crate::gecko_bindings::bindings::Gecko_nsFont_SetFontFeatureValuesLookup;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_NORMAL;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_SWASH;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_STYLISTIC;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_ORNAMENTS;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_ANNOTATION;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_STYLESET;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_HISTORICAL;
        use crate::values::specified::font::VariantAlternates;

        unsafe {
            Gecko_ClearAlternateValues(&mut self.gecko.mFont, v.len());
        }

        if v.0.is_empty() {
            self.gecko.mFont.variantAlternates = NS_FONT_VARIANT_ALTERNATES_NORMAL as u16;
            unsafe { Gecko_nsFont_ResetFontFeatureValuesLookup(&mut self.gecko.mFont); }
            return;
        }

        for val in v.0.iter() {
            match *val {
                    VariantAlternates::Swash(ref ident) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_SWASH as u16;
                        unsafe {
                            Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                        NS_FONT_VARIANT_ALTERNATES_SWASH,
                                                        ident.0.as_ptr());
                        }
                    },
                    VariantAlternates::Stylistic(ref ident) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_STYLISTIC as u16;
                        unsafe {
                            Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                        NS_FONT_VARIANT_ALTERNATES_STYLISTIC,
                                                        ident.0.as_ptr());
                        }
                    },
                    VariantAlternates::Ornaments(ref ident) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_ORNAMENTS as u16;
                        unsafe {
                            Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                        NS_FONT_VARIANT_ALTERNATES_ORNAMENTS,
                                                        ident.0.as_ptr());
                        }
                    },
                    VariantAlternates::Annotation(ref ident) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_ANNOTATION as u16;
                        unsafe {
                            Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                        NS_FONT_VARIANT_ALTERNATES_ANNOTATION,
                                                        ident.0.as_ptr());
                        }
                    },
                    VariantAlternates::Styleset(ref slice) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_STYLESET as u16;
                        for ident in slice.iter() {
                            unsafe {
                                Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                            NS_FONT_VARIANT_ALTERNATES_STYLESET,
                                                            ident.0.as_ptr());
                            }
                        }
                    },
                    VariantAlternates::CharacterVariant(ref slice) => {
                        self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT as u16;
                        for ident in slice.iter() {
                            unsafe {
                                Gecko_AppendAlternateValues(&mut self.gecko.mFont,
                                                            NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT,
                                                            ident.0.as_ptr());
                            }
                        }
                    },
                VariantAlternates::HistoricalForms => {
                    self.gecko.mFont.variantAlternates |= NS_FONT_VARIANT_ALTERNATES_HISTORICAL as u16;
                }
            }
        }

        unsafe {
            Gecko_nsFont_SetFontFeatureValuesLookup(&mut self.gecko.mFont, device.pres_context());
        }
    }

    #[allow(non_snake_case)]
    pub fn copy_font_variant_alternates_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyAlternateValuesFrom;

        self.gecko.mFont.variantAlternates = other.gecko.mFont.variantAlternates;
        unsafe {
            Gecko_CopyAlternateValuesFrom(&mut self.gecko.mFont, &other.gecko.mFont);
        }
    }

    pub fn reset_font_variant_alternates(&mut self, other: &Self) {
        self.copy_font_variant_alternates_from(other)
    }

    pub fn clone_font_variant_alternates(&self) -> values::computed::font::FontVariantAlternates {
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_NORMAL;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_SWASH;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_STYLISTIC;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_ORNAMENTS;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_ANNOTATION;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_STYLESET;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT;
            use crate::gecko_bindings::structs::NS_FONT_VARIANT_ALTERNATES_HISTORICAL;
        use crate::values::specified::font::VariantAlternates;
        use crate::values::specified::font::VariantAlternatesList;
        use crate::values::CustomIdent;

        if self.gecko.mFont.variantAlternates == NS_FONT_VARIANT_ALTERNATES_NORMAL as u16 {
            return VariantAlternatesList(vec![].into_boxed_slice());
        }

        let mut alternates = Vec::with_capacity(self.gecko.mFont.alternateValues.len());
        if self.gecko.mFont.variantAlternates & (NS_FONT_VARIANT_ALTERNATES_HISTORICAL as u16) != 0 {
            alternates.push(VariantAlternates::HistoricalForms);
        }

        
            let mut styleset_list = Vec::new();
            let mut character_variant_list = Vec::new();

        for gecko_alternate_value in self.gecko.mFont.alternateValues.iter() {
            let ident = Atom::from(gecko_alternate_value.value.to_string());
            match gecko_alternate_value.alternate {
                    NS_FONT_VARIANT_ALTERNATES_SWASH => {
                        alternates.push(VariantAlternates::Swash(CustomIdent(ident)));
                    },
                    NS_FONT_VARIANT_ALTERNATES_STYLISTIC => {
                        alternates.push(VariantAlternates::Stylistic(CustomIdent(ident)));
                    },
                    NS_FONT_VARIANT_ALTERNATES_ORNAMENTS => {
                        alternates.push(VariantAlternates::Ornaments(CustomIdent(ident)));
                    },
                    NS_FONT_VARIANT_ALTERNATES_ANNOTATION => {
                        alternates.push(VariantAlternates::Annotation(CustomIdent(ident)));
                    },
                    NS_FONT_VARIANT_ALTERNATES_STYLESET => {
                        styleset_list.push(CustomIdent(ident));
                    },
                    NS_FONT_VARIANT_ALTERNATES_CHARACTER_VARIANT => {
                        character_variant_list.push(CustomIdent(ident));
                    },
                _ => {
                    panic!("Found unexpected value for font-variant-alternates");
                }
            }
        }

            if !styleset_list.is_empty() {
                alternates.push(VariantAlternates::Styleset(styleset_list.into_boxed_slice()));
            }
            if !character_variant_list.is_empty() {
                alternates.push(VariantAlternates::CharacterVariant(character_variant_list.into_boxed_slice()));
            }

        VariantAlternatesList(alternates.into_boxed_slice())
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_ligatures(&mut self, v: longhands::font_variant_ligatures::computed_value::T) {
        self.gecko.mFont.variantLigatures = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_ligatures_from(&mut self, other: &Self) {
        self.gecko.mFont.variantLigatures = other.gecko.mFont.variantLigatures;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_ligatures(&mut self, other: &Self) {
        self.copy_font_variant_ligatures_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_ligatures(&self) -> longhands::font_variant_ligatures::computed_value::T {
        From::from(self.gecko.mFont.variantLigatures)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_east_asian(&mut self, v: longhands::font_variant_east_asian::computed_value::T) {
        self.gecko.mFont.variantEastAsian = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_east_asian_from(&mut self, other: &Self) {
        self.gecko.mFont.variantEastAsian = other.gecko.mFont.variantEastAsian;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_east_asian(&mut self, other: &Self) {
        self.copy_font_variant_east_asian_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_east_asian(&self) -> longhands::font_variant_east_asian::computed_value::T {
        From::from(self.gecko.mFont.variantEastAsian)
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_numeric(&mut self, v: longhands::font_variant_numeric::computed_value::T) {
        self.gecko.mFont.variantNumeric = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_numeric_from(&mut self, other: &Self) {
        self.gecko.mFont.variantNumeric = other.gecko.mFont.variantNumeric;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_numeric(&mut self, other: &Self) {
        self.copy_font_variant_numeric_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_numeric(&self) -> longhands::font_variant_numeric::computed_value::T {
        From::from(self.gecko.mFont.variantNumeric)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_min_font_size_ratio(
        &self,
    ) -> longhands::_moz_min_font_size_ratio::computed_value::T {
        Percentage(self.gecko.mMinFontSizeRatio as f32 / 100.)
    }

    #[allow(non_snake_case)]
    pub fn set__moz_min_font_size_ratio(&mut self, v: longhands::_moz_min_font_size_ratio::computed_value::T) {
        let scaled = v.0 * 100.;
        let percentage = if scaled > 255. {
            255.
        } else if scaled < 0. {
            0.
        } else {
            scaled
        };

        self.gecko.mMinFontSizeRatio = percentage as u8;
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_min_font_size_ratio_from(&mut self, other: &Self) {
        self.gecko.mMinFontSizeRatio = other.gecko.mMinFontSizeRatio;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_min_font_size_ratio(&mut self, other: &Self) {
        self.copy__moz_min_font_size_ratio_from(other)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_caps(&mut self, v: longhands::font_variant_caps::computed_value::T) {
        use crate::properties::longhands::font_variant_caps::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_FONT_VARIANT_CAPS_NORMAL as u8,
                Keyword::SmallCaps =>
                    structs::NS_FONT_VARIANT_CAPS_SMALLCAPS as u8,
                Keyword::AllSmallCaps =>
                    structs::NS_FONT_VARIANT_CAPS_ALLSMALL as u8,
                Keyword::PetiteCaps =>
                    structs::NS_FONT_VARIANT_CAPS_PETITECAPS as u8,
                Keyword::AllPetiteCaps =>
                    structs::NS_FONT_VARIANT_CAPS_ALLPETITE as u8,
                Keyword::Unicase =>
                    structs::NS_FONT_VARIANT_CAPS_UNICASE as u8,
                Keyword::TitlingCaps =>
                    structs::NS_FONT_VARIANT_CAPS_TITLING as u8,
        };
        self.gecko.mFont.variantCaps = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_caps_from(&mut self, other: &Self) {
        self.gecko.mFont.variantCaps = other.gecko.mFont.variantCaps;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_caps(&mut self, other: &Self) {
        self.copy_font_variant_caps_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_font_variant_caps(&self) -> longhands::font_variant_caps::computed_value::T {
        use crate::properties::longhands::font_variant_caps::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_VARIANT_CAPS_NORMAL : u8 =
            structs::NS_FONT_VARIANT_CAPS_NORMAL as u8;
        const U8_NS_FONT_VARIANT_CAPS_SMALLCAPS : u8 =
            structs::NS_FONT_VARIANT_CAPS_SMALLCAPS as u8;
        const U8_NS_FONT_VARIANT_CAPS_ALLSMALL : u8 =
            structs::NS_FONT_VARIANT_CAPS_ALLSMALL as u8;
        const U8_NS_FONT_VARIANT_CAPS_PETITECAPS : u8 =
            structs::NS_FONT_VARIANT_CAPS_PETITECAPS as u8;
        const U8_NS_FONT_VARIANT_CAPS_ALLPETITE : u8 =
            structs::NS_FONT_VARIANT_CAPS_ALLPETITE as u8;
        const U8_NS_FONT_VARIANT_CAPS_UNICASE : u8 =
            structs::NS_FONT_VARIANT_CAPS_UNICASE as u8;
        const U8_NS_FONT_VARIANT_CAPS_TITLING : u8 =
            structs::NS_FONT_VARIANT_CAPS_TITLING as u8;

        match self.gecko.mFont.variantCaps as u8 {
            U8_NS_FONT_VARIANT_CAPS_NORMAL => Keyword::Normal,
            U8_NS_FONT_VARIANT_CAPS_SMALLCAPS => Keyword::SmallCaps,
            U8_NS_FONT_VARIANT_CAPS_ALLSMALL => Keyword::AllSmallCaps,
            U8_NS_FONT_VARIANT_CAPS_PETITECAPS => Keyword::PetiteCaps,
            U8_NS_FONT_VARIANT_CAPS_ALLPETITE => Keyword::AllPetiteCaps,
            U8_NS_FONT_VARIANT_CAPS_UNICASE => Keyword::Unicase,
            U8_NS_FONT_VARIANT_CAPS_TITLING => Keyword::TitlingCaps,
            _ => panic!("Found unexpected value in style struct for font_variant_caps property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_kerning(&mut self, v: longhands::font_kerning::computed_value::T) {
        use crate::properties::longhands::font_kerning::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_KERNING_AUTO as u8,
                Keyword::None =>
                    structs::NS_FONT_KERNING_NONE as u8,
                Keyword::Normal =>
                    structs::NS_FONT_KERNING_NORMAL as u8,
        };
        self.gecko.mFont.kerning = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_kerning_from(&mut self, other: &Self) {
        self.gecko.mFont.kerning = other.gecko.mFont.kerning;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_kerning(&mut self, other: &Self) {
        self.copy_font_kerning_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_font_kerning(&self) -> longhands::font_kerning::computed_value::T {
        use crate::properties::longhands::font_kerning::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_KERNING_AUTO : u8 =
            structs::NS_FONT_KERNING_AUTO as u8;
        const U8_NS_FONT_KERNING_NONE : u8 =
            structs::NS_FONT_KERNING_NONE as u8;
        const U8_NS_FONT_KERNING_NORMAL : u8 =
            structs::NS_FONT_KERNING_NORMAL as u8;

        match self.gecko.mFont.kerning as u8 {
            U8_NS_FONT_KERNING_AUTO => Keyword::Auto,
            U8_NS_FONT_KERNING_NONE => Keyword::None,
            U8_NS_FONT_KERNING_NORMAL => Keyword::Normal,
            _ => panic!("Found unexpected value in style struct for font_kerning property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_variant_position(&mut self, v: longhands::font_variant_position::computed_value::T) {
        use crate::properties::longhands::font_variant_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_FONT_VARIANT_POSITION_NORMAL as u8,
                Keyword::Sub =>
                    structs::NS_FONT_VARIANT_POSITION_SUB as u8,
                Keyword::Super =>
                    structs::NS_FONT_VARIANT_POSITION_SUPER as u8,
        };
        self.gecko.mFont.variantPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_position_from(&mut self, other: &Self) {
        self.gecko.mFont.variantPosition = other.gecko.mFont.variantPosition;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_position(&mut self, other: &Self) {
        self.copy_font_variant_position_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_font_variant_position(&self) -> longhands::font_variant_position::computed_value::T {
        use crate::properties::longhands::font_variant_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_VARIANT_POSITION_NORMAL : u8 =
            structs::NS_FONT_VARIANT_POSITION_NORMAL as u8;
        const U8_NS_FONT_VARIANT_POSITION_SUB : u8 =
            structs::NS_FONT_VARIANT_POSITION_SUB as u8;
        const U8_NS_FONT_VARIANT_POSITION_SUPER : u8 =
            structs::NS_FONT_VARIANT_POSITION_SUPER as u8;

        match self.gecko.mFont.variantPosition as u8 {
            U8_NS_FONT_VARIANT_POSITION_NORMAL => Keyword::Normal,
            U8_NS_FONT_VARIANT_POSITION_SUB => Keyword::Sub,
            U8_NS_FONT_VARIANT_POSITION_SUPER => Keyword::Super,
            _ => panic!("Found unexpected value in style struct for font_variant_position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_optical_sizing(&mut self, v: longhands::font_optical_sizing::computed_value::T) {
        use crate::properties::longhands::font_optical_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_OPTICAL_SIZING_AUTO as u8,
                Keyword::None =>
                    structs::NS_FONT_OPTICAL_SIZING_NONE as u8,
        };
        self.gecko.mFont.opticalSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_optical_sizing_from(&mut self, other: &Self) {
        self.gecko.mFont.opticalSizing = other.gecko.mFont.opticalSizing;
    }

    #[allow(non_snake_case)]
    pub fn reset_font_optical_sizing(&mut self, other: &Self) {
        self.copy_font_optical_sizing_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_font_optical_sizing(&self) -> longhands::font_optical_sizing::computed_value::T {
        use crate::properties::longhands::font_optical_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_OPTICAL_SIZING_AUTO : u8 =
            structs::NS_FONT_OPTICAL_SIZING_AUTO as u8;
        const U8_NS_FONT_OPTICAL_SIZING_NONE : u8 =
            structs::NS_FONT_OPTICAL_SIZING_NONE as u8;

        match self.gecko.mFont.opticalSizing as u8 {
            U8_NS_FONT_OPTICAL_SIZING_AUTO => Keyword::Auto,
            U8_NS_FONT_OPTICAL_SIZING_NONE => Keyword::None,
            _ => panic!("Found unexpected value in style struct for font_optical_sizing property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_script_size_multiplier(&mut self, v: longhands::_moz_script_size_multiplier::computed_value::T) {
        self.gecko.mScriptSizeMultiplier = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_script_size_multiplier_from(&mut self, other: &Self) {
        self.gecko.mScriptSizeMultiplier = other.gecko.mScriptSizeMultiplier;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_size_multiplier(&mut self, other: &Self) {
        self.copy__moz_script_size_multiplier_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_script_size_multiplier(&self) -> longhands::_moz_script_size_multiplier::computed_value::T {
        From::from(self.gecko.mScriptSizeMultiplier)
    }



    #[allow(non_snake_case)]
    pub fn set__moz_math_display(&mut self, v: longhands::_moz_math_display::computed_value::T) {
        use crate::properties::longhands::_moz_math_display::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Inline =>
                    structs::NS_MATHML_DISPLAYSTYLE_INLINE as u8,
                Keyword::Block =>
                    structs::NS_MATHML_DISPLAYSTYLE_BLOCK as u8,
        };
        self.gecko.mMathDisplay = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_math_display_from(&mut self, other: &Self) {
        self.gecko.mMathDisplay = other.gecko.mMathDisplay;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_math_display(&mut self, other: &Self) {
        self.copy__moz_math_display_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_math_display(&self) -> longhands::_moz_math_display::computed_value::T {
        use crate::properties::longhands::_moz_math_display::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_MATHML_DISPLAYSTYLE_INLINE : u8 =
            structs::NS_MATHML_DISPLAYSTYLE_INLINE as u8;
        const U8_NS_MATHML_DISPLAYSTYLE_BLOCK : u8 =
            structs::NS_MATHML_DISPLAYSTYLE_BLOCK as u8;

        match self.gecko.mMathDisplay as u8 {
            U8_NS_MATHML_DISPLAYSTYLE_INLINE => Keyword::Inline,
            U8_NS_MATHML_DISPLAYSTYLE_BLOCK => Keyword::Block,
            _ => panic!("Found unexpected value in style struct for _moz_math_display property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_math_variant(&mut self, v: longhands::_moz_math_variant::computed_value::T) {
        use crate::properties::longhands::_moz_math_variant::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_MATHML_MATHVARIANT_NONE as u8,
                Keyword::Normal =>
                    structs::NS_MATHML_MATHVARIANT_NORMAL as u8,
                Keyword::Bold =>
                    structs::NS_MATHML_MATHVARIANT_BOLD as u8,
                Keyword::Italic =>
                    structs::NS_MATHML_MATHVARIANT_ITALIC as u8,
                Keyword::BoldItalic =>
                    structs::NS_MATHML_MATHVARIANT_BOLD_ITALIC as u8,
                Keyword::Script =>
                    structs::NS_MATHML_MATHVARIANT_SCRIPT as u8,
                Keyword::BoldScript =>
                    structs::NS_MATHML_MATHVARIANT_BOLD_SCRIPT as u8,
                Keyword::Fraktur =>
                    structs::NS_MATHML_MATHVARIANT_FRAKTUR as u8,
                Keyword::DoubleStruck =>
                    structs::NS_MATHML_MATHVARIANT_DOUBLE_STRUCK as u8,
                Keyword::BoldFraktur =>
                    structs::NS_MATHML_MATHVARIANT_BOLD_FRAKTUR as u8,
                Keyword::SansSerif =>
                    structs::NS_MATHML_MATHVARIANT_SANS_SERIF as u8,
                Keyword::BoldSansSerif =>
                    structs::NS_MATHML_MATHVARIANT_BOLD_SANS_SERIF as u8,
                Keyword::SansSerifItalic =>
                    structs::NS_MATHML_MATHVARIANT_SANS_SERIF_ITALIC as u8,
                Keyword::SansSerifBoldItalic =>
                    structs::NS_MATHML_MATHVARIANT_SANS_SERIF_BOLD_ITALIC as u8,
                Keyword::Monospace =>
                    structs::NS_MATHML_MATHVARIANT_MONOSPACE as u8,
                Keyword::Initial =>
                    structs::NS_MATHML_MATHVARIANT_INITIAL as u8,
                Keyword::Tailed =>
                    structs::NS_MATHML_MATHVARIANT_TAILED as u8,
                Keyword::Looped =>
                    structs::NS_MATHML_MATHVARIANT_LOOPED as u8,
                Keyword::Stretched =>
                    structs::NS_MATHML_MATHVARIANT_STRETCHED as u8,
        };
        self.gecko.mMathVariant = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_math_variant_from(&mut self, other: &Self) {
        self.gecko.mMathVariant = other.gecko.mMathVariant;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_math_variant(&mut self, other: &Self) {
        self.copy__moz_math_variant_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_math_variant(&self) -> longhands::_moz_math_variant::computed_value::T {
        use crate::properties::longhands::_moz_math_variant::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_MATHML_MATHVARIANT_NONE : u8 =
            structs::NS_MATHML_MATHVARIANT_NONE as u8;
        const U8_NS_MATHML_MATHVARIANT_NORMAL : u8 =
            structs::NS_MATHML_MATHVARIANT_NORMAL as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD as u8;
        const U8_NS_MATHML_MATHVARIANT_ITALIC : u8 =
            structs::NS_MATHML_MATHVARIANT_ITALIC as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD_ITALIC : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD_ITALIC as u8;
        const U8_NS_MATHML_MATHVARIANT_SCRIPT : u8 =
            structs::NS_MATHML_MATHVARIANT_SCRIPT as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD_SCRIPT : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD_SCRIPT as u8;
        const U8_NS_MATHML_MATHVARIANT_FRAKTUR : u8 =
            structs::NS_MATHML_MATHVARIANT_FRAKTUR as u8;
        const U8_NS_MATHML_MATHVARIANT_DOUBLE_STRUCK : u8 =
            structs::NS_MATHML_MATHVARIANT_DOUBLE_STRUCK as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD_FRAKTUR : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD_FRAKTUR as u8;
        const U8_NS_MATHML_MATHVARIANT_SANS_SERIF : u8 =
            structs::NS_MATHML_MATHVARIANT_SANS_SERIF as u8;
        const U8_NS_MATHML_MATHVARIANT_BOLD_SANS_SERIF : u8 =
            structs::NS_MATHML_MATHVARIANT_BOLD_SANS_SERIF as u8;
        const U8_NS_MATHML_MATHVARIANT_SANS_SERIF_ITALIC : u8 =
            structs::NS_MATHML_MATHVARIANT_SANS_SERIF_ITALIC as u8;
        const U8_NS_MATHML_MATHVARIANT_SANS_SERIF_BOLD_ITALIC : u8 =
            structs::NS_MATHML_MATHVARIANT_SANS_SERIF_BOLD_ITALIC as u8;
        const U8_NS_MATHML_MATHVARIANT_MONOSPACE : u8 =
            structs::NS_MATHML_MATHVARIANT_MONOSPACE as u8;
        const U8_NS_MATHML_MATHVARIANT_INITIAL : u8 =
            structs::NS_MATHML_MATHVARIANT_INITIAL as u8;
        const U8_NS_MATHML_MATHVARIANT_TAILED : u8 =
            structs::NS_MATHML_MATHVARIANT_TAILED as u8;
        const U8_NS_MATHML_MATHVARIANT_LOOPED : u8 =
            structs::NS_MATHML_MATHVARIANT_LOOPED as u8;
        const U8_NS_MATHML_MATHVARIANT_STRETCHED : u8 =
            structs::NS_MATHML_MATHVARIANT_STRETCHED as u8;

        match self.gecko.mMathVariant as u8 {
            U8_NS_MATHML_MATHVARIANT_NONE => Keyword::None,
            U8_NS_MATHML_MATHVARIANT_NORMAL => Keyword::Normal,
            U8_NS_MATHML_MATHVARIANT_BOLD => Keyword::Bold,
            U8_NS_MATHML_MATHVARIANT_ITALIC => Keyword::Italic,
            U8_NS_MATHML_MATHVARIANT_BOLD_ITALIC => Keyword::BoldItalic,
            U8_NS_MATHML_MATHVARIANT_SCRIPT => Keyword::Script,
            U8_NS_MATHML_MATHVARIANT_BOLD_SCRIPT => Keyword::BoldScript,
            U8_NS_MATHML_MATHVARIANT_FRAKTUR => Keyword::Fraktur,
            U8_NS_MATHML_MATHVARIANT_DOUBLE_STRUCK => Keyword::DoubleStruck,
            U8_NS_MATHML_MATHVARIANT_BOLD_FRAKTUR => Keyword::BoldFraktur,
            U8_NS_MATHML_MATHVARIANT_SANS_SERIF => Keyword::SansSerif,
            U8_NS_MATHML_MATHVARIANT_BOLD_SANS_SERIF => Keyword::BoldSansSerif,
            U8_NS_MATHML_MATHVARIANT_SANS_SERIF_ITALIC => Keyword::SansSerifItalic,
            U8_NS_MATHML_MATHVARIANT_SANS_SERIF_BOLD_ITALIC => Keyword::SansSerifBoldItalic,
            U8_NS_MATHML_MATHVARIANT_MONOSPACE => Keyword::Monospace,
            U8_NS_MATHML_MATHVARIANT_INITIAL => Keyword::Initial,
            U8_NS_MATHML_MATHVARIANT_TAILED => Keyword::Tailed,
            U8_NS_MATHML_MATHVARIANT_LOOPED => Keyword::Looped,
            U8_NS_MATHML_MATHVARIANT_STRETCHED => Keyword::Stretched,
            _ => panic!("Found unexpected value in style struct for _moz_math_variant property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set__moz_script_min_size(&mut self, v: longhands::_moz_script_min_size::computed_value::T) {
        self.gecko.mScriptMinSize = v.to_i32_au();
    }
    
    #[allow(non_snake_case)]
    pub fn copy__moz_script_min_size_from(&mut self, other: &Self) {
        self.gecko.mScriptMinSize = other.gecko.mScriptMinSize;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_min_size(&mut self, other: &Self) {
        self.copy__moz_script_min_size_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_script_min_size(&self) -> longhands::_moz_script_min_size::computed_value::T {
        Au(self.gecko.mScriptMinSize).into()
    }


    #[allow(non_snake_case)]
    pub fn set__moz_osx_font_smoothing(&mut self, v: longhands::_moz_osx_font_smoothing::computed_value::T) {
        use crate::properties::longhands::_moz_osx_font_smoothing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_SMOOTHING_AUTO as u8,
                Keyword::Grayscale =>
                    structs::NS_FONT_SMOOTHING_GRAYSCALE as u8,
        };
        self.gecko.mFont.smoothing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_osx_font_smoothing_from(&mut self, other: &Self) {
        self.gecko.mFont.smoothing = other.gecko.mFont.smoothing;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_osx_font_smoothing(&mut self, other: &Self) {
        self.copy__moz_osx_font_smoothing_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_osx_font_smoothing(&self) -> longhands::_moz_osx_font_smoothing::computed_value::T {
        use crate::properties::longhands::_moz_osx_font_smoothing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_SMOOTHING_AUTO : u8 =
            structs::NS_FONT_SMOOTHING_AUTO as u8;
        const U8_NS_FONT_SMOOTHING_GRAYSCALE : u8 =
            structs::NS_FONT_SMOOTHING_GRAYSCALE as u8;

        match self.gecko.mFont.smoothing as u8 {
            U8_NS_FONT_SMOOTHING_AUTO => Keyword::Auto,
            U8_NS_FONT_SMOOTHING_GRAYSCALE => Keyword::Grayscale,
            _ => panic!("Found unexpected value in style struct for _moz_osx_font_smoothing property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set__moz_font_smoothing_background_color(&mut self, v: longhands::_moz_font_smoothing_background_color::computed_value::T) {
        self.gecko.mFont.fontSmoothingBackgroundColor = convert_rgba_to_nscolor(&v);
    }
    
    #[allow(non_snake_case)]
    pub fn copy__moz_font_smoothing_background_color_from(&mut self, other: &Self) {
        self.gecko.mFont.fontSmoothingBackgroundColor = other.gecko.mFont.fontSmoothingBackgroundColor;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_font_smoothing_background_color(&mut self, other: &Self) {
        self.copy__moz_font_smoothing_background_color_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_font_smoothing_background_color(&self) -> longhands::_moz_font_smoothing_background_color::computed_value::T {
        convert_nscolor_to_rgba(self.gecko.mFont.fontSmoothingBackgroundColor)
    }

}































impl GeckoBox {
    /*
     * Manually-Implemented Methods.
     */
    
    #[inline]
    pub fn set_display(&mut self, v: longhands::display::computed_value::T) {
        self.gecko.mDisplay = v;
        self.gecko.mOriginalDisplay = v;
    }

    #[inline]
    pub fn copy_display_from(&mut self, other: &Self) {
        self.gecko.mDisplay = other.gecko.mDisplay;
        self.gecko.mOriginalDisplay = other.gecko.mDisplay;
    }

    #[inline]
    pub fn reset_display(&mut self, other: &Self) {
        self.copy_display_from(other)
    }

    #[inline]
    pub fn set_adjusted_display(
        &mut self,
        v: longhands::display::computed_value::T,
        _is_item_or_root: bool
    ) {
        self.gecko.mDisplay = v;
    }

    #[inline]
    pub fn clone_display(&self) -> longhands::display::computed_value::T {
        self.gecko.mDisplay
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_clear(&mut self, v: longhands::clear::computed_value::T) {
        use crate::properties::longhands::clear::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Left =>
                    structs::StyleClear::Left ,
                Keyword::Right =>
                    structs::StyleClear::Right ,
                Keyword::None =>
                    structs::StyleClear::None ,
                Keyword::Both =>
                    structs::StyleClear::Both ,
        };
        self.gecko.mBreakType = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_clear_from(&mut self, other: &Self) {
        self.gecko.mBreakType = other.gecko.mBreakType;
    }

    #[allow(non_snake_case)]
    pub fn reset_clear(&mut self, other: &Self) {
        self.copy_clear_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_clear(&self) -> longhands::clear::computed_value::T {
        use crate::properties::longhands::clear::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBreakType {
            structs::StyleClear::Left => Keyword::Left,
            structs::StyleClear::Right => Keyword::Right,
            structs::StyleClear::None => Keyword::None,
            structs::StyleClear::Both => Keyword::Both,
            _ => panic!("Found unexpected value in style struct for clear property"),
        }
    }



    pub fn set_vertical_align(&mut self, v: longhands::vertical_align::computed_value::T) {
        use crate::values::generics::box_::VerticalAlign;
        let value = match v {
            VerticalAlign::Baseline => structs::NS_STYLE_VERTICAL_ALIGN_BASELINE,
            VerticalAlign::Sub => structs::NS_STYLE_VERTICAL_ALIGN_SUB,
            VerticalAlign::Super => structs::NS_STYLE_VERTICAL_ALIGN_SUPER,
            VerticalAlign::Top => structs::NS_STYLE_VERTICAL_ALIGN_TOP,
            VerticalAlign::TextTop => structs::NS_STYLE_VERTICAL_ALIGN_TEXT_TOP,
            VerticalAlign::Middle => structs::NS_STYLE_VERTICAL_ALIGN_MIDDLE,
            VerticalAlign::Bottom => structs::NS_STYLE_VERTICAL_ALIGN_BOTTOM,
            VerticalAlign::TextBottom => structs::NS_STYLE_VERTICAL_ALIGN_TEXT_BOTTOM,
            VerticalAlign::MozMiddleWithBaseline => {
                structs::NS_STYLE_VERTICAL_ALIGN_MIDDLE_WITH_BASELINE
            },
            VerticalAlign::Length(length) => {
                self.gecko.mVerticalAlign.set(length);
                return;
            },
        };
        self.gecko.mVerticalAlign.set_value(CoordDataValue::Enumerated(value));
    }

    pub fn clone_vertical_align(&self) -> longhands::vertical_align::computed_value::T {
        use crate::values::computed::LengthPercentage;
        use crate::values::generics::box_::VerticalAlign;

        let gecko = &self.gecko.mVerticalAlign;
        match gecko.as_value() {
            CoordDataValue::Enumerated(value) => VerticalAlign::from_gecko_keyword(value),
            _ => {
                VerticalAlign::Length(
                    LengthPercentage::from_gecko_style_coord(gecko).expect(
                        "expected <length-percentage> for vertical-align",
                    ),
                )
            },
        }
    }

    
    #[allow(non_snake_case)]
    pub fn copy_vertical_align_from(&mut self, other: &Self) {
        self.gecko.mVerticalAlign.copy_from(&other.gecko.mVerticalAlign);
    }

    #[allow(non_snake_case)]
    pub fn reset_vertical_align(&mut self, other: &Self) {
        self.copy_vertical_align_from(other)
    }


    
    #[allow(non_snake_case)]
    pub fn set_scroll_snap_points_x(&mut self, v: longhands::scroll_snap_points_x::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mScrollSnapPointsX);
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_points_x_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapPointsX.copy_from(&other.gecko.mScrollSnapPointsX);
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_points_x(&mut self, other: &Self) {
        self.copy_scroll_snap_points_x_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_points_x(&self) -> longhands::scroll_snap_points_x::computed_value::T {
        use crate::properties::longhands::scroll_snap_points_x::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mScrollSnapPointsX)
            .expect("clone for scroll_snap_points_x failed")
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_snap_points_y(&mut self, v: longhands::scroll_snap_points_y::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mScrollSnapPointsY);
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_points_y_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapPointsY.copy_from(&other.gecko.mScrollSnapPointsY);
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_points_y(&mut self, other: &Self) {
        self.copy_scroll_snap_points_y_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_points_y(&self) -> longhands::scroll_snap_points_y::computed_value::T {
        use crate::properties::longhands::scroll_snap_points_y::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mScrollSnapPointsY)
            .expect("clone for scroll_snap_points_y failed")
    }


    pub fn set_scroll_snap_coordinate<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::scroll_snap_coordinate::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        let iter = v.into_iter().map(|c| structs::mozilla::Position {
            mXPosition: c.horizontal.into(),
            mYPosition: c.vertical.into(),
        });
        self.gecko.mScrollSnapCoordinate.assign_from_iter_pod(iter);
    }

    pub fn copy_scroll_snap_coordinate_from(&mut self, other: &Self) {
        let iter = other.gecko.mScrollSnapCoordinate.iter().map(|c| *c);
        self.gecko.mScrollSnapCoordinate.assign_from_iter_pod(iter);
    }

    pub fn reset_scroll_snap_coordinate(&mut self, other: &Self) {
        self.copy_scroll_snap_coordinate_from(other)
    }

    pub fn clone_scroll_snap_coordinate(&self) -> longhands::scroll_snap_coordinate::computed_value::T {
        let vec = self.gecko.mScrollSnapCoordinate.iter().map(|f| f.into()).collect();
        longhands::scroll_snap_coordinate::computed_value::List(vec)
    }

    
    #[allow(non_snake_case)]
    pub fn set__moz_binding(&mut self, v: longhands::_moz_binding::computed_value::T) {
        match v {
            UrlOrNone::Url(ref url) => {
                self.gecko.mBinding.set_move(url.0.url_value.clone())
            }
            UrlOrNone::None => {
                unsafe {
                    self.gecko.mBinding.clear();
                }
            }
        }
    }
    #[allow(non_snake_case)]
    pub fn copy__moz_binding_from(&mut self, other: &Self) {
        unsafe {
            self.gecko.mBinding.set(&other.gecko.mBinding);
        }
    }
    #[allow(non_snake_case)]
    pub fn reset__moz_binding(&mut self, other: &Self) {
        self.copy__moz_binding_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_binding(&self) -> longhands::_moz_binding::computed_value::T {
        use crate::values::computed::url::ComputedUrl;

        if self.gecko.mBinding.mRawPtr.is_null() {
            return UrlOrNone::none()
        }

        UrlOrNone::Url(unsafe {
            ComputedUrl::from_url_value(self.gecko.mBinding.to_safe())
        })
    }


    
    
    #[allow(non_snake_case)]
    pub fn set_transition_delay<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_delay::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mTransitions.ensure_len(input_len);

        self.gecko.mTransitionDelayCount = input_len as u32;
        for (gecko, servo) in self.gecko.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDelay = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn transition_delay_at(&self, index: usize)
        -> longhands::transition_delay::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mTransitions[index].mDelay / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn transition_delay_count(&self) -> usize {
        self.gecko.mTransitionDelayCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transition_delay_from(&mut self, other: &Self) {
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionDelayCount;
        self.gecko.mTransitionDelayCount = count;

        let iter = self.gecko.mTransitions.iter_mut().take(count as usize).zip(
            other.gecko.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mDelay = others.mDelay;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transition_delay(&mut self, other: &Self) {
        self.copy_transition_delay_from(other)
    }



    
    
    #[allow(non_snake_case)]
    pub fn set_transition_duration<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_duration::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mTransitions.ensure_len(input_len);

        self.gecko.mTransitionDurationCount = input_len as u32;
        for (gecko, servo) in self.gecko.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDuration = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn transition_duration_at(&self, index: usize)
        -> longhands::transition_duration::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mTransitions[index].mDuration / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn transition_duration_count(&self) -> usize {
        self.gecko.mTransitionDurationCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transition_duration_from(&mut self, other: &Self) {
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionDurationCount;
        self.gecko.mTransitionDurationCount = count;

        let iter = self.gecko.mTransitions.iter_mut().take(count as usize).zip(
            other.gecko.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mDuration = others.mDuration;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transition_duration(&mut self, other: &Self) {
        self.copy_transition_duration_from(other)
    }



    
    
    pub fn set_transition_timing_function<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_timing_function::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mTransitions.ensure_len(input_len);

        self.gecko.mTransitionTimingFunctionCount = input_len as u32;
        for (gecko, servo) in self.gecko.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimingFunction.mTiming = servo;
        }
    }
    
    #[allow(non_snake_case)]
    pub fn transition_timing_function_count(&self) -> usize {
        self.gecko.mTransitionTimingFunctionCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transition_timing_function_from(&mut self, other: &Self) {
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionTimingFunctionCount;
        self.gecko.mTransitionTimingFunctionCount = count;

        let iter = self.gecko.mTransitions.iter_mut().take(count as usize).zip(
            other.gecko.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mTimingFunction.mTiming = others.mTimingFunction.mTiming;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transition_timing_function(&mut self, other: &Self) {
        self.copy_transition_timing_function_from(other)
    }

    pub fn transition_timing_function_at(&self, index: usize)
        -> longhands::transition_timing_function::computed_value::SingleComputedValue {
        self.gecko.mTransitions[index].mTimingFunction.mTiming
    }



    pub fn transition_combined_duration_at(&self, index: usize) -> f32 {
        // https://drafts.csswg.org/css-transitions/#transition-combined-duration
        self.gecko.mTransitions[index % self.gecko.mTransitionDurationCount as usize].mDuration.max(0.0)
            + self.gecko.mTransitions[index % self.gecko.mTransitionDelayCount as usize].mDelay
    }

    pub fn set_transition_property<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_property::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_no_properties;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;

        let v = v.into_iter();

        if v.len() != 0 {
            self.gecko.mTransitions.ensure_len(v.len());
            self.gecko.mTransitionPropertyCount = v.len() as u32;
            for (servo, gecko) in v.zip(self.gecko.mTransitions.iter_mut()) {
                unsafe { gecko.mUnknownProperty.clear() };

                match servo {
                    TransitionProperty::Unsupported(ident) => {
                        gecko.mProperty = eCSSProperty_UNKNOWN;
                        gecko.mUnknownProperty.mRawPtr = ident.0.into_addrefed();
                    },
                    TransitionProperty::Custom(name) => {
                        gecko.mProperty = eCSSPropertyExtra_variable;
                        gecko.mUnknownProperty.mRawPtr = name.into_addrefed();
                    }
                    _ => gecko.mProperty = servo.to_nscsspropertyid().unwrap(),
                }
            }
        } else {
            // In gecko |none| is represented by eCSSPropertyExtra_no_properties.
            self.gecko.mTransitionPropertyCount = 1;
            self.gecko.mTransitions[0].mProperty = eCSSPropertyExtra_no_properties;
        }
    }

    /// Returns whether there are any transitions specified.
    pub fn specifies_transitions(&self) -> bool {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_all_properties;
        if self.gecko.mTransitionPropertyCount == 1 &&
            self.gecko.mTransitions[0].mProperty == eCSSPropertyExtra_all_properties &&
            self.transition_combined_duration_at(0) <= 0.0f32 {
            return false;
        }

        self.gecko.mTransitionPropertyCount > 0
    }

    pub fn transition_property_at(&self, index: usize)
        -> longhands::transition_property::computed_value::SingleComputedValue {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_no_properties;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;

        let property = self.gecko.mTransitions[index].mProperty;
        if property == eCSSProperty_UNKNOWN {
            let atom = self.gecko.mTransitions[index].mUnknownProperty.mRawPtr;
            debug_assert!(!atom.is_null());
            TransitionProperty::Unsupported(CustomIdent(unsafe{
                Atom::from_raw(atom)
            }))
        } else if property == eCSSPropertyExtra_variable {
            let atom = self.gecko.mTransitions[index].mUnknownProperty.mRawPtr;
            debug_assert!(!atom.is_null());
            TransitionProperty::Custom(unsafe{
                Atom::from_raw(atom)
            })
        } else if property == eCSSPropertyExtra_no_properties {
            // Actually, we don't expect TransitionProperty::Unsupported also
            // represents "none", but if the caller wants to convert it, it is
            // fine. Please use it carefully.
            //
            // FIXME(emilio): This is a hack, is this reachable?
            TransitionProperty::Unsupported(CustomIdent(atom!("none")))
        } else {
            property.into()
        }
    }

    pub fn transition_nscsspropertyid_at(&self, index: usize) -> nsCSSPropertyID {
        self.gecko.mTransitions[index].mProperty
    }

    pub fn copy_transition_property_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionPropertyCount;
        self.gecko.mTransitionPropertyCount = count;

        for (index, transition) in self.gecko.mTransitions.iter_mut().enumerate().take(count as usize) {
            transition.mProperty = other.gecko.mTransitions[index].mProperty;
            unsafe { transition.mUnknownProperty.clear() };
            if transition.mProperty == eCSSProperty_UNKNOWN ||
               transition.mProperty == eCSSPropertyExtra_variable {
                let atom = other.gecko.mTransitions[index].mUnknownProperty.mRawPtr;
                debug_assert!(!atom.is_null());
                transition.mUnknownProperty.mRawPtr = unsafe { Atom::from_raw(atom) }.into_addrefed();
            }
        }
    }

    pub fn reset_transition_property(&mut self, other: &Self) {
        self.copy_transition_property_from(other)
    }

    // Hand-written because the Mako helpers transform `Preserve3d` into `PRESERVE3D`.
    pub fn set_transform_style(&mut self, v: TransformStyle) {
        self.gecko.mTransformStyle = match v {
            TransformStyle::Flat => structs::NS_STYLE_TRANSFORM_STYLE_FLAT as u8,
            TransformStyle::Preserve3d => structs::NS_STYLE_TRANSFORM_STYLE_PRESERVE_3D as u8,
        };
    }

    // Hand-written because the Mako helpers transform `Preserve3d` into `PRESERVE3D`.
    pub fn clone_transform_style(&self) -> TransformStyle {
        match self.gecko.mTransformStyle as u32 {
            structs::NS_STYLE_TRANSFORM_STYLE_FLAT => TransformStyle::Flat,
            structs::NS_STYLE_TRANSFORM_STYLE_PRESERVE_3D => TransformStyle::Preserve3d,
            _ => panic!("illegal transform style"),
        }
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transform_style_from(&mut self, other: &Self) {
        self.gecko.mTransformStyle = other.gecko.mTransformStyle;
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_style(&mut self, other: &Self) {
        self.copy_transform_style_from(other)
    }


    
    
    #[allow(non_snake_case)]
    pub fn transition_property_count(&self) -> usize {
        self.gecko.mTransitionPropertyCount as usize
    }



    pub fn animations_equals(&self, other: &Self) -> bool {
        return self.gecko.mAnimationNameCount == other.gecko.mAnimationNameCount
            && self.gecko.mAnimationDelayCount == other.gecko.mAnimationDelayCount
            && self.gecko.mAnimationDirectionCount == other.gecko.mAnimationDirectionCount
            && self.gecko.mAnimationDurationCount == other.gecko.mAnimationDurationCount
            && self.gecko.mAnimationFillModeCount == other.gecko.mAnimationFillModeCount
            && self.gecko.mAnimationIterationCountCount == other.gecko.mAnimationIterationCountCount
            && self.gecko.mAnimationPlayStateCount == other.gecko.mAnimationPlayStateCount
            && self.gecko.mAnimationTimingFunctionCount == other.gecko.mAnimationTimingFunctionCount
            && unsafe { bindings::Gecko_StyleAnimationsEquals(&self.gecko.mAnimations, &other.gecko.mAnimations) }
    }

    pub fn set_animation_name<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_name::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        self.gecko.mAnimations.ensure_len(v.len());

        self.gecko.mAnimationNameCount = v.len() as u32;
        for (servo, gecko) in v.zip(self.gecko.mAnimations.iter_mut()) {
            let atom = match servo.0 {
                None => atom!(""),
                Some(ref name) => name.as_atom().clone(),
            };
            unsafe { bindings::Gecko_SetAnimationName(gecko, atom.into_addrefed()); }
        }
    }
    pub fn animation_name_at(&self, index: usize)
        -> longhands::animation_name::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_name::single_value::SpecifiedValue as AnimationName;

        let atom = self.gecko.mAnimations[index].mName.mRawPtr;
        if atom == atom!("").as_ptr() {
            return AnimationName(None)
        }
        AnimationName(Some(KeyframesName::from_atom(unsafe { Atom::from_raw(atom) })))
    }
    pub fn copy_animation_name_from(&mut self, other: &Self) {
        self.gecko.mAnimationNameCount = other.gecko.mAnimationNameCount;
        unsafe { bindings::Gecko_CopyAnimationNames(&mut self.gecko.mAnimations, &other.gecko.mAnimations); }
    }

    pub fn reset_animation_name(&mut self, other: &Self) {
        self.copy_animation_name_from(other)
    }

    
    
    #[allow(non_snake_case)]
    pub fn animation_name_count(&self) -> usize {
        self.gecko.mAnimationNameCount as usize
    }



    
    
    #[allow(non_snake_case)]
    pub fn set_animation_delay<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_delay::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationDelayCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDelay = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_delay_at(&self, index: usize)
        -> longhands::animation_delay::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mAnimations[index].mDelay / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn animation_delay_count(&self) -> usize {
        self.gecko.mAnimationDelayCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_animation_delay_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationDelayCount;
        self.gecko.mAnimationDelayCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDelay = others.mDelay;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_delay(&mut self, other: &Self) {
        self.copy_animation_delay_from(other)
    }



    
    
    #[allow(non_snake_case)]
    pub fn set_animation_duration<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_duration::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationDurationCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDuration = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_duration_at(&self, index: usize)
        -> longhands::animation_duration::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mAnimations[index].mDuration / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn animation_duration_count(&self) -> usize {
        self.gecko.mAnimationDurationCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_animation_duration_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationDurationCount;
        self.gecko.mAnimationDurationCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDuration = others.mDuration;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_duration(&mut self, other: &Self) {
        self.copy_animation_duration_from(other)
    }




    
    #[allow(non_snake_case)]
    pub fn set_animation_direction<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_direction::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_direction::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationDirectionCount = input_len as u32;

        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::Normal =>
                        structs::PlaybackDirection::Normal ,
                    Keyword::Reverse =>
                        structs::PlaybackDirection::Reverse ,
                    Keyword::Alternate =>
                        structs::PlaybackDirection::Alternate ,
                    Keyword::AlternateReverse =>
                        structs::PlaybackDirection::Alternate_reverse ,
            };
            gecko.mDirection = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_direction_at(&self, index: usize)
        -> longhands::animation_direction::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_direction::single_value::computed_value::T as Keyword;
        match self.gecko.mAnimations[index].mDirection  {
                structs::PlaybackDirection::Normal => Keyword::Normal,
                structs::PlaybackDirection::Reverse => Keyword::Reverse,
                structs::PlaybackDirection::Alternate => Keyword::Alternate,
                structs::PlaybackDirection::Alternate_reverse => Keyword::AlternateReverse,
            _ => panic!("Found unexpected value for animation-direction"),
        }
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_direction_count(&self) -> usize {
        self.gecko.mAnimationDirectionCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_direction_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationDirectionCount;
        self.gecko.mAnimationDirectionCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDirection = others.mDirection;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_direction(&mut self, other: &Self) {
        self.copy_animation_direction_from(other)
    }



    
    #[allow(non_snake_case)]
    pub fn set_animation_fill_mode<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_fill_mode::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_fill_mode::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationFillModeCount = input_len as u32;

        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::None =>
                        structs::FillMode::None ,
                    Keyword::Forwards =>
                        structs::FillMode::Forwards ,
                    Keyword::Backwards =>
                        structs::FillMode::Backwards ,
                    Keyword::Both =>
                        structs::FillMode::Both ,
            };
            gecko.mFillMode = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_fill_mode_at(&self, index: usize)
        -> longhands::animation_fill_mode::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_fill_mode::single_value::computed_value::T as Keyword;
        match self.gecko.mAnimations[index].mFillMode  {
                structs::FillMode::None => Keyword::None,
                structs::FillMode::Forwards => Keyword::Forwards,
                structs::FillMode::Backwards => Keyword::Backwards,
                structs::FillMode::Both => Keyword::Both,
            _ => panic!("Found unexpected value for animation-fill_mode"),
        }
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_fill_mode_count(&self) -> usize {
        self.gecko.mAnimationFillModeCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_fill_mode_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationFillModeCount;
        self.gecko.mAnimationFillModeCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mFillMode = others.mFillMode;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_fill_mode(&mut self, other: &Self) {
        self.copy_animation_fill_mode_from(other)
    }



    
    #[allow(non_snake_case)]
    pub fn set_animation_play_state<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_play_state::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_play_state::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationPlayStateCount = input_len as u32;

        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::Running =>
                        structs::StyleAnimationPlayState::Running ,
                    Keyword::Paused =>
                        structs::StyleAnimationPlayState::Paused ,
            };
            gecko.mPlayState = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_play_state_at(&self, index: usize)
        -> longhands::animation_play_state::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_play_state::single_value::computed_value::T as Keyword;
        match self.gecko.mAnimations[index].mPlayState  {
                structs::StyleAnimationPlayState::Running => Keyword::Running,
                structs::StyleAnimationPlayState::Paused => Keyword::Paused,
        }
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_play_state_count(&self) -> usize {
        self.gecko.mAnimationPlayStateCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_play_state_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationPlayStateCount;
        self.gecko.mAnimationPlayStateCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mPlayState = others.mPlayState;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_play_state(&mut self, other: &Self) {
        self.copy_animation_play_state_from(other)
    }




    pub fn set_animation_iteration_count<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = values::computed::AnimationIterationCount>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        use std::f32;
        use crate::values::generics::box_::AnimationIterationCount;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationIterationCountCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            match servo {
                AnimationIterationCount::Number(n) => gecko.mIterationCount = n,
                AnimationIterationCount::Infinite => gecko.mIterationCount = f32::INFINITY,
            }
        }
    }

    pub fn animation_iteration_count_at(
        &self,
        index: usize,
    ) -> values::computed::AnimationIterationCount {
        use crate::values::generics::box_::AnimationIterationCount;

        if self.gecko.mAnimations[index].mIterationCount.is_infinite() {
            AnimationIterationCount::Infinite
        } else {
            AnimationIterationCount::Number(self.gecko.mAnimations[index].mIterationCount)
        }
    }

    
    
    #[allow(non_snake_case)]
    pub fn animation_iteration_count_count(&self) -> usize {
        self.gecko.mAnimationIterationCountCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_iteration_count_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationIterationCountCount;
        self.gecko.mAnimationIterationCountCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mIterationCount = others.mIterationCount;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_iteration_count(&mut self, other: &Self) {
        self.copy_animation_iteration_count_from(other)
    }



    
    
    pub fn set_animation_timing_function<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_timing_function::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationTimingFunctionCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimingFunction.mTiming = servo;
        }
    }
    
    #[allow(non_snake_case)]
    pub fn animation_timing_function_count(&self) -> usize {
        self.gecko.mAnimationTimingFunctionCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_animation_timing_function_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationTimingFunctionCount;
        self.gecko.mAnimationTimingFunctionCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mTimingFunction.mTiming = others.mTimingFunction.mTiming;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_timing_function(&mut self, other: &Self) {
        self.copy_animation_timing_function_from(other)
    }

    pub fn animation_timing_function_at(&self, index: usize)
        -> longhands::animation_timing_function::computed_value::SingleComputedValue {
        self.gecko.mAnimations[index].mTimingFunction.mTiming
    }



    pub fn set_perspective_origin(&mut self, v: longhands::perspective_origin::computed_value::T) {
        self.gecko.mPerspectiveOrigin[0].set(v.horizontal);
        self.gecko.mPerspectiveOrigin[1].set(v.vertical);
    }

    pub fn copy_perspective_origin_from(&mut self, other: &Self) {
        self.gecko.mPerspectiveOrigin[0].copy_from(&other.gecko.mPerspectiveOrigin[0]);
        self.gecko.mPerspectiveOrigin[1].copy_from(&other.gecko.mPerspectiveOrigin[1]);
    }

    pub fn reset_perspective_origin(&mut self, other: &Self) {
        self.copy_perspective_origin_from(other)
    }

    pub fn clone_perspective_origin(&self) -> longhands::perspective_origin::computed_value::T {
        use crate::properties::longhands::perspective_origin::computed_value::T;
        use crate::values::computed::LengthPercentage;
        T {
            horizontal: LengthPercentage::from_gecko_style_coord(&self.gecko.mPerspectiveOrigin[0])
                .expect("Expected length or percentage for horizontal value of perspective-origin"),
            vertical: LengthPercentage::from_gecko_style_coord(&self.gecko.mPerspectiveOrigin[1])
                .expect("Expected length or percentage for vertical value of perspective-origin"),
        }
    }

    
    pub fn set_rotate(&mut self, other: values::computed::Rotate) {
        unsafe { self.gecko.mSpecifiedRotate.clear() };

        if let Some(operation) = other.to_transform_operation() {
            convert_transform(&[operation], &mut self.gecko.mSpecifiedRotate)
        }
    }

    pub fn copy_rotate_from(&mut self, other: &Self) {
        unsafe { self.gecko.mSpecifiedRotate.set(&other.gecko.mSpecifiedRotate); }
    }

    pub fn reset_rotate(&mut self, other: &Self) {
        self.copy_rotate_from(other)
    }

    pub fn clone_rotate(&self) -> values::computed::Rotate {
        use crate::values::generics::transform::Rotate;

        if self.gecko.mSpecifiedRotate.mRawPtr.is_null() {
            return Rotate::None;
        }

        let list = unsafe { (*self.gecko.mSpecifiedRotate.to_safe().get()).mHead.as_ref() };

        let mut transform = clone_transform_from_list(list);
        debug_assert_eq!(transform.0.len(), 1);
        Rotate::from_transform_operation(&transform.0.pop().unwrap())
    }

    
    pub fn set_translate(&mut self, other: values::computed::Translate) {
        unsafe { self.gecko.mSpecifiedTranslate.clear() };

        if let Some(operation) = other.to_transform_operation() {
            convert_transform(&[operation], &mut self.gecko.mSpecifiedTranslate)
        }
    }

    pub fn copy_translate_from(&mut self, other: &Self) {
        unsafe { self.gecko.mSpecifiedTranslate.set(&other.gecko.mSpecifiedTranslate); }
    }

    pub fn reset_translate(&mut self, other: &Self) {
        self.copy_translate_from(other)
    }

    pub fn clone_translate(&self) -> values::computed::Translate {
        use crate::values::generics::transform::Translate;

        if self.gecko.mSpecifiedTranslate.mRawPtr.is_null() {
            return Translate::None;
        }

        let list = unsafe { (*self.gecko.mSpecifiedTranslate.to_safe().get()).mHead.as_ref() };

        let mut transform = clone_transform_from_list(list);
        debug_assert_eq!(transform.0.len(), 1);
        Translate::from_transform_operation(&transform.0.pop().unwrap())
    }

    
    pub fn set_scale(&mut self, other: values::computed::Scale) {
        unsafe { self.gecko.mSpecifiedScale.clear() };

        if let Some(operation) = other.to_transform_operation() {
            convert_transform(&[operation], &mut self.gecko.mSpecifiedScale)
        }
    }

    pub fn copy_scale_from(&mut self, other: &Self) {
        unsafe { self.gecko.mSpecifiedScale.set(&other.gecko.mSpecifiedScale); }
    }

    pub fn reset_scale(&mut self, other: &Self) {
        self.copy_scale_from(other)
    }

    pub fn clone_scale(&self) -> values::computed::Scale {
        use crate::values::generics::transform::Scale;

        if self.gecko.mSpecifiedScale.mRawPtr.is_null() {
            return Scale::None;
        }

        let list = unsafe { (*self.gecko.mSpecifiedScale.to_safe().get()).mHead.as_ref() };

        let mut transform = clone_transform_from_list(list);
        debug_assert_eq!(transform.0.len(), 1);
        Scale::from_transform_operation(&transform.0.pop().unwrap())
    }


    pub fn set_will_change(&mut self, v: longhands::will_change::computed_value::T) {
        use crate::gecko_bindings::bindings::{Gecko_AppendWillChange, Gecko_ClearWillChange};
        use crate::properties::longhands::will_change::computed_value::T;

        match v {
            T::AnimateableFeatures { features, bits } => {
                unsafe {
                    Gecko_ClearWillChange(&mut self.gecko, features.len());
                }

                for feature in features.iter() {
                    unsafe {
                        Gecko_AppendWillChange(&mut self.gecko, feature.0.as_ptr())
                    }
                }

                self.gecko.mWillChangeBitField = bits.bits();
            },
            T::Auto => {
                unsafe {
                    Gecko_ClearWillChange(&mut self.gecko, 0);
                }
                self.gecko.mWillChangeBitField = 0;
            },
        };
    }

    pub fn copy_will_change_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyWillChangeFrom;

        self.gecko.mWillChangeBitField = other.gecko.mWillChangeBitField;
        unsafe {
            Gecko_CopyWillChangeFrom(&mut self.gecko, &other.gecko as *const _ as *mut _);
        }
    }

    pub fn reset_will_change(&mut self, other: &Self) {
        self.copy_will_change_from(other)
    }

    pub fn clone_will_change(&self) -> longhands::will_change::computed_value::T {
        use crate::properties::longhands::will_change::computed_value::T;
        use crate::gecko_bindings::structs::nsAtom;
        use crate::values::CustomIdent;
        use crate::values::specified::box_::WillChangeBits;

        if self.gecko.mWillChange.len() == 0 {
            return T::Auto
        }

        let custom_idents: Vec<CustomIdent> = self.gecko.mWillChange.iter().map(|gecko_atom| {
            unsafe {
                CustomIdent(Atom::from_raw(gecko_atom.mRawPtr as *mut nsAtom))
            }
        }).collect();

        T::AnimateableFeatures {
            features: custom_idents.into_boxed_slice(),
            bits: WillChangeBits::from_bits_truncate(self.gecko.mWillChangeBitField),
        }
    }

    
    pub fn set_shape_outside(&mut self, v: longhands::shape_outside::computed_value::T) {
        use crate::gecko_bindings::bindings::{Gecko_NewBasicShape, Gecko_DestroyShapeSource};
        use crate::gecko_bindings::structs::{StyleBasicShape, StyleBasicShapeType, StyleShapeSourceType};
        use crate::gecko_bindings::structs::{StyleGeometryBox, StyleShapeSource};
        use crate::gecko::conversions::basic_shape::set_corners_from_radius;
        use crate::gecko::values::GeckoStyleCoordConvertible;
        use crate::values::generics::basic_shape::{BasicShape, ShapeSource};

        let ref mut shape_outside = self.gecko.mShapeOutside;

        // clean up existing struct
        unsafe { Gecko_DestroyShapeSource(shape_outside) };
        shape_outside.mType = StyleShapeSourceType::None;

        match v {
            ShapeSource::ImageOrUrl(image) => {
                unsafe {
                    bindings::Gecko_NewShapeImage(shape_outside);
                    let style_image = &mut *shape_outside.__bindgen_anon_1.mShapeImage.as_mut().mPtr;
                    style_image.set(image);
                }
            }
            ShapeSource::None => {} // don't change the type
            ShapeSource::Box(reference) => {
                shape_outside.mReferenceBox = reference.into();
                shape_outside.mType = StyleShapeSourceType::Box;
            }
            ShapeSource::Path(p) => set_style_svg_path(shape_outside, &p.path, p.fill),
            ShapeSource::Shape(servo_shape, maybe_box) => {
                fn init_shape(shape_outside: &mut StyleShapeSource, basic_shape_type: StyleBasicShapeType)
                              -> &mut StyleBasicShape {
                    unsafe {
                        // Create StyleBasicShape in StyleShapeSource. mReferenceBox and mType
                        // will be set manually later.
                        Gecko_NewBasicShape(shape_outside, basic_shape_type);
                        &mut *shape_outside.__bindgen_anon_1.mBasicShape.as_mut().mPtr
                    }
                }
                match servo_shape {
                    BasicShape::Inset(inset) => {
                        let shape = init_shape(shape_outside, StyleBasicShapeType::Inset);
                        unsafe { shape.mCoordinates.set_len(4) };

                        // set_len() can't call constructors, so the coordinates
                        // can contain any value. set_value() attempts to free
                        // allocated coordinates, so we don't want to feed it
                        // garbage values which it may misinterpret.
                        // Instead, we use leaky_set_value to blindly overwrite
                        // the garbage data without
                        // attempting to clean up.
                        shape.mCoordinates[0].leaky_set_null();
                        inset.rect.0.to_gecko_style_coord(&mut shape.mCoordinates[0]);
                        shape.mCoordinates[1].leaky_set_null();
                        inset.rect.1.to_gecko_style_coord(&mut shape.mCoordinates[1]);
                        shape.mCoordinates[2].leaky_set_null();
                        inset.rect.2.to_gecko_style_coord(&mut shape.mCoordinates[2]);
                        shape.mCoordinates[3].leaky_set_null();
                        inset.rect.3.to_gecko_style_coord(&mut shape.mCoordinates[3]);

                        set_corners_from_radius(inset.round, &mut shape.mRadius);
                    }
                    BasicShape::Circle(circ) => {
                        let shape = init_shape(shape_outside, StyleBasicShapeType::Circle);
                        unsafe { shape.mCoordinates.set_len(1) };
                        shape.mCoordinates[0].leaky_set_null();
                        circ.radius.to_gecko_style_coord(&mut shape.mCoordinates[0]);

                        shape.mPosition = circ.position.into();
                    }
                    BasicShape::Ellipse(el) => {
                        let shape = init_shape(shape_outside, StyleBasicShapeType::Ellipse);
                        unsafe { shape.mCoordinates.set_len(2) };
                        shape.mCoordinates[0].leaky_set_null();
                        el.semiaxis_x.to_gecko_style_coord(&mut shape.mCoordinates[0]);
                        shape.mCoordinates[1].leaky_set_null();
                        el.semiaxis_y.to_gecko_style_coord(&mut shape.mCoordinates[1]);

                        shape.mPosition = el.position.into();
                    }
                    BasicShape::Polygon(poly) => {
                        let shape = init_shape(shape_outside, StyleBasicShapeType::Polygon);
                        unsafe {
                            shape.mCoordinates.set_len(poly.coordinates.len() as u32 * 2);
                        }
                        for (i, coord) in poly.coordinates.iter().enumerate() {
                            shape.mCoordinates[2 * i].leaky_set_null();
                            shape.mCoordinates[2 * i + 1].leaky_set_null();
                            coord.0.to_gecko_style_coord(&mut shape.mCoordinates[2 * i]);
                            coord.1.to_gecko_style_coord(&mut shape.mCoordinates[2 * i + 1]);
                        }
                        shape.mFillRule = poly.fill;
                    }
                }

                shape_outside.mReferenceBox = maybe_box.map(Into::into)
                                                  .unwrap_or(StyleGeometryBox::NoBox);
                shape_outside.mType = StyleShapeSourceType::Shape;
            }
        }

    }

    pub fn clone_shape_outside(&self) -> longhands::shape_outside::computed_value::T {
        (&self.gecko.mShapeOutside).into()
    }

    pub fn copy_shape_outside_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyShapeSourceFrom;
        unsafe {
            Gecko_CopyShapeSourceFrom(&mut self.gecko.mShapeOutside, &other.gecko.mShapeOutside);
        }
    }

    pub fn reset_shape_outside(&mut self, other: &Self) {
        self.copy_shape_outside_from(other)
    }


    pub fn set_contain(&mut self, v: longhands::contain::computed_value::T) {
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_NONE;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_STRICT;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_CONTENT;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_SIZE;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_LAYOUT;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_STYLE;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_PAINT;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_ALL_BITS;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_CONTENT_BITS;
        use crate::properties::longhands::contain::SpecifiedValue;

        if v.is_empty() {
            self.gecko.mContain = NS_STYLE_CONTAIN_NONE as u8;
            return;
        }

        if v.contains(SpecifiedValue::STRICT) {
            self.gecko.mContain = (NS_STYLE_CONTAIN_STRICT | NS_STYLE_CONTAIN_ALL_BITS) as u8;
            return;
        }
        if v.contains(SpecifiedValue::CONTENT) {
            self.gecko.mContain = (NS_STYLE_CONTAIN_CONTENT | NS_STYLE_CONTAIN_CONTENT_BITS) as u8;
            return;
        }

        let mut bitfield = 0;
        if v.contains(SpecifiedValue::LAYOUT) {
            bitfield |= NS_STYLE_CONTAIN_LAYOUT;
        }
        if v.contains(SpecifiedValue::STYLE) {
            bitfield |= NS_STYLE_CONTAIN_STYLE;
        }
        if v.contains(SpecifiedValue::PAINT) {
            bitfield |= NS_STYLE_CONTAIN_PAINT;
        }
        if v.contains(SpecifiedValue::SIZE) {
            bitfield |= NS_STYLE_CONTAIN_SIZE;
        }

        self.gecko.mContain = bitfield as u8;
    }

    pub fn clone_contain(&self) -> longhands::contain::computed_value::T {
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_STRICT;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_CONTENT;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_SIZE;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_LAYOUT;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_STYLE;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_PAINT;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_ALL_BITS;
        use crate::gecko_bindings::structs::NS_STYLE_CONTAIN_CONTENT_BITS;
        use crate::properties::longhands::contain::{self, SpecifiedValue};

        let mut servo_flags = contain::computed_value::T::empty();
        let gecko_flags = self.gecko.mContain;

        if gecko_flags & (NS_STYLE_CONTAIN_STRICT as u8) != 0 {
            debug_assert_eq!(
                gecko_flags & (NS_STYLE_CONTAIN_ALL_BITS as u8),
                NS_STYLE_CONTAIN_ALL_BITS as u8,
                "When strict is specified, ALL_BITS should be specified as well"
            );
            servo_flags.insert(SpecifiedValue::STRICT | SpecifiedValue::STRICT_BITS);
            return servo_flags;
        }
        if gecko_flags & (NS_STYLE_CONTAIN_CONTENT as u8) != 0 {
            debug_assert_eq!(
                gecko_flags & (NS_STYLE_CONTAIN_CONTENT_BITS as u8),
                NS_STYLE_CONTAIN_CONTENT_BITS as u8,
                "When content is specified, CONTENT_BITS should be specified as well"
            );
            servo_flags.insert(SpecifiedValue::CONTENT | SpecifiedValue::CONTENT_BITS);
            return servo_flags;
        }
        if gecko_flags & (NS_STYLE_CONTAIN_LAYOUT as u8) != 0 {
            servo_flags.insert(SpecifiedValue::LAYOUT);
        }
        if gecko_flags & (NS_STYLE_CONTAIN_STYLE as u8) != 0 {
            servo_flags.insert(SpecifiedValue::STYLE);
        }
        if gecko_flags & (NS_STYLE_CONTAIN_PAINT as u8) != 0 {
            servo_flags.insert(SpecifiedValue::PAINT);
        }
        if gecko_flags & (NS_STYLE_CONTAIN_SIZE as u8) != 0 {
            servo_flags.insert(SpecifiedValue::SIZE);
        }

        return servo_flags;
    }

    
    #[allow(non_snake_case)]
    pub fn copy_contain_from(&mut self, other: &Self) {
        self.gecko.mContain = other.gecko.mContain;
    }

    #[allow(non_snake_case)]
    pub fn reset_contain(&mut self, other: &Self) {
        self.copy_contain_from(other)
    }


    
    

    #[allow(non_snake_case)]
    pub fn set_touch_action(&mut self, v: longhands::touch_action::computed_value::T) {
        self.gecko.mTouchAction = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_touch_action_from(&mut self, other: &Self) {
        self.gecko.mTouchAction = other.gecko.mTouchAction;
    }

    #[allow(non_snake_case)]
    pub fn reset_touch_action(&mut self, other: &Self) {
        self.copy_touch_action_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_touch_action(&self) -> longhands::touch_action::computed_value::T {
        From::from(self.gecko.mTouchAction)
    }


    pub fn set_offset_path(&mut self, v: longhands::offset_path::computed_value::T) {
        use crate::gecko_bindings::bindings::{Gecko_NewStyleMotion, Gecko_SetStyleMotion};
        use crate::gecko_bindings::structs::StyleShapeSourceType;
        use crate::values::generics::basic_shape::FillRule;
        use crate::values::specified::OffsetPath;

        let motion = unsafe { Gecko_NewStyleMotion().as_mut().unwrap() };
        match v {
            OffsetPath::None => motion.mOffsetPath.mType = StyleShapeSourceType::None,
            OffsetPath::Path(p) => {
                set_style_svg_path(&mut motion.mOffsetPath, &p, FillRule::Nonzero)
            },
        }
        unsafe { Gecko_SetStyleMotion(&mut self.gecko.mMotion, motion) };
    }

    pub fn clone_offset_path(&self) -> longhands::offset_path::computed_value::T {
        use crate::values::specified::OffsetPath;
        match unsafe { self.gecko.mMotion.mPtr.as_ref() } {
            None => OffsetPath::none(),
            Some(v) => (&v.mOffsetPath).into()
        }
    }

    pub fn copy_offset_path_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyStyleMotions;
        unsafe { Gecko_CopyStyleMotions(&mut self.gecko.mMotion, other.gecko.mMotion.mPtr) };
    }

    pub fn reset_offset_path(&mut self, other: &Self) {
        self.copy_offset_path_from(other);
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set__moz_top_layer(&mut self, v: longhands::_moz_top_layer::computed_value::T) {
        use crate::properties::longhands::_moz_top_layer::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_TOP_LAYER_NONE as u8,
                Keyword::Top =>
                    structs::NS_STYLE_TOP_LAYER_TOP as u8,
        };
        self.gecko.mTopLayer = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_top_layer_from(&mut self, other: &Self) {
        self.gecko.mTopLayer = other.gecko.mTopLayer;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_top_layer(&mut self, other: &Self) {
        self.copy__moz_top_layer_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_top_layer(&self) -> longhands::_moz_top_layer::computed_value::T {
        use crate::properties::longhands::_moz_top_layer::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TOP_LAYER_NONE : u8 =
            structs::NS_STYLE_TOP_LAYER_NONE as u8;
        const U8_NS_STYLE_TOP_LAYER_TOP : u8 =
            structs::NS_STYLE_TOP_LAYER_TOP as u8;

        match self.gecko.mTopLayer as u8 {
            U8_NS_STYLE_TOP_LAYER_NONE => Keyword::None,
            U8_NS_STYLE_TOP_LAYER_TOP => Keyword::Top,
            _ => panic!("Found unexpected value in style struct for _moz_top_layer property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_position(&mut self, v: longhands::position::computed_value::T) {
        use crate::properties::longhands::position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Static =>
                    structs::NS_STYLE_POSITION_STATIC as u8,
                Keyword::Absolute =>
                    structs::NS_STYLE_POSITION_ABSOLUTE as u8,
                Keyword::Relative =>
                    structs::NS_STYLE_POSITION_RELATIVE as u8,
                Keyword::Fixed =>
                    structs::NS_STYLE_POSITION_FIXED as u8,
                Keyword::Sticky =>
                    structs::NS_STYLE_POSITION_STICKY as u8,
        };
        self.gecko.mPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_position_from(&mut self, other: &Self) {
        self.gecko.mPosition = other.gecko.mPosition;
    }

    #[allow(non_snake_case)]
    pub fn reset_position(&mut self, other: &Self) {
        self.copy_position_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_position(&self) -> longhands::position::computed_value::T {
        use crate::properties::longhands::position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_POSITION_STATIC : u8 =
            structs::NS_STYLE_POSITION_STATIC as u8;
        const U8_NS_STYLE_POSITION_ABSOLUTE : u8 =
            structs::NS_STYLE_POSITION_ABSOLUTE as u8;
        const U8_NS_STYLE_POSITION_RELATIVE : u8 =
            structs::NS_STYLE_POSITION_RELATIVE as u8;
        const U8_NS_STYLE_POSITION_FIXED : u8 =
            structs::NS_STYLE_POSITION_FIXED as u8;
        const U8_NS_STYLE_POSITION_STICKY : u8 =
            structs::NS_STYLE_POSITION_STICKY as u8;

        match self.gecko.mPosition as u8 {
            U8_NS_STYLE_POSITION_STATIC => Keyword::Static,
            U8_NS_STYLE_POSITION_ABSOLUTE => Keyword::Absolute,
            U8_NS_STYLE_POSITION_RELATIVE => Keyword::Relative,
            U8_NS_STYLE_POSITION_FIXED => Keyword::Fixed,
            U8_NS_STYLE_POSITION_STICKY => Keyword::Sticky,
            _ => panic!("Found unexpected value in style struct for position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_float(&mut self, v: longhands::float::computed_value::T) {
        self.gecko.mFloat = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_float_from(&mut self, other: &Self) {
        self.gecko.mFloat = other.gecko.mFloat;
    }

    #[allow(non_snake_case)]
    pub fn reset_float(&mut self, other: &Self) {
        self.copy_float_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_float(&self) -> longhands::float::computed_value::T {
        From::from(self.gecko.mFloat)
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_inline(&mut self, v: longhands::overflow_clip_box_inline::computed_value::T) {
        self.gecko.mOverflowClipBoxInline = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_box_inline_from(&mut self, other: &Self) {
        self.gecko.mOverflowClipBoxInline = other.gecko.mOverflowClipBoxInline;
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_box_inline(&mut self, other: &Self) {
        self.copy_overflow_clip_box_inline_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_inline(&self) -> longhands::overflow_clip_box_inline::computed_value::T {
        From::from(self.gecko.mOverflowClipBoxInline)
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_block(&mut self, v: longhands::overflow_clip_box_block::computed_value::T) {
        self.gecko.mOverflowClipBoxBlock = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_box_block_from(&mut self, other: &Self) {
        self.gecko.mOverflowClipBoxBlock = other.gecko.mOverflowClipBoxBlock;
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_box_block(&mut self, other: &Self) {
        self.copy_overflow_clip_box_block_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_block(&self) -> longhands::overflow_clip_box_block::computed_value::T {
        From::from(self.gecko.mOverflowClipBoxBlock)
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_x(&mut self, v: longhands::overflow_x::computed_value::T) {
        self.gecko.mOverflowX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_x_from(&mut self, other: &Self) {
        self.gecko.mOverflowX = other.gecko.mOverflowX;
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_x(&mut self, other: &Self) {
        self.copy_overflow_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_x(&self) -> longhands::overflow_x::computed_value::T {
        From::from(self.gecko.mOverflowX)
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_y(&mut self, v: longhands::overflow_y::computed_value::T) {
        self.gecko.mOverflowY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_y_from(&mut self, other: &Self) {
        self.gecko.mOverflowY = other.gecko.mOverflowY;
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_y(&mut self, other: &Self) {
        self.copy_overflow_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_y(&self) -> longhands::overflow_y::computed_value::T {
        From::from(self.gecko.mOverflowY)
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_anchor(&mut self, v: longhands::overflow_anchor::computed_value::T) {
        self.gecko.mOverflowAnchor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_anchor_from(&mut self, other: &Self) {
        self.gecko.mOverflowAnchor = other.gecko.mOverflowAnchor;
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_anchor(&mut self, other: &Self) {
        self.copy_overflow_anchor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_anchor(&self) -> longhands::overflow_anchor::computed_value::T {
        From::from(self.gecko.mOverflowAnchor)
    }


    #[allow(non_snake_case)]
    pub fn set_scroll_snap_destination(&mut self, v: longhands::scroll_snap_destination::computed_value::T) {
        self.gecko.mScrollSnapDestination.mXPosition = v.horizontal.into();
        self.gecko.mScrollSnapDestination.mYPosition = v.vertical.into();
    }
    
    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_destination_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapDestination = other.gecko.mScrollSnapDestination;
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_destination(&mut self, other: &Self) {
        self.copy_scroll_snap_destination_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_destination(&self) -> longhands::scroll_snap_destination::computed_value::T {
        longhands::scroll_snap_destination::computed_value::T {
            horizontal: self.gecko.mScrollSnapDestination.mXPosition.into(),
            vertical: self.gecko.mScrollSnapDestination.mYPosition.into(),
        }
    }

    #[allow(non_snake_case)]
    pub fn set_transform(&mut self, other: values::computed::Transform) {
        use crate::gecko_properties::convert_transform;
        if other.0.is_empty() {
            unsafe {
                self.gecko.mSpecifiedTransform.clear();
            }
            return;
        };
        convert_transform(&other.0, &mut self.gecko.mSpecifiedTransform);
    }

    #[allow(non_snake_case)]
    pub fn copy_transform_from(&mut self, other: &Self) {
        unsafe { self.gecko.mSpecifiedTransform.set(&other.gecko.mSpecifiedTransform); }
    }

    #[allow(non_snake_case)]
    pub fn reset_transform(&mut self, other: &Self) {
        self.copy_transform_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_transform(&self) -> values::computed::Transform {
        use crate::gecko_properties::clone_transform_from_list;
        use crate::values::generics::transform::Transform;

        if self.gecko.mSpecifiedTransform.mRawPtr.is_null() {
            return Transform(vec!());
        }
        let list = unsafe { (*self.gecko.mSpecifiedTransform.to_safe().get()).mHead.as_ref() };
        clone_transform_from_list(list)
    }


    #[allow(non_snake_case)]
    pub fn set_scroll_behavior(&mut self, v: longhands::scroll_behavior::computed_value::T) {
        use crate::properties::longhands::scroll_behavior::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_SCROLL_BEHAVIOR_AUTO as u8,
                Keyword::Smooth =>
                    structs::NS_STYLE_SCROLL_BEHAVIOR_SMOOTH as u8,
        };
        self.gecko.mScrollBehavior = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_behavior_from(&mut self, other: &Self) {
        self.gecko.mScrollBehavior = other.gecko.mScrollBehavior;
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_behavior(&mut self, other: &Self) {
        self.copy_scroll_behavior_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_scroll_behavior(&self) -> longhands::scroll_behavior::computed_value::T {
        use crate::properties::longhands::scroll_behavior::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_SCROLL_BEHAVIOR_AUTO : u8 =
            structs::NS_STYLE_SCROLL_BEHAVIOR_AUTO as u8;
        const U8_NS_STYLE_SCROLL_BEHAVIOR_SMOOTH : u8 =
            structs::NS_STYLE_SCROLL_BEHAVIOR_SMOOTH as u8;

        match self.gecko.mScrollBehavior as u8 {
            U8_NS_STYLE_SCROLL_BEHAVIOR_AUTO => Keyword::Auto,
            U8_NS_STYLE_SCROLL_BEHAVIOR_SMOOTH => Keyword::Smooth,
            _ => panic!("Found unexpected value in style struct for scroll_behavior property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_type_x(&mut self, v: longhands::scroll_snap_type_x::computed_value::T) {
        self.gecko.mScrollSnapTypeX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_type_x_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapTypeX = other.gecko.mScrollSnapTypeX;
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_type_x(&mut self, other: &Self) {
        self.copy_scroll_snap_type_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_type_x(&self) -> longhands::scroll_snap_type_x::computed_value::T {
        From::from(self.gecko.mScrollSnapTypeX)
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_type_y(&mut self, v: longhands::scroll_snap_type_y::computed_value::T) {
        self.gecko.mScrollSnapTypeY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_type_y_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapTypeY = other.gecko.mScrollSnapTypeY;
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_type_y(&mut self, other: &Self) {
        self.copy_scroll_snap_type_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_type_y(&self) -> longhands::scroll_snap_type_y::computed_value::T {
        From::from(self.gecko.mScrollSnapTypeY)
    }



    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_x(&mut self, v: longhands::overscroll_behavior_x::computed_value::T) {
        self.gecko.mOverscrollBehaviorX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overscroll_behavior_x_from(&mut self, other: &Self) {
        self.gecko.mOverscrollBehaviorX = other.gecko.mOverscrollBehaviorX;
    }

    #[allow(non_snake_case)]
    pub fn reset_overscroll_behavior_x(&mut self, other: &Self) {
        self.copy_overscroll_behavior_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_x(&self) -> longhands::overscroll_behavior_x::computed_value::T {
        From::from(self.gecko.mOverscrollBehaviorX)
    }



    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_y(&mut self, v: longhands::overscroll_behavior_y::computed_value::T) {
        self.gecko.mOverscrollBehaviorY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overscroll_behavior_y_from(&mut self, other: &Self) {
        self.gecko.mOverscrollBehaviorY = other.gecko.mOverscrollBehaviorY;
    }

    #[allow(non_snake_case)]
    pub fn reset_overscroll_behavior_y(&mut self, other: &Self) {
        self.copy_overscroll_behavior_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_y(&self) -> longhands::overscroll_behavior_y::computed_value::T {
        From::from(self.gecko.mOverscrollBehaviorY)
    }



    #[allow(non_snake_case)]
    pub fn set_isolation(&mut self, v: longhands::isolation::computed_value::T) {
        use crate::properties::longhands::isolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_ISOLATION_AUTO as u8,
                Keyword::Isolate =>
                    structs::NS_STYLE_ISOLATION_ISOLATE as u8,
        };
        self.gecko.mIsolation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_isolation_from(&mut self, other: &Self) {
        self.gecko.mIsolation = other.gecko.mIsolation;
    }

    #[allow(non_snake_case)]
    pub fn reset_isolation(&mut self, other: &Self) {
        self.copy_isolation_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_isolation(&self) -> longhands::isolation::computed_value::T {
        use crate::properties::longhands::isolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_ISOLATION_AUTO : u8 =
            structs::NS_STYLE_ISOLATION_AUTO as u8;
        const U8_NS_STYLE_ISOLATION_ISOLATE : u8 =
            structs::NS_STYLE_ISOLATION_ISOLATE as u8;

        match self.gecko.mIsolation as u8 {
            U8_NS_STYLE_ISOLATION_AUTO => Keyword::Auto,
            U8_NS_STYLE_ISOLATION_ISOLATE => Keyword::Isolate,
            _ => panic!("Found unexpected value in style struct for isolation property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_break_after(&mut self, v: longhands::break_after::computed_value::T) {
        self.gecko.mBreakAfter = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_after_from(&mut self, other: &Self) {
        self.gecko.mBreakAfter = other.gecko.mBreakAfter;
    }

    #[allow(non_snake_case)]
    pub fn reset_break_after(&mut self, other: &Self) {
        self.copy_break_after_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_after(&self) -> longhands::break_after::computed_value::T {
        From::from(self.gecko.mBreakAfter)
    }



    #[allow(non_snake_case)]
    pub fn set_break_before(&mut self, v: longhands::break_before::computed_value::T) {
        self.gecko.mBreakBefore = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_before_from(&mut self, other: &Self) {
        self.gecko.mBreakBefore = other.gecko.mBreakBefore;
    }

    #[allow(non_snake_case)]
    pub fn reset_break_before(&mut self, other: &Self) {
        self.copy_break_before_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_before(&self) -> longhands::break_before::computed_value::T {
        From::from(self.gecko.mBreakBefore)
    }



    #[allow(non_snake_case)]
    pub fn set_break_inside(&mut self, v: longhands::break_inside::computed_value::T) {
        self.gecko.mBreakInside = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_inside_from(&mut self, other: &Self) {
        self.gecko.mBreakInside = other.gecko.mBreakInside;
    }

    #[allow(non_snake_case)]
    pub fn reset_break_inside(&mut self, other: &Self) {
        self.copy_break_inside_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_inside(&self) -> longhands::break_inside::computed_value::T {
        From::from(self.gecko.mBreakInside)
    }



    #[allow(non_snake_case)]
    pub fn set_resize(&mut self, v: longhands::resize::computed_value::T) {
        self.gecko.mResize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_resize_from(&mut self, other: &Self) {
        self.gecko.mResize = other.gecko.mResize;
    }

    #[allow(non_snake_case)]
    pub fn reset_resize(&mut self, other: &Self) {
        self.copy_resize_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_resize(&self) -> longhands::resize::computed_value::T {
        From::from(self.gecko.mResize)
    }


    #[allow(non_snake_case)]
    pub fn set_perspective(&mut self, v: longhands::perspective::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mChildPerspective);
    }
    #[allow(non_snake_case)]
    pub fn copy_perspective_from(&mut self, other: &Self) {
        self.gecko.mChildPerspective.copy_from(&other.gecko.mChildPerspective);
    }
    #[allow(non_snake_case)]
    pub fn reset_perspective(&mut self, other: &Self) {
        self.copy_perspective_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_perspective(&self) -> longhands::perspective::computed_value::T {
        use crate::properties::longhands::perspective::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mChildPerspective)
            .expect("clone for perspective failed")
    }


    #[allow(non_snake_case)]
    pub fn set_backface_visibility(&mut self, v: longhands::backface_visibility::computed_value::T) {
        use crate::properties::longhands::backface_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Visible =>
                    structs::NS_STYLE_BACKFACE_VISIBILITY_VISIBLE as u8,
                Keyword::Hidden =>
                    structs::NS_STYLE_BACKFACE_VISIBILITY_HIDDEN as u8,
        };
        self.gecko.mBackfaceVisibility = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_backface_visibility_from(&mut self, other: &Self) {
        self.gecko.mBackfaceVisibility = other.gecko.mBackfaceVisibility;
    }

    #[allow(non_snake_case)]
    pub fn reset_backface_visibility(&mut self, other: &Self) {
        self.copy_backface_visibility_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_backface_visibility(&self) -> longhands::backface_visibility::computed_value::T {
        use crate::properties::longhands::backface_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_BACKFACE_VISIBILITY_VISIBLE : u8 =
            structs::NS_STYLE_BACKFACE_VISIBILITY_VISIBLE as u8;
        const U8_NS_STYLE_BACKFACE_VISIBILITY_HIDDEN : u8 =
            structs::NS_STYLE_BACKFACE_VISIBILITY_HIDDEN as u8;

        match self.gecko.mBackfaceVisibility as u8 {
            U8_NS_STYLE_BACKFACE_VISIBILITY_VISIBLE => Keyword::Visible,
            U8_NS_STYLE_BACKFACE_VISIBILITY_HIDDEN => Keyword::Hidden,
            _ => panic!("Found unexpected value in style struct for backface_visibility property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_transform_box(&mut self, v: longhands::transform_box::computed_value::T) {
        use crate::properties::longhands::transform_box::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::BorderBox =>
                    structs::StyleGeometryBox::BorderBox ,
                Keyword::FillBox =>
                    structs::StyleGeometryBox::FillBox ,
                Keyword::ViewBox =>
                    structs::StyleGeometryBox::ViewBox ,
        };
        self.gecko.mTransformBox = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_box_from(&mut self, other: &Self) {
        self.gecko.mTransformBox = other.gecko.mTransformBox;
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_box(&mut self, other: &Self) {
        self.copy_transform_box_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_transform_box(&self) -> longhands::transform_box::computed_value::T {
        use crate::properties::longhands::transform_box::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTransformBox {
            structs::StyleGeometryBox::BorderBox => Keyword::BorderBox,
            structs::StyleGeometryBox::FillBox => Keyword::FillBox,
            structs::StyleGeometryBox::ViewBox => Keyword::ViewBox,
            _ => panic!("Found unexpected value in style struct for transform_box property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set_transform_origin(&mut self, v: values::computed::TransformOrigin) {
        self.gecko.mTransformOrigin[0].set(v.horizontal);
        self.gecko.mTransformOrigin[1].set(v.vertical);
        // transform-origin supports the third value for depth, while
        // -moz-window-transform-origin doesn't. The following code is
        // for handling this difference. If we can have more knowledge
        // about the type here, we may want to check that the length is
        // exactly either 2 or 3 in compile time.
        if let Some(third) = self.gecko.mTransformOrigin.get_mut(2) {
            third.set(v.depth);
        }
    }

    #[allow(non_snake_case)]
    pub fn copy_transform_origin_from(&mut self, other: &Self) {
        self.gecko.mTransformOrigin[0].copy_from(&other.gecko.mTransformOrigin[0]);
        self.gecko.mTransformOrigin[1].copy_from(&other.gecko.mTransformOrigin[1]);
        if let (Some(self_third), Some(other_third)) =
            (self.gecko.mTransformOrigin.get_mut(2), other.gecko.mTransformOrigin.get(2))
        {
            self_third.copy_from(other_third)
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_origin(&mut self, other: &Self) {
        self.copy_transform_origin_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_transform_origin(&self) -> values::computed::TransformOrigin {
        use crate::values::computed::{Length, LengthPercentage, TransformOrigin};
        TransformOrigin {
            horizontal: LengthPercentage::from_gecko_style_coord(&self.gecko.mTransformOrigin[0])
                .expect("clone for LengthPercentage failed"),
            vertical: LengthPercentage::from_gecko_style_coord(&self.gecko.mTransformOrigin[1])
                .expect("clone for LengthPercentage failed"),
            depth: if let Some(third) = self.gecko.mTransformOrigin.get(2) {
                Length::from_gecko_style_coord(third)
                    .expect("clone for Length failed")
            } else {
                Length::new(0.)
            },
        }
    }


    #[allow(non_snake_case)]
    pub fn set__moz_appearance(&mut self, v: longhands::_moz_appearance::computed_value::T) {
        self.gecko.mAppearance = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_appearance_from(&mut self, other: &Self) {
        self.gecko.mAppearance = other.gecko.mAppearance;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_appearance(&mut self, other: &Self) {
        self.copy__moz_appearance_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_appearance(&self) -> longhands::_moz_appearance::computed_value::T {
        From::from(self.gecko.mAppearance)
    }



    #[allow(non_snake_case)]
    pub fn set__moz_orient(&mut self, v: longhands::_moz_orient::computed_value::T) {
        use crate::properties::longhands::_moz_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Inline =>
                    structs::StyleOrient::Inline ,
                Keyword::Block =>
                    structs::StyleOrient::Block ,
                Keyword::Horizontal =>
                    structs::StyleOrient::Horizontal ,
                Keyword::Vertical =>
                    structs::StyleOrient::Vertical ,
        };
        self.gecko.mOrient = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_orient_from(&mut self, other: &Self) {
        self.gecko.mOrient = other.gecko.mOrient;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_orient(&mut self, other: &Self) {
        self.copy__moz_orient_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_orient(&self) -> longhands::_moz_orient::computed_value::T {
        use crate::properties::longhands::_moz_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mOrient {
            structs::StyleOrient::Inline => Keyword::Inline,
            structs::StyleOrient::Block => Keyword::Block,
            structs::StyleOrient::Horizontal => Keyword::Horizontal,
            structs::StyleOrient::Vertical => Keyword::Vertical,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_shape_image_threshold(&mut self, v: longhands::shape_image_threshold::computed_value::T) {
        self.gecko.mShapeImageThreshold = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_image_threshold_from(&mut self, other: &Self) {
        self.gecko.mShapeImageThreshold = other.gecko.mShapeImageThreshold;
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_image_threshold(&mut self, other: &Self) {
        self.copy_shape_image_threshold_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_image_threshold(&self) -> longhands::shape_image_threshold::computed_value::T {
        From::from(self.gecko.mShapeImageThreshold)
    }


    #[allow(non_snake_case)]
    pub fn set_shape_margin(&mut self, v: longhands::shape_margin::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mShapeMargin);
    }
    #[allow(non_snake_case)]
    pub fn copy_shape_margin_from(&mut self, other: &Self) {
        self.gecko.mShapeMargin.copy_from(&other.gecko.mShapeMargin);
    }
    #[allow(non_snake_case)]
    pub fn reset_shape_margin(&mut self, other: &Self) {
        self.copy_shape_margin_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_shape_margin(&self) -> longhands::shape_margin::computed_value::T {
        use crate::properties::longhands::shape_margin::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mShapeMargin)
            .expect("clone for shape_margin failed")
    }

}










// TODO: Gecko accepts lists in most background-related properties. We just use
// the first element (which is the common case), but at some point we want to
// add support for parsing these lists in servo and pushing to nsTArray's.



impl GeckoBackground {
    /*
     * Manually-Implemented Methods.
     */
    

    
    

    
    
    pub fn copy_background_repeat_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mRepeatCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mRepeat = other.mRepeat;
        }
        self.gecko.mImage.mRepeatCount = count;
    }

    pub fn reset_background_repeat(&mut self, other: &Self) {
        self.copy_background_repeat_from(other)
    }


    pub fn set_background_repeat<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::background_repeat::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mRepeatCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mRepeat = {
                
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Repeat;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_ns(repeat: BackgroundRepeatKeyword) -> StyleImageLayerRepeat {
            match repeat {
                BackgroundRepeatKeyword::Repeat => StyleImageLayerRepeat::Repeat,
                BackgroundRepeatKeyword::Space => StyleImageLayerRepeat::Space,
                BackgroundRepeatKeyword::Round => StyleImageLayerRepeat::Round,
                BackgroundRepeatKeyword::NoRepeat => StyleImageLayerRepeat::NoRepeat,
            }
        }

        let repeat_x = to_ns(servo.0);
        let repeat_y = to_ns(servo.1);
        nsStyleImageLayers_Repeat {
              mXRepeat: repeat_x,
              mYRepeat: repeat_y,
        }
    
            };
        }
    }


    pub fn clone_background_repeat(&self) -> longhands::background_repeat::computed_value::T {
        use crate::properties::longhands::background_repeat::single_value::computed_value::T;
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_servo(repeat: StyleImageLayerRepeat) -> BackgroundRepeatKeyword {
            match repeat {
                StyleImageLayerRepeat::Repeat => BackgroundRepeatKeyword::Repeat,
                StyleImageLayerRepeat::Space => BackgroundRepeatKeyword::Space,
                StyleImageLayerRepeat::Round => BackgroundRepeatKeyword::Round,
                StyleImageLayerRepeat::NoRepeat => BackgroundRepeatKeyword::NoRepeat,
                _ => panic!("Found unexpected value in style struct for background_repeat property"),
            }
        }

        longhands::background_repeat::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mRepeatCount as usize)
                .map(|ref layer| {
                    T(to_servo(layer.mRepeat.mXRepeat), to_servo(layer.mRepeat.mYRepeat))
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_clip_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mClipCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mClip = other.mClip;
        }
        self.gecko.mImage.mClipCount = count;
    }

    pub fn reset_background_clip(&mut self, other: &Self) {
        self.copy_background_clip_from(other)
    }


    pub fn set_background_clip<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_clip::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_clip::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mClipCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mClip = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::Text =>
                        structs::StyleGeometryBox::Text ,
                }
            };
        }
    }

    pub fn clone_background_clip(&self) -> longhands::background_clip::computed_value::T {
        use crate::properties::longhands::background_clip::single_value::computed_value::T as Keyword;


        longhands::background_clip::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mClipCount as usize)
                .map(|ref layer| {
                    match layer.mClip {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::Text
                            => Keyword::Text,
                        _ => panic!("Found unexpected value in style struct for background_clip property"),
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_origin_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mOriginCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mOrigin = other.mOrigin;
        }
        self.gecko.mImage.mOriginCount = count;
    }

    pub fn reset_background_origin(&mut self, other: &Self) {
        self.copy_background_origin_from(other)
    }


    pub fn set_background_origin<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_origin::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_origin::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mOriginCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mOrigin = {
                match servo {
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                }
            };
        }
    }

    pub fn clone_background_origin(&self) -> longhands::background_origin::computed_value::T {
        use crate::properties::longhands::background_origin::single_value::computed_value::T as Keyword;


        longhands::background_origin::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mOriginCount as usize)
                .map(|ref layer| {
                    match layer.mOrigin {
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        _ => panic!("Found unexpected value in style struct for background_origin property"),
                    }
                }).collect()
        )
    }


    pub fn copy_background_position_x_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mPositionXCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }

        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.mXPosition
                = other.mPosition.mXPosition;
        }
        self.gecko.mImage.mPositionXCount = count;
    }

    pub fn reset_background_position_x(&mut self, other: &Self) {
        self.copy_background_position_x_from(other)
    }

    pub fn clone_background_position_x(&self)
        -> longhands::background_position_x::computed_value::T {
        longhands::background_position_x::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mPositionXCount as usize)
                .map(|position| position.mPosition.mXPosition.into())
                .collect()
        )
    }

    pub fn set_background_position_x<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::background_position_x
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mPositionXCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.mXPosition = servo.into();
        }
    }
    pub fn copy_background_position_y_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mPositionYCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }

        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.mYPosition
                = other.mPosition.mYPosition;
        }
        self.gecko.mImage.mPositionYCount = count;
    }

    pub fn reset_background_position_y(&mut self, other: &Self) {
        self.copy_background_position_y_from(other)
    }

    pub fn clone_background_position_y(&self)
        -> longhands::background_position_y::computed_value::T {
        longhands::background_position_y::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mPositionYCount as usize)
                .map(|position| position.mPosition.mYPosition.into())
                .collect()
        )
    }

    pub fn set_background_position_y<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::background_position_y
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mPositionYCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.mYPosition = servo.into();
        }
    }

    
    
    pub fn copy_background_size_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mSizeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mSize = other.mSize;
        }
        self.gecko.mImage.mSizeCount = count;
    }

    pub fn reset_background_size(&mut self, other: &Self) {
        self.copy_background_size_from(other)
    }


    pub fn set_background_size<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::background_size::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mSizeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mSize = {
                
        use crate::gecko_bindings::structs::nsStyleImageLayers_Size_Dimension;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Size_DimensionType;
        use crate::gecko_bindings::structs::{nsStyleCoord_CalcValue, nsStyleImageLayers_Size};
        use crate::values::generics::background::BackgroundSize;

        let mut width = nsStyleCoord_CalcValue::new();
        let mut height = nsStyleCoord_CalcValue::new();

        let (w_type, h_type) = match servo {
            BackgroundSize::Explicit { width: explicit_width, height: explicit_height } => {
                let mut w_type = nsStyleImageLayers_Size_DimensionType::eAuto;
                let mut h_type = nsStyleImageLayers_Size_DimensionType::eAuto;
                if let Some(w) = explicit_width.0.to_calc_value() {
                    width = w;
                    w_type = nsStyleImageLayers_Size_DimensionType::eLengthPercentage;
                }
                if let Some(h) = explicit_height.0.to_calc_value() {
                    height = h;
                    h_type = nsStyleImageLayers_Size_DimensionType::eLengthPercentage;
                }
                (w_type, h_type)
            }
            BackgroundSize::Cover => {
                (
                    nsStyleImageLayers_Size_DimensionType::eCover,
                    nsStyleImageLayers_Size_DimensionType::eCover,
                )
            },
            BackgroundSize::Contain => {
                (
                    nsStyleImageLayers_Size_DimensionType::eContain,
                    nsStyleImageLayers_Size_DimensionType::eContain,
                )
            },
        };

        nsStyleImageLayers_Size {
            mWidth: nsStyleImageLayers_Size_Dimension { _base: width },
            mHeight: nsStyleImageLayers_Size_Dimension { _base: height },
            mWidthType: w_type as u8,
            mHeightType: h_type as u8,
        }
    
            };
        }
    }


    pub fn clone_background_size(&self) -> longhands::background_size::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleCoord_CalcValue as CalcValue;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Size_DimensionType as DimensionType;
        use crate::values::computed::NonNegativeLengthPercentageOrAuto;
        use crate::values::generics::background::BackgroundSize;

        fn to_servo(value: CalcValue, ty: u8) -> NonNegativeLengthPercentageOrAuto {
            if ty == DimensionType::eAuto as u8 {
                NonNegativeLengthPercentageOrAuto::auto()
            } else {
                debug_assert_eq!(ty, DimensionType::eLengthPercentage as u8);
                value.into()
            }
        }

        longhands::background_size::computed_value::List(
            self.gecko.mImage.mLayers.iter().map(|ref layer| {
                if DimensionType::eCover as u8 == layer.mSize.mWidthType {
                    debug_assert_eq!(layer.mSize.mHeightType, DimensionType::eCover as u8);
                    return BackgroundSize::Cover
                }
                if DimensionType::eContain as u8 == layer.mSize.mWidthType {
                    debug_assert_eq!(layer.mSize.mHeightType, DimensionType::eContain as u8);
                    return BackgroundSize::Contain
                }
                BackgroundSize::Explicit {
                    width: to_servo(layer.mSize.mWidth._base, layer.mSize.mWidthType),
                    height: to_servo(layer.mSize.mHeight._base, layer.mSize.mHeightType),
                }
            }).collect()
        )
    }

    pub fn copy_background_image_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        unsafe {
            let count = other.gecko.mImage.mImageCount;
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);

            for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                      .zip(other.gecko.mImage.mLayers.iter())
                                      .take(count as usize) {
                Gecko_CopyImageValueFrom(&mut layer.mImage, &other.mImage);
            }
            self.gecko.mImage.mImageCount = count;
        }
    }

    pub fn reset_background_image(&mut self, other: &Self) {
        self.copy_background_image_from(other)
    }

    #[allow(unused_variables)]
    pub fn set_background_image<I>(&mut self, images: I)
        where I: IntoIterator<Item = longhands::background_image::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let images = images.into_iter();

        unsafe {
            // Prevent leaking of the last elements we did set
            for image in &mut self.gecko.mImage.mLayers {
                Gecko_SetNullImageValue(&mut image.mImage)
            }
            // XXXManishearth clear mSourceURI for masks
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, images.len(),
                                          LayerType::Background);
        }

        self.gecko.mImage.mImageCount = images.len() as u32;

        for (image, geckoimage) in images.zip(self.gecko.mImage
                                                  .mLayers.iter_mut()) {
            if let Either::Second(image) = image {
                geckoimage.mImage.set(image)
            }
        }
    }

    pub fn clone_background_image(&self) -> longhands::background_image::computed_value::T {
        use crate::values::None_;

        longhands::background_image::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mImageCount as usize)
                .map(|ref layer| {
                    match unsafe { layer.mImage.into_image() } {
                        Some(image) => Either::Second(image),
                        None => Either::First(None_),
                    }
            }).collect()
        )
    }

    
    pub fn fill_arrays(&mut self) {
        use crate::gecko_bindings::bindings::Gecko_FillAllImageLayers;
        use std::cmp;
        let mut max_len = 1;
            max_len = cmp::max(max_len, self.gecko.mImage.mRepeatCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mClipCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mOriginCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mPositionXCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mPositionYCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mImageCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mSizeCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mAttachmentCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mBlendModeCount);
        unsafe {
            // While we could do this manually, we'd need to also manually
            // run all the copy constructors, so we just delegate to gecko
            Gecko_FillAllImageLayers(&mut self.gecko.mImage, max_len);
        }
    }

    
    

    
    pub fn copy_background_attachment_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mAttachmentCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mAttachment = other.mAttachment;
        }
        self.gecko.mImage.mAttachmentCount = count;
    }

    pub fn reset_background_attachment(&mut self, other: &Self) {
        self.copy_background_attachment_from(other)
    }


    pub fn set_background_attachment<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_attachment::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_attachment::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mAttachmentCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mAttachment = {
                match servo {
                    Keyword::Scroll =>
                        structs::StyleImageLayerAttachment::Scroll ,
                    Keyword::Fixed =>
                        structs::StyleImageLayerAttachment::Fixed ,
                    Keyword::Local =>
                        structs::StyleImageLayerAttachment::Local ,
                }
            };
        }
    }

    pub fn clone_background_attachment(&self) -> longhands::background_attachment::computed_value::T {
        use crate::properties::longhands::background_attachment::single_value::computed_value::T as Keyword;


        longhands::background_attachment::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mAttachmentCount as usize)
                .map(|ref layer| {
                    match layer.mAttachment {
                        structs::StyleImageLayerAttachment::Scroll
                            => Keyword::Scroll,
                        structs::StyleImageLayerAttachment::Fixed
                            => Keyword::Fixed,
                        structs::StyleImageLayerAttachment::Local
                            => Keyword::Local,
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_blend_mode_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mBlendModeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mBlendMode = other.mBlendMode;
        }
        self.gecko.mImage.mBlendModeCount = count;
    }

    pub fn reset_background_blend_mode(&mut self, other: &Self) {
        self.copy_background_blend_mode_from(other)
    }


    pub fn set_background_blend_mode<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_blend_mode::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_blend_mode::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mBlendModeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mBlendMode = {
                match servo {
                    Keyword::Normal =>
                        structs::NS_STYLE_BLEND_NORMAL as u8,
                    Keyword::Multiply =>
                        structs::NS_STYLE_BLEND_MULTIPLY as u8,
                    Keyword::Screen =>
                        structs::NS_STYLE_BLEND_SCREEN as u8,
                    Keyword::Overlay =>
                        structs::NS_STYLE_BLEND_OVERLAY as u8,
                    Keyword::Darken =>
                        structs::NS_STYLE_BLEND_DARKEN as u8,
                    Keyword::Lighten =>
                        structs::NS_STYLE_BLEND_LIGHTEN as u8,
                    Keyword::ColorDodge =>
                        structs::NS_STYLE_BLEND_COLOR_DODGE as u8,
                    Keyword::ColorBurn =>
                        structs::NS_STYLE_BLEND_COLOR_BURN as u8,
                    Keyword::HardLight =>
                        structs::NS_STYLE_BLEND_HARD_LIGHT as u8,
                    Keyword::SoftLight =>
                        structs::NS_STYLE_BLEND_SOFT_LIGHT as u8,
                    Keyword::Difference =>
                        structs::NS_STYLE_BLEND_DIFFERENCE as u8,
                    Keyword::Exclusion =>
                        structs::NS_STYLE_BLEND_EXCLUSION as u8,
                    Keyword::Hue =>
                        structs::NS_STYLE_BLEND_HUE as u8,
                    Keyword::Saturation =>
                        structs::NS_STYLE_BLEND_SATURATION as u8,
                    Keyword::Color =>
                        structs::NS_STYLE_BLEND_COLOR as u8,
                    Keyword::Luminosity =>
                        structs::NS_STYLE_BLEND_LUMINOSITY as u8,
                }
            };
        }
    }

    pub fn clone_background_blend_mode(&self) -> longhands::background_blend_mode::computed_value::T {
        use crate::properties::longhands::background_blend_mode::single_value::computed_value::T as Keyword;

        const U8_NS_STYLE_BLEND_NORMAL : u8 =
            structs::NS_STYLE_BLEND_NORMAL as u8;
        const U8_NS_STYLE_BLEND_MULTIPLY : u8 =
            structs::NS_STYLE_BLEND_MULTIPLY as u8;
        const U8_NS_STYLE_BLEND_SCREEN : u8 =
            structs::NS_STYLE_BLEND_SCREEN as u8;
        const U8_NS_STYLE_BLEND_OVERLAY : u8 =
            structs::NS_STYLE_BLEND_OVERLAY as u8;
        const U8_NS_STYLE_BLEND_DARKEN : u8 =
            structs::NS_STYLE_BLEND_DARKEN as u8;
        const U8_NS_STYLE_BLEND_LIGHTEN : u8 =
            structs::NS_STYLE_BLEND_LIGHTEN as u8;
        const U8_NS_STYLE_BLEND_COLOR_DODGE : u8 =
            structs::NS_STYLE_BLEND_COLOR_DODGE as u8;
        const U8_NS_STYLE_BLEND_COLOR_BURN : u8 =
            structs::NS_STYLE_BLEND_COLOR_BURN as u8;
        const U8_NS_STYLE_BLEND_HARD_LIGHT : u8 =
            structs::NS_STYLE_BLEND_HARD_LIGHT as u8;
        const U8_NS_STYLE_BLEND_SOFT_LIGHT : u8 =
            structs::NS_STYLE_BLEND_SOFT_LIGHT as u8;
        const U8_NS_STYLE_BLEND_DIFFERENCE : u8 =
            structs::NS_STYLE_BLEND_DIFFERENCE as u8;
        const U8_NS_STYLE_BLEND_EXCLUSION : u8 =
            structs::NS_STYLE_BLEND_EXCLUSION as u8;
        const U8_NS_STYLE_BLEND_HUE : u8 =
            structs::NS_STYLE_BLEND_HUE as u8;
        const U8_NS_STYLE_BLEND_SATURATION : u8 =
            structs::NS_STYLE_BLEND_SATURATION as u8;
        const U8_NS_STYLE_BLEND_COLOR : u8 =
            structs::NS_STYLE_BLEND_COLOR as u8;
        const U8_NS_STYLE_BLEND_LUMINOSITY : u8 =
            structs::NS_STYLE_BLEND_LUMINOSITY as u8;

        longhands::background_blend_mode::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mBlendModeCount as usize)
                .map(|ref layer| {
                    match layer.mBlendMode {
                        U8_NS_STYLE_BLEND_NORMAL
                            => Keyword::Normal,
                        U8_NS_STYLE_BLEND_MULTIPLY
                            => Keyword::Multiply,
                        U8_NS_STYLE_BLEND_SCREEN
                            => Keyword::Screen,
                        U8_NS_STYLE_BLEND_OVERLAY
                            => Keyword::Overlay,
                        U8_NS_STYLE_BLEND_DARKEN
                            => Keyword::Darken,
                        U8_NS_STYLE_BLEND_LIGHTEN
                            => Keyword::Lighten,
                        U8_NS_STYLE_BLEND_COLOR_DODGE
                            => Keyword::ColorDodge,
                        U8_NS_STYLE_BLEND_COLOR_BURN
                            => Keyword::ColorBurn,
                        U8_NS_STYLE_BLEND_HARD_LIGHT
                            => Keyword::HardLight,
                        U8_NS_STYLE_BLEND_SOFT_LIGHT
                            => Keyword::SoftLight,
                        U8_NS_STYLE_BLEND_DIFFERENCE
                            => Keyword::Difference,
                        U8_NS_STYLE_BLEND_EXCLUSION
                            => Keyword::Exclusion,
                        U8_NS_STYLE_BLEND_HUE
                            => Keyword::Hue,
                        U8_NS_STYLE_BLEND_SATURATION
                            => Keyword::Saturation,
                        U8_NS_STYLE_BLEND_COLOR
                            => Keyword::Color,
                        U8_NS_STYLE_BLEND_LUMINOSITY
                            => Keyword::Luminosity,
                        _ => panic!("Found unexpected value in style struct for background_blend_mode property"),
                    }
                }).collect()
        )
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_background_color(&mut self, v: longhands::background_color::computed_value::T) {
        self.gecko.mBackgroundColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_background_color_from(&mut self, other: &Self) {
        let color = other.gecko.mBackgroundColor;
        self.gecko.mBackgroundColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_background_color(&mut self, other: &Self) {
        self.copy_background_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_background_color(&self) -> longhands::background_color::computed_value::T {
        self.gecko.mBackgroundColor.into()
    }


}




impl GeckoList {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_list_style_image(&mut self, image: longhands::list_style_image::computed_value::T) {
        match image {
            UrlOrNone::None => {
                unsafe {
                    Gecko_SetListStyleImageNone(&mut self.gecko);
                }
            }
            UrlOrNone::Url(ref url) => {
                unsafe {
                    Gecko_SetListStyleImageImageValue(
                        &mut self.gecko,
                        url.url_value_ptr(),
                    );
                }
            }
        }
    }

    pub fn copy_list_style_image_from(&mut self, other: &Self) {
        unsafe { Gecko_CopyListStyleImageFrom(&mut self.gecko, &other.gecko); }
    }

    pub fn reset_list_style_image(&mut self, other: &Self) {
        self.copy_list_style_image_from(other)
    }

    pub fn clone_list_style_image(&self) -> longhands::list_style_image::computed_value::T {
        use crate::values::computed::url::ComputedImageUrl;

        if self.gecko.mListStyleImage.mRawPtr.is_null() {
            return UrlOrNone::None;
        }

        unsafe {
            let ref gecko_image_request = *self.gecko.mListStyleImage.mRawPtr;
            UrlOrNone::Url(ComputedImageUrl::from_image_request(gecko_image_request))
        }
    }

    pub fn set_list_style_type(&mut self, v: longhands::list_style_type::computed_value::T, device: &Device) {
        use crate::gecko_bindings::bindings::Gecko_SetCounterStyleToString;
        use nsstring::{nsACString, nsCStr};
        use self::longhands::list_style_type::computed_value::T;
        match v {
            T::CounterStyle(s) => s.to_gecko_value(&mut self.gecko.mCounterStyle, device),
            T::String(s) => unsafe {
                Gecko_SetCounterStyleToString(&mut self.gecko.mCounterStyle,
                                              &nsCStr::from(&s) as &nsACString)
            }
        }
    }

    pub fn copy_list_style_type_from(&mut self, other: &Self) {
        unsafe {
            Gecko_CopyCounterStyle(&mut self.gecko.mCounterStyle, &other.gecko.mCounterStyle);
        }
    }

    pub fn reset_list_style_type(&mut self, other: &Self) {
        self.copy_list_style_type_from(other)
    }

    pub fn clone_list_style_type(&self) -> longhands::list_style_type::computed_value::T {
        use self::longhands::list_style_type::computed_value::T;
        use crate::values::Either;
        use crate::values::generics::CounterStyleOrNone;

        let result = CounterStyleOrNone::from_gecko_value(&self.gecko.mCounterStyle);
        match result {
            Either::First(counter_style) => T::CounterStyle(counter_style),
            Either::Second(string) => T::String(string),
        }
    }

    pub fn set_quotes(&mut self, other: longhands::quotes::computed_value::T) {
        self.gecko.mQuotes.set_arc(other.0.clone());
    }

    pub fn copy_quotes_from(&mut self, other: &Self) {
        self.set_quotes(other.clone_quotes());
    }

    pub fn reset_quotes(&mut self, other: &Self) {
        self.copy_quotes_from(other)
    }

    pub fn clone_quotes(&self) -> longhands::quotes::computed_value::T {
        use gecko_bindings::sugar::ownership::HasArcFFI;
        use values::computed::QuotePair;

        let quote_pairs = unsafe { &*self.gecko.mQuotes.mRawPtr };
        longhands::quotes::computed_value::T(
            Box::<[QuotePair]>::as_arc(&quote_pairs).clone_arc()
        )
    }

    #[allow(non_snake_case)]
    pub fn set__moz_image_region(&mut self, v: longhands::_moz_image_region::computed_value::T) {
        use crate::values::Either;

        match v {
            Either::Second(_auto) => {
                self.gecko.mImageRegion.x = 0;
                self.gecko.mImageRegion.y = 0;
                self.gecko.mImageRegion.width = 0;
                self.gecko.mImageRegion.height = 0;
            }
            Either::First(rect) => {
                self.gecko.mImageRegion.x = rect.left.map(Au::from).unwrap_or(Au(0)).0;
                self.gecko.mImageRegion.y = rect.top.map(Au::from).unwrap_or(Au(0)).0;
                self.gecko.mImageRegion.height = match rect.bottom {
                    Some(value) => (Au::from(value) - Au(self.gecko.mImageRegion.y)).0,
                    None => 0,
                };
                self.gecko.mImageRegion.width = match rect.right {
                    Some(value) => (Au::from(value) - Au(self.gecko.mImageRegion.x)).0,
                    None => 0,
                };
            }
        }
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_image_region(&self) -> longhands::_moz_image_region::computed_value::T {
        use crate::values::{Auto, Either};
        use crate::values::computed::ClipRect;

        // There is no ideal way to detect auto type for structs::nsRect and its components, so
        // if all components are zero, we use Auto.
        if self.gecko.mImageRegion.x == 0 &&
           self.gecko.mImageRegion.y == 0 &&
           self.gecko.mImageRegion.width == 0 &&
           self.gecko.mImageRegion.height == 0 {
           return Either::Second(Auto);
        }

        Either::First(ClipRect {
            top: Some(Au(self.gecko.mImageRegion.y).into()),
            right: Some(Au(self.gecko.mImageRegion.width + self.gecko.mImageRegion.x).into()),
            bottom: Some(Au(self.gecko.mImageRegion.height + self.gecko.mImageRegion.y).into()),
            left: Some(Au(self.gecko.mImageRegion.x).into()),
        })
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_image_region_from(&mut self, other: &Self) {
        self.gecko.mImageRegion = other.gecko.mImageRegion;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_image_region(&mut self, other: &Self) {
        self.copy__moz_image_region_from(other)
    }




    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_list_style_position(&mut self, v: longhands::list_style_position::computed_value::T) {
        use crate::properties::longhands::list_style_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Outside =>
                    structs::NS_STYLE_LIST_STYLE_POSITION_OUTSIDE as u8,
                Keyword::Inside =>
                    structs::NS_STYLE_LIST_STYLE_POSITION_INSIDE as u8,
        };
        self.gecko.mListStylePosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_list_style_position_from(&mut self, other: &Self) {
        self.gecko.mListStylePosition = other.gecko.mListStylePosition;
    }

    #[allow(non_snake_case)]
    pub fn reset_list_style_position(&mut self, other: &Self) {
        self.copy_list_style_position_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_list_style_position(&self) -> longhands::list_style_position::computed_value::T {
        use crate::properties::longhands::list_style_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_LIST_STYLE_POSITION_OUTSIDE : u8 =
            structs::NS_STYLE_LIST_STYLE_POSITION_OUTSIDE as u8;
        const U8_NS_STYLE_LIST_STYLE_POSITION_INSIDE : u8 =
            structs::NS_STYLE_LIST_STYLE_POSITION_INSIDE as u8;

        match self.gecko.mListStylePosition as u8 {
            U8_NS_STYLE_LIST_STYLE_POSITION_OUTSIDE => Keyword::Outside,
            U8_NS_STYLE_LIST_STYLE_POSITION_INSIDE => Keyword::Inside,
            _ => panic!("Found unexpected value in style struct for list_style_position property"),
        }
    }


}




impl GeckoTable {
    /*
     * Manually-Implemented Methods.
     */
    
    #[allow(non_snake_case)]
    pub fn set__x_span(&mut self, v: longhands::_x_span::computed_value::T) {
        self.gecko.mSpan = v.0
    }

    #[allow(non_snake_case)]
    pub fn clone__x_span(&self) -> longhands::_x_span::computed_value::T {
        longhands::_x_span::computed_value::T(
            self.gecko.mSpan
        )
    }

    
    #[allow(non_snake_case)]
    pub fn copy__x_span_from(&mut self, other: &Self) {
        self.gecko.mSpan = other.gecko.mSpan;
    }

    #[allow(non_snake_case)]
    pub fn reset__x_span(&mut self, other: &Self) {
        self.copy__x_span_from(other)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_table_layout(&mut self, v: longhands::table_layout::computed_value::T) {
        use crate::properties::longhands::table_layout::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_TABLE_LAYOUT_AUTO as u8,
                Keyword::Fixed =>
                    structs::NS_STYLE_TABLE_LAYOUT_FIXED as u8,
        };
        self.gecko.mLayoutStrategy = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_table_layout_from(&mut self, other: &Self) {
        self.gecko.mLayoutStrategy = other.gecko.mLayoutStrategy;
    }

    #[allow(non_snake_case)]
    pub fn reset_table_layout(&mut self, other: &Self) {
        self.copy_table_layout_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_table_layout(&self) -> longhands::table_layout::computed_value::T {
        use crate::properties::longhands::table_layout::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TABLE_LAYOUT_AUTO : u8 =
            structs::NS_STYLE_TABLE_LAYOUT_AUTO as u8;
        const U8_NS_STYLE_TABLE_LAYOUT_FIXED : u8 =
            structs::NS_STYLE_TABLE_LAYOUT_FIXED as u8;

        match self.gecko.mLayoutStrategy as u8 {
            U8_NS_STYLE_TABLE_LAYOUT_AUTO => Keyword::Auto,
            U8_NS_STYLE_TABLE_LAYOUT_FIXED => Keyword::Fixed,
            _ => panic!("Found unexpected value in style struct for table_layout property"),
        }
    }


}




impl GeckoEffects {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_box_shadow<I>(&mut self, v: I)
        where I: IntoIterator<Item = BoxShadow>,
              I::IntoIter: ExactSizeIterator
    {
        let v = v.into_iter();
        self.gecko.mBoxShadow.replace_with_new(v.len() as u32);
        for (servo, gecko_shadow) in v.zip(self.gecko.mBoxShadow.iter_mut()) {
            gecko_shadow.set_from_box_shadow(servo);
        }
    }

    pub fn copy_box_shadow_from(&mut self, other: &Self) {
        self.gecko.mBoxShadow.copy_from(&other.gecko.mBoxShadow);
    }

    pub fn reset_box_shadow(&mut self, other: &Self) {
        self.copy_box_shadow_from(other)
    }

    pub fn clone_box_shadow(&self) -> longhands::box_shadow::computed_value::T {
        let buf = self.gecko.mBoxShadow.iter().map(|v| v.to_box_shadow()).collect();
        longhands::box_shadow::computed_value::List(buf)
    }

    pub fn set_clip(&mut self, v: longhands::clip::computed_value::T) {
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_RECT;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_LEFT_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_TOP_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_RIGHT_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_BOTTOM_AUTO;
        use crate::values::Either;

        match v {
            Either::First(rect) => {
                self.gecko.mClipFlags = NS_STYLE_CLIP_RECT as u8;
                if let Some(left) = rect.left {
                    self.gecko.mClip.x = left.to_i32_au();
                } else {
                    self.gecko.mClip.x = 0;
                    self.gecko.mClipFlags |= NS_STYLE_CLIP_LEFT_AUTO as u8;
                }

                if let Some(top) = rect.top {
                    self.gecko.mClip.y = top.to_i32_au();
                } else {
                    self.gecko.mClip.y = 0;
                    self.gecko.mClipFlags |= NS_STYLE_CLIP_TOP_AUTO as u8;
                }

                if let Some(bottom) = rect.bottom {
                    self.gecko.mClip.height = (Au::from(bottom) - Au(self.gecko.mClip.y)).0;
                } else {
                    self.gecko.mClip.height = 1 << 30; // NS_MAXSIZE
                    self.gecko.mClipFlags |= NS_STYLE_CLIP_BOTTOM_AUTO as u8;
                }

                if let Some(right) = rect.right {
                    self.gecko.mClip.width = (Au::from(right) - Au(self.gecko.mClip.x)).0;
                } else {
                    self.gecko.mClip.width = 1 << 30; // NS_MAXSIZE
                    self.gecko.mClipFlags |= NS_STYLE_CLIP_RIGHT_AUTO as u8;
                }
            },
            Either::Second(_auto) => {
                self.gecko.mClipFlags = NS_STYLE_CLIP_AUTO as u8;
                self.gecko.mClip.x = 0;
                self.gecko.mClip.y = 0;
                self.gecko.mClip.width = 0;
                self.gecko.mClip.height = 0;
            }
        }
    }

    pub fn copy_clip_from(&mut self, other: &Self) {
        self.gecko.mClip = other.gecko.mClip;
        self.gecko.mClipFlags = other.gecko.mClipFlags;
    }

    pub fn reset_clip(&mut self, other: &Self) {
        self.copy_clip_from(other)
    }

    pub fn clone_clip(&self) -> longhands::clip::computed_value::T {
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_BOTTOM_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_LEFT_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_RIGHT_AUTO;
        use crate::gecko_bindings::structs::NS_STYLE_CLIP_TOP_AUTO;
        use crate::values::computed::{ClipRect, ClipRectOrAuto};
        use crate::values::Either;

        if self.gecko.mClipFlags == NS_STYLE_CLIP_AUTO as u8 {
            ClipRectOrAuto::auto()
        } else {
            let left = if self.gecko.mClipFlags & NS_STYLE_CLIP_LEFT_AUTO as u8 != 0 {
                debug_assert_eq!(self.gecko.mClip.x, 0);
                None
            } else {
                Some(Au(self.gecko.mClip.x).into())
            };

            let top = if self.gecko.mClipFlags & NS_STYLE_CLIP_TOP_AUTO as u8 != 0 {
                debug_assert_eq!(self.gecko.mClip.y, 0);
                None
            } else {
                Some(Au(self.gecko.mClip.y).into())
            };

            let bottom = if self.gecko.mClipFlags & NS_STYLE_CLIP_BOTTOM_AUTO as u8 != 0 {
                debug_assert_eq!(self.gecko.mClip.height, 1 << 30); // NS_MAXSIZE
                None
            } else {
                Some(Au(self.gecko.mClip.y + self.gecko.mClip.height).into())
            };

            let right = if self.gecko.mClipFlags & NS_STYLE_CLIP_RIGHT_AUTO as u8 != 0 {
                debug_assert_eq!(self.gecko.mClip.width, 1 << 30); // NS_MAXSIZE
                None
            } else {
                Some(Au(self.gecko.mClip.x + self.gecko.mClip.width).into())
            };

            Either::First(ClipRect { top, right, bottom, left })
        }
    }

    

    pub fn set_filter<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = Filter>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::values::generics::effects::Filter::*;
        use crate::gecko_bindings::structs::nsCSSShadowArray;
        use crate::gecko_bindings::structs::nsStyleFilter;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_BLUR;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_BRIGHTNESS;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_CONTRAST;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_GRAYSCALE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_INVERT;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_OPACITY;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_SATURATE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_SEPIA;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_HUE_ROTATE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_DROP_SHADOW;

        fn fill_filter(m_type: u32, value: CoordDataValue, gecko_filter: &mut nsStyleFilter){
            gecko_filter.mType = m_type;
            gecko_filter.mFilterParameter.set_value(value);
        }

        let v = v.into_iter();
        unsafe {
            Gecko_ResetFilters(&mut self.gecko, v.len());
        }
        debug_assert_eq!(v.len(), self.gecko.mFilters.len());

        for (servo, gecko_filter) in v.zip(self.gecko.mFilters.iter_mut()) {
            match servo {
                Brightness(factor) => fill_filter(NS_STYLE_FILTER_BRIGHTNESS,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Contrast(factor) => fill_filter(NS_STYLE_FILTER_CONTRAST,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Grayscale(factor) => fill_filter(NS_STYLE_FILTER_GRAYSCALE,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Invert(factor) => fill_filter(NS_STYLE_FILTER_INVERT,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Opacity(factor) => fill_filter(NS_STYLE_FILTER_OPACITY,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Saturate(factor) => fill_filter(NS_STYLE_FILTER_SATURATE,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Sepia(factor) => fill_filter(NS_STYLE_FILTER_SEPIA,
                                               CoordDataValue::Factor(factor.0),
                                               gecko_filter),
                Blur(length) => fill_filter(NS_STYLE_FILTER_BLUR,
                                            CoordDataValue::Coord(length.0.to_i32_au()),
                                            gecko_filter),

                HueRotate(angle) => fill_filter(NS_STYLE_FILTER_HUE_ROTATE,
                                                CoordDataValue::from(angle),
                                                gecko_filter),

                DropShadow(shadow) => {
                    gecko_filter.mType = NS_STYLE_FILTER_DROP_SHADOW;

                    fn init_shadow(filter: &mut nsStyleFilter) -> &mut nsCSSShadowArray {
                        unsafe {
                            let ref mut union = filter.__bindgen_anon_1;
                            let shadow_array: &mut *mut nsCSSShadowArray = union.mDropShadow.as_mut();
                            *shadow_array = Gecko_NewCSSShadowArray(1);

                            &mut **shadow_array
                        }
                    }

                    let gecko_shadow = init_shadow(gecko_filter);
                    gecko_shadow.mArray[0].set_from_simple_shadow(shadow);
                },
                Url(ref url) => {
                    unsafe {
                        bindings::Gecko_nsStyleFilter_SetURLValue(gecko_filter, url.0.url_value.get());
                    }
                },
            }
        }
    }

    pub fn copy_filter_from(&mut self, other: &Self) {
        unsafe {
            Gecko_CopyFiltersFrom(&other.gecko as *const _ as *mut _, &mut self.gecko);
        }
    }

    pub fn reset_filter(&mut self, other: &Self) {
        self.copy_filter_from(other)
    }

    pub fn clone_filter(&self) -> longhands::filter::computed_value::T {
        use crate::values::generics::effects::Filter;
        use crate::values::computed::url::ComputedUrl;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_BLUR;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_BRIGHTNESS;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_CONTRAST;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_GRAYSCALE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_INVERT;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_OPACITY;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_SATURATE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_SEPIA;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_HUE_ROTATE;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_DROP_SHADOW;
        use crate::gecko_bindings::structs::NS_STYLE_FILTER_URL;

        let mut filters = Vec::new();
        for filter in self.gecko.mFilters.iter(){
            match filter.mType {
                NS_STYLE_FILTER_BRIGHTNESS => {
                    filters.push(Filter::Brightness(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter).unwrap()));
                },
                NS_STYLE_FILTER_CONTRAST => {
                    filters.push(Filter::Contrast(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter).unwrap()));
                },
                NS_STYLE_FILTER_GRAYSCALE => {
                    filters.push(Filter::Grayscale(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter).unwrap()));
                },
                NS_STYLE_FILTER_INVERT => {
                    filters.push(Filter::Invert(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter).unwrap()));
                },
                NS_STYLE_FILTER_OPACITY => {
                    filters.push(Filter::Opacity(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter).unwrap()));
                },
                NS_STYLE_FILTER_SATURATE => {
                    filters.push(Filter::Saturate(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter).unwrap()));
                },
                NS_STYLE_FILTER_SEPIA => {
                    filters.push(Filter::Sepia(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter).unwrap()));
                },
                NS_STYLE_FILTER_BLUR => {
                    filters.push(Filter::Blur(NonNegativeLength::from_gecko_style_coord(
                        &filter.mFilterParameter).unwrap()));
                },
                NS_STYLE_FILTER_HUE_ROTATE => {
                    filters.push(Filter::HueRotate(
                        GeckoStyleCoordConvertible::from_gecko_style_coord(
                            &filter.mFilterParameter).unwrap()));
                },
                NS_STYLE_FILTER_DROP_SHADOW => {
                    filters.push(unsafe {
                        Filter::DropShadow(
                            (**filter.__bindgen_anon_1.mDropShadow.as_ref()).mArray[0].to_simple_shadow(),
                        )
                    });
                },
                NS_STYLE_FILTER_URL => {
                    filters.push(Filter::Url(unsafe {
                        let url = RefPtr::new(*filter.__bindgen_anon_1.mURL.as_ref());
                        ComputedUrl::from_url_value(url)
                    }));
                }
                _ => {},
            }
        }
        longhands::filter::computed_value::List(filters)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_opacity(&mut self, v: longhands::opacity::computed_value::T) {
        self.gecko.mOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_opacity_from(&mut self, other: &Self) {
        self.gecko.mOpacity = other.gecko.mOpacity;
    }

    #[allow(non_snake_case)]
    pub fn reset_opacity(&mut self, other: &Self) {
        self.copy_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_opacity(&self) -> longhands::opacity::computed_value::T {
        From::from(self.gecko.mOpacity)
    }



    #[allow(non_snake_case)]
    pub fn set_mix_blend_mode(&mut self, v: longhands::mix_blend_mode::computed_value::T) {
        use crate::properties::longhands::mix_blend_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_STYLE_BLEND_NORMAL as u8,
                Keyword::Multiply =>
                    structs::NS_STYLE_BLEND_MULTIPLY as u8,
                Keyword::Screen =>
                    structs::NS_STYLE_BLEND_SCREEN as u8,
                Keyword::Overlay =>
                    structs::NS_STYLE_BLEND_OVERLAY as u8,
                Keyword::Darken =>
                    structs::NS_STYLE_BLEND_DARKEN as u8,
                Keyword::Lighten =>
                    structs::NS_STYLE_BLEND_LIGHTEN as u8,
                Keyword::ColorDodge =>
                    structs::NS_STYLE_BLEND_COLOR_DODGE as u8,
                Keyword::ColorBurn =>
                    structs::NS_STYLE_BLEND_COLOR_BURN as u8,
                Keyword::HardLight =>
                    structs::NS_STYLE_BLEND_HARD_LIGHT as u8,
                Keyword::SoftLight =>
                    structs::NS_STYLE_BLEND_SOFT_LIGHT as u8,
                Keyword::Difference =>
                    structs::NS_STYLE_BLEND_DIFFERENCE as u8,
                Keyword::Exclusion =>
                    structs::NS_STYLE_BLEND_EXCLUSION as u8,
                Keyword::Hue =>
                    structs::NS_STYLE_BLEND_HUE as u8,
                Keyword::Saturation =>
                    structs::NS_STYLE_BLEND_SATURATION as u8,
                Keyword::Color =>
                    structs::NS_STYLE_BLEND_COLOR as u8,
                Keyword::Luminosity =>
                    structs::NS_STYLE_BLEND_LUMINOSITY as u8,
        };
        self.gecko.mMixBlendMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_mix_blend_mode_from(&mut self, other: &Self) {
        self.gecko.mMixBlendMode = other.gecko.mMixBlendMode;
    }

    #[allow(non_snake_case)]
    pub fn reset_mix_blend_mode(&mut self, other: &Self) {
        self.copy_mix_blend_mode_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_mix_blend_mode(&self) -> longhands::mix_blend_mode::computed_value::T {
        use crate::properties::longhands::mix_blend_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_BLEND_NORMAL : u8 =
            structs::NS_STYLE_BLEND_NORMAL as u8;
        const U8_NS_STYLE_BLEND_MULTIPLY : u8 =
            structs::NS_STYLE_BLEND_MULTIPLY as u8;
        const U8_NS_STYLE_BLEND_SCREEN : u8 =
            structs::NS_STYLE_BLEND_SCREEN as u8;
        const U8_NS_STYLE_BLEND_OVERLAY : u8 =
            structs::NS_STYLE_BLEND_OVERLAY as u8;
        const U8_NS_STYLE_BLEND_DARKEN : u8 =
            structs::NS_STYLE_BLEND_DARKEN as u8;
        const U8_NS_STYLE_BLEND_LIGHTEN : u8 =
            structs::NS_STYLE_BLEND_LIGHTEN as u8;
        const U8_NS_STYLE_BLEND_COLOR_DODGE : u8 =
            structs::NS_STYLE_BLEND_COLOR_DODGE as u8;
        const U8_NS_STYLE_BLEND_COLOR_BURN : u8 =
            structs::NS_STYLE_BLEND_COLOR_BURN as u8;
        const U8_NS_STYLE_BLEND_HARD_LIGHT : u8 =
            structs::NS_STYLE_BLEND_HARD_LIGHT as u8;
        const U8_NS_STYLE_BLEND_SOFT_LIGHT : u8 =
            structs::NS_STYLE_BLEND_SOFT_LIGHT as u8;
        const U8_NS_STYLE_BLEND_DIFFERENCE : u8 =
            structs::NS_STYLE_BLEND_DIFFERENCE as u8;
        const U8_NS_STYLE_BLEND_EXCLUSION : u8 =
            structs::NS_STYLE_BLEND_EXCLUSION as u8;
        const U8_NS_STYLE_BLEND_HUE : u8 =
            structs::NS_STYLE_BLEND_HUE as u8;
        const U8_NS_STYLE_BLEND_SATURATION : u8 =
            structs::NS_STYLE_BLEND_SATURATION as u8;
        const U8_NS_STYLE_BLEND_COLOR : u8 =
            structs::NS_STYLE_BLEND_COLOR as u8;
        const U8_NS_STYLE_BLEND_LUMINOSITY : u8 =
            structs::NS_STYLE_BLEND_LUMINOSITY as u8;

        match self.gecko.mMixBlendMode as u8 {
            U8_NS_STYLE_BLEND_NORMAL => Keyword::Normal,
            U8_NS_STYLE_BLEND_MULTIPLY => Keyword::Multiply,
            U8_NS_STYLE_BLEND_SCREEN => Keyword::Screen,
            U8_NS_STYLE_BLEND_OVERLAY => Keyword::Overlay,
            U8_NS_STYLE_BLEND_DARKEN => Keyword::Darken,
            U8_NS_STYLE_BLEND_LIGHTEN => Keyword::Lighten,
            U8_NS_STYLE_BLEND_COLOR_DODGE => Keyword::ColorDodge,
            U8_NS_STYLE_BLEND_COLOR_BURN => Keyword::ColorBurn,
            U8_NS_STYLE_BLEND_HARD_LIGHT => Keyword::HardLight,
            U8_NS_STYLE_BLEND_SOFT_LIGHT => Keyword::SoftLight,
            U8_NS_STYLE_BLEND_DIFFERENCE => Keyword::Difference,
            U8_NS_STYLE_BLEND_EXCLUSION => Keyword::Exclusion,
            U8_NS_STYLE_BLEND_HUE => Keyword::Hue,
            U8_NS_STYLE_BLEND_SATURATION => Keyword::Saturation,
            U8_NS_STYLE_BLEND_COLOR => Keyword::Color,
            U8_NS_STYLE_BLEND_LUMINOSITY => Keyword::Luminosity,
            _ => panic!("Found unexpected value in style struct for mix_blend_mode property"),
        }
    }


}




impl GeckoInheritedBox {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_visibility(&mut self, v: longhands::visibility::computed_value::T) {
        use crate::properties::longhands::visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Visible =>
                    structs::NS_STYLE_VISIBILITY_VISIBLE as u8,
                Keyword::Hidden =>
                    structs::NS_STYLE_VISIBILITY_HIDDEN as u8,
                Keyword::Collapse =>
                    structs::NS_STYLE_VISIBILITY_COLLAPSE as u8,
        };
        self.gecko.mVisible = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_visibility_from(&mut self, other: &Self) {
        self.gecko.mVisible = other.gecko.mVisible;
    }

    #[allow(non_snake_case)]
    pub fn reset_visibility(&mut self, other: &Self) {
        self.copy_visibility_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_visibility(&self) -> longhands::visibility::computed_value::T {
        use crate::properties::longhands::visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_VISIBILITY_VISIBLE : u8 =
            structs::NS_STYLE_VISIBILITY_VISIBLE as u8;
        const U8_NS_STYLE_VISIBILITY_HIDDEN : u8 =
            structs::NS_STYLE_VISIBILITY_HIDDEN as u8;
        const U8_NS_STYLE_VISIBILITY_COLLAPSE : u8 =
            structs::NS_STYLE_VISIBILITY_COLLAPSE as u8;

        match self.gecko.mVisible as u8 {
            U8_NS_STYLE_VISIBILITY_VISIBLE => Keyword::Visible,
            U8_NS_STYLE_VISIBILITY_HIDDEN => Keyword::Hidden,
            U8_NS_STYLE_VISIBILITY_COLLAPSE => Keyword::Collapse,
            _ => panic!("Found unexpected value in style struct for visibility property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_writing_mode(&mut self, v: longhands::writing_mode::computed_value::T) {
        use crate::properties::longhands::writing_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::HorizontalTb =>
                    structs::NS_STYLE_WRITING_MODE_HORIZONTAL_TB as u8,
                Keyword::VerticalRl =>
                    structs::NS_STYLE_WRITING_MODE_VERTICAL_RL as u8,
                Keyword::VerticalLr =>
                    structs::NS_STYLE_WRITING_MODE_VERTICAL_LR as u8,
                Keyword::SidewaysRl =>
                    structs::NS_STYLE_WRITING_MODE_SIDEWAYS_RL as u8,
                Keyword::SidewaysLr =>
                    structs::NS_STYLE_WRITING_MODE_SIDEWAYS_LR as u8,
        };
        self.gecko.mWritingMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_writing_mode_from(&mut self, other: &Self) {
        self.gecko.mWritingMode = other.gecko.mWritingMode;
    }

    #[allow(non_snake_case)]
    pub fn reset_writing_mode(&mut self, other: &Self) {
        self.copy_writing_mode_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_writing_mode(&self) -> longhands::writing_mode::computed_value::T {
        use crate::properties::longhands::writing_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_WRITING_MODE_HORIZONTAL_TB : u8 =
            structs::NS_STYLE_WRITING_MODE_HORIZONTAL_TB as u8;
        const U8_NS_STYLE_WRITING_MODE_VERTICAL_RL : u8 =
            structs::NS_STYLE_WRITING_MODE_VERTICAL_RL as u8;
        const U8_NS_STYLE_WRITING_MODE_VERTICAL_LR : u8 =
            structs::NS_STYLE_WRITING_MODE_VERTICAL_LR as u8;
        const U8_NS_STYLE_WRITING_MODE_SIDEWAYS_RL : u8 =
            structs::NS_STYLE_WRITING_MODE_SIDEWAYS_RL as u8;
        const U8_NS_STYLE_WRITING_MODE_SIDEWAYS_LR : u8 =
            structs::NS_STYLE_WRITING_MODE_SIDEWAYS_LR as u8;

        match self.gecko.mWritingMode as u8 {
            U8_NS_STYLE_WRITING_MODE_HORIZONTAL_TB => Keyword::HorizontalTb,
            U8_NS_STYLE_WRITING_MODE_VERTICAL_RL => Keyword::VerticalRl,
            U8_NS_STYLE_WRITING_MODE_VERTICAL_LR => Keyword::VerticalLr,
            U8_NS_STYLE_WRITING_MODE_SIDEWAYS_RL => Keyword::SidewaysRl,
            U8_NS_STYLE_WRITING_MODE_SIDEWAYS_LR => Keyword::SidewaysLr,
            _ => panic!("Found unexpected value in style struct for writing_mode property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_direction(&mut self, v: longhands::direction::computed_value::T) {
        use crate::properties::longhands::direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Ltr =>
                    structs::NS_STYLE_DIRECTION_LTR as u8,
                Keyword::Rtl =>
                    structs::NS_STYLE_DIRECTION_RTL as u8,
        };
        self.gecko.mDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_direction_from(&mut self, other: &Self) {
        self.gecko.mDirection = other.gecko.mDirection;
    }

    #[allow(non_snake_case)]
    pub fn reset_direction(&mut self, other: &Self) {
        self.copy_direction_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_direction(&self) -> longhands::direction::computed_value::T {
        use crate::properties::longhands::direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_DIRECTION_LTR : u8 =
            structs::NS_STYLE_DIRECTION_LTR as u8;
        const U8_NS_STYLE_DIRECTION_RTL : u8 =
            structs::NS_STYLE_DIRECTION_RTL as u8;

        match self.gecko.mDirection as u8 {
            U8_NS_STYLE_DIRECTION_LTR => Keyword::Ltr,
            U8_NS_STYLE_DIRECTION_RTL => Keyword::Rtl,
            _ => panic!("Found unexpected value in style struct for direction property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_orientation(&mut self, v: longhands::text_orientation::computed_value::T) {
        use crate::properties::longhands::text_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Mixed =>
                    structs::NS_STYLE_TEXT_ORIENTATION_MIXED as u8,
                Keyword::Upright =>
                    structs::NS_STYLE_TEXT_ORIENTATION_UPRIGHT as u8,
                Keyword::Sideways =>
                    structs::NS_STYLE_TEXT_ORIENTATION_SIDEWAYS as u8,
        };
        self.gecko.mTextOrientation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_orientation_from(&mut self, other: &Self) {
        self.gecko.mTextOrientation = other.gecko.mTextOrientation;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_orientation(&mut self, other: &Self) {
        self.copy_text_orientation_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_orientation(&self) -> longhands::text_orientation::computed_value::T {
        use crate::properties::longhands::text_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_ORIENTATION_MIXED : u8 =
            structs::NS_STYLE_TEXT_ORIENTATION_MIXED as u8;
        const U8_NS_STYLE_TEXT_ORIENTATION_UPRIGHT : u8 =
            structs::NS_STYLE_TEXT_ORIENTATION_UPRIGHT as u8;
        const U8_NS_STYLE_TEXT_ORIENTATION_SIDEWAYS : u8 =
            structs::NS_STYLE_TEXT_ORIENTATION_SIDEWAYS as u8;

        match self.gecko.mTextOrientation as u8 {
            U8_NS_STYLE_TEXT_ORIENTATION_MIXED => Keyword::Mixed,
            U8_NS_STYLE_TEXT_ORIENTATION_UPRIGHT => Keyword::Upright,
            U8_NS_STYLE_TEXT_ORIENTATION_SIDEWAYS => Keyword::Sideways,
            _ => panic!("Found unexpected value in style struct for text_orientation property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_adjust(&mut self, v: longhands::color_adjust::computed_value::T) {
        use crate::properties::longhands::color_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Economy =>
                    structs::StyleColorAdjust::Economy ,
                Keyword::Exact =>
                    structs::StyleColorAdjust::Exact ,
        };
        self.gecko.mColorAdjust = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_adjust_from(&mut self, other: &Self) {
        self.gecko.mColorAdjust = other.gecko.mColorAdjust;
    }

    #[allow(non_snake_case)]
    pub fn reset_color_adjust(&mut self, other: &Self) {
        self.copy_color_adjust_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_color_adjust(&self) -> longhands::color_adjust::computed_value::T {
        use crate::properties::longhands::color_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColorAdjust {
            structs::StyleColorAdjust::Economy => Keyword::Economy,
            structs::StyleColorAdjust::Exact => Keyword::Exact,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_image_rendering(&mut self, v: longhands::image_rendering::computed_value::T) {
        use crate::properties::longhands::image_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_IMAGE_RENDERING_AUTO as u8,
                Keyword::CrispEdges =>
                    structs::NS_STYLE_IMAGE_RENDERING_CRISP_EDGES as u8,
                Keyword::Optimizespeed =>
                    structs::NS_STYLE_IMAGE_RENDERING_OPTIMIZESPEED as u8,
                Keyword::Optimizequality =>
                    structs::NS_STYLE_IMAGE_RENDERING_OPTIMIZEQUALITY as u8,
        };
        self.gecko.mImageRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_image_rendering_from(&mut self, other: &Self) {
        self.gecko.mImageRendering = other.gecko.mImageRendering;
    }

    #[allow(non_snake_case)]
    pub fn reset_image_rendering(&mut self, other: &Self) {
        self.copy_image_rendering_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_image_rendering(&self) -> longhands::image_rendering::computed_value::T {
        use crate::properties::longhands::image_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_IMAGE_RENDERING_AUTO : u8 =
            structs::NS_STYLE_IMAGE_RENDERING_AUTO as u8;
        const U8_NS_STYLE_IMAGE_RENDERING_CRISP_EDGES : u8 =
            structs::NS_STYLE_IMAGE_RENDERING_CRISP_EDGES as u8;
        const U8_NS_STYLE_IMAGE_RENDERING_OPTIMIZESPEED : u8 =
            structs::NS_STYLE_IMAGE_RENDERING_OPTIMIZESPEED as u8;
        const U8_NS_STYLE_IMAGE_RENDERING_OPTIMIZEQUALITY : u8 =
            structs::NS_STYLE_IMAGE_RENDERING_OPTIMIZEQUALITY as u8;

        match self.gecko.mImageRendering as u8 {
            U8_NS_STYLE_IMAGE_RENDERING_AUTO => Keyword::Auto,
            U8_NS_STYLE_IMAGE_RENDERING_CRISP_EDGES => Keyword::CrispEdges,
            U8_NS_STYLE_IMAGE_RENDERING_OPTIMIZESPEED => Keyword::Optimizespeed,
            U8_NS_STYLE_IMAGE_RENDERING_OPTIMIZEQUALITY => Keyword::Optimizequality,
            _ => panic!("Found unexpected value in style struct for image_rendering property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_image_orientation(&mut self, v: longhands::image_orientation::computed_value::T) {
        use crate::properties::longhands::image_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleImageOrientation::None ,
                Keyword::FromImage =>
                    structs::StyleImageOrientation::FromImage ,
        };
        self.gecko.mImageOrientation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_image_orientation_from(&mut self, other: &Self) {
        self.gecko.mImageOrientation = other.gecko.mImageOrientation;
    }

    #[allow(non_snake_case)]
    pub fn reset_image_orientation(&mut self, other: &Self) {
        self.copy_image_orientation_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_image_orientation(&self) -> longhands::image_orientation::computed_value::T {
        use crate::properties::longhands::image_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mImageOrientation {
            structs::StyleImageOrientation::None => Keyword::None,
            structs::StyleImageOrientation::FromImage => Keyword::FromImage,
        }
    }


}




impl GeckoInheritedTable {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_border_spacing(&mut self, v: longhands::border_spacing::computed_value::T) {
        self.gecko.mBorderSpacingCol = v.horizontal().0;
        self.gecko.mBorderSpacingRow = v.vertical().0;
    }

    pub fn copy_border_spacing_from(&mut self, other: &Self) {
        self.gecko.mBorderSpacingCol = other.gecko.mBorderSpacingCol;
        self.gecko.mBorderSpacingRow = other.gecko.mBorderSpacingRow;
    }

    pub fn reset_border_spacing(&mut self, other: &Self) {
        self.copy_border_spacing_from(other)
    }

    pub fn clone_border_spacing(&self) -> longhands::border_spacing::computed_value::T {
        longhands::border_spacing::computed_value::T::new(
            Au(self.gecko.mBorderSpacingCol).into(),
            Au(self.gecko.mBorderSpacingRow).into()
        )
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_border_collapse(&mut self, v: longhands::border_collapse::computed_value::T) {
        use crate::properties::longhands::border_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Separate =>
                    structs::NS_STYLE_BORDER_SEPARATE as u8,
                Keyword::Collapse =>
                    structs::NS_STYLE_BORDER_COLLAPSE as u8,
        };
        self.gecko.mBorderCollapse = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_border_collapse_from(&mut self, other: &Self) {
        self.gecko.mBorderCollapse = other.gecko.mBorderCollapse;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_collapse(&mut self, other: &Self) {
        self.copy_border_collapse_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_border_collapse(&self) -> longhands::border_collapse::computed_value::T {
        use crate::properties::longhands::border_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_BORDER_SEPARATE : u8 =
            structs::NS_STYLE_BORDER_SEPARATE as u8;
        const U8_NS_STYLE_BORDER_COLLAPSE : u8 =
            structs::NS_STYLE_BORDER_COLLAPSE as u8;

        match self.gecko.mBorderCollapse as u8 {
            U8_NS_STYLE_BORDER_SEPARATE => Keyword::Separate,
            U8_NS_STYLE_BORDER_COLLAPSE => Keyword::Collapse,
            _ => panic!("Found unexpected value in style struct for border_collapse property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_empty_cells(&mut self, v: longhands::empty_cells::computed_value::T) {
        use crate::properties::longhands::empty_cells::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Show =>
                    structs::NS_STYLE_TABLE_EMPTY_CELLS_SHOW as u8,
                Keyword::Hide =>
                    structs::NS_STYLE_TABLE_EMPTY_CELLS_HIDE as u8,
        };
        self.gecko.mEmptyCells = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_empty_cells_from(&mut self, other: &Self) {
        self.gecko.mEmptyCells = other.gecko.mEmptyCells;
    }

    #[allow(non_snake_case)]
    pub fn reset_empty_cells(&mut self, other: &Self) {
        self.copy_empty_cells_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_empty_cells(&self) -> longhands::empty_cells::computed_value::T {
        use crate::properties::longhands::empty_cells::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TABLE_EMPTY_CELLS_SHOW : u8 =
            structs::NS_STYLE_TABLE_EMPTY_CELLS_SHOW as u8;
        const U8_NS_STYLE_TABLE_EMPTY_CELLS_HIDE : u8 =
            structs::NS_STYLE_TABLE_EMPTY_CELLS_HIDE as u8;

        match self.gecko.mEmptyCells as u8 {
            U8_NS_STYLE_TABLE_EMPTY_CELLS_SHOW => Keyword::Show,
            U8_NS_STYLE_TABLE_EMPTY_CELLS_HIDE => Keyword::Hide,
            _ => panic!("Found unexpected value in style struct for empty_cells property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_caption_side(&mut self, v: longhands::caption_side::computed_value::T) {
        use crate::properties::longhands::caption_side::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Top =>
                    structs::NS_STYLE_CAPTION_SIDE_TOP as u8,
                Keyword::Bottom =>
                    structs::NS_STYLE_CAPTION_SIDE_BOTTOM as u8,
                Keyword::Right =>
                    structs::NS_STYLE_CAPTION_SIDE_RIGHT as u8,
                Keyword::Left =>
                    structs::NS_STYLE_CAPTION_SIDE_LEFT as u8,
                Keyword::TopOutside =>
                    structs::NS_STYLE_CAPTION_SIDE_TOP_OUTSIDE as u8,
                Keyword::BottomOutside =>
                    structs::NS_STYLE_CAPTION_SIDE_BOTTOM_OUTSIDE as u8,
        };
        self.gecko.mCaptionSide = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_caption_side_from(&mut self, other: &Self) {
        self.gecko.mCaptionSide = other.gecko.mCaptionSide;
    }

    #[allow(non_snake_case)]
    pub fn reset_caption_side(&mut self, other: &Self) {
        self.copy_caption_side_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_caption_side(&self) -> longhands::caption_side::computed_value::T {
        use crate::properties::longhands::caption_side::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_CAPTION_SIDE_TOP : u8 =
            structs::NS_STYLE_CAPTION_SIDE_TOP as u8;
        const U8_NS_STYLE_CAPTION_SIDE_BOTTOM : u8 =
            structs::NS_STYLE_CAPTION_SIDE_BOTTOM as u8;
        const U8_NS_STYLE_CAPTION_SIDE_RIGHT : u8 =
            structs::NS_STYLE_CAPTION_SIDE_RIGHT as u8;
        const U8_NS_STYLE_CAPTION_SIDE_LEFT : u8 =
            structs::NS_STYLE_CAPTION_SIDE_LEFT as u8;
        const U8_NS_STYLE_CAPTION_SIDE_TOP_OUTSIDE : u8 =
            structs::NS_STYLE_CAPTION_SIDE_TOP_OUTSIDE as u8;
        const U8_NS_STYLE_CAPTION_SIDE_BOTTOM_OUTSIDE : u8 =
            structs::NS_STYLE_CAPTION_SIDE_BOTTOM_OUTSIDE as u8;

        match self.gecko.mCaptionSide as u8 {
            U8_NS_STYLE_CAPTION_SIDE_TOP => Keyword::Top,
            U8_NS_STYLE_CAPTION_SIDE_BOTTOM => Keyword::Bottom,
            U8_NS_STYLE_CAPTION_SIDE_RIGHT => Keyword::Right,
            U8_NS_STYLE_CAPTION_SIDE_LEFT => Keyword::Left,
            U8_NS_STYLE_CAPTION_SIDE_TOP_OUTSIDE => Keyword::TopOutside,
            U8_NS_STYLE_CAPTION_SIDE_BOTTOM_OUTSIDE => Keyword::BottomOutside,
            _ => panic!("Found unexpected value in style struct for caption_side property"),
        }
    }


}





impl GeckoInheritedText {
    /*
     * Manually-Implemented Methods.
     */
    

    
    

    #[allow(non_snake_case)]
    pub fn set_text_align(&mut self, v: longhands::text_align::computed_value::T) {
        use crate::properties::longhands::text_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::NS_STYLE_TEXT_ALIGN_START as u8,
                Keyword::End =>
                    structs::NS_STYLE_TEXT_ALIGN_END as u8,
                Keyword::Left =>
                    structs::NS_STYLE_TEXT_ALIGN_LEFT as u8,
                Keyword::Right =>
                    structs::NS_STYLE_TEXT_ALIGN_RIGHT as u8,
                Keyword::Center =>
                    structs::NS_STYLE_TEXT_ALIGN_CENTER as u8,
                Keyword::Justify =>
                    structs::NS_STYLE_TEXT_ALIGN_JUSTIFY as u8,
                Keyword::MozCenter =>
                    structs::NS_STYLE_TEXT_ALIGN_MOZ_CENTER as u8,
                Keyword::MozLeft =>
                    structs::NS_STYLE_TEXT_ALIGN_MOZ_LEFT as u8,
                Keyword::MozRight =>
                    structs::NS_STYLE_TEXT_ALIGN_MOZ_RIGHT as u8,
                Keyword::Char =>
                    structs::NS_STYLE_TEXT_ALIGN_CHAR as u8,
        };
        self.gecko.mTextAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_align_from(&mut self, other: &Self) {
        self.gecko.mTextAlign = other.gecko.mTextAlign;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_align(&mut self, other: &Self) {
        self.copy_text_align_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_align(&self) -> longhands::text_align::computed_value::T {
        use crate::properties::longhands::text_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_ALIGN_START : u8 =
            structs::NS_STYLE_TEXT_ALIGN_START as u8;
        const U8_NS_STYLE_TEXT_ALIGN_END : u8 =
            structs::NS_STYLE_TEXT_ALIGN_END as u8;
        const U8_NS_STYLE_TEXT_ALIGN_LEFT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_LEFT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_RIGHT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_RIGHT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_CENTER : u8 =
            structs::NS_STYLE_TEXT_ALIGN_CENTER as u8;
        const U8_NS_STYLE_TEXT_ALIGN_JUSTIFY : u8 =
            structs::NS_STYLE_TEXT_ALIGN_JUSTIFY as u8;
        const U8_NS_STYLE_TEXT_ALIGN_MOZ_CENTER : u8 =
            structs::NS_STYLE_TEXT_ALIGN_MOZ_CENTER as u8;
        const U8_NS_STYLE_TEXT_ALIGN_MOZ_LEFT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_MOZ_LEFT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_MOZ_RIGHT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_MOZ_RIGHT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_CHAR : u8 =
            structs::NS_STYLE_TEXT_ALIGN_CHAR as u8;

        match self.gecko.mTextAlign as u8 {
            U8_NS_STYLE_TEXT_ALIGN_START => Keyword::Start,
            U8_NS_STYLE_TEXT_ALIGN_END => Keyword::End,
            U8_NS_STYLE_TEXT_ALIGN_LEFT => Keyword::Left,
            U8_NS_STYLE_TEXT_ALIGN_RIGHT => Keyword::Right,
            U8_NS_STYLE_TEXT_ALIGN_CENTER => Keyword::Center,
            U8_NS_STYLE_TEXT_ALIGN_JUSTIFY => Keyword::Justify,
            U8_NS_STYLE_TEXT_ALIGN_MOZ_CENTER => Keyword::MozCenter,
            U8_NS_STYLE_TEXT_ALIGN_MOZ_LEFT => Keyword::MozLeft,
            U8_NS_STYLE_TEXT_ALIGN_MOZ_RIGHT => Keyword::MozRight,
            U8_NS_STYLE_TEXT_ALIGN_CHAR => Keyword::Char,
            _ => panic!("Found unexpected value in style struct for text_align property"),
        }
    }



    pub fn set_text_shadow<I>(&mut self, v: I)
        where I: IntoIterator<Item = SimpleShadow>,
              I::IntoIter: ExactSizeIterator
    {
        let v = v.into_iter();
        self.gecko.mTextShadow.replace_with_new(v.len() as u32);
        for (servo, gecko_shadow) in v.zip(self.gecko.mTextShadow.iter_mut()) {
            gecko_shadow.set_from_simple_shadow(servo);
        }
    }

    pub fn copy_text_shadow_from(&mut self, other: &Self) {
        self.gecko.mTextShadow.copy_from(&other.gecko.mTextShadow);
    }

    pub fn reset_text_shadow(&mut self, other: &Self) {
        self.copy_text_shadow_from(other)
    }

    pub fn clone_text_shadow(&self) -> longhands::text_shadow::computed_value::T {
        let buf = self.gecko.mTextShadow.iter().map(|v| v.to_simple_shadow()).collect();
        longhands::text_shadow::computed_value::List(buf)
    }

    pub fn set_line_height(&mut self, v: longhands::line_height::computed_value::T) {
        use crate::values::generics::text::LineHeight;
        // FIXME: Align binary representations and ditch |match| for cast + static_asserts
        let en = match v {
            LineHeight::Normal => CoordDataValue::Normal,
            LineHeight::Length(val) => CoordDataValue::Coord(val.0.to_i32_au()),
            LineHeight::Number(val) => CoordDataValue::Factor(val.0),
            LineHeight::MozBlockHeight =>
                    CoordDataValue::Enumerated(structs::NS_STYLE_LINE_HEIGHT_BLOCK_HEIGHT),
        };
        self.gecko.mLineHeight.set_value(en);
    }

    pub fn clone_line_height(&self) -> longhands::line_height::computed_value::T {
        use crate::values::generics::text::LineHeight;
        return match self.gecko.mLineHeight.as_value() {
            CoordDataValue::Normal => LineHeight::Normal,
            CoordDataValue::Coord(coord) => LineHeight::Length(Au(coord).into()),
            CoordDataValue::Factor(n) => LineHeight::Number(n.into()),
            CoordDataValue::Enumerated(val) if val == structs::NS_STYLE_LINE_HEIGHT_BLOCK_HEIGHT =>
                LineHeight::MozBlockHeight,
            _ => panic!("this should not happen"),
        }
    }

    
    #[allow(non_snake_case)]
    pub fn copy_line_height_from(&mut self, other: &Self) {
        self.gecko.mLineHeight.copy_from(&other.gecko.mLineHeight);
    }

    #[allow(non_snake_case)]
    pub fn reset_line_height(&mut self, other: &Self) {
        self.copy_line_height_from(other)
    }


    pub fn set_letter_spacing(&mut self, v: longhands::letter_spacing::computed_value::T) {
        use crate::values::generics::text::Spacing;
        match v {
            Spacing::Value(value) => self.gecko.mLetterSpacing.set(value),
            Spacing::Normal => self.gecko.mLetterSpacing.set_value(CoordDataValue::Normal)
        }
    }

    pub fn clone_letter_spacing(&self) -> longhands::letter_spacing::computed_value::T {
        use crate::values::computed::Length;
        use crate::values::generics::text::Spacing;
        debug_assert!(
            matches!(self.gecko.mLetterSpacing.as_value(),
                     CoordDataValue::Normal |
                     CoordDataValue::Coord(_)),
            "Unexpected computed value for letter-spacing");
        Length::from_gecko_style_coord(&self.gecko.mLetterSpacing).map_or(Spacing::Normal, Spacing::Value)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_letter_spacing_from(&mut self, other: &Self) {
        self.gecko.mLetterSpacing.copy_from(&other.gecko.mLetterSpacing);
    }

    #[allow(non_snake_case)]
    pub fn reset_letter_spacing(&mut self, other: &Self) {
        self.copy_letter_spacing_from(other)
    }


    pub fn set_word_spacing(&mut self, v: longhands::word_spacing::computed_value::T) {
        use crate::values::generics::text::Spacing;
        match v {
            Spacing::Value(lp) => self.gecko.mWordSpacing.set(lp),
            // https://drafts.csswg.org/css-text-3/#valdef-word-spacing-normal
            Spacing::Normal => self.gecko.mWordSpacing.set_value(CoordDataValue::Coord(0)),
        }
    }

    pub fn clone_word_spacing(&self) -> longhands::word_spacing::computed_value::T {
        use crate::values::computed::LengthPercentage;
        use crate::values::generics::text::Spacing;
        debug_assert!(
            matches!(self.gecko.mWordSpacing.as_value(),
                     CoordDataValue::Normal |
                     CoordDataValue::Coord(_) |
                     CoordDataValue::Percent(_) |
                     CoordDataValue::Calc(_)),
            "Unexpected computed value for word-spacing");
        LengthPercentage::from_gecko_style_coord(&self.gecko.mWordSpacing).map_or(Spacing::Normal, Spacing::Value)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_word_spacing_from(&mut self, other: &Self) {
        self.gecko.mWordSpacing.copy_from(&other.gecko.mWordSpacing);
    }

    #[allow(non_snake_case)]
    pub fn reset_word_spacing(&mut self, other: &Self) {
        self.copy_word_spacing_from(other)
    }


    fn clear_text_emphasis_style_if_string(&mut self) {
        if self.gecko.mTextEmphasisStyle == structs::NS_STYLE_TEXT_EMPHASIS_STYLE_STRING as u8 {
            self.gecko.mTextEmphasisStyleString.truncate();
            self.gecko.mTextEmphasisStyle = structs::NS_STYLE_TEXT_EMPHASIS_STYLE_NONE as u8;
        }
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_text_emphasis_position(&mut self, v: longhands::text_emphasis_position::computed_value::T) {
        self.gecko.mTextEmphasisPosition = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_position_from(&mut self, other: &Self) {
        self.gecko.mTextEmphasisPosition = other.gecko.mTextEmphasisPosition;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_position(&mut self, other: &Self) {
        self.copy_text_emphasis_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_position(&self) -> longhands::text_emphasis_position::computed_value::T {
        From::from(self.gecko.mTextEmphasisPosition)
    }


    pub fn set_text_emphasis_style(&mut self, v: values::computed::TextEmphasisStyle) {
        use crate::values::computed::TextEmphasisStyle;
        use crate::values::specified::text::{TextEmphasisFillMode, TextEmphasisShapeKeyword};

        self.clear_text_emphasis_style_if_string();
        let (te, s) = match v {
            TextEmphasisStyle::None => (structs::NS_STYLE_TEXT_EMPHASIS_STYLE_NONE, ""),
            TextEmphasisStyle::Keyword(ref keyword) => {
                let fill = match keyword.fill {
                    TextEmphasisFillMode::Filled => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_FILLED,
                    TextEmphasisFillMode::Open => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_OPEN,
                };
                let shape = match keyword.shape {
                    TextEmphasisShapeKeyword::Dot => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_DOT,
                    TextEmphasisShapeKeyword::Circle => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_CIRCLE,
                    TextEmphasisShapeKeyword::DoubleCircle => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_DOUBLE_CIRCLE,
                    TextEmphasisShapeKeyword::Triangle => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_TRIANGLE,
                    TextEmphasisShapeKeyword::Sesame => structs::NS_STYLE_TEXT_EMPHASIS_STYLE_SESAME,
                };

                (shape | fill, keyword.shape.char(keyword.fill))
            },
            TextEmphasisStyle::String(ref s) => {
                (structs::NS_STYLE_TEXT_EMPHASIS_STYLE_STRING, &**s)
            },
        };
        self.gecko.mTextEmphasisStyleString.assign_str(s);
        self.gecko.mTextEmphasisStyle = te as u8;
    }

    pub fn copy_text_emphasis_style_from(&mut self, other: &Self) {
        self.clear_text_emphasis_style_if_string();
        if other.gecko.mTextEmphasisStyle == structs::NS_STYLE_TEXT_EMPHASIS_STYLE_STRING as u8 {
            self.gecko.mTextEmphasisStyleString
                      .assign(&*other.gecko.mTextEmphasisStyleString)
        }
        self.gecko.mTextEmphasisStyle = other.gecko.mTextEmphasisStyle;
    }

    pub fn reset_text_emphasis_style(&mut self, other: &Self) {
        self.copy_text_emphasis_style_from(other)
    }

    pub fn clone_text_emphasis_style(&self) -> values::computed::TextEmphasisStyle {
        use crate::values::computed::TextEmphasisStyle;
        use crate::values::computed::text::TextEmphasisKeywordValue;
        use crate::values::specified::text::{TextEmphasisFillMode, TextEmphasisShapeKeyword};

        if self.gecko.mTextEmphasisStyle == structs::NS_STYLE_TEXT_EMPHASIS_STYLE_NONE as u8 {
            return TextEmphasisStyle::None;
        }

        if self.gecko.mTextEmphasisStyle == structs::NS_STYLE_TEXT_EMPHASIS_STYLE_STRING as u8 {
            return TextEmphasisStyle::String(self.gecko.mTextEmphasisStyleString.to_string());
        }

        let fill =
            self.gecko.mTextEmphasisStyle & structs::NS_STYLE_TEXT_EMPHASIS_STYLE_OPEN as u8 == 0;

        let fill = if fill { TextEmphasisFillMode::Filled } else { TextEmphasisFillMode::Open };

        let shape =
            match self.gecko.mTextEmphasisStyle as u32 & !structs::NS_STYLE_TEXT_EMPHASIS_STYLE_OPEN {
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_DOT => TextEmphasisShapeKeyword::Dot,
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_CIRCLE => TextEmphasisShapeKeyword::Circle,
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_DOUBLE_CIRCLE => TextEmphasisShapeKeyword::DoubleCircle,
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_TRIANGLE => TextEmphasisShapeKeyword::Triangle,
                structs::NS_STYLE_TEXT_EMPHASIS_STYLE_SESAME => TextEmphasisShapeKeyword::Sesame,
                _ => panic!("Unexpected value in style struct for text-emphasis-style property")
            };

        TextEmphasisStyle::Keyword(TextEmphasisKeywordValue { fill, shape })
    }

    
    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_width(&mut self, v: longhands::_webkit_text_stroke_width::computed_value::T) {
        let value = {
            v.0.to_i32_au()
        };

        self.gecko.mWebkitTextStrokeWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy__webkit_text_stroke_width_from(&mut self, other: &Self) {
        self.gecko.mWebkitTextStrokeWidth = other.gecko.mWebkitTextStrokeWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_width(&mut self, other: &Self) {
        self.copy__webkit_text_stroke_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_width(&self) -> longhands::_webkit_text_stroke_width::computed_value::T {
        Au(self.gecko.mWebkitTextStrokeWidth).into()
    }


    #[allow(non_snake_case)]
    pub fn set__moz_tab_size(&mut self, v: longhands::_moz_tab_size::computed_value::T) {
        match v {
            MozTabSize::Number(non_negative_number) => {
                self.gecko.mTabSize.set_value(CoordDataValue::Factor(non_negative_number.0));
            }
            MozTabSize::Length(non_negative_length) => {
                self.gecko.mTabSize.set(non_negative_length);
            }
        }
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_tab_size(&self) -> longhands::_moz_tab_size::computed_value::T {
        match self.gecko.mTabSize.as_value() {
            CoordDataValue::Coord(coord) => MozTabSize::Length(Au(coord).into()),
            CoordDataValue::Factor(number) => MozTabSize::Number(From::from(number)),
            _ => unreachable!(),
        }
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_tab_size_from(&mut self, other: &Self) {
        self.gecko.mTabSize.copy_from(&other.gecko.mTabSize);
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_tab_size(&mut self, other: &Self) {
        self.copy__moz_tab_size_from(other)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_text_transform(&mut self, v: longhands::text_transform::computed_value::T) {
        use crate::properties::longhands::text_transform::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_TEXT_TRANSFORM_NONE as u8,
                Keyword::Capitalize =>
                    structs::NS_STYLE_TEXT_TRANSFORM_CAPITALIZE as u8,
                Keyword::Uppercase =>
                    structs::NS_STYLE_TEXT_TRANSFORM_UPPERCASE as u8,
                Keyword::Lowercase =>
                    structs::NS_STYLE_TEXT_TRANSFORM_LOWERCASE as u8,
                Keyword::FullWidth =>
                    structs::NS_STYLE_TEXT_TRANSFORM_FULL_WIDTH as u8,
                Keyword::FullSizeKana =>
                    structs::NS_STYLE_TEXT_TRANSFORM_FULL_SIZE_KANA as u8,
        };
        self.gecko.mTextTransform = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_transform_from(&mut self, other: &Self) {
        self.gecko.mTextTransform = other.gecko.mTextTransform;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_transform(&mut self, other: &Self) {
        self.copy_text_transform_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_transform(&self) -> longhands::text_transform::computed_value::T {
        use crate::properties::longhands::text_transform::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_TRANSFORM_NONE : u8 =
            structs::NS_STYLE_TEXT_TRANSFORM_NONE as u8;
        const U8_NS_STYLE_TEXT_TRANSFORM_CAPITALIZE : u8 =
            structs::NS_STYLE_TEXT_TRANSFORM_CAPITALIZE as u8;
        const U8_NS_STYLE_TEXT_TRANSFORM_UPPERCASE : u8 =
            structs::NS_STYLE_TEXT_TRANSFORM_UPPERCASE as u8;
        const U8_NS_STYLE_TEXT_TRANSFORM_LOWERCASE : u8 =
            structs::NS_STYLE_TEXT_TRANSFORM_LOWERCASE as u8;
        const U8_NS_STYLE_TEXT_TRANSFORM_FULL_WIDTH : u8 =
            structs::NS_STYLE_TEXT_TRANSFORM_FULL_WIDTH as u8;
        const U8_NS_STYLE_TEXT_TRANSFORM_FULL_SIZE_KANA : u8 =
            structs::NS_STYLE_TEXT_TRANSFORM_FULL_SIZE_KANA as u8;

        match self.gecko.mTextTransform as u8 {
            U8_NS_STYLE_TEXT_TRANSFORM_NONE => Keyword::None,
            U8_NS_STYLE_TEXT_TRANSFORM_CAPITALIZE => Keyword::Capitalize,
            U8_NS_STYLE_TEXT_TRANSFORM_UPPERCASE => Keyword::Uppercase,
            U8_NS_STYLE_TEXT_TRANSFORM_LOWERCASE => Keyword::Lowercase,
            U8_NS_STYLE_TEXT_TRANSFORM_FULL_WIDTH => Keyword::FullWidth,
            U8_NS_STYLE_TEXT_TRANSFORM_FULL_SIZE_KANA => Keyword::FullSizeKana,
            _ => panic!("Found unexpected value in style struct for text_transform property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_hyphens(&mut self, v: longhands::hyphens::computed_value::T) {
        use crate::properties::longhands::hyphens::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Manual =>
                    structs::StyleHyphens::Manual ,
                Keyword::None =>
                    structs::StyleHyphens::None ,
                Keyword::Auto =>
                    structs::StyleHyphens::Auto ,
        };
        self.gecko.mHyphens = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_hyphens_from(&mut self, other: &Self) {
        self.gecko.mHyphens = other.gecko.mHyphens;
    }

    #[allow(non_snake_case)]
    pub fn reset_hyphens(&mut self, other: &Self) {
        self.copy_hyphens_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_hyphens(&self) -> longhands::hyphens::computed_value::T {
        use crate::properties::longhands::hyphens::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mHyphens {
            structs::StyleHyphens::Manual => Keyword::Manual,
            structs::StyleHyphens::None => Keyword::None,
            structs::StyleHyphens::Auto => Keyword::Auto,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_text_size_adjust(&mut self, v: longhands::_moz_text_size_adjust::computed_value::T) {
        use crate::properties::longhands::_moz_text_size_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_TEXT_SIZE_ADJUST_AUTO as u8,
                Keyword::None =>
                    structs::NS_STYLE_TEXT_SIZE_ADJUST_NONE as u8,
        };
        self.gecko.mTextSizeAdjust = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_text_size_adjust_from(&mut self, other: &Self) {
        self.gecko.mTextSizeAdjust = other.gecko.mTextSizeAdjust;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_text_size_adjust(&mut self, other: &Self) {
        self.copy__moz_text_size_adjust_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_text_size_adjust(&self) -> longhands::_moz_text_size_adjust::computed_value::T {
        use crate::properties::longhands::_moz_text_size_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_SIZE_ADJUST_AUTO : u8 =
            structs::NS_STYLE_TEXT_SIZE_ADJUST_AUTO as u8;
        const U8_NS_STYLE_TEXT_SIZE_ADJUST_NONE : u8 =
            structs::NS_STYLE_TEXT_SIZE_ADJUST_NONE as u8;

        match self.gecko.mTextSizeAdjust as u8 {
            U8_NS_STYLE_TEXT_SIZE_ADJUST_AUTO => Keyword::Auto,
            U8_NS_STYLE_TEXT_SIZE_ADJUST_NONE => Keyword::None,
            _ => panic!("Found unexpected value in style struct for _moz_text_size_adjust property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set_text_indent(&mut self, v: longhands::text_indent::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mTextIndent);
    }
    #[allow(non_snake_case)]
    pub fn copy_text_indent_from(&mut self, other: &Self) {
        self.gecko.mTextIndent.copy_from(&other.gecko.mTextIndent);
    }
    #[allow(non_snake_case)]
    pub fn reset_text_indent(&mut self, other: &Self) {
        self.copy_text_indent_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_text_indent(&self) -> longhands::text_indent::computed_value::T {
        use crate::properties::longhands::text_indent::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mTextIndent)
            .expect("clone for text_indent failed")
    }


    #[allow(non_snake_case)]
    pub fn set_overflow_wrap(&mut self, v: longhands::overflow_wrap::computed_value::T) {
        self.gecko.mOverflowWrap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_wrap_from(&mut self, other: &Self) {
        self.gecko.mOverflowWrap = other.gecko.mOverflowWrap;
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_wrap(&mut self, other: &Self) {
        self.copy_overflow_wrap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_wrap(&self) -> longhands::overflow_wrap::computed_value::T {
        From::from(self.gecko.mOverflowWrap)
    }



    #[allow(non_snake_case)]
    pub fn set_word_break(&mut self, v: longhands::word_break::computed_value::T) {
        use crate::properties::longhands::word_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_STYLE_WORDBREAK_NORMAL as u8,
                Keyword::BreakAll =>
                    structs::NS_STYLE_WORDBREAK_BREAK_ALL as u8,
                Keyword::KeepAll =>
                    structs::NS_STYLE_WORDBREAK_KEEP_ALL as u8,
        };
        self.gecko.mWordBreak = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_word_break_from(&mut self, other: &Self) {
        self.gecko.mWordBreak = other.gecko.mWordBreak;
    }

    #[allow(non_snake_case)]
    pub fn reset_word_break(&mut self, other: &Self) {
        self.copy_word_break_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_word_break(&self) -> longhands::word_break::computed_value::T {
        use crate::properties::longhands::word_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_WORDBREAK_NORMAL : u8 =
            structs::NS_STYLE_WORDBREAK_NORMAL as u8;
        const U8_NS_STYLE_WORDBREAK_BREAK_ALL : u8 =
            structs::NS_STYLE_WORDBREAK_BREAK_ALL as u8;
        const U8_NS_STYLE_WORDBREAK_KEEP_ALL : u8 =
            structs::NS_STYLE_WORDBREAK_KEEP_ALL as u8;

        match self.gecko.mWordBreak as u8 {
            U8_NS_STYLE_WORDBREAK_NORMAL => Keyword::Normal,
            U8_NS_STYLE_WORDBREAK_BREAK_ALL => Keyword::BreakAll,
            U8_NS_STYLE_WORDBREAK_KEEP_ALL => Keyword::KeepAll,
            _ => panic!("Found unexpected value in style struct for word_break property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_justify(&mut self, v: longhands::text_justify::computed_value::T) {
        use crate::properties::longhands::text_justify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTextJustify::Auto ,
                Keyword::None =>
                    structs::StyleTextJustify::None ,
                Keyword::InterWord =>
                    structs::StyleTextJustify::InterWord ,
                Keyword::InterCharacter =>
                    structs::StyleTextJustify::InterCharacter ,
        };
        self.gecko.mTextJustify = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_justify_from(&mut self, other: &Self) {
        self.gecko.mTextJustify = other.gecko.mTextJustify;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_justify(&mut self, other: &Self) {
        self.copy_text_justify_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_justify(&self) -> longhands::text_justify::computed_value::T {
        use crate::properties::longhands::text_justify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTextJustify {
            structs::StyleTextJustify::Auto => Keyword::Auto,
            structs::StyleTextJustify::None => Keyword::None,
            structs::StyleTextJustify::InterWord => Keyword::InterWord,
            structs::StyleTextJustify::InterCharacter => Keyword::InterCharacter,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_align_last(&mut self, v: longhands::text_align_last::computed_value::T) {
        use crate::properties::longhands::text_align_last::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_TEXT_ALIGN_AUTO as u8,
                Keyword::Start =>
                    structs::NS_STYLE_TEXT_ALIGN_START as u8,
                Keyword::End =>
                    structs::NS_STYLE_TEXT_ALIGN_END as u8,
                Keyword::Left =>
                    structs::NS_STYLE_TEXT_ALIGN_LEFT as u8,
                Keyword::Right =>
                    structs::NS_STYLE_TEXT_ALIGN_RIGHT as u8,
                Keyword::Center =>
                    structs::NS_STYLE_TEXT_ALIGN_CENTER as u8,
                Keyword::Justify =>
                    structs::NS_STYLE_TEXT_ALIGN_JUSTIFY as u8,
        };
        self.gecko.mTextAlignLast = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_align_last_from(&mut self, other: &Self) {
        self.gecko.mTextAlignLast = other.gecko.mTextAlignLast;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_align_last(&mut self, other: &Self) {
        self.copy_text_align_last_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_align_last(&self) -> longhands::text_align_last::computed_value::T {
        use crate::properties::longhands::text_align_last::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_ALIGN_AUTO : u8 =
            structs::NS_STYLE_TEXT_ALIGN_AUTO as u8;
        const U8_NS_STYLE_TEXT_ALIGN_START : u8 =
            structs::NS_STYLE_TEXT_ALIGN_START as u8;
        const U8_NS_STYLE_TEXT_ALIGN_END : u8 =
            structs::NS_STYLE_TEXT_ALIGN_END as u8;
        const U8_NS_STYLE_TEXT_ALIGN_LEFT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_LEFT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_RIGHT : u8 =
            structs::NS_STYLE_TEXT_ALIGN_RIGHT as u8;
        const U8_NS_STYLE_TEXT_ALIGN_CENTER : u8 =
            structs::NS_STYLE_TEXT_ALIGN_CENTER as u8;
        const U8_NS_STYLE_TEXT_ALIGN_JUSTIFY : u8 =
            structs::NS_STYLE_TEXT_ALIGN_JUSTIFY as u8;

        match self.gecko.mTextAlignLast as u8 {
            U8_NS_STYLE_TEXT_ALIGN_AUTO => Keyword::Auto,
            U8_NS_STYLE_TEXT_ALIGN_START => Keyword::Start,
            U8_NS_STYLE_TEXT_ALIGN_END => Keyword::End,
            U8_NS_STYLE_TEXT_ALIGN_LEFT => Keyword::Left,
            U8_NS_STYLE_TEXT_ALIGN_RIGHT => Keyword::Right,
            U8_NS_STYLE_TEXT_ALIGN_CENTER => Keyword::Center,
            U8_NS_STYLE_TEXT_ALIGN_JUSTIFY => Keyword::Justify,
            _ => panic!("Found unexpected value in style struct for text_align_last property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_white_space(&mut self, v: longhands::white_space::computed_value::T) {
        use crate::properties::longhands::white_space::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleWhiteSpace::Normal ,
                Keyword::Pre =>
                    structs::StyleWhiteSpace::Pre ,
                Keyword::Nowrap =>
                    structs::StyleWhiteSpace::Nowrap ,
                Keyword::PreWrap =>
                    structs::StyleWhiteSpace::PreWrap ,
                Keyword::PreLine =>
                    structs::StyleWhiteSpace::PreLine ,
                Keyword::MozPreSpace =>
                    structs::StyleWhiteSpace::PreSpace ,
        };
        self.gecko.mWhiteSpace = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_white_space_from(&mut self, other: &Self) {
        self.gecko.mWhiteSpace = other.gecko.mWhiteSpace;
    }

    #[allow(non_snake_case)]
    pub fn reset_white_space(&mut self, other: &Self) {
        self.copy_white_space_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_white_space(&self) -> longhands::white_space::computed_value::T {
        use crate::properties::longhands::white_space::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mWhiteSpace {
            structs::StyleWhiteSpace::Normal => Keyword::Normal,
            structs::StyleWhiteSpace::Pre => Keyword::Pre,
            structs::StyleWhiteSpace::Nowrap => Keyword::Nowrap,
            structs::StyleWhiteSpace::PreWrap => Keyword::PreWrap,
            structs::StyleWhiteSpace::PreLine => Keyword::PreLine,
            structs::StyleWhiteSpace::PreSpace => Keyword::MozPreSpace,
        }
    }



    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_text_emphasis_color(&mut self, v: longhands::text_emphasis_color::computed_value::T) {
        self.gecko.mTextEmphasisColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_color_from(&mut self, other: &Self) {
        let color = other.gecko.mTextEmphasisColor;
        self.gecko.mTextEmphasisColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_color(&mut self, other: &Self) {
        self.copy_text_emphasis_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_color(&self) -> longhands::text_emphasis_color::computed_value::T {
        self.gecko.mTextEmphasisColor.into()
    }



    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set__webkit_text_fill_color(&mut self, v: longhands::_webkit_text_fill_color::computed_value::T) {
        self.gecko.mWebkitTextFillColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_fill_color_from(&mut self, other: &Self) {
        let color = other.gecko.mWebkitTextFillColor;
        self.gecko.mWebkitTextFillColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_fill_color(&mut self, other: &Self) {
        self.copy__webkit_text_fill_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_fill_color(&self) -> longhands::_webkit_text_fill_color::computed_value::T {
        self.gecko.mWebkitTextFillColor.into()
    }



    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_color(&mut self, v: longhands::_webkit_text_stroke_color::computed_value::T) {
        self.gecko.mWebkitTextStrokeColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_stroke_color_from(&mut self, other: &Self) {
        let color = other.gecko.mWebkitTextStrokeColor;
        self.gecko.mWebkitTextStrokeColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_color(&mut self, other: &Self) {
        self.copy__webkit_text_stroke_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_color(&self) -> longhands::_webkit_text_stroke_color::computed_value::T {
        self.gecko.mWebkitTextStrokeColor.into()
    }



    #[allow(non_snake_case)]
    pub fn set_ruby_align(&mut self, v: longhands::ruby_align::computed_value::T) {
        use crate::properties::longhands::ruby_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::SpaceAround =>
                    structs::NS_STYLE_RUBY_ALIGN_SPACE_AROUND as u8,
                Keyword::Start =>
                    structs::NS_STYLE_RUBY_ALIGN_START as u8,
                Keyword::Center =>
                    structs::NS_STYLE_RUBY_ALIGN_CENTER as u8,
                Keyword::SpaceBetween =>
                    structs::NS_STYLE_RUBY_ALIGN_SPACE_BETWEEN as u8,
        };
        self.gecko.mRubyAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ruby_align_from(&mut self, other: &Self) {
        self.gecko.mRubyAlign = other.gecko.mRubyAlign;
    }

    #[allow(non_snake_case)]
    pub fn reset_ruby_align(&mut self, other: &Self) {
        self.copy_ruby_align_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_ruby_align(&self) -> longhands::ruby_align::computed_value::T {
        use crate::properties::longhands::ruby_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_RUBY_ALIGN_SPACE_AROUND : u8 =
            structs::NS_STYLE_RUBY_ALIGN_SPACE_AROUND as u8;
        const U8_NS_STYLE_RUBY_ALIGN_START : u8 =
            structs::NS_STYLE_RUBY_ALIGN_START as u8;
        const U8_NS_STYLE_RUBY_ALIGN_CENTER : u8 =
            structs::NS_STYLE_RUBY_ALIGN_CENTER as u8;
        const U8_NS_STYLE_RUBY_ALIGN_SPACE_BETWEEN : u8 =
            structs::NS_STYLE_RUBY_ALIGN_SPACE_BETWEEN as u8;

        match self.gecko.mRubyAlign as u8 {
            U8_NS_STYLE_RUBY_ALIGN_SPACE_AROUND => Keyword::SpaceAround,
            U8_NS_STYLE_RUBY_ALIGN_START => Keyword::Start,
            U8_NS_STYLE_RUBY_ALIGN_CENTER => Keyword::Center,
            U8_NS_STYLE_RUBY_ALIGN_SPACE_BETWEEN => Keyword::SpaceBetween,
            _ => panic!("Found unexpected value in style struct for ruby_align property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_ruby_position(&mut self, v: longhands::ruby_position::computed_value::T) {
        use crate::properties::longhands::ruby_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Over =>
                    structs::NS_STYLE_RUBY_POSITION_OVER as u8,
                Keyword::Under =>
                    structs::NS_STYLE_RUBY_POSITION_UNDER as u8,
        };
        self.gecko.mRubyPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ruby_position_from(&mut self, other: &Self) {
        self.gecko.mRubyPosition = other.gecko.mRubyPosition;
    }

    #[allow(non_snake_case)]
    pub fn reset_ruby_position(&mut self, other: &Self) {
        self.copy_ruby_position_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_ruby_position(&self) -> longhands::ruby_position::computed_value::T {
        use crate::properties::longhands::ruby_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_RUBY_POSITION_OVER : u8 =
            structs::NS_STYLE_RUBY_POSITION_OVER as u8;
        const U8_NS_STYLE_RUBY_POSITION_UNDER : u8 =
            structs::NS_STYLE_RUBY_POSITION_UNDER as u8;

        match self.gecko.mRubyPosition as u8 {
            U8_NS_STYLE_RUBY_POSITION_OVER => Keyword::Over,
            U8_NS_STYLE_RUBY_POSITION_UNDER => Keyword::Under,
            _ => panic!("Found unexpected value in style struct for ruby_position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_combine_upright(&mut self, v: longhands::text_combine_upright::computed_value::T) {
        use crate::properties::longhands::text_combine_upright::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE as u8,
                Keyword::All =>
                    structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL as u8,
        };
        self.gecko.mTextCombineUpright = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_combine_upright_from(&mut self, other: &Self) {
        self.gecko.mTextCombineUpright = other.gecko.mTextCombineUpright;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_combine_upright(&mut self, other: &Self) {
        self.copy_text_combine_upright_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_combine_upright(&self) -> longhands::text_combine_upright::computed_value::T {
        use crate::properties::longhands::text_combine_upright::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE : u8 =
            structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE as u8;
        const U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL : u8 =
            structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL as u8;

        match self.gecko.mTextCombineUpright as u8 {
            U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE => Keyword::None,
            U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL => Keyword::All,
            _ => panic!("Found unexpected value in style struct for text_combine_upright property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_rendering(&mut self, v: longhands::text_rendering::computed_value::T) {
        use crate::properties::longhands::text_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTextRendering::Auto ,
                Keyword::Optimizespeed =>
                    structs::StyleTextRendering::Optimizespeed ,
                Keyword::Optimizelegibility =>
                    structs::StyleTextRendering::Optimizelegibility ,
                Keyword::Geometricprecision =>
                    structs::StyleTextRendering::Geometricprecision ,
        };
        self.gecko.mTextRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_rendering_from(&mut self, other: &Self) {
        self.gecko.mTextRendering = other.gecko.mTextRendering;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_rendering(&mut self, other: &Self) {
        self.copy_text_rendering_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_rendering(&self) -> longhands::text_rendering::computed_value::T {
        use crate::properties::longhands::text_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTextRendering {
            structs::StyleTextRendering::Auto => Keyword::Auto,
            structs::StyleTextRendering::Optimizespeed => Keyword::Optimizespeed,
            structs::StyleTextRendering::Optimizelegibility => Keyword::Optimizelegibility,
            structs::StyleTextRendering::Geometricprecision => Keyword::Geometricprecision,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_control_character_visibility(&mut self, v: longhands::_moz_control_character_visibility::computed_value::T) {
        use crate::properties::longhands::_moz_control_character_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Hidden =>
                    structs::NS_STYLE_CONTROL_CHARACTER_VISIBILITY_HIDDEN as u8,
                Keyword::Visible =>
                    structs::NS_STYLE_CONTROL_CHARACTER_VISIBILITY_VISIBLE as u8,
        };
        self.gecko.mControlCharacterVisibility = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_control_character_visibility_from(&mut self, other: &Self) {
        self.gecko.mControlCharacterVisibility = other.gecko.mControlCharacterVisibility;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_control_character_visibility(&mut self, other: &Self) {
        self.copy__moz_control_character_visibility_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_control_character_visibility(&self) -> longhands::_moz_control_character_visibility::computed_value::T {
        use crate::properties::longhands::_moz_control_character_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_CONTROL_CHARACTER_VISIBILITY_HIDDEN : u8 =
            structs::NS_STYLE_CONTROL_CHARACTER_VISIBILITY_HIDDEN as u8;
        const U8_NS_STYLE_CONTROL_CHARACTER_VISIBILITY_VISIBLE : u8 =
            structs::NS_STYLE_CONTROL_CHARACTER_VISIBILITY_VISIBLE as u8;

        match self.gecko.mControlCharacterVisibility as u8 {
            U8_NS_STYLE_CONTROL_CHARACTER_VISIBILITY_HIDDEN => Keyword::Hidden,
            U8_NS_STYLE_CONTROL_CHARACTER_VISIBILITY_VISIBLE => Keyword::Visible,
            _ => panic!("Found unexpected value in style struct for _moz_control_character_visibility property"),
        }
    }


}




impl GeckoText {
    /*
     * Manually-Implemented Methods.
     */
    

    
    

    #[allow(non_snake_case)]
    pub fn set_text_decoration_line(&mut self, v: longhands::text_decoration_line::computed_value::T) {
        self.gecko.mTextDecorationLine = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_text_decoration_line_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationLine = other.gecko.mTextDecorationLine;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_line(&mut self, other: &Self) {
        self.copy_text_decoration_line_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_line(&self) -> longhands::text_decoration_line::computed_value::T {
        From::from(self.gecko.mTextDecorationLine)
    }


    fn clear_overflow_sides_if_string(&mut self) {
        use crate::gecko_bindings::structs::nsStyleTextOverflowSide;
        fn clear_if_string(side: &mut nsStyleTextOverflowSide) {
            if side.mType == structs::NS_STYLE_TEXT_OVERFLOW_STRING as u8 {
                side.mString.truncate();
                side.mType = structs::NS_STYLE_TEXT_OVERFLOW_CLIP as u8;
            }
        }
        clear_if_string(&mut self.gecko.mTextOverflow.mLeft);
        clear_if_string(&mut self.gecko.mTextOverflow.mRight);
    }

    pub fn set_text_overflow(&mut self, v: longhands::text_overflow::computed_value::T) {
        use crate::gecko_bindings::structs::nsStyleTextOverflowSide;
        use crate::values::specified::text::TextOverflowSide;

        fn set(side: &mut nsStyleTextOverflowSide, value: &TextOverflowSide) {
            let ty = match *value {
                TextOverflowSide::Clip => structs::NS_STYLE_TEXT_OVERFLOW_CLIP,
                TextOverflowSide::Ellipsis => structs::NS_STYLE_TEXT_OVERFLOW_ELLIPSIS,
                TextOverflowSide::String(ref s) => {
                    side.mString.assign_str(s);
                    structs::NS_STYLE_TEXT_OVERFLOW_STRING
                }
            };
            side.mType = ty as u8;
        }

        self.clear_overflow_sides_if_string();
        self.gecko.mTextOverflow.mLogicalDirections = v.sides_are_logical;

        set(&mut self.gecko.mTextOverflow.mLeft, &v.first);
        set(&mut self.gecko.mTextOverflow.mRight, &v.second);
    }

    pub fn copy_text_overflow_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleTextOverflowSide;
        fn set(side: &mut nsStyleTextOverflowSide, other: &nsStyleTextOverflowSide) {
            if other.mType == structs::NS_STYLE_TEXT_OVERFLOW_STRING as u8 {
                side.mString.assign(&*other.mString)
            }
            side.mType = other.mType
        }
        self.clear_overflow_sides_if_string();
        set(&mut self.gecko.mTextOverflow.mLeft, &other.gecko.mTextOverflow.mLeft);
        set(&mut self.gecko.mTextOverflow.mRight, &other.gecko.mTextOverflow.mRight);
        self.gecko.mTextOverflow.mLogicalDirections = other.gecko.mTextOverflow.mLogicalDirections;
    }

    pub fn reset_text_overflow(&mut self, other: &Self) {
        self.copy_text_overflow_from(other)
    }

    pub fn clone_text_overflow(&self) -> longhands::text_overflow::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleTextOverflowSide;
        use crate::values::specified::text::TextOverflowSide;

        fn to_servo(side: &nsStyleTextOverflowSide) -> TextOverflowSide {
            match side.mType as u32 {
                structs::NS_STYLE_TEXT_OVERFLOW_CLIP => TextOverflowSide::Clip,
                structs::NS_STYLE_TEXT_OVERFLOW_ELLIPSIS => TextOverflowSide::Ellipsis,
                structs::NS_STYLE_TEXT_OVERFLOW_STRING =>
                    TextOverflowSide::String(side.mString.to_string().into_boxed_str()),
                _ => panic!("Found unexpected value in style struct for text_overflow property"),
            }
        }

        longhands::text_overflow::computed_value::T {
            first: to_servo(&self.gecko.mTextOverflow.mLeft),
            second: to_servo(&self.gecko.mTextOverflow.mRight),
            sides_are_logical: self.gecko.mTextOverflow.mLogicalDirections
        }
    }

    pub fn set_initial_letter(&mut self, v: longhands::initial_letter::computed_value::T) {
        use crate::values::generics::text::InitialLetter;
        match v {
            InitialLetter::Normal => {
                self.gecko.mInitialLetterSize = 0.;
                self.gecko.mInitialLetterSink = 0;
            },
            InitialLetter::Specified(size, sink) => {
                self.gecko.mInitialLetterSize = size;
                if let Some(sink) = sink {
                    self.gecko.mInitialLetterSink = sink;
                } else {
                    self.gecko.mInitialLetterSink = size.floor() as i32;
                }
            }
        }
    }

    pub fn copy_initial_letter_from(&mut self, other: &Self) {
        self.gecko.mInitialLetterSize = other.gecko.mInitialLetterSize;
        self.gecko.mInitialLetterSink = other.gecko.mInitialLetterSink;
    }

    pub fn reset_initial_letter(&mut self, other: &Self) {
        self.copy_initial_letter_from(other)
    }

    pub fn clone_initial_letter(&self) -> longhands::initial_letter::computed_value::T {
        use crate::values::generics::text::InitialLetter;

        if self.gecko.mInitialLetterSize == 0. && self.gecko.mInitialLetterSink == 0 {
            InitialLetter::Normal
        } else if self.gecko.mInitialLetterSize.floor() as i32 == self.gecko.mInitialLetterSink {
            InitialLetter::Specified(self.gecko.mInitialLetterSize, None)
        } else {
            InitialLetter::Specified(self.gecko.mInitialLetterSize, Some(self.gecko.mInitialLetterSink))
        }
    }

    #[inline]
    pub fn has_underline(&self) -> bool {
        (self.gecko.mTextDecorationLine & (structs::NS_STYLE_TEXT_DECORATION_LINE_UNDERLINE as u8)) != 0
    }

    #[inline]
    pub fn has_overline(&self) -> bool {
        (self.gecko.mTextDecorationLine & (structs::NS_STYLE_TEXT_DECORATION_LINE_OVERLINE as u8)) != 0
    }

    #[inline]
    pub fn has_line_through(&self) -> bool {
        (self.gecko.mTextDecorationLine & (structs::NS_STYLE_TEXT_DECORATION_LINE_LINE_THROUGH as u8)) != 0
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_unicode_bidi(&mut self, v: longhands::unicode_bidi::computed_value::T) {
        use crate::properties::longhands::unicode_bidi::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_STYLE_UNICODE_BIDI_NORMAL as u8,
                Keyword::Embed =>
                    structs::NS_STYLE_UNICODE_BIDI_EMBED as u8,
                Keyword::Isolate =>
                    structs::NS_STYLE_UNICODE_BIDI_ISOLATE as u8,
                Keyword::BidiOverride =>
                    structs::NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE as u8,
                Keyword::IsolateOverride =>
                    structs::NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE as u8,
                Keyword::Plaintext =>
                    structs::NS_STYLE_UNICODE_BIDI_PLAINTEXT as u8,
        };
        self.gecko.mUnicodeBidi = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_unicode_bidi_from(&mut self, other: &Self) {
        self.gecko.mUnicodeBidi = other.gecko.mUnicodeBidi;
    }

    #[allow(non_snake_case)]
    pub fn reset_unicode_bidi(&mut self, other: &Self) {
        self.copy_unicode_bidi_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_unicode_bidi(&self) -> longhands::unicode_bidi::computed_value::T {
        use crate::properties::longhands::unicode_bidi::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_UNICODE_BIDI_NORMAL : u8 =
            structs::NS_STYLE_UNICODE_BIDI_NORMAL as u8;
        const U8_NS_STYLE_UNICODE_BIDI_EMBED : u8 =
            structs::NS_STYLE_UNICODE_BIDI_EMBED as u8;
        const U8_NS_STYLE_UNICODE_BIDI_ISOLATE : u8 =
            structs::NS_STYLE_UNICODE_BIDI_ISOLATE as u8;
        const U8_NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE : u8 =
            structs::NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE as u8;
        const U8_NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE : u8 =
            structs::NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE as u8;
        const U8_NS_STYLE_UNICODE_BIDI_PLAINTEXT : u8 =
            structs::NS_STYLE_UNICODE_BIDI_PLAINTEXT as u8;

        match self.gecko.mUnicodeBidi as u8 {
            U8_NS_STYLE_UNICODE_BIDI_NORMAL => Keyword::Normal,
            U8_NS_STYLE_UNICODE_BIDI_EMBED => Keyword::Embed,
            U8_NS_STYLE_UNICODE_BIDI_ISOLATE => Keyword::Isolate,
            U8_NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE => Keyword::BidiOverride,
            U8_NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE => Keyword::IsolateOverride,
            U8_NS_STYLE_UNICODE_BIDI_PLAINTEXT => Keyword::Plaintext,
            _ => panic!("Found unexpected value in style struct for unicode_bidi property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_style(&mut self, v: longhands::text_decoration_style::computed_value::T) {
        use crate::properties::longhands::text_decoration_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Solid =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_SOLID as u8,
                Keyword::Double =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE as u8,
                Keyword::Dotted =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_DOTTED as u8,
                Keyword::Dashed =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_DASHED as u8,
                Keyword::Wavy =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_WAVY as u8,
                Keyword::MozNone =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_NONE as u8,
        };
        self.gecko.mTextDecorationStyle = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_style_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationStyle = other.gecko.mTextDecorationStyle;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_style(&mut self, other: &Self) {
        self.copy_text_decoration_style_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_decoration_style(&self) -> longhands::text_decoration_style::computed_value::T {
        use crate::properties::longhands::text_decoration_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_SOLID : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_SOLID as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_DOTTED : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_DOTTED as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_DASHED : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_DASHED as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_WAVY : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_WAVY as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_NONE : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_NONE as u8;

        match self.gecko.mTextDecorationStyle as u8 {
            U8_NS_STYLE_TEXT_DECORATION_STYLE_SOLID => Keyword::Solid,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE => Keyword::Double,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_DOTTED => Keyword::Dotted,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_DASHED => Keyword::Dashed,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_WAVY => Keyword::Wavy,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_NONE => Keyword::MozNone,
            _ => panic!("Found unexpected value in style struct for text_decoration_style property"),
        }
    }



    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_text_decoration_color(&mut self, v: longhands::text_decoration_color::computed_value::T) {
        self.gecko.mTextDecorationColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_color_from(&mut self, other: &Self) {
        let color = other.gecko.mTextDecorationColor;
        self.gecko.mTextDecorationColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_color(&mut self, other: &Self) {
        self.copy_text_decoration_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_color(&self) -> longhands::text_decoration_color::computed_value::T {
        self.gecko.mTextDecorationColor.into()
    }


}


// Set SVGPathData to StyleShapeSource.
fn set_style_svg_path(
    shape_source: &mut structs::mozilla::StyleShapeSource,
    servo_path: &values::specified::svg_path::SVGPathData,
    fill: values::generics::basic_shape::FillRule,
) {
    use crate::gecko_bindings::bindings::Gecko_NewStyleSVGPath;
    use crate::gecko_bindings::structs::StyleShapeSourceType;

    // Setup type.
    shape_source.mType = StyleShapeSourceType::Path;

    // Setup path.
    let gecko_path = unsafe {
        Gecko_NewStyleSVGPath(shape_source);
        &mut shape_source.__bindgen_anon_1.mSVGPath.as_mut().mPtr.as_mut().unwrap()
    };

    gecko_path.mPath.assign_from_iter_pod(servo_path.commands().iter().cloned());

    // Setup fill-rule.
    gecko_path.mFillRule = fill;
}






impl GeckoSVG {
    /*
     * Manually-Implemented Methods.
     */
    

    
    

    
    
    pub fn copy_mask_repeat_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mRepeatCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mRepeat = other.mRepeat;
        }
        self.gecko.mMask.mRepeatCount = count;
    }

    pub fn reset_mask_repeat(&mut self, other: &Self) {
        self.copy_mask_repeat_from(other)
    }


    pub fn set_mask_repeat<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::mask_repeat::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mRepeatCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mRepeat = {
                
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Repeat;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_ns(repeat: BackgroundRepeatKeyword) -> StyleImageLayerRepeat {
            match repeat {
                BackgroundRepeatKeyword::Repeat => StyleImageLayerRepeat::Repeat,
                BackgroundRepeatKeyword::Space => StyleImageLayerRepeat::Space,
                BackgroundRepeatKeyword::Round => StyleImageLayerRepeat::Round,
                BackgroundRepeatKeyword::NoRepeat => StyleImageLayerRepeat::NoRepeat,
            }
        }

        let repeat_x = to_ns(servo.0);
        let repeat_y = to_ns(servo.1);
        nsStyleImageLayers_Repeat {
              mXRepeat: repeat_x,
              mYRepeat: repeat_y,
        }
    
            };
        }
    }


    pub fn clone_mask_repeat(&self) -> longhands::mask_repeat::computed_value::T {
        use crate::properties::longhands::mask_repeat::single_value::computed_value::T;
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_servo(repeat: StyleImageLayerRepeat) -> BackgroundRepeatKeyword {
            match repeat {
                StyleImageLayerRepeat::Repeat => BackgroundRepeatKeyword::Repeat,
                StyleImageLayerRepeat::Space => BackgroundRepeatKeyword::Space,
                StyleImageLayerRepeat::Round => BackgroundRepeatKeyword::Round,
                StyleImageLayerRepeat::NoRepeat => BackgroundRepeatKeyword::NoRepeat,
                _ => panic!("Found unexpected value in style struct for mask_repeat property"),
            }
        }

        longhands::mask_repeat::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mRepeatCount as usize)
                .map(|ref layer| {
                    T(to_servo(layer.mRepeat.mXRepeat), to_servo(layer.mRepeat.mYRepeat))
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_clip_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mClipCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mClip = other.mClip;
        }
        self.gecko.mMask.mClipCount = count;
    }

    pub fn reset_mask_clip(&mut self, other: &Self) {
        self.copy_mask_clip_from(other)
    }


    pub fn set_mask_clip<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_clip::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_clip::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mClipCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mClip = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::FillBox =>
                        structs::StyleGeometryBox::FillBox ,
                    Keyword::StrokeBox =>
                        structs::StyleGeometryBox::StrokeBox ,
                    Keyword::ViewBox =>
                        structs::StyleGeometryBox::ViewBox ,
                    Keyword::NoClip =>
                        structs::StyleGeometryBox::NoClip ,
                }
            };
        }
    }

    pub fn clone_mask_clip(&self) -> longhands::mask_clip::computed_value::T {
        use crate::properties::longhands::mask_clip::single_value::computed_value::T as Keyword;


        longhands::mask_clip::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mClipCount as usize)
                .map(|ref layer| {
                    match layer.mClip {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::FillBox
                            => Keyword::FillBox,
                        structs::StyleGeometryBox::StrokeBox
                            => Keyword::StrokeBox,
                        structs::StyleGeometryBox::ViewBox
                            => Keyword::ViewBox,
                        structs::StyleGeometryBox::NoClip
                            => Keyword::NoClip,
                        _ => panic!("Found unexpected value in style struct for mask_clip property"),
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_origin_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mOriginCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mOrigin = other.mOrigin;
        }
        self.gecko.mMask.mOriginCount = count;
    }

    pub fn reset_mask_origin(&mut self, other: &Self) {
        self.copy_mask_origin_from(other)
    }


    pub fn set_mask_origin<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_origin::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_origin::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mOriginCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mOrigin = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::FillBox =>
                        structs::StyleGeometryBox::FillBox ,
                    Keyword::StrokeBox =>
                        structs::StyleGeometryBox::StrokeBox ,
                    Keyword::ViewBox =>
                        structs::StyleGeometryBox::ViewBox ,
                }
            };
        }
    }

    pub fn clone_mask_origin(&self) -> longhands::mask_origin::computed_value::T {
        use crate::properties::longhands::mask_origin::single_value::computed_value::T as Keyword;


        longhands::mask_origin::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mOriginCount as usize)
                .map(|ref layer| {
                    match layer.mOrigin {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::FillBox
                            => Keyword::FillBox,
                        structs::StyleGeometryBox::StrokeBox
                            => Keyword::StrokeBox,
                        structs::StyleGeometryBox::ViewBox
                            => Keyword::ViewBox,
                        _ => panic!("Found unexpected value in style struct for mask_origin property"),
                    }
                }).collect()
        )
    }


    pub fn copy_mask_position_x_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mPositionXCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }

        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.mXPosition
                = other.mPosition.mXPosition;
        }
        self.gecko.mMask.mPositionXCount = count;
    }

    pub fn reset_mask_position_x(&mut self, other: &Self) {
        self.copy_mask_position_x_from(other)
    }

    pub fn clone_mask_position_x(&self)
        -> longhands::mask_position_x::computed_value::T {
        longhands::mask_position_x::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mPositionXCount as usize)
                .map(|position| position.mPosition.mXPosition.into())
                .collect()
        )
    }

    pub fn set_mask_position_x<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::mask_position_x
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mPositionXCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.mXPosition = servo.into();
        }
    }
    pub fn copy_mask_position_y_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mPositionYCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }

        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.mYPosition
                = other.mPosition.mYPosition;
        }
        self.gecko.mMask.mPositionYCount = count;
    }

    pub fn reset_mask_position_y(&mut self, other: &Self) {
        self.copy_mask_position_y_from(other)
    }

    pub fn clone_mask_position_y(&self)
        -> longhands::mask_position_y::computed_value::T {
        longhands::mask_position_y::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mPositionYCount as usize)
                .map(|position| position.mPosition.mYPosition.into())
                .collect()
        )
    }

    pub fn set_mask_position_y<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::mask_position_y
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mPositionYCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.mYPosition = servo.into();
        }
    }

    
    
    pub fn copy_mask_size_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mSizeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mSize = other.mSize;
        }
        self.gecko.mMask.mSizeCount = count;
    }

    pub fn reset_mask_size(&mut self, other: &Self) {
        self.copy_mask_size_from(other)
    }


    pub fn set_mask_size<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::mask_size::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mSizeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mSize = {
                
        use crate::gecko_bindings::structs::nsStyleImageLayers_Size_Dimension;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Size_DimensionType;
        use crate::gecko_bindings::structs::{nsStyleCoord_CalcValue, nsStyleImageLayers_Size};
        use crate::values::generics::background::BackgroundSize;

        let mut width = nsStyleCoord_CalcValue::new();
        let mut height = nsStyleCoord_CalcValue::new();

        let (w_type, h_type) = match servo {
            BackgroundSize::Explicit { width: explicit_width, height: explicit_height } => {
                let mut w_type = nsStyleImageLayers_Size_DimensionType::eAuto;
                let mut h_type = nsStyleImageLayers_Size_DimensionType::eAuto;
                if let Some(w) = explicit_width.0.to_calc_value() {
                    width = w;
                    w_type = nsStyleImageLayers_Size_DimensionType::eLengthPercentage;
                }
                if let Some(h) = explicit_height.0.to_calc_value() {
                    height = h;
                    h_type = nsStyleImageLayers_Size_DimensionType::eLengthPercentage;
                }
                (w_type, h_type)
            }
            BackgroundSize::Cover => {
                (
                    nsStyleImageLayers_Size_DimensionType::eCover,
                    nsStyleImageLayers_Size_DimensionType::eCover,
                )
            },
            BackgroundSize::Contain => {
                (
                    nsStyleImageLayers_Size_DimensionType::eContain,
                    nsStyleImageLayers_Size_DimensionType::eContain,
                )
            },
        };

        nsStyleImageLayers_Size {
            mWidth: nsStyleImageLayers_Size_Dimension { _base: width },
            mHeight: nsStyleImageLayers_Size_Dimension { _base: height },
            mWidthType: w_type as u8,
            mHeightType: h_type as u8,
        }
    
            };
        }
    }


    pub fn clone_mask_size(&self) -> longhands::mask_size::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleCoord_CalcValue as CalcValue;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Size_DimensionType as DimensionType;
        use crate::values::computed::NonNegativeLengthPercentageOrAuto;
        use crate::values::generics::background::BackgroundSize;

        fn to_servo(value: CalcValue, ty: u8) -> NonNegativeLengthPercentageOrAuto {
            if ty == DimensionType::eAuto as u8 {
                NonNegativeLengthPercentageOrAuto::auto()
            } else {
                debug_assert_eq!(ty, DimensionType::eLengthPercentage as u8);
                value.into()
            }
        }

        longhands::mask_size::computed_value::List(
            self.gecko.mMask.mLayers.iter().map(|ref layer| {
                if DimensionType::eCover as u8 == layer.mSize.mWidthType {
                    debug_assert_eq!(layer.mSize.mHeightType, DimensionType::eCover as u8);
                    return BackgroundSize::Cover
                }
                if DimensionType::eContain as u8 == layer.mSize.mWidthType {
                    debug_assert_eq!(layer.mSize.mHeightType, DimensionType::eContain as u8);
                    return BackgroundSize::Contain
                }
                BackgroundSize::Explicit {
                    width: to_servo(layer.mSize.mWidth._base, layer.mSize.mWidthType),
                    height: to_servo(layer.mSize.mHeight._base, layer.mSize.mHeightType),
                }
            }).collect()
        )
    }

    pub fn copy_mask_image_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        unsafe {
            let count = other.gecko.mMask.mImageCount;
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);

            for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                      .zip(other.gecko.mMask.mLayers.iter())
                                      .take(count as usize) {
                Gecko_CopyImageValueFrom(&mut layer.mImage, &other.mImage);
            }
            self.gecko.mMask.mImageCount = count;
        }
    }

    pub fn reset_mask_image(&mut self, other: &Self) {
        self.copy_mask_image_from(other)
    }

    #[allow(unused_variables)]
    pub fn set_mask_image<I>(&mut self, images: I)
        where I: IntoIterator<Item = longhands::mask_image::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let images = images.into_iter();

        unsafe {
            // Prevent leaking of the last elements we did set
            for image in &mut self.gecko.mMask.mLayers {
                Gecko_SetNullImageValue(&mut image.mImage)
            }
            // XXXManishearth clear mSourceURI for masks
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, images.len(),
                                          LayerType::Mask);
        }

        self.gecko.mMask.mImageCount = images.len() as u32;

        for (image, geckoimage) in images.zip(self.gecko.mMask
                                                  .mLayers.iter_mut()) {
            if let Either::Second(image) = image {
                geckoimage.mImage.set(image)
            }
        }
    }

    pub fn clone_mask_image(&self) -> longhands::mask_image::computed_value::T {
        use crate::values::None_;

        longhands::mask_image::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mImageCount as usize)
                .map(|ref layer| {
                    match unsafe { layer.mImage.into_image() } {
                        Some(image) => Either::Second(image),
                        None => Either::First(None_),
                    }
            }).collect()
        )
    }

    
    pub fn fill_arrays(&mut self) {
        use crate::gecko_bindings::bindings::Gecko_FillAllImageLayers;
        use std::cmp;
        let mut max_len = 1;
            max_len = cmp::max(max_len, self.gecko.mMask.mRepeatCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mClipCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mOriginCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mPositionXCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mPositionYCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mImageCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mSizeCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mMaskModeCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mCompositeCount);
        unsafe {
            // While we could do this manually, we'd need to also manually
            // run all the copy constructors, so we just delegate to gecko
            Gecko_FillAllImageLayers(&mut self.gecko.mMask, max_len);
        }
    }

    
    

    
    pub fn copy_mask_mode_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mMaskModeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mMaskMode = other.mMaskMode;
        }
        self.gecko.mMask.mMaskModeCount = count;
    }

    pub fn reset_mask_mode(&mut self, other: &Self) {
        self.copy_mask_mode_from(other)
    }


    pub fn set_mask_mode<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_mode::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_mode::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mMaskModeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mMaskMode = {
                match servo {
                    Keyword::MatchSource =>
                        structs::NS_STYLE_MASK_MODE_MATCH_SOURCE as u8,
                    Keyword::Alpha =>
                        structs::NS_STYLE_MASK_MODE_ALPHA as u8,
                    Keyword::Luminance =>
                        structs::NS_STYLE_MASK_MODE_LUMINANCE as u8,
                }
            };
        }
    }

    pub fn clone_mask_mode(&self) -> longhands::mask_mode::computed_value::T {
        use crate::properties::longhands::mask_mode::single_value::computed_value::T as Keyword;

        const U8_NS_STYLE_MASK_MODE_MATCH_SOURCE : u8 =
            structs::NS_STYLE_MASK_MODE_MATCH_SOURCE as u8;
        const U8_NS_STYLE_MASK_MODE_ALPHA : u8 =
            structs::NS_STYLE_MASK_MODE_ALPHA as u8;
        const U8_NS_STYLE_MASK_MODE_LUMINANCE : u8 =
            structs::NS_STYLE_MASK_MODE_LUMINANCE as u8;

        longhands::mask_mode::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mMaskModeCount as usize)
                .map(|ref layer| {
                    match layer.mMaskMode {
                        U8_NS_STYLE_MASK_MODE_MATCH_SOURCE
                            => Keyword::MatchSource,
                        U8_NS_STYLE_MASK_MODE_ALPHA
                            => Keyword::Alpha,
                        U8_NS_STYLE_MASK_MODE_LUMINANCE
                            => Keyword::Luminance,
                        _ => panic!("Found unexpected value in style struct for mask_mode property"),
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_composite_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mCompositeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mComposite = other.mComposite;
        }
        self.gecko.mMask.mCompositeCount = count;
    }

    pub fn reset_mask_composite(&mut self, other: &Self) {
        self.copy_mask_composite_from(other)
    }


    pub fn set_mask_composite<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_composite::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_composite::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mCompositeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mComposite = {
                match servo {
                    Keyword::Add =>
                        structs::NS_STYLE_MASK_COMPOSITE_ADD as u8,
                    Keyword::Subtract =>
                        structs::NS_STYLE_MASK_COMPOSITE_SUBTRACT as u8,
                    Keyword::Intersect =>
                        structs::NS_STYLE_MASK_COMPOSITE_INTERSECT as u8,
                    Keyword::Exclude =>
                        structs::NS_STYLE_MASK_COMPOSITE_EXCLUDE as u8,
                }
            };
        }
    }

    pub fn clone_mask_composite(&self) -> longhands::mask_composite::computed_value::T {
        use crate::properties::longhands::mask_composite::single_value::computed_value::T as Keyword;

        const U8_NS_STYLE_MASK_COMPOSITE_ADD : u8 =
            structs::NS_STYLE_MASK_COMPOSITE_ADD as u8;
        const U8_NS_STYLE_MASK_COMPOSITE_SUBTRACT : u8 =
            structs::NS_STYLE_MASK_COMPOSITE_SUBTRACT as u8;
        const U8_NS_STYLE_MASK_COMPOSITE_INTERSECT : u8 =
            structs::NS_STYLE_MASK_COMPOSITE_INTERSECT as u8;
        const U8_NS_STYLE_MASK_COMPOSITE_EXCLUDE : u8 =
            structs::NS_STYLE_MASK_COMPOSITE_EXCLUDE as u8;

        longhands::mask_composite::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mCompositeCount as usize)
                .map(|ref layer| {
                    match layer.mComposite {
                        U8_NS_STYLE_MASK_COMPOSITE_ADD
                            => Keyword::Add,
                        U8_NS_STYLE_MASK_COMPOSITE_SUBTRACT
                            => Keyword::Subtract,
                        U8_NS_STYLE_MASK_COMPOSITE_INTERSECT
                            => Keyword::Intersect,
                        U8_NS_STYLE_MASK_COMPOSITE_EXCLUDE
                            => Keyword::Exclude,
                        _ => panic!("Found unexpected value in style struct for mask_composite property"),
                    }
                }).collect()
        )
    }

    
    pub fn set_clip_path(&mut self, v: longhands::clip_path::computed_value::T) {
        use crate::gecko_bindings::bindings::{Gecko_NewBasicShape, Gecko_DestroyShapeSource};
        use crate::gecko_bindings::structs::{StyleBasicShape, StyleBasicShapeType, StyleShapeSourceType};
        use crate::gecko_bindings::structs::{StyleGeometryBox, StyleShapeSource};
        use crate::gecko::conversions::basic_shape::set_corners_from_radius;
        use crate::gecko::values::GeckoStyleCoordConvertible;
        use crate::values::generics::basic_shape::{BasicShape, ShapeSource};

        let ref mut clip_path = self.gecko.mClipPath;

        // clean up existing struct
        unsafe { Gecko_DestroyShapeSource(clip_path) };
        clip_path.mType = StyleShapeSourceType::None;

        match v {
            ShapeSource::ImageOrUrl(ref url) => {
                unsafe {
                    bindings::Gecko_StyleShapeSource_SetURLValue(clip_path, url.0.url_value.get())
                }
            }
            ShapeSource::None => {} // don't change the type
            ShapeSource::Box(reference) => {
                clip_path.mReferenceBox = reference.into();
                clip_path.mType = StyleShapeSourceType::Box;
            }
            ShapeSource::Path(p) => set_style_svg_path(clip_path, &p.path, p.fill),
            ShapeSource::Shape(servo_shape, maybe_box) => {
                fn init_shape(clip_path: &mut StyleShapeSource, basic_shape_type: StyleBasicShapeType)
                              -> &mut StyleBasicShape {
                    unsafe {
                        // Create StyleBasicShape in StyleShapeSource. mReferenceBox and mType
                        // will be set manually later.
                        Gecko_NewBasicShape(clip_path, basic_shape_type);
                        &mut *clip_path.__bindgen_anon_1.mBasicShape.as_mut().mPtr
                    }
                }
                match servo_shape {
                    BasicShape::Inset(inset) => {
                        let shape = init_shape(clip_path, StyleBasicShapeType::Inset);
                        unsafe { shape.mCoordinates.set_len(4) };

                        // set_len() can't call constructors, so the coordinates
                        // can contain any value. set_value() attempts to free
                        // allocated coordinates, so we don't want to feed it
                        // garbage values which it may misinterpret.
                        // Instead, we use leaky_set_value to blindly overwrite
                        // the garbage data without
                        // attempting to clean up.
                        shape.mCoordinates[0].leaky_set_null();
                        inset.rect.0.to_gecko_style_coord(&mut shape.mCoordinates[0]);
                        shape.mCoordinates[1].leaky_set_null();
                        inset.rect.1.to_gecko_style_coord(&mut shape.mCoordinates[1]);
                        shape.mCoordinates[2].leaky_set_null();
                        inset.rect.2.to_gecko_style_coord(&mut shape.mCoordinates[2]);
                        shape.mCoordinates[3].leaky_set_null();
                        inset.rect.3.to_gecko_style_coord(&mut shape.mCoordinates[3]);

                        set_corners_from_radius(inset.round, &mut shape.mRadius);
                    }
                    BasicShape::Circle(circ) => {
                        let shape = init_shape(clip_path, StyleBasicShapeType::Circle);
                        unsafe { shape.mCoordinates.set_len(1) };
                        shape.mCoordinates[0].leaky_set_null();
                        circ.radius.to_gecko_style_coord(&mut shape.mCoordinates[0]);

                        shape.mPosition = circ.position.into();
                    }
                    BasicShape::Ellipse(el) => {
                        let shape = init_shape(clip_path, StyleBasicShapeType::Ellipse);
                        unsafe { shape.mCoordinates.set_len(2) };
                        shape.mCoordinates[0].leaky_set_null();
                        el.semiaxis_x.to_gecko_style_coord(&mut shape.mCoordinates[0]);
                        shape.mCoordinates[1].leaky_set_null();
                        el.semiaxis_y.to_gecko_style_coord(&mut shape.mCoordinates[1]);

                        shape.mPosition = el.position.into();
                    }
                    BasicShape::Polygon(poly) => {
                        let shape = init_shape(clip_path, StyleBasicShapeType::Polygon);
                        unsafe {
                            shape.mCoordinates.set_len(poly.coordinates.len() as u32 * 2);
                        }
                        for (i, coord) in poly.coordinates.iter().enumerate() {
                            shape.mCoordinates[2 * i].leaky_set_null();
                            shape.mCoordinates[2 * i + 1].leaky_set_null();
                            coord.0.to_gecko_style_coord(&mut shape.mCoordinates[2 * i]);
                            coord.1.to_gecko_style_coord(&mut shape.mCoordinates[2 * i + 1]);
                        }
                        shape.mFillRule = poly.fill;
                    }
                }

                clip_path.mReferenceBox = maybe_box.map(Into::into)
                                                  .unwrap_or(StyleGeometryBox::NoBox);
                clip_path.mType = StyleShapeSourceType::Shape;
            }
        }

    }

    pub fn clone_clip_path(&self) -> longhands::clip_path::computed_value::T {
        (&self.gecko.mClipPath).into()
    }

    pub fn copy_clip_path_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyShapeSourceFrom;
        unsafe {
            Gecko_CopyShapeSourceFrom(&mut self.gecko.mClipPath, &other.gecko.mClipPath);
        }
    }

    pub fn reset_clip_path(&mut self, other: &Self) {
        self.copy_clip_path_from(other)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_dominant_baseline(&mut self, v: longhands::dominant_baseline::computed_value::T) {
        use crate::properties::longhands::dominant_baseline::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_DOMINANT_BASELINE_AUTO as u8,
                Keyword::UseScript =>
                    structs::NS_STYLE_DOMINANT_BASELINE_USE_SCRIPT as u8,
                Keyword::NoChange =>
                    structs::NS_STYLE_DOMINANT_BASELINE_NO_CHANGE as u8,
                Keyword::ResetSize =>
                    structs::NS_STYLE_DOMINANT_BASELINE_RESET_SIZE as u8,
                Keyword::Ideographic =>
                    structs::NS_STYLE_DOMINANT_BASELINE_IDEOGRAPHIC as u8,
                Keyword::Alphabetic =>
                    structs::NS_STYLE_DOMINANT_BASELINE_ALPHABETIC as u8,
                Keyword::Hanging =>
                    structs::NS_STYLE_DOMINANT_BASELINE_HANGING as u8,
                Keyword::Mathematical =>
                    structs::NS_STYLE_DOMINANT_BASELINE_MATHEMATICAL as u8,
                Keyword::Central =>
                    structs::NS_STYLE_DOMINANT_BASELINE_CENTRAL as u8,
                Keyword::Middle =>
                    structs::NS_STYLE_DOMINANT_BASELINE_MIDDLE as u8,
                Keyword::TextAfterEdge =>
                    structs::NS_STYLE_DOMINANT_BASELINE_TEXT_AFTER_EDGE as u8,
                Keyword::TextBeforeEdge =>
                    structs::NS_STYLE_DOMINANT_BASELINE_TEXT_BEFORE_EDGE as u8,
        };
        self.gecko.mDominantBaseline = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_dominant_baseline_from(&mut self, other: &Self) {
        self.gecko.mDominantBaseline = other.gecko.mDominantBaseline;
    }

    #[allow(non_snake_case)]
    pub fn reset_dominant_baseline(&mut self, other: &Self) {
        self.copy_dominant_baseline_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_dominant_baseline(&self) -> longhands::dominant_baseline::computed_value::T {
        use crate::properties::longhands::dominant_baseline::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_DOMINANT_BASELINE_AUTO : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_AUTO as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_USE_SCRIPT : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_USE_SCRIPT as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_NO_CHANGE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_NO_CHANGE as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_RESET_SIZE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_RESET_SIZE as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_IDEOGRAPHIC : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_IDEOGRAPHIC as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_ALPHABETIC : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_ALPHABETIC as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_HANGING : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_HANGING as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_MATHEMATICAL : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_MATHEMATICAL as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_CENTRAL : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_CENTRAL as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_MIDDLE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_MIDDLE as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_TEXT_AFTER_EDGE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_TEXT_AFTER_EDGE as u8;
        const U8_NS_STYLE_DOMINANT_BASELINE_TEXT_BEFORE_EDGE : u8 =
            structs::NS_STYLE_DOMINANT_BASELINE_TEXT_BEFORE_EDGE as u8;

        match self.gecko.mDominantBaseline as u8 {
            U8_NS_STYLE_DOMINANT_BASELINE_AUTO => Keyword::Auto,
            U8_NS_STYLE_DOMINANT_BASELINE_USE_SCRIPT => Keyword::UseScript,
            U8_NS_STYLE_DOMINANT_BASELINE_NO_CHANGE => Keyword::NoChange,
            U8_NS_STYLE_DOMINANT_BASELINE_RESET_SIZE => Keyword::ResetSize,
            U8_NS_STYLE_DOMINANT_BASELINE_IDEOGRAPHIC => Keyword::Ideographic,
            U8_NS_STYLE_DOMINANT_BASELINE_ALPHABETIC => Keyword::Alphabetic,
            U8_NS_STYLE_DOMINANT_BASELINE_HANGING => Keyword::Hanging,
            U8_NS_STYLE_DOMINANT_BASELINE_MATHEMATICAL => Keyword::Mathematical,
            U8_NS_STYLE_DOMINANT_BASELINE_CENTRAL => Keyword::Central,
            U8_NS_STYLE_DOMINANT_BASELINE_MIDDLE => Keyword::Middle,
            U8_NS_STYLE_DOMINANT_BASELINE_TEXT_AFTER_EDGE => Keyword::TextAfterEdge,
            U8_NS_STYLE_DOMINANT_BASELINE_TEXT_BEFORE_EDGE => Keyword::TextBeforeEdge,
            _ => panic!("Found unexpected value in style struct for dominant_baseline property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_vector_effect(&mut self, v: longhands::vector_effect::computed_value::T) {
        use crate::properties::longhands::vector_effect::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_VECTOR_EFFECT_NONE as u8,
                Keyword::NonScalingStroke =>
                    structs::NS_STYLE_VECTOR_EFFECT_NON_SCALING_STROKE as u8,
        };
        self.gecko.mVectorEffect = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_vector_effect_from(&mut self, other: &Self) {
        self.gecko.mVectorEffect = other.gecko.mVectorEffect;
    }

    #[allow(non_snake_case)]
    pub fn reset_vector_effect(&mut self, other: &Self) {
        self.copy_vector_effect_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_vector_effect(&self) -> longhands::vector_effect::computed_value::T {
        use crate::properties::longhands::vector_effect::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_VECTOR_EFFECT_NONE : u8 =
            structs::NS_STYLE_VECTOR_EFFECT_NONE as u8;
        const U8_NS_STYLE_VECTOR_EFFECT_NON_SCALING_STROKE : u8 =
            structs::NS_STYLE_VECTOR_EFFECT_NON_SCALING_STROKE as u8;

        match self.gecko.mVectorEffect as u8 {
            U8_NS_STYLE_VECTOR_EFFECT_NONE => Keyword::None,
            U8_NS_STYLE_VECTOR_EFFECT_NON_SCALING_STROKE => Keyword::NonScalingStroke,
            _ => panic!("Found unexpected value in style struct for vector_effect property"),
        }
    }



    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_stop_color(&mut self, v: longhands::stop_color::computed_value::T) {
        self.gecko.mStopColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_stop_color_from(&mut self, other: &Self) {
        let color = other.gecko.mStopColor;
        self.gecko.mStopColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_stop_color(&mut self, other: &Self) {
        self.copy_stop_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stop_color(&self) -> longhands::stop_color::computed_value::T {
        self.gecko.mStopColor.into()
    }



    #[allow(non_snake_case)]
    pub fn set_stop_opacity(&mut self, v: longhands::stop_opacity::computed_value::T) {
        self.gecko.mStopOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stop_opacity_from(&mut self, other: &Self) {
        self.gecko.mStopOpacity = other.gecko.mStopOpacity;
    }

    #[allow(non_snake_case)]
    pub fn reset_stop_opacity(&mut self, other: &Self) {
        self.copy_stop_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stop_opacity(&self) -> longhands::stop_opacity::computed_value::T {
        From::from(self.gecko.mStopOpacity)
    }



    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_flood_color(&mut self, v: longhands::flood_color::computed_value::T) {
        self.gecko.mFloodColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_flood_color_from(&mut self, other: &Self) {
        let color = other.gecko.mFloodColor;
        self.gecko.mFloodColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_flood_color(&mut self, other: &Self) {
        self.copy_flood_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flood_color(&self) -> longhands::flood_color::computed_value::T {
        self.gecko.mFloodColor.into()
    }



    #[allow(non_snake_case)]
    pub fn set_flood_opacity(&mut self, v: longhands::flood_opacity::computed_value::T) {
        self.gecko.mFloodOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flood_opacity_from(&mut self, other: &Self) {
        self.gecko.mFloodOpacity = other.gecko.mFloodOpacity;
    }

    #[allow(non_snake_case)]
    pub fn reset_flood_opacity(&mut self, other: &Self) {
        self.copy_flood_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flood_opacity(&self) -> longhands::flood_opacity::computed_value::T {
        From::from(self.gecko.mFloodOpacity)
    }



    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_lighting_color(&mut self, v: longhands::lighting_color::computed_value::T) {
        self.gecko.mLightingColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_lighting_color_from(&mut self, other: &Self) {
        let color = other.gecko.mLightingColor;
        self.gecko.mLightingColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_lighting_color(&mut self, other: &Self) {
        self.copy_lighting_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_lighting_color(&self) -> longhands::lighting_color::computed_value::T {
        self.gecko.mLightingColor.into()
    }



    #[allow(non_snake_case)]
    pub fn set_mask_type(&mut self, v: longhands::mask_type::computed_value::T) {
        use crate::properties::longhands::mask_type::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Luminance =>
                    structs::NS_STYLE_MASK_TYPE_LUMINANCE as u8,
                Keyword::Alpha =>
                    structs::NS_STYLE_MASK_TYPE_ALPHA as u8,
        };
        self.gecko.mMaskType = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_mask_type_from(&mut self, other: &Self) {
        self.gecko.mMaskType = other.gecko.mMaskType;
    }

    #[allow(non_snake_case)]
    pub fn reset_mask_type(&mut self, other: &Self) {
        self.copy_mask_type_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_mask_type(&self) -> longhands::mask_type::computed_value::T {
        use crate::properties::longhands::mask_type::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_MASK_TYPE_LUMINANCE : u8 =
            structs::NS_STYLE_MASK_TYPE_LUMINANCE as u8;
        const U8_NS_STYLE_MASK_TYPE_ALPHA : u8 =
            structs::NS_STYLE_MASK_TYPE_ALPHA as u8;

        match self.gecko.mMaskType as u8 {
            U8_NS_STYLE_MASK_TYPE_LUMINANCE => Keyword::Luminance,
            U8_NS_STYLE_MASK_TYPE_ALPHA => Keyword::Alpha,
            _ => panic!("Found unexpected value in style struct for mask_type property"),
        }
    }


}




impl GeckoInheritedSVG {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_paint_order(&mut self, v: longhands::paint_order::computed_value::T) {
        self.gecko.mPaintOrder = v.0;
    }

    
    #[allow(non_snake_case)]
    pub fn copy_paint_order_from(&mut self, other: &Self) {
        self.gecko.mPaintOrder = other.gecko.mPaintOrder;
    }

    #[allow(non_snake_case)]
    pub fn reset_paint_order(&mut self, other: &Self) {
        self.copy_paint_order_from(other)
    }


    pub fn clone_paint_order(&self) -> longhands::paint_order::computed_value::T {
        use crate::properties::longhands::paint_order::computed_value::T;
        T(self.gecko.mPaintOrder)
    }

    pub fn set_stroke_dasharray(&mut self, v: longhands::stroke_dasharray::computed_value::T) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHARRAY_CONTEXT as CONTEXT_VALUE;
        use crate::values::generics::svg::{SVGStrokeDashArray, SvgLengthPercentageOrNumber};

        match v {
            SVGStrokeDashArray::Values(v) => {
                let v = v.into_iter();
                self.gecko.mContextFlags &= !CONTEXT_VALUE;
                unsafe {
                    bindings::Gecko_nsStyleSVG_SetDashArrayLength(&mut self.gecko, v.len() as u32);
                }
                for (gecko, servo) in self.gecko.mStrokeDasharray.iter_mut().zip(v) {
                    match servo {
                        SvgLengthPercentageOrNumber::LengthPercentage(lp) =>
                            gecko.set(lp),
                        SvgLengthPercentageOrNumber::Number(num) =>
                            gecko.set_value(CoordDataValue::Factor(num.into())),
                    }
                }
            }
            SVGStrokeDashArray::ContextValue => {
                self.gecko.mContextFlags |= CONTEXT_VALUE;
                unsafe {
                    bindings::Gecko_nsStyleSVG_SetDashArrayLength(&mut self.gecko, 0);
                }
            }
        }
    }

    pub fn copy_stroke_dasharray_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHARRAY_CONTEXT as CONTEXT_VALUE;
        unsafe {
            bindings::Gecko_nsStyleSVG_CopyDashArray(&mut self.gecko, &other.gecko);
        }
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !CONTEXT_VALUE) |
            (other.gecko.mContextFlags & CONTEXT_VALUE);
    }

    pub fn reset_stroke_dasharray(&mut self, other: &Self) {
        self.copy_stroke_dasharray_from(other)
    }

    pub fn clone_stroke_dasharray(&self) -> longhands::stroke_dasharray::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHARRAY_CONTEXT as CONTEXT_VALUE;
        use crate::values::computed::LengthPercentage;
        use crate::values::generics::NonNegative;
        use crate::values::generics::svg::{SVGStrokeDashArray, SvgLengthPercentageOrNumber};

        if self.gecko.mContextFlags & CONTEXT_VALUE != 0 {
            debug_assert_eq!(self.gecko.mStrokeDasharray.len(), 0);
            return SVGStrokeDashArray::ContextValue;
        }
        let mut vec = vec![];
        for gecko in self.gecko.mStrokeDasharray.iter() {
            match gecko.as_value() {
                CoordDataValue::Factor(number) =>
                    vec.push(SvgLengthPercentageOrNumber::Number(number.into())),
                CoordDataValue::Coord(coord) =>
                    vec.push(SvgLengthPercentageOrNumber::LengthPercentage(
                        NonNegative(LengthPercentage::new(Au(coord).into(), None).into()))),
                CoordDataValue::Percent(p) =>
                    vec.push(SvgLengthPercentageOrNumber::LengthPercentage(
                        NonNegative(LengthPercentage::new_percent(Percentage(p)).into()))),
                CoordDataValue::Calc(calc) =>
                    vec.push(SvgLengthPercentageOrNumber::LengthPercentage(
                        NonNegative(LengthPercentage::from(calc).clamp_to_non_negative()))),
                _ => unreachable!(),
            }
        }
        SVGStrokeDashArray::Values(vec)
    }

    #[allow(non_snake_case)]
    pub fn _moz_context_properties_count(&self) -> usize {
        self.gecko.mContextProps.len()
    }

    #[allow(non_snake_case)]
    pub fn _moz_context_properties_at(
        &self,
        index: usize,
    ) -> longhands::_moz_context_properties::computed_value::single_value::T {
        longhands::_moz_context_properties::computed_value::single_value::T(
            CustomIdent(unsafe {
                Atom::from_raw(self.gecko.mContextProps[index].mRawPtr)
            })
        )
    }

    #[allow(non_snake_case)]
    pub fn set__moz_context_properties<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::_moz_context_properties::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator
    {
        let v = v.into_iter();
        unsafe {
            bindings::Gecko_nsStyleSVG_SetContextPropertiesLength(&mut self.gecko, v.len() as u32);
        }

        self.gecko.mContextPropsBits = 0;
        for (gecko, servo) in self.gecko.mContextProps.iter_mut().zip(v) {
            if (servo.0).0 == atom!("fill") {
                self.gecko.mContextPropsBits |= structs::NS_STYLE_CONTEXT_PROPERTY_FILL as u8;
            } else if (servo.0).0 == atom!("stroke") {
                self.gecko.mContextPropsBits |= structs::NS_STYLE_CONTEXT_PROPERTY_STROKE as u8;
            } else if (servo.0).0 == atom!("fill-opacity") {
                self.gecko.mContextPropsBits |= structs::NS_STYLE_CONTEXT_PROPERTY_FILL_OPACITY as u8;
            } else if (servo.0).0 == atom!("stroke-opacity") {
                self.gecko.mContextPropsBits |= structs::NS_STYLE_CONTEXT_PROPERTY_STROKE_OPACITY as u8;
            }
            gecko.mRawPtr = (servo.0).0.into_addrefed();
        }
    }

    #[allow(non_snake_case)]
    pub fn copy__moz_context_properties_from(&mut self, other: &Self) {
        unsafe {
            bindings::Gecko_nsStyleSVG_CopyContextProperties(&mut self.gecko, &other.gecko);
        }
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_context_properties(&mut self, other: &Self) {
        self.copy__moz_context_properties_from(other)
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_text_anchor(&mut self, v: longhands::text_anchor::computed_value::T) {
        use crate::properties::longhands::text_anchor::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::NS_STYLE_TEXT_ANCHOR_START as u8,
                Keyword::Middle =>
                    structs::NS_STYLE_TEXT_ANCHOR_MIDDLE as u8,
                Keyword::End =>
                    structs::NS_STYLE_TEXT_ANCHOR_END as u8,
        };
        self.gecko.mTextAnchor = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_anchor_from(&mut self, other: &Self) {
        self.gecko.mTextAnchor = other.gecko.mTextAnchor;
    }

    #[allow(non_snake_case)]
    pub fn reset_text_anchor(&mut self, other: &Self) {
        self.copy_text_anchor_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_text_anchor(&self) -> longhands::text_anchor::computed_value::T {
        use crate::properties::longhands::text_anchor::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_ANCHOR_START : u8 =
            structs::NS_STYLE_TEXT_ANCHOR_START as u8;
        const U8_NS_STYLE_TEXT_ANCHOR_MIDDLE : u8 =
            structs::NS_STYLE_TEXT_ANCHOR_MIDDLE as u8;
        const U8_NS_STYLE_TEXT_ANCHOR_END : u8 =
            structs::NS_STYLE_TEXT_ANCHOR_END as u8;

        match self.gecko.mTextAnchor as u8 {
            U8_NS_STYLE_TEXT_ANCHOR_START => Keyword::Start,
            U8_NS_STYLE_TEXT_ANCHOR_MIDDLE => Keyword::Middle,
            U8_NS_STYLE_TEXT_ANCHOR_END => Keyword::End,
            _ => panic!("Found unexpected value in style struct for text_anchor property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_interpolation(&mut self, v: longhands::color_interpolation::computed_value::T) {
        use crate::properties::longhands::color_interpolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Srgb =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_SRGB as u8,
                Keyword::Auto =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_AUTO as u8,
                Keyword::Linearrgb =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_LINEARRGB as u8,
        };
        self.gecko.mColorInterpolation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_interpolation_from(&mut self, other: &Self) {
        self.gecko.mColorInterpolation = other.gecko.mColorInterpolation;
    }

    #[allow(non_snake_case)]
    pub fn reset_color_interpolation(&mut self, other: &Self) {
        self.copy_color_interpolation_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_color_interpolation(&self) -> longhands::color_interpolation::computed_value::T {
        use crate::properties::longhands::color_interpolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_COLOR_INTERPOLATION_SRGB : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_SRGB as u8;
        const U8_NS_STYLE_COLOR_INTERPOLATION_AUTO : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_AUTO as u8;
        const U8_NS_STYLE_COLOR_INTERPOLATION_LINEARRGB : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_LINEARRGB as u8;

        match self.gecko.mColorInterpolation as u8 {
            U8_NS_STYLE_COLOR_INTERPOLATION_SRGB => Keyword::Srgb,
            U8_NS_STYLE_COLOR_INTERPOLATION_AUTO => Keyword::Auto,
            U8_NS_STYLE_COLOR_INTERPOLATION_LINEARRGB => Keyword::Linearrgb,
            _ => panic!("Found unexpected value in style struct for color_interpolation property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_interpolation_filters(&mut self, v: longhands::color_interpolation_filters::computed_value::T) {
        use crate::properties::longhands::color_interpolation_filters::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Linearrgb =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_LINEARRGB as u8,
                Keyword::Auto =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_AUTO as u8,
                Keyword::Srgb =>
                    structs::NS_STYLE_COLOR_INTERPOLATION_SRGB as u8,
        };
        self.gecko.mColorInterpolationFilters = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_interpolation_filters_from(&mut self, other: &Self) {
        self.gecko.mColorInterpolationFilters = other.gecko.mColorInterpolationFilters;
    }

    #[allow(non_snake_case)]
    pub fn reset_color_interpolation_filters(&mut self, other: &Self) {
        self.copy_color_interpolation_filters_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_color_interpolation_filters(&self) -> longhands::color_interpolation_filters::computed_value::T {
        use crate::properties::longhands::color_interpolation_filters::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_COLOR_INTERPOLATION_LINEARRGB : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_LINEARRGB as u8;
        const U8_NS_STYLE_COLOR_INTERPOLATION_AUTO : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_AUTO as u8;
        const U8_NS_STYLE_COLOR_INTERPOLATION_SRGB : u8 =
            structs::NS_STYLE_COLOR_INTERPOLATION_SRGB as u8;

        match self.gecko.mColorInterpolationFilters as u8 {
            U8_NS_STYLE_COLOR_INTERPOLATION_LINEARRGB => Keyword::Linearrgb,
            U8_NS_STYLE_COLOR_INTERPOLATION_AUTO => Keyword::Auto,
            U8_NS_STYLE_COLOR_INTERPOLATION_SRGB => Keyword::Srgb,
            _ => panic!("Found unexpected value in style struct for color_interpolation_filters property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set_fill(&mut self, mut v: longhands::fill::computed_value::T) {
        use crate::values::generics::svg::SVGPaintKind;
        use self::structs::nsStyleSVGPaintType;
        use self::structs::nsStyleSVGFallbackType;

        let ref mut paint = self.gecko.mFill;
        unsafe {
            bindings::Gecko_nsStyleSVGPaint_Reset(paint);
        }
        let fallback = v.fallback.take();
        match v.kind {
            SVGPaintKind::None => return,
            SVGPaintKind::ContextFill => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_ContextFill;
            }
            SVGPaintKind::ContextStroke => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_ContextStroke;
            }
            SVGPaintKind::PaintServer(url) => {
                unsafe {
                    bindings::Gecko_nsStyleSVGPaint_SetURLValue(
                        paint,
                        url.url_value_ptr(),
                    )
                }
            }
            SVGPaintKind::Color(color) => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_Color;
                unsafe {
                    *paint.mPaint.mColor.as_mut() = color.into();
                }
            }
        }

        paint.mFallbackType = match fallback {
            Some(Either::First(color)) => {
                paint.mFallbackColor = color.into();
                nsStyleSVGFallbackType::eStyleSVGFallbackType_Color
            },
            Some(Either::Second(_)) => {
                nsStyleSVGFallbackType::eStyleSVGFallbackType_None
            },
            None => nsStyleSVGFallbackType::eStyleSVGFallbackType_NotSet
        };
    }

    #[allow(non_snake_case)]
    pub fn copy_fill_from(&mut self, other: &Self) {
        unsafe {
            bindings::Gecko_nsStyleSVGPaint_CopyFrom(
                &mut self.gecko.mFill,
                & other.gecko.mFill
            );
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_fill(&mut self, other: &Self) {
        self.copy_fill_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_fill(&self) -> longhands::fill::computed_value::T {
        use crate::values::computed::url::ComputedUrl;
        use crate::values::generics::svg::{SVGPaint, SVGPaintKind};
        use self::structs::nsStyleSVGPaintType;
        use self::structs::nsStyleSVGFallbackType;
        let ref paint = self.gecko.mFill;

        let fallback = match paint.mFallbackType {
            nsStyleSVGFallbackType::eStyleSVGFallbackType_Color => {
                Some(Either::First(paint.mFallbackColor.into()))
            },
            nsStyleSVGFallbackType::eStyleSVGFallbackType_None => {
                Some(Either::Second(None_))
            },
            nsStyleSVGFallbackType::eStyleSVGFallbackType_NotSet => None,
        };

        let kind = match paint.mType {
            nsStyleSVGPaintType::eStyleSVGPaintType_None => SVGPaintKind::None,
            nsStyleSVGPaintType::eStyleSVGPaintType_ContextFill => SVGPaintKind::ContextFill,
            nsStyleSVGPaintType::eStyleSVGPaintType_ContextStroke => SVGPaintKind::ContextStroke,
            nsStyleSVGPaintType::eStyleSVGPaintType_Server => {
                SVGPaintKind::PaintServer(unsafe {
                    let url = RefPtr::new(*paint.mPaint.mPaintServer.as_ref());
                    ComputedUrl::from_url_value(url)
                })
            }
            nsStyleSVGPaintType::eStyleSVGPaintType_Color => {
                let col = unsafe { *paint.mPaint.mColor.as_ref() };
                SVGPaintKind::Color(col.into())
            }
        };
        SVGPaint {
            kind: kind,
            fallback: fallback,
        }
    }

    

    pub fn set_fill_opacity(&mut self, v: longhands::fill_opacity::computed_value::T) {
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_MASK as MASK;
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_SHIFT as SHIFT;
        use crate::gecko_bindings::structs::nsStyleSVGOpacitySource::*;
        use crate::values::generics::svg::SVGOpacity;
        self.gecko.mContextFlags &= !MASK;
        match v {
            SVGOpacity::Opacity(opacity) => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_Normal as u8) << SHIFT;
                self.gecko.mFillOpacity = opacity;
            }
            SVGOpacity::ContextFillOpacity => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_ContextFillOpacity as u8) << SHIFT;
                self.gecko.mFillOpacity = 1.;
            }
            SVGOpacity::ContextStrokeOpacity => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_ContextStrokeOpacity as u8) << SHIFT;
                self.gecko.mFillOpacity = 1.;
            }
        }
    }

    pub fn copy_fill_opacity_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_MASK as MASK;
        self.gecko.mFillOpacity = other.gecko.mFillOpacity;
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !MASK) |
            (other.gecko.mContextFlags & MASK);
    }

    pub fn reset_fill_opacity(&mut self, other: &Self) {
        self.copy_fill_opacity_from(other)
    }

    pub fn clone_fill_opacity(&self) -> longhands::fill_opacity::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_MASK as MASK;
        use crate::gecko_bindings::structs::nsStyleSVG_FILL_OPACITY_SOURCE_SHIFT as SHIFT;
        use crate::gecko_bindings::structs::nsStyleSVGOpacitySource::*;
        use crate::values::generics::svg::SVGOpacity;

        let source = (self.gecko.mContextFlags & MASK) >> SHIFT;
        if source == eStyleSVGOpacitySource_Normal as u8 {
            return SVGOpacity::Opacity(self.gecko.mFillOpacity);
        } else {
            debug_assert_eq!(self.gecko.mFillOpacity, 1.0);
            if source == eStyleSVGOpacitySource_ContextFillOpacity as u8 {
                SVGOpacity::ContextFillOpacity
            } else {
                debug_assert_eq!(source, eStyleSVGOpacitySource_ContextStrokeOpacity as u8);
                SVGOpacity::ContextStrokeOpacity
            }
        }
    }


    #[allow(non_snake_case)]
    pub fn set_fill_rule(&mut self, v: longhands::fill_rule::computed_value::T) {
        self.gecko.mFillRule = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_fill_rule_from(&mut self, other: &Self) {
        self.gecko.mFillRule = other.gecko.mFillRule;
    }

    #[allow(non_snake_case)]
    pub fn reset_fill_rule(&mut self, other: &Self) {
        self.copy_fill_rule_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_fill_rule(&self) -> longhands::fill_rule::computed_value::T {
        From::from(self.gecko.mFillRule)
    }



    #[allow(non_snake_case)]
    pub fn set_shape_rendering(&mut self, v: longhands::shape_rendering::computed_value::T) {
        use crate::properties::longhands::shape_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_SHAPE_RENDERING_AUTO as u8,
                Keyword::Optimizespeed =>
                    structs::NS_STYLE_SHAPE_RENDERING_OPTIMIZESPEED as u8,
                Keyword::Crispedges =>
                    structs::NS_STYLE_SHAPE_RENDERING_CRISPEDGES as u8,
                Keyword::Geometricprecision =>
                    structs::NS_STYLE_SHAPE_RENDERING_GEOMETRICPRECISION as u8,
        };
        self.gecko.mShapeRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_rendering_from(&mut self, other: &Self) {
        self.gecko.mShapeRendering = other.gecko.mShapeRendering;
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_rendering(&mut self, other: &Self) {
        self.copy_shape_rendering_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_shape_rendering(&self) -> longhands::shape_rendering::computed_value::T {
        use crate::properties::longhands::shape_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_SHAPE_RENDERING_AUTO : u8 =
            structs::NS_STYLE_SHAPE_RENDERING_AUTO as u8;
        const U8_NS_STYLE_SHAPE_RENDERING_OPTIMIZESPEED : u8 =
            structs::NS_STYLE_SHAPE_RENDERING_OPTIMIZESPEED as u8;
        const U8_NS_STYLE_SHAPE_RENDERING_CRISPEDGES : u8 =
            structs::NS_STYLE_SHAPE_RENDERING_CRISPEDGES as u8;
        const U8_NS_STYLE_SHAPE_RENDERING_GEOMETRICPRECISION : u8 =
            structs::NS_STYLE_SHAPE_RENDERING_GEOMETRICPRECISION as u8;

        match self.gecko.mShapeRendering as u8 {
            U8_NS_STYLE_SHAPE_RENDERING_AUTO => Keyword::Auto,
            U8_NS_STYLE_SHAPE_RENDERING_OPTIMIZESPEED => Keyword::Optimizespeed,
            U8_NS_STYLE_SHAPE_RENDERING_CRISPEDGES => Keyword::Crispedges,
            U8_NS_STYLE_SHAPE_RENDERING_GEOMETRICPRECISION => Keyword::Geometricprecision,
            _ => panic!("Found unexpected value in style struct for shape_rendering property"),
        }
    }


    #[allow(non_snake_case)]
    pub fn set_stroke(&mut self, mut v: longhands::stroke::computed_value::T) {
        use crate::values::generics::svg::SVGPaintKind;
        use self::structs::nsStyleSVGPaintType;
        use self::structs::nsStyleSVGFallbackType;

        let ref mut paint = self.gecko.mStroke;
        unsafe {
            bindings::Gecko_nsStyleSVGPaint_Reset(paint);
        }
        let fallback = v.fallback.take();
        match v.kind {
            SVGPaintKind::None => return,
            SVGPaintKind::ContextFill => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_ContextFill;
            }
            SVGPaintKind::ContextStroke => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_ContextStroke;
            }
            SVGPaintKind::PaintServer(url) => {
                unsafe {
                    bindings::Gecko_nsStyleSVGPaint_SetURLValue(
                        paint,
                        url.url_value_ptr(),
                    )
                }
            }
            SVGPaintKind::Color(color) => {
                paint.mType = nsStyleSVGPaintType::eStyleSVGPaintType_Color;
                unsafe {
                    *paint.mPaint.mColor.as_mut() = color.into();
                }
            }
        }

        paint.mFallbackType = match fallback {
            Some(Either::First(color)) => {
                paint.mFallbackColor = color.into();
                nsStyleSVGFallbackType::eStyleSVGFallbackType_Color
            },
            Some(Either::Second(_)) => {
                nsStyleSVGFallbackType::eStyleSVGFallbackType_None
            },
            None => nsStyleSVGFallbackType::eStyleSVGFallbackType_NotSet
        };
    }

    #[allow(non_snake_case)]
    pub fn copy_stroke_from(&mut self, other: &Self) {
        unsafe {
            bindings::Gecko_nsStyleSVGPaint_CopyFrom(
                &mut self.gecko.mStroke,
                & other.gecko.mStroke
            );
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke(&mut self, other: &Self) {
        self.copy_stroke_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_stroke(&self) -> longhands::stroke::computed_value::T {
        use crate::values::computed::url::ComputedUrl;
        use crate::values::generics::svg::{SVGPaint, SVGPaintKind};
        use self::structs::nsStyleSVGPaintType;
        use self::structs::nsStyleSVGFallbackType;
        let ref paint = self.gecko.mStroke;

        let fallback = match paint.mFallbackType {
            nsStyleSVGFallbackType::eStyleSVGFallbackType_Color => {
                Some(Either::First(paint.mFallbackColor.into()))
            },
            nsStyleSVGFallbackType::eStyleSVGFallbackType_None => {
                Some(Either::Second(None_))
            },
            nsStyleSVGFallbackType::eStyleSVGFallbackType_NotSet => None,
        };

        let kind = match paint.mType {
            nsStyleSVGPaintType::eStyleSVGPaintType_None => SVGPaintKind::None,
            nsStyleSVGPaintType::eStyleSVGPaintType_ContextFill => SVGPaintKind::ContextFill,
            nsStyleSVGPaintType::eStyleSVGPaintType_ContextStroke => SVGPaintKind::ContextStroke,
            nsStyleSVGPaintType::eStyleSVGPaintType_Server => {
                SVGPaintKind::PaintServer(unsafe {
                    let url = RefPtr::new(*paint.mPaint.mPaintServer.as_ref());
                    ComputedUrl::from_url_value(url)
                })
            }
            nsStyleSVGPaintType::eStyleSVGPaintType_Color => {
                let col = unsafe { *paint.mPaint.mColor.as_ref() };
                SVGPaintKind::Color(col.into())
            }
        };
        SVGPaint {
            kind: kind,
            fallback: fallback,
        }
    }

    // When context-value is used on an SVG length, the corresponding flag is
    // set on mContextFlags, and the length field is set to the initial value.

    pub fn set_stroke_width(&mut self, v: longhands::stroke_width::computed_value::T) {
        use crate::values::generics::svg::{SVGLength, SvgLengthPercentageOrNumber};
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_WIDTH_CONTEXT as CONTEXT_VALUE;
        let length = match v {
            SVGLength::Length(length) => {
                self.gecko.mContextFlags &= !CONTEXT_VALUE;
                length
            }
            SVGLength::ContextValue => {
                self.gecko.mContextFlags |= CONTEXT_VALUE;
                match longhands::stroke_width::get_initial_value() {
                    SVGLength::Length(length) => length,
                    _ => unreachable!("Initial value should not be context-value"),
                }
            }
        };
        match length {
            SvgLengthPercentageOrNumber::LengthPercentage(lp) =>
                self.gecko.mStrokeWidth.set(lp),
            SvgLengthPercentageOrNumber::Number(num) =>
                self.gecko.mStrokeWidth.set_value(CoordDataValue::Factor(num.into())),
        }
    }

    pub fn copy_stroke_width_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_WIDTH_CONTEXT as CONTEXT_VALUE;
        self.gecko.mStrokeWidth.copy_from(&other.gecko.mStrokeWidth);
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !CONTEXT_VALUE) |
            (other.gecko.mContextFlags & CONTEXT_VALUE);
    }

    pub fn reset_stroke_width(&mut self, other: &Self) {
        self.copy_stroke_width_from(other)
    }

    pub fn clone_stroke_width(&self) -> longhands::stroke_width::computed_value::T {
        use crate::values::generics::svg::{SVGLength, SvgLengthPercentageOrNumber};
        use crate::values::computed::LengthPercentage;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_WIDTH_CONTEXT as CONTEXT_VALUE;
        if (self.gecko.mContextFlags & CONTEXT_VALUE) != 0 {
            return SVGLength::ContextValue;
        }
        let length = match self.gecko.mStrokeWidth.as_value() {
            CoordDataValue::Factor(number) => {
                SvgLengthPercentageOrNumber::Number(number)
            },
            CoordDataValue::Coord(coord) => {
                SvgLengthPercentageOrNumber::LengthPercentage(
                    LengthPercentage::new(Au(coord).into(), None)
                )
            },
            CoordDataValue::Percent(p) => {
                SvgLengthPercentageOrNumber::LengthPercentage(
                    LengthPercentage::new(Au(0).into(), Some(Percentage(p)))
                )
            },
            CoordDataValue::Calc(calc) => {
                SvgLengthPercentageOrNumber::LengthPercentage(calc.into())
            },
            _ => unreachable!("Unexpected coordinate in stroke_width"),
        };
        SVGLength::Length(length.into())
    }


    #[allow(non_snake_case)]
    pub fn set_stroke_linecap(&mut self, v: longhands::stroke_linecap::computed_value::T) {
        use crate::properties::longhands::stroke_linecap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Butt =>
                    structs::NS_STYLE_STROKE_LINECAP_BUTT as u8,
                Keyword::Round =>
                    structs::NS_STYLE_STROKE_LINECAP_ROUND as u8,
                Keyword::Square =>
                    structs::NS_STYLE_STROKE_LINECAP_SQUARE as u8,
        };
        self.gecko.mStrokeLinecap = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_linecap_from(&mut self, other: &Self) {
        self.gecko.mStrokeLinecap = other.gecko.mStrokeLinecap;
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_linecap(&mut self, other: &Self) {
        self.copy_stroke_linecap_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_stroke_linecap(&self) -> longhands::stroke_linecap::computed_value::T {
        use crate::properties::longhands::stroke_linecap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_STROKE_LINECAP_BUTT : u8 =
            structs::NS_STYLE_STROKE_LINECAP_BUTT as u8;
        const U8_NS_STYLE_STROKE_LINECAP_ROUND : u8 =
            structs::NS_STYLE_STROKE_LINECAP_ROUND as u8;
        const U8_NS_STYLE_STROKE_LINECAP_SQUARE : u8 =
            structs::NS_STYLE_STROKE_LINECAP_SQUARE as u8;

        match self.gecko.mStrokeLinecap as u8 {
            U8_NS_STYLE_STROKE_LINECAP_BUTT => Keyword::Butt,
            U8_NS_STYLE_STROKE_LINECAP_ROUND => Keyword::Round,
            U8_NS_STYLE_STROKE_LINECAP_SQUARE => Keyword::Square,
            _ => panic!("Found unexpected value in style struct for stroke_linecap property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_linejoin(&mut self, v: longhands::stroke_linejoin::computed_value::T) {
        use crate::properties::longhands::stroke_linejoin::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Miter =>
                    structs::NS_STYLE_STROKE_LINEJOIN_MITER as u8,
                Keyword::Round =>
                    structs::NS_STYLE_STROKE_LINEJOIN_ROUND as u8,
                Keyword::Bevel =>
                    structs::NS_STYLE_STROKE_LINEJOIN_BEVEL as u8,
        };
        self.gecko.mStrokeLinejoin = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_linejoin_from(&mut self, other: &Self) {
        self.gecko.mStrokeLinejoin = other.gecko.mStrokeLinejoin;
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_linejoin(&mut self, other: &Self) {
        self.copy_stroke_linejoin_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_stroke_linejoin(&self) -> longhands::stroke_linejoin::computed_value::T {
        use crate::properties::longhands::stroke_linejoin::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_STROKE_LINEJOIN_MITER : u8 =
            structs::NS_STYLE_STROKE_LINEJOIN_MITER as u8;
        const U8_NS_STYLE_STROKE_LINEJOIN_ROUND : u8 =
            structs::NS_STYLE_STROKE_LINEJOIN_ROUND as u8;
        const U8_NS_STYLE_STROKE_LINEJOIN_BEVEL : u8 =
            structs::NS_STYLE_STROKE_LINEJOIN_BEVEL as u8;

        match self.gecko.mStrokeLinejoin as u8 {
            U8_NS_STYLE_STROKE_LINEJOIN_MITER => Keyword::Miter,
            U8_NS_STYLE_STROKE_LINEJOIN_ROUND => Keyword::Round,
            U8_NS_STYLE_STROKE_LINEJOIN_BEVEL => Keyword::Bevel,
            _ => panic!("Found unexpected value in style struct for stroke_linejoin property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_miterlimit(&mut self, v: longhands::stroke_miterlimit::computed_value::T) {
        self.gecko.mStrokeMiterlimit = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_miterlimit_from(&mut self, other: &Self) {
        self.gecko.mStrokeMiterlimit = other.gecko.mStrokeMiterlimit;
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_miterlimit(&mut self, other: &Self) {
        self.copy_stroke_miterlimit_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_miterlimit(&self) -> longhands::stroke_miterlimit::computed_value::T {
        From::from(self.gecko.mStrokeMiterlimit)
    }


    

    pub fn set_stroke_opacity(&mut self, v: longhands::stroke_opacity::computed_value::T) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_MASK as MASK;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_SHIFT as SHIFT;
        use crate::gecko_bindings::structs::nsStyleSVGOpacitySource::*;
        use crate::values::generics::svg::SVGOpacity;
        self.gecko.mContextFlags &= !MASK;
        match v {
            SVGOpacity::Opacity(opacity) => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_Normal as u8) << SHIFT;
                self.gecko.mStrokeOpacity = opacity;
            }
            SVGOpacity::ContextFillOpacity => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_ContextFillOpacity as u8) << SHIFT;
                self.gecko.mStrokeOpacity = 1.;
            }
            SVGOpacity::ContextStrokeOpacity => {
                self.gecko.mContextFlags |=
                    (eStyleSVGOpacitySource_ContextStrokeOpacity as u8) << SHIFT;
                self.gecko.mStrokeOpacity = 1.;
            }
        }
    }

    pub fn copy_stroke_opacity_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_MASK as MASK;
        self.gecko.mStrokeOpacity = other.gecko.mStrokeOpacity;
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !MASK) |
            (other.gecko.mContextFlags & MASK);
    }

    pub fn reset_stroke_opacity(&mut self, other: &Self) {
        self.copy_stroke_opacity_from(other)
    }

    pub fn clone_stroke_opacity(&self) -> longhands::stroke_opacity::computed_value::T {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_MASK as MASK;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_OPACITY_SOURCE_SHIFT as SHIFT;
        use crate::gecko_bindings::structs::nsStyleSVGOpacitySource::*;
        use crate::values::generics::svg::SVGOpacity;

        let source = (self.gecko.mContextFlags & MASK) >> SHIFT;
        if source == eStyleSVGOpacitySource_Normal as u8 {
            return SVGOpacity::Opacity(self.gecko.mStrokeOpacity);
        } else {
            debug_assert_eq!(self.gecko.mStrokeOpacity, 1.0);
            if source == eStyleSVGOpacitySource_ContextFillOpacity as u8 {
                SVGOpacity::ContextFillOpacity
            } else {
                debug_assert_eq!(source, eStyleSVGOpacitySource_ContextStrokeOpacity as u8);
                SVGOpacity::ContextStrokeOpacity
            }
        }
    }

    // When context-value is used on an SVG length, the corresponding flag is
    // set on mContextFlags, and the length field is set to the initial value.

    pub fn set_stroke_dashoffset(&mut self, v: longhands::stroke_dashoffset::computed_value::T) {
        use crate::values::generics::svg::{SVGLength, SvgLengthPercentageOrNumber};
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHOFFSET_CONTEXT as CONTEXT_VALUE;
        let length = match v {
            SVGLength::Length(length) => {
                self.gecko.mContextFlags &= !CONTEXT_VALUE;
                length
            }
            SVGLength::ContextValue => {
                self.gecko.mContextFlags |= CONTEXT_VALUE;
                match longhands::stroke_dashoffset::get_initial_value() {
                    SVGLength::Length(length) => length,
                    _ => unreachable!("Initial value should not be context-value"),
                }
            }
        };
        match length {
            SvgLengthPercentageOrNumber::LengthPercentage(lp) =>
                self.gecko.mStrokeDashoffset.set(lp),
            SvgLengthPercentageOrNumber::Number(num) =>
                self.gecko.mStrokeDashoffset.set_value(CoordDataValue::Factor(num.into())),
        }
    }

    pub fn copy_stroke_dashoffset_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHOFFSET_CONTEXT as CONTEXT_VALUE;
        self.gecko.mStrokeDashoffset.copy_from(&other.gecko.mStrokeDashoffset);
        self.gecko.mContextFlags =
            (self.gecko.mContextFlags & !CONTEXT_VALUE) |
            (other.gecko.mContextFlags & CONTEXT_VALUE);
    }

    pub fn reset_stroke_dashoffset(&mut self, other: &Self) {
        self.copy_stroke_dashoffset_from(other)
    }

    pub fn clone_stroke_dashoffset(&self) -> longhands::stroke_dashoffset::computed_value::T {
        use crate::values::generics::svg::{SVGLength, SvgLengthPercentageOrNumber};
        use crate::values::computed::LengthPercentage;
        use crate::gecko_bindings::structs::nsStyleSVG_STROKE_DASHOFFSET_CONTEXT as CONTEXT_VALUE;
        if (self.gecko.mContextFlags & CONTEXT_VALUE) != 0 {
            return SVGLength::ContextValue;
        }
        let length = match self.gecko.mStrokeDashoffset.as_value() {
            CoordDataValue::Factor(number) => {
                SvgLengthPercentageOrNumber::Number(number)
            },
            CoordDataValue::Coord(coord) => {
                SvgLengthPercentageOrNumber::LengthPercentage(
                    LengthPercentage::new(Au(coord).into(), None)
                )
            },
            CoordDataValue::Percent(p) => {
                SvgLengthPercentageOrNumber::LengthPercentage(
                    LengthPercentage::new(Au(0).into(), Some(Percentage(p)))
                )
            },
            CoordDataValue::Calc(calc) => {
                SvgLengthPercentageOrNumber::LengthPercentage(calc.into())
            },
            _ => unreachable!("Unexpected coordinate in stroke_dashoffset"),
        };
        SVGLength::Length(length.into())
    }


    #[allow(non_snake_case)]
    pub fn set_clip_rule(&mut self, v: longhands::clip_rule::computed_value::T) {
        self.gecko.mClipRule = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_clip_rule_from(&mut self, other: &Self) {
        self.gecko.mClipRule = other.gecko.mClipRule;
    }

    #[allow(non_snake_case)]
    pub fn reset_clip_rule(&mut self, other: &Self) {
        self.copy_clip_rule_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clip_rule(&self) -> longhands::clip_rule::computed_value::T {
        From::from(self.gecko.mClipRule)
    }


    #[allow(non_snake_case)]
    pub fn set_marker_start(&mut self, v: longhands::marker_start::computed_value::T) {
        match v {
            UrlOrNone::Url(ref url) => {
                self.gecko.mMarkerStart.set_move(url.0.url_value.clone())
            }
            UrlOrNone::None => {
                unsafe {
                    self.gecko.mMarkerStart.clear();
                }
            }
        }
    }
    #[allow(non_snake_case)]
    pub fn copy_marker_start_from(&mut self, other: &Self) {
        unsafe {
            self.gecko.mMarkerStart.set(&other.gecko.mMarkerStart);
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_marker_start(&mut self, other: &Self) {
        self.copy_marker_start_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_marker_start(&self) -> longhands::marker_start::computed_value::T {
        use crate::values::computed::url::ComputedUrl;

        if self.gecko.mMarkerStart.mRawPtr.is_null() {
            return UrlOrNone::none()
        }

        UrlOrNone::Url(unsafe {
            ComputedUrl::from_url_value(self.gecko.mMarkerStart.to_safe())
        })
    }

    #[allow(non_snake_case)]
    pub fn set_marker_mid(&mut self, v: longhands::marker_mid::computed_value::T) {
        match v {
            UrlOrNone::Url(ref url) => {
                self.gecko.mMarkerMid.set_move(url.0.url_value.clone())
            }
            UrlOrNone::None => {
                unsafe {
                    self.gecko.mMarkerMid.clear();
                }
            }
        }
    }
    #[allow(non_snake_case)]
    pub fn copy_marker_mid_from(&mut self, other: &Self) {
        unsafe {
            self.gecko.mMarkerMid.set(&other.gecko.mMarkerMid);
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_marker_mid(&mut self, other: &Self) {
        self.copy_marker_mid_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_marker_mid(&self) -> longhands::marker_mid::computed_value::T {
        use crate::values::computed::url::ComputedUrl;

        if self.gecko.mMarkerMid.mRawPtr.is_null() {
            return UrlOrNone::none()
        }

        UrlOrNone::Url(unsafe {
            ComputedUrl::from_url_value(self.gecko.mMarkerMid.to_safe())
        })
    }

    #[allow(non_snake_case)]
    pub fn set_marker_end(&mut self, v: longhands::marker_end::computed_value::T) {
        match v {
            UrlOrNone::Url(ref url) => {
                self.gecko.mMarkerEnd.set_move(url.0.url_value.clone())
            }
            UrlOrNone::None => {
                unsafe {
                    self.gecko.mMarkerEnd.clear();
                }
            }
        }
    }
    #[allow(non_snake_case)]
    pub fn copy_marker_end_from(&mut self, other: &Self) {
        unsafe {
            self.gecko.mMarkerEnd.set(&other.gecko.mMarkerEnd);
        }
    }
    #[allow(non_snake_case)]
    pub fn reset_marker_end(&mut self, other: &Self) {
        self.copy_marker_end_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_marker_end(&self) -> longhands::marker_end::computed_value::T {
        use crate::values::computed::url::ComputedUrl;

        if self.gecko.mMarkerEnd.mRawPtr.is_null() {
            return UrlOrNone::none()
        }

        UrlOrNone::Url(unsafe {
            ComputedUrl::from_url_value(self.gecko.mMarkerEnd.to_safe())
        })
    }

}




impl GeckoColor {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_color(&mut self, v: longhands::color::computed_value::T) {
        let result = convert_rgba_to_nscolor(&v);
        self.gecko.mColor = result;
    }

    
    #[allow(non_snake_case)]
    pub fn copy_color_from(&mut self, other: &Self) {
        self.gecko.mColor = other.gecko.mColor;
    }

    #[allow(non_snake_case)]
    pub fn reset_color(&mut self, other: &Self) {
        self.copy_color_from(other)
    }


    pub fn clone_color(&self) -> longhands::color::computed_value::T {
        let color = self.gecko.mColor as u32;
        convert_nscolor_to_rgba(color)
    }


    /*
     * Auto-Generated Methods.
     */
    
}




impl GeckoInheritedUI {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_cursor(&mut self, v: longhands::cursor::computed_value::T) {
        self.gecko.mCursor = v.keyword;
        unsafe {
            Gecko_SetCursorArrayLength(&mut self.gecko, v.images.len());
        }
        for i in 0..v.images.len() {
            unsafe {
                Gecko_SetCursorImageValue(
                    &mut self.gecko.mCursorImages[i],
                    v.images[i].url.url_value_ptr(),
                );
            }

            match v.images[i].hotspot {
                Some((x, y)) => {
                    self.gecko.mCursorImages[i].mHaveHotspot = true;
                    self.gecko.mCursorImages[i].mHotspotX = x;
                    self.gecko.mCursorImages[i].mHotspotY = y;
                },
                _ => {
                    self.gecko.mCursorImages[i].mHaveHotspot = false;
                }
            }
        }
    }

    pub fn copy_cursor_from(&mut self, other: &Self) {
        self.gecko.mCursor = other.gecko.mCursor;
        unsafe {
            Gecko_CopyCursorArrayFrom(&mut self.gecko, &other.gecko);
        }
    }

    pub fn reset_cursor(&mut self, other: &Self) {
        self.copy_cursor_from(other)
    }

    pub fn clone_cursor(&self) -> longhands::cursor::computed_value::T {
        use crate::values::computed::ui::CursorImage;
        use crate::values::computed::url::ComputedImageUrl;

        let keyword = self.gecko.mCursor;

        let images = self.gecko.mCursorImages.iter().map(|gecko_cursor_image| {
            let url = unsafe {
                let gecko_image_request = gecko_cursor_image.mImage.mRawPtr.as_ref().unwrap();
                ComputedImageUrl::from_image_request(&gecko_image_request)
            };

            let hotspot =
                if gecko_cursor_image.mHaveHotspot {
                    Some((gecko_cursor_image.mHotspotX, gecko_cursor_image.mHotspotY))
                } else {
                    None
                };

            CursorImage { url, hotspot }
        }).collect::<Vec<_>>().into_boxed_slice();

        longhands::cursor::computed_value::T { images, keyword }
    }

    pub fn set_scrollbar_color(&mut self, v: longhands::scrollbar_color::computed_value::T) {
        use crate::gecko_bindings::structs::StyleComplexColor;
        use crate::values::generics::ui::ScrollbarColor;
        match v {
            ScrollbarColor::Auto => {
                self.gecko.mScrollbarFaceColor = StyleComplexColor::auto();
                self.gecko.mScrollbarTrackColor = StyleComplexColor::auto();
            }
            ScrollbarColor::Colors { thumb, track } => {
                self.gecko.mScrollbarFaceColor = thumb.into();
                self.gecko.mScrollbarTrackColor = track.into();
            }
        }
    }

    pub fn copy_scrollbar_color_from(&mut self, other: &Self) {
        self.gecko.mScrollbarFaceColor = other.gecko.mScrollbarFaceColor;
        self.gecko.mScrollbarTrackColor = other.gecko.mScrollbarTrackColor;
    }

    pub fn reset_scrollbar_color(&mut self, other: &Self) {
        self.copy_scrollbar_color_from(other);
    }

    pub fn clone_scrollbar_color(&self) -> longhands::scrollbar_color::computed_value::T {
        use crate::gecko_bindings::structs::StyleComplexColor_Tag as Tag;
        use crate::values::generics::ui::ScrollbarColor;
        debug_assert!(
            (self.gecko.mScrollbarFaceColor.mTag == Tag::eAuto) ==
            (self.gecko.mScrollbarTrackColor.mTag == Tag::eAuto),
            "Whether the two colors are `auto` should match",
        );
        if self.gecko.mScrollbarFaceColor.mTag == Tag::eAuto {
            ScrollbarColor::Auto
        } else {
            ScrollbarColor::Colors {
                thumb: self.gecko.mScrollbarFaceColor.into(),
                track: self.gecko.mScrollbarTrackColor.into(),
            }
        }
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_pointer_events(&mut self, v: longhands::pointer_events::computed_value::T) {
        use crate::properties::longhands::pointer_events::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_POINTER_EVENTS_AUTO as u8,
                Keyword::None =>
                    structs::NS_STYLE_POINTER_EVENTS_NONE as u8,
                Keyword::Visiblepainted =>
                    structs::NS_STYLE_POINTER_EVENTS_VISIBLEPAINTED as u8,
                Keyword::Visiblefill =>
                    structs::NS_STYLE_POINTER_EVENTS_VISIBLEFILL as u8,
                Keyword::Visiblestroke =>
                    structs::NS_STYLE_POINTER_EVENTS_VISIBLESTROKE as u8,
                Keyword::Visible =>
                    structs::NS_STYLE_POINTER_EVENTS_VISIBLE as u8,
                Keyword::Painted =>
                    structs::NS_STYLE_POINTER_EVENTS_PAINTED as u8,
                Keyword::Fill =>
                    structs::NS_STYLE_POINTER_EVENTS_FILL as u8,
                Keyword::Stroke =>
                    structs::NS_STYLE_POINTER_EVENTS_STROKE as u8,
                Keyword::All =>
                    structs::NS_STYLE_POINTER_EVENTS_ALL as u8,
        };
        self.gecko.mPointerEvents = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_pointer_events_from(&mut self, other: &Self) {
        self.gecko.mPointerEvents = other.gecko.mPointerEvents;
    }

    #[allow(non_snake_case)]
    pub fn reset_pointer_events(&mut self, other: &Self) {
        self.copy_pointer_events_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_pointer_events(&self) -> longhands::pointer_events::computed_value::T {
        use crate::properties::longhands::pointer_events::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_POINTER_EVENTS_AUTO : u8 =
            structs::NS_STYLE_POINTER_EVENTS_AUTO as u8;
        const U8_NS_STYLE_POINTER_EVENTS_NONE : u8 =
            structs::NS_STYLE_POINTER_EVENTS_NONE as u8;
        const U8_NS_STYLE_POINTER_EVENTS_VISIBLEPAINTED : u8 =
            structs::NS_STYLE_POINTER_EVENTS_VISIBLEPAINTED as u8;
        const U8_NS_STYLE_POINTER_EVENTS_VISIBLEFILL : u8 =
            structs::NS_STYLE_POINTER_EVENTS_VISIBLEFILL as u8;
        const U8_NS_STYLE_POINTER_EVENTS_VISIBLESTROKE : u8 =
            structs::NS_STYLE_POINTER_EVENTS_VISIBLESTROKE as u8;
        const U8_NS_STYLE_POINTER_EVENTS_VISIBLE : u8 =
            structs::NS_STYLE_POINTER_EVENTS_VISIBLE as u8;
        const U8_NS_STYLE_POINTER_EVENTS_PAINTED : u8 =
            structs::NS_STYLE_POINTER_EVENTS_PAINTED as u8;
        const U8_NS_STYLE_POINTER_EVENTS_FILL : u8 =
            structs::NS_STYLE_POINTER_EVENTS_FILL as u8;
        const U8_NS_STYLE_POINTER_EVENTS_STROKE : u8 =
            structs::NS_STYLE_POINTER_EVENTS_STROKE as u8;
        const U8_NS_STYLE_POINTER_EVENTS_ALL : u8 =
            structs::NS_STYLE_POINTER_EVENTS_ALL as u8;

        match self.gecko.mPointerEvents as u8 {
            U8_NS_STYLE_POINTER_EVENTS_AUTO => Keyword::Auto,
            U8_NS_STYLE_POINTER_EVENTS_NONE => Keyword::None,
            U8_NS_STYLE_POINTER_EVENTS_VISIBLEPAINTED => Keyword::Visiblepainted,
            U8_NS_STYLE_POINTER_EVENTS_VISIBLEFILL => Keyword::Visiblefill,
            U8_NS_STYLE_POINTER_EVENTS_VISIBLESTROKE => Keyword::Visiblestroke,
            U8_NS_STYLE_POINTER_EVENTS_VISIBLE => Keyword::Visible,
            U8_NS_STYLE_POINTER_EVENTS_PAINTED => Keyword::Painted,
            U8_NS_STYLE_POINTER_EVENTS_FILL => Keyword::Fill,
            U8_NS_STYLE_POINTER_EVENTS_STROKE => Keyword::Stroke,
            U8_NS_STYLE_POINTER_EVENTS_ALL => Keyword::All,
            _ => panic!("Found unexpected value in style struct for pointer_events property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_input(&mut self, v: longhands::_moz_user_input::computed_value::T) {
        use crate::properties::longhands::_moz_user_input::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleUserInput::Auto ,
                Keyword::None =>
                    structs::StyleUserInput::None ,
        };
        self.gecko.mUserInput = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_input_from(&mut self, other: &Self) {
        self.gecko.mUserInput = other.gecko.mUserInput;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_input(&mut self, other: &Self) {
        self.copy__moz_user_input_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_user_input(&self) -> longhands::_moz_user_input::computed_value::T {
        use crate::properties::longhands::_moz_user_input::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mUserInput {
            structs::StyleUserInput::Auto => Keyword::Auto,
            structs::StyleUserInput::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_modify(&mut self, v: longhands::_moz_user_modify::computed_value::T) {
        use crate::properties::longhands::_moz_user_modify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ReadOnly =>
                    structs::StyleUserModify::ReadOnly ,
                Keyword::ReadWrite =>
                    structs::StyleUserModify::ReadWrite ,
                Keyword::WriteOnly =>
                    structs::StyleUserModify::WriteOnly ,
        };
        self.gecko.mUserModify = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_modify_from(&mut self, other: &Self) {
        self.gecko.mUserModify = other.gecko.mUserModify;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_modify(&mut self, other: &Self) {
        self.copy__moz_user_modify_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_user_modify(&self) -> longhands::_moz_user_modify::computed_value::T {
        use crate::properties::longhands::_moz_user_modify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mUserModify {
            structs::StyleUserModify::ReadOnly => Keyword::ReadOnly,
            structs::StyleUserModify::ReadWrite => Keyword::ReadWrite,
            structs::StyleUserModify::WriteOnly => Keyword::WriteOnly,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_focus(&mut self, v: longhands::_moz_user_focus::computed_value::T) {
        use crate::properties::longhands::_moz_user_focus::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleUserFocus::None ,
                Keyword::Ignore =>
                    structs::StyleUserFocus::Ignore ,
                Keyword::Normal =>
                    structs::StyleUserFocus::Normal ,
                Keyword::SelectAfter =>
                    structs::StyleUserFocus::SelectAfter ,
                Keyword::SelectBefore =>
                    structs::StyleUserFocus::SelectBefore ,
                Keyword::SelectMenu =>
                    structs::StyleUserFocus::SelectMenu ,
                Keyword::SelectSame =>
                    structs::StyleUserFocus::SelectSame ,
                Keyword::SelectAll =>
                    structs::StyleUserFocus::SelectAll ,
        };
        self.gecko.mUserFocus = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_focus_from(&mut self, other: &Self) {
        self.gecko.mUserFocus = other.gecko.mUserFocus;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_focus(&mut self, other: &Self) {
        self.copy__moz_user_focus_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_user_focus(&self) -> longhands::_moz_user_focus::computed_value::T {
        use crate::properties::longhands::_moz_user_focus::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mUserFocus {
            structs::StyleUserFocus::None => Keyword::None,
            structs::StyleUserFocus::Ignore => Keyword::Ignore,
            structs::StyleUserFocus::Normal => Keyword::Normal,
            structs::StyleUserFocus::SelectAfter => Keyword::SelectAfter,
            structs::StyleUserFocus::SelectBefore => Keyword::SelectBefore,
            structs::StyleUserFocus::SelectMenu => Keyword::SelectMenu,
            structs::StyleUserFocus::SelectSame => Keyword::SelectSame,
            structs::StyleUserFocus::SelectAll => Keyword::SelectAll,
        }
    }



    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_caret_color(&mut self, v: longhands::caret_color::computed_value::T) {
        self.gecko.mCaretColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_caret_color_from(&mut self, other: &Self) {
        let color = other.gecko.mCaretColor;
        self.gecko.mCaretColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_caret_color(&mut self, other: &Self) {
        self.copy_caret_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_caret_color(&self) -> longhands::caret_color::computed_value::T {
        self.gecko.mCaretColor.into()
    }


}




impl GeckoColumn {
    /*
     * Manually-Implemented Methods.
     */
    

    #[allow(unused_unsafe)]
    pub fn set_column_count(&mut self, v: longhands::column_count::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleColumn_kColumnCountAuto, nsStyleColumn_kMaxColumnCount};

        self.gecko.mColumnCount = match v {
            ColumnCount::Integer(integer) => {
                cmp::min(integer.0 as u32, unsafe { nsStyleColumn_kMaxColumnCount })
            },
            ColumnCount::Auto => nsStyleColumn_kColumnCountAuto
        };
    }

    
    #[allow(non_snake_case)]
    pub fn copy_column_count_from(&mut self, other: &Self) {
        self.gecko.mColumnCount = other.gecko.mColumnCount;
    }

    #[allow(non_snake_case)]
    pub fn reset_column_count(&mut self, other: &Self) {
        self.copy_column_count_from(other)
    }


    pub fn clone_column_count(&self) -> longhands::column_count::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleColumn_kColumnCountAuto, nsStyleColumn_kMaxColumnCount};
        if self.gecko.mColumnCount != nsStyleColumn_kColumnCountAuto {
            debug_assert!(self.gecko.mColumnCount >= 1 &&
                          self.gecko.mColumnCount <= nsStyleColumn_kMaxColumnCount);
            ColumnCount::Integer((self.gecko.mColumnCount as i32).into())
        } else {
            ColumnCount::Auto
        }
    }

    
    #[allow(non_snake_case)]
    pub fn set_column_rule_width(&mut self, v: longhands::column_rule_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mColumnRuleWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_column_rule_width_from(&mut self, other: &Self) {
        self.gecko.mColumnRuleWidth = other.gecko.mColumnRuleWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_width(&mut self, other: &Self) {
        self.copy_column_rule_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_column_rule_width(&self) -> longhands::column_rule_width::computed_value::T {
        Au(self.gecko.mColumnRuleWidth).into()
    }

    

    #[allow(non_snake_case)]
    pub fn set_column_rule_style(&mut self, v: longhands::column_rule_style::computed_value::T) {
        self.gecko.mColumnRuleStyle = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_rule_style_from(&mut self, other: &Self) {
        self.gecko.mColumnRuleStyle = other.gecko.mColumnRuleStyle;
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_style(&mut self, other: &Self) {
        self.copy_column_rule_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_rule_style(&self) -> longhands::column_rule_style::computed_value::T {
        From::from(self.gecko.mColumnRuleStyle)
    }




    /*
     * Auto-Generated Methods.
     */
    
    #[allow(non_snake_case)]
    pub fn set_column_width(&mut self, v: longhands::column_width::computed_value::T) {
        v.to_gecko_style_coord(&mut self.gecko.mColumnWidth);
    }
    #[allow(non_snake_case)]
    pub fn copy_column_width_from(&mut self, other: &Self) {
        self.gecko.mColumnWidth.copy_from(&other.gecko.mColumnWidth);
    }
    #[allow(non_snake_case)]
    pub fn reset_column_width(&mut self, other: &Self) {
        self.copy_column_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_column_width(&self) -> longhands::column_width::computed_value::T {
        use crate::properties::longhands::column_width::computed_value::T;
        T::from_gecko_style_coord(&self.gecko.mColumnWidth)
            .expect("clone for column_width failed")
    }


    #[allow(non_snake_case)]
    pub fn set_column_fill(&mut self, v: longhands::column_fill::computed_value::T) {
        use crate::properties::longhands::column_fill::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Balance =>
                    structs::StyleColumnFill::Balance ,
                Keyword::Auto =>
                    structs::StyleColumnFill::Auto ,
        };
        self.gecko.mColumnFill = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_column_fill_from(&mut self, other: &Self) {
        self.gecko.mColumnFill = other.gecko.mColumnFill;
    }

    #[allow(non_snake_case)]
    pub fn reset_column_fill(&mut self, other: &Self) {
        self.copy_column_fill_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_column_fill(&self) -> longhands::column_fill::computed_value::T {
        use crate::properties::longhands::column_fill::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColumnFill {
            structs::StyleColumnFill::Balance => Keyword::Balance,
            structs::StyleColumnFill::Auto => Keyword::Auto,
        }
    }



    #[allow(unreachable_code)]
    #[allow(non_snake_case)]
    pub fn set_column_rule_color(&mut self, v: longhands::column_rule_color::computed_value::T) {
        self.gecko.mColumnRuleColor = v.into();
    }


    #[allow(non_snake_case)]
    pub fn copy_column_rule_color_from(&mut self, other: &Self) {
        let color = other.gecko.mColumnRuleColor;
        self.gecko.mColumnRuleColor = color;;
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_color(&mut self, other: &Self) {
        self.copy_column_rule_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_rule_color(&self) -> longhands::column_rule_color::computed_value::T {
        self.gecko.mColumnRuleColor.into()
    }



    #[allow(non_snake_case)]
    pub fn set_column_span(&mut self, v: longhands::column_span::computed_value::T) {
        use crate::properties::longhands::column_span::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleColumnSpan::None ,
                Keyword::All =>
                    structs::StyleColumnSpan::All ,
        };
        self.gecko.mColumnSpan = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_column_span_from(&mut self, other: &Self) {
        self.gecko.mColumnSpan = other.gecko.mColumnSpan;
    }

    #[allow(non_snake_case)]
    pub fn reset_column_span(&mut self, other: &Self) {
        self.copy_column_span_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_column_span(&self) -> longhands::column_span::computed_value::T {
        use crate::properties::longhands::column_span::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColumnSpan {
            structs::StyleColumnSpan::None => Keyword::None,
            structs::StyleColumnSpan::All => Keyword::All,
        }
    }


}




impl GeckoCounters {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn ineffective_content_property(&self) -> bool {
        self.gecko.mContents.is_empty()
    }

    pub fn set_content(&mut self, v: longhands::content::computed_value::T, device: &Device) {
        use crate::values::CustomIdent;
        use crate::values::generics::counters::{Content, ContentItem};
        use crate::values::generics::CounterStyleOrNone;
        use crate::gecko_bindings::structs::nsStyleContentData;
        use crate::gecko_bindings::structs::nsStyleContentAttr;
        use crate::gecko_bindings::structs::StyleContentType;
        use crate::gecko_bindings::bindings::Gecko_ClearAndResizeStyleContents;

        // Converts a string as utf16, and returns an owned, zero-terminated raw buffer.
        fn as_utf16_and_forget(s: &str) -> *mut u16 {
            use std::mem;
            let mut vec = s.encode_utf16().collect::<Vec<_>>();
            vec.push(0u16);
            let ptr = vec.as_mut_ptr();
            mem::forget(vec);
            ptr
        }

        fn set_counter_function(
            data: &mut nsStyleContentData,
            content_type: StyleContentType,
            name: &CustomIdent,
            sep: &str,
            style: CounterStyleOrNone,
            device: &Device,
        ) {
            debug_assert!(content_type == StyleContentType::Counter ||
                          content_type == StyleContentType::Counters);
            let counter_func = unsafe {
                bindings::Gecko_SetCounterFunction(data, content_type).as_mut().unwrap()
            };
            counter_func.mIdent.assign(name.0.as_slice());
            if content_type == StyleContentType::Counters {
                counter_func.mSeparator.assign_str(sep);
            }
            style.to_gecko_value(&mut counter_func.mCounterStyle, device);
        }

        match v {
            Content::None |
            Content::Normal => {
                // Ensure destructors run, otherwise we could leak.
                if !self.gecko.mContents.is_empty() {
                    unsafe {
                        Gecko_ClearAndResizeStyleContents(&mut self.gecko, 0);
                    }
                }
            },
            Content::MozAltContent => {
                unsafe {
                    Gecko_ClearAndResizeStyleContents(&mut self.gecko, 1);
                    *self.gecko.mContents[0].mContent.mString.as_mut() = ptr::null_mut();
                }
                self.gecko.mContents[0].mType = StyleContentType::AltContent;
            },
            Content::Items(items) => {
                unsafe {
                    Gecko_ClearAndResizeStyleContents(&mut self.gecko,
                                                      items.len() as u32);
                }
                for (i, item) in items.into_iter().enumerate() {
                    // NB: Gecko compares the mString value if type is not image
                    // or URI independently of whatever gets there. In the quote
                    // cases, they set it to null, so do the same here.
                    unsafe {
                        *self.gecko.mContents[i].mContent.mString.as_mut() = ptr::null_mut();
                    }
                    match *item {
                        ContentItem::String(ref value) => {
                            self.gecko.mContents[i].mType = StyleContentType::String;
                            unsafe {
                                // NB: we share allocators, so doing this is fine.
                                *self.gecko.mContents[i].mContent.mString.as_mut() =
                                    as_utf16_and_forget(&value);
                            }
                        }
                        ContentItem::Attr(ref attr) => {
                            self.gecko.mContents[i].mType = StyleContentType::Attr;
                            unsafe {
                                // NB: we share allocators, so doing this is fine.
                                let maybe_ns = attr.namespace.clone();
                                let attr_struct = Box::new(nsStyleContentAttr {
                                    mName: structs::RefPtr {
                                        mRawPtr: attr.attribute.clone().into_addrefed(),
                                        _phantom_0: PhantomData,
                                    },
                                    mNamespaceURL: structs::RefPtr {
                                        mRawPtr: maybe_ns.map_or(ptr::null_mut(), |x| (x.1).0.into_addrefed()),
                                        _phantom_0: PhantomData,
                                    },
                                });
                                *self.gecko.mContents[i].mContent.mAttr.as_mut() =
                                    Box::into_raw(attr_struct);
                            }
                        }
                        ContentItem::OpenQuote
                            => self.gecko.mContents[i].mType = StyleContentType::OpenQuote,
                        ContentItem::CloseQuote
                            => self.gecko.mContents[i].mType = StyleContentType::CloseQuote,
                        ContentItem::NoOpenQuote
                            => self.gecko.mContents[i].mType = StyleContentType::NoOpenQuote,
                        ContentItem::NoCloseQuote
                            => self.gecko.mContents[i].mType = StyleContentType::NoCloseQuote,
                        ContentItem::Counter(ref name, ref style) => {
                            set_counter_function(
                                &mut self.gecko.mContents[i],
                                StyleContentType::Counter,
                                &name,
                                "",
                                style.clone(),
                                device,
                            );
                        }
                        ContentItem::Counters(ref name, ref sep, ref style) => {
                            set_counter_function(
                                &mut self.gecko.mContents[i],
                                StyleContentType::Counters,
                                &name,
                                &sep,
                                style.clone(),
                                device,
                            );
                        }
                        ContentItem::Url(ref url) => {
                            unsafe {
                                bindings::Gecko_SetContentDataImageValue(
                                    &mut self.gecko.mContents[i],
                                    url.url_value_ptr(),
                                )
                            }
                        }
                    }
                }
            }
        }
    }

    pub fn copy_content_from(&mut self, other: &Self) {
        use crate::gecko_bindings::bindings::Gecko_CopyStyleContentsFrom;
        unsafe {
            Gecko_CopyStyleContentsFrom(&mut self.gecko, &other.gecko)
        }
    }

    pub fn reset_content(&mut self, other: &Self) {
        self.copy_content_from(other)
    }

    pub fn clone_content(&self) -> longhands::content::computed_value::T {
        use {Atom, Namespace};
        use crate::gecko::conversions::string_from_chars_pointer;
        use crate::gecko_bindings::structs::StyleContentType;
        use crate::values::generics::counters::{Content, ContentItem};
        use crate::values::computed::url::ComputedImageUrl;
        use crate::values::{CustomIdent, Either};
        use crate::values::generics::CounterStyleOrNone;
        use crate::values::specified::Attr;

        if self.gecko.mContents.is_empty() {
            return Content::None;
        }

        if self.gecko.mContents.len() == 1 &&
           self.gecko.mContents[0].mType == StyleContentType::AltContent {
            return Content::MozAltContent;
        }

        Content::Items(
            self.gecko.mContents.iter().map(|gecko_content| {
                match gecko_content.mType {
                    StyleContentType::OpenQuote => ContentItem::OpenQuote,
                    StyleContentType::CloseQuote => ContentItem::CloseQuote,
                    StyleContentType::NoOpenQuote => ContentItem::NoOpenQuote,
                    StyleContentType::NoCloseQuote => ContentItem::NoCloseQuote,
                    StyleContentType::String => {
                        let gecko_chars = unsafe { gecko_content.mContent.mString.as_ref() };
                        let string = unsafe { string_from_chars_pointer(*gecko_chars) };
                        ContentItem::String(string.into_boxed_str())
                    },
                    StyleContentType::Attr => {
                        let (namespace, attribute) = unsafe {
                            let s = &**gecko_content.mContent.mAttr.as_ref();
                            let ns = if s.mNamespaceURL.mRawPtr.is_null() {
                                None
                            } else {
                                // FIXME(bholley): We don't have any way to get the prefix here. :-(
                                let prefix = atom!("");
                                Some((prefix, Namespace(Atom::from_raw(s.mNamespaceURL.mRawPtr))))
                            };
                            (ns, Atom::from_raw(s.mName.mRawPtr))
                        };
                        ContentItem::Attr(Attr { namespace, attribute })
                    },
                    StyleContentType::Counter | StyleContentType::Counters => {
                        let gecko_function =
                            unsafe { &**gecko_content.mContent.mCounters.as_ref() };
                        let ident = CustomIdent(Atom::from(&*gecko_function.mIdent));
                        let style =
                            CounterStyleOrNone::from_gecko_value(&gecko_function.mCounterStyle);
                        let style = match style {
                            Either::First(counter_style) => counter_style,
                            Either::Second(_) =>
                                unreachable!("counter function shouldn't have single string type"),
                        };
                        if gecko_content.mType == StyleContentType::Counter {
                            ContentItem::Counter(ident, style)
                        } else {
                            let separator = gecko_function.mSeparator.to_string();
                            ContentItem::Counters(ident, separator.into_boxed_str(), style)
                        }
                    },
                    StyleContentType::Image => {
                        unsafe {
                            let gecko_image_request =
                                &**gecko_content.mContent.mImage.as_ref();
                            ContentItem::Url(
                                ComputedImageUrl::from_image_request(gecko_image_request)
                            )
                        }
                    },
                    _ => panic!("Found unexpected value in style struct for content property"),
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }

        pub fn set_counter_increment(
            &mut self,
            v: longhands::counter_increment::computed_value::T
        ) {
            unsafe {
                bindings::Gecko_ClearAndResizeCounterIncrements(&mut self.gecko, v.len() as u32);
                for (i, ref pair) in v.iter().enumerate() {
                    self.gecko.mIncrements[i].mCounter.assign(pair.name.0.as_slice());
                    self.gecko.mIncrements[i].mValue = pair.value;
                }
            }
        }

        pub fn copy_counter_increment_from(&mut self, other: &Self) {
            unsafe {
                bindings::Gecko_CopyCounterIncrementsFrom(&mut self.gecko, &other.gecko)
            }
        }

        pub fn reset_counter_increment(&mut self, other: &Self) {
            self.copy_counter_increment_from(other)
        }

        pub fn clone_counter_increment(
            &self
        ) -> longhands::counter_increment::computed_value::T {
            use crate::values::generics::counters::CounterPair;
            use crate::values::CustomIdent;

            longhands::counter_increment::computed_value::T::new(
                self.gecko.mIncrements.iter().map(|ref gecko_counter| {
                    CounterPair {
                        name: CustomIdent(Atom::from(gecko_counter.mCounter.to_string())),
                        value: gecko_counter.mValue,
                    }
                }).collect()
            )
        }
        pub fn set_counter_reset(
            &mut self,
            v: longhands::counter_reset::computed_value::T
        ) {
            unsafe {
                bindings::Gecko_ClearAndResizeCounterResets(&mut self.gecko, v.len() as u32);
                for (i, ref pair) in v.iter().enumerate() {
                    self.gecko.mResets[i].mCounter.assign(pair.name.0.as_slice());
                    self.gecko.mResets[i].mValue = pair.value;
                }
            }
        }

        pub fn copy_counter_reset_from(&mut self, other: &Self) {
            unsafe {
                bindings::Gecko_CopyCounterResetsFrom(&mut self.gecko, &other.gecko)
            }
        }

        pub fn reset_counter_reset(&mut self, other: &Self) {
            self.copy_counter_reset_from(other)
        }

        pub fn clone_counter_reset(
            &self
        ) -> longhands::counter_reset::computed_value::T {
            use crate::values::generics::counters::CounterPair;
            use crate::values::CustomIdent;

            longhands::counter_reset::computed_value::T::new(
                self.gecko.mResets.iter().map(|ref gecko_counter| {
                    CounterPair {
                        name: CustomIdent(Atom::from(gecko_counter.mCounter.to_string())),
                        value: gecko_counter.mValue,
                    }
                }).collect()
            )
        }


    /*
     * Auto-Generated Methods.
     */
    
}




impl GeckoUI {
    /*
     * Manually-Implemented Methods.
     */
    
    
    

    #[allow(non_snake_case)]
    pub fn set__moz_force_broken_image_icon(&mut self, v: longhands::_moz_force_broken_image_icon::computed_value::T) {
        self.gecko.mForceBrokenImageIcon = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_force_broken_image_icon_from(&mut self, other: &Self) {
        self.gecko.mForceBrokenImageIcon = other.gecko.mForceBrokenImageIcon;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_force_broken_image_icon(&mut self, other: &Self) {
        self.copy__moz_force_broken_image_icon_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_force_broken_image_icon(&self) -> longhands::_moz_force_broken_image_icon::computed_value::T {
        From::from(self.gecko.mForceBrokenImageIcon)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_ime_mode(&mut self, v: longhands::ime_mode::computed_value::T) {
        use crate::properties::longhands::ime_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_STYLE_IME_MODE_AUTO as u8,
                Keyword::Normal =>
                    structs::NS_STYLE_IME_MODE_NORMAL as u8,
                Keyword::Active =>
                    structs::NS_STYLE_IME_MODE_ACTIVE as u8,
                Keyword::Disabled =>
                    structs::NS_STYLE_IME_MODE_DISABLED as u8,
                Keyword::Inactive =>
                    structs::NS_STYLE_IME_MODE_INACTIVE as u8,
        };
        self.gecko.mIMEMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ime_mode_from(&mut self, other: &Self) {
        self.gecko.mIMEMode = other.gecko.mIMEMode;
    }

    #[allow(non_snake_case)]
    pub fn reset_ime_mode(&mut self, other: &Self) {
        self.copy_ime_mode_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_ime_mode(&self) -> longhands::ime_mode::computed_value::T {
        use crate::properties::longhands::ime_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_IME_MODE_AUTO : u8 =
            structs::NS_STYLE_IME_MODE_AUTO as u8;
        const U8_NS_STYLE_IME_MODE_NORMAL : u8 =
            structs::NS_STYLE_IME_MODE_NORMAL as u8;
        const U8_NS_STYLE_IME_MODE_ACTIVE : u8 =
            structs::NS_STYLE_IME_MODE_ACTIVE as u8;
        const U8_NS_STYLE_IME_MODE_DISABLED : u8 =
            structs::NS_STYLE_IME_MODE_DISABLED as u8;
        const U8_NS_STYLE_IME_MODE_INACTIVE : u8 =
            structs::NS_STYLE_IME_MODE_INACTIVE as u8;

        match self.gecko.mIMEMode as u8 {
            U8_NS_STYLE_IME_MODE_AUTO => Keyword::Auto,
            U8_NS_STYLE_IME_MODE_NORMAL => Keyword::Normal,
            U8_NS_STYLE_IME_MODE_ACTIVE => Keyword::Active,
            U8_NS_STYLE_IME_MODE_DISABLED => Keyword::Disabled,
            U8_NS_STYLE_IME_MODE_INACTIVE => Keyword::Inactive,
            _ => panic!("Found unexpected value in style struct for ime_mode property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_scrollbar_width(&mut self, v: longhands::scrollbar_width::computed_value::T) {
        use crate::properties::longhands::scrollbar_width::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleScrollbarWidth::Auto ,
                Keyword::Thin =>
                    structs::StyleScrollbarWidth::Thin ,
                Keyword::None =>
                    structs::StyleScrollbarWidth::None ,
        };
        self.gecko.mScrollbarWidth = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_scrollbar_width_from(&mut self, other: &Self) {
        self.gecko.mScrollbarWidth = other.gecko.mScrollbarWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset_scrollbar_width(&mut self, other: &Self) {
        self.copy_scrollbar_width_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone_scrollbar_width(&self) -> longhands::scrollbar_width::computed_value::T {
        use crate::properties::longhands::scrollbar_width::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mScrollbarWidth {
            structs::StyleScrollbarWidth::Auto => Keyword::Auto,
            structs::StyleScrollbarWidth::Thin => Keyword::Thin,
            structs::StyleScrollbarWidth::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_select(&mut self, v: longhands::_moz_user_select::computed_value::T) {
        self.gecko.mUserSelect = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_select_from(&mut self, other: &Self) {
        self.gecko.mUserSelect = other.gecko.mUserSelect;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_select(&mut self, other: &Self) {
        self.copy__moz_user_select_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_user_select(&self) -> longhands::_moz_user_select::computed_value::T {
        From::from(self.gecko.mUserSelect)
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_dragging(&mut self, v: longhands::_moz_window_dragging::computed_value::T) {
        use crate::properties::longhands::_moz_window_dragging::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Default =>
                    structs::StyleWindowDragging::Default ,
                Keyword::Drag =>
                    structs::StyleWindowDragging::Drag ,
                Keyword::NoDrag =>
                    structs::StyleWindowDragging::NoDrag ,
        };
        self.gecko.mWindowDragging = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_dragging_from(&mut self, other: &Self) {
        self.gecko.mWindowDragging = other.gecko.mWindowDragging;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_dragging(&mut self, other: &Self) {
        self.copy__moz_window_dragging_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_window_dragging(&self) -> longhands::_moz_window_dragging::computed_value::T {
        use crate::properties::longhands::_moz_window_dragging::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mWindowDragging {
            structs::StyleWindowDragging::Default => Keyword::Default,
            structs::StyleWindowDragging::Drag => Keyword::Drag,
            structs::StyleWindowDragging::NoDrag => Keyword::NoDrag,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_shadow(&mut self, v: longhands::_moz_window_shadow::computed_value::T) {
        use crate::properties::longhands::_moz_window_shadow::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_WINDOW_SHADOW_NONE as u8,
                Keyword::Default =>
                    structs::NS_STYLE_WINDOW_SHADOW_DEFAULT as u8,
                Keyword::Menu =>
                    structs::NS_STYLE_WINDOW_SHADOW_MENU as u8,
                Keyword::Tooltip =>
                    structs::NS_STYLE_WINDOW_SHADOW_TOOLTIP as u8,
                Keyword::Sheet =>
                    structs::NS_STYLE_WINDOW_SHADOW_SHEET as u8,
        };
        self.gecko.mWindowShadow = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_shadow_from(&mut self, other: &Self) {
        self.gecko.mWindowShadow = other.gecko.mWindowShadow;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_shadow(&mut self, other: &Self) {
        self.copy__moz_window_shadow_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_window_shadow(&self) -> longhands::_moz_window_shadow::computed_value::T {
        use crate::properties::longhands::_moz_window_shadow::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_WINDOW_SHADOW_NONE : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_NONE as u8;
        const U8_NS_STYLE_WINDOW_SHADOW_DEFAULT : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_DEFAULT as u8;
        const U8_NS_STYLE_WINDOW_SHADOW_MENU : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_MENU as u8;
        const U8_NS_STYLE_WINDOW_SHADOW_TOOLTIP : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_TOOLTIP as u8;
        const U8_NS_STYLE_WINDOW_SHADOW_SHEET : u8 =
            structs::NS_STYLE_WINDOW_SHADOW_SHEET as u8;

        match self.gecko.mWindowShadow as u8 {
            U8_NS_STYLE_WINDOW_SHADOW_NONE => Keyword::None,
            U8_NS_STYLE_WINDOW_SHADOW_DEFAULT => Keyword::Default,
            U8_NS_STYLE_WINDOW_SHADOW_MENU => Keyword::Menu,
            U8_NS_STYLE_WINDOW_SHADOW_TOOLTIP => Keyword::Tooltip,
            U8_NS_STYLE_WINDOW_SHADOW_SHEET => Keyword::Sheet,
            _ => panic!("Found unexpected value in style struct for _moz_window_shadow property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_opacity(&mut self, v: longhands::_moz_window_opacity::computed_value::T) {
        self.gecko.mWindowOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_opacity_from(&mut self, other: &Self) {
        self.gecko.mWindowOpacity = other.gecko.mWindowOpacity;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_opacity(&mut self, other: &Self) {
        self.copy__moz_window_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_opacity(&self) -> longhands::_moz_window_opacity::computed_value::T {
        From::from(self.gecko.mWindowOpacity)
    }


    #[allow(non_snake_case)]
    pub fn set__moz_window_transform(&mut self, other: values::computed::Transform) {
        use crate::gecko_properties::convert_transform;
        if other.0.is_empty() {
            unsafe {
                self.gecko.mSpecifiedWindowTransform.clear();
            }
            return;
        };
        convert_transform(&other.0, &mut self.gecko.mSpecifiedWindowTransform);
    }

    #[allow(non_snake_case)]
    pub fn copy__moz_window_transform_from(&mut self, other: &Self) {
        unsafe { self.gecko.mSpecifiedWindowTransform.set(&other.gecko.mSpecifiedWindowTransform); }
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_transform(&mut self, other: &Self) {
        self.copy__moz_window_transform_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform(&self) -> values::computed::Transform {
        use crate::gecko_properties::clone_transform_from_list;
        use crate::values::generics::transform::Transform;

        if self.gecko.mSpecifiedWindowTransform.mRawPtr.is_null() {
            return Transform(vec!());
        }
        let list = unsafe { (*self.gecko.mSpecifiedWindowTransform.to_safe().get()).mHead.as_ref() };
        clone_transform_from_list(list)
    }

    #[allow(non_snake_case)]
    pub fn set__moz_window_transform_origin(&mut self, v: values::computed::TransformOrigin) {
        self.gecko.mWindowTransformOrigin[0].set(v.horizontal);
        self.gecko.mWindowTransformOrigin[1].set(v.vertical);
        // transform-origin supports the third value for depth, while
        // -moz-window-transform-origin doesn't. The following code is
        // for handling this difference. If we can have more knowledge
        // about the type here, we may want to check that the length is
        // exactly either 2 or 3 in compile time.
        if let Some(third) = self.gecko.mWindowTransformOrigin.get_mut(2) {
            third.set(v.depth);
        }
    }

    #[allow(non_snake_case)]
    pub fn copy__moz_window_transform_origin_from(&mut self, other: &Self) {
        self.gecko.mWindowTransformOrigin[0].copy_from(&other.gecko.mWindowTransformOrigin[0]);
        self.gecko.mWindowTransformOrigin[1].copy_from(&other.gecko.mWindowTransformOrigin[1]);
        if let (Some(self_third), Some(other_third)) =
            (self.gecko.mWindowTransformOrigin.get_mut(2), other.gecko.mWindowTransformOrigin.get(2))
        {
            self_third.copy_from(other_third)
        }
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_transform_origin(&mut self, other: &Self) {
        self.copy__moz_window_transform_origin_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform_origin(&self) -> values::computed::TransformOrigin {
        use crate::values::computed::{Length, LengthPercentage, TransformOrigin};
        TransformOrigin {
            horizontal: LengthPercentage::from_gecko_style_coord(&self.gecko.mWindowTransformOrigin[0])
                .expect("clone for LengthPercentage failed"),
            vertical: LengthPercentage::from_gecko_style_coord(&self.gecko.mWindowTransformOrigin[1])
                .expect("clone for LengthPercentage failed"),
            depth: if let Some(third) = self.gecko.mWindowTransformOrigin.get(2) {
                Length::from_gecko_style_coord(third)
                    .expect("clone for Length failed")
            } else {
                Length::new(0.)
            },
        }
    }

}




impl GeckoXUL {
    /*
     * Manually-Implemented Methods.
     */
    
    #[allow(non_snake_case)]
    pub fn set__moz_box_ordinal_group(&mut self, v: i32) {
        self.gecko.mBoxOrdinal = v as u32;
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_box_ordinal_group_from(&mut self, other: &Self) {
        self.gecko.mBoxOrdinal = other.gecko.mBoxOrdinal;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_ordinal_group(&mut self, other: &Self) {
        self.copy__moz_box_ordinal_group_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_ordinal_group(&self) -> i32 {
        self.gecko.mBoxOrdinal as i32
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set__moz_box_align(&mut self, v: longhands::_moz_box_align::computed_value::T) {
        use crate::properties::longhands::_moz_box_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Stretch =>
                    structs::StyleBoxAlign::Stretch ,
                Keyword::Start =>
                    structs::StyleBoxAlign::Start ,
                Keyword::Center =>
                    structs::StyleBoxAlign::Center ,
                Keyword::Baseline =>
                    structs::StyleBoxAlign::Baseline ,
                Keyword::End =>
                    structs::StyleBoxAlign::End ,
        };
        self.gecko.mBoxAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_align_from(&mut self, other: &Self) {
        self.gecko.mBoxAlign = other.gecko.mBoxAlign;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_align(&mut self, other: &Self) {
        self.copy__moz_box_align_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_box_align(&self) -> longhands::_moz_box_align::computed_value::T {
        use crate::properties::longhands::_moz_box_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxAlign {
            structs::StyleBoxAlign::Stretch => Keyword::Stretch,
            structs::StyleBoxAlign::Start => Keyword::Start,
            structs::StyleBoxAlign::Center => Keyword::Center,
            structs::StyleBoxAlign::Baseline => Keyword::Baseline,
            structs::StyleBoxAlign::End => Keyword::End,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_direction(&mut self, v: longhands::_moz_box_direction::computed_value::T) {
        use crate::properties::longhands::_moz_box_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleBoxDirection::Normal ,
                Keyword::Reverse =>
                    structs::StyleBoxDirection::Reverse ,
        };
        self.gecko.mBoxDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_direction_from(&mut self, other: &Self) {
        self.gecko.mBoxDirection = other.gecko.mBoxDirection;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_direction(&mut self, other: &Self) {
        self.copy__moz_box_direction_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_box_direction(&self) -> longhands::_moz_box_direction::computed_value::T {
        use crate::properties::longhands::_moz_box_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxDirection {
            structs::StyleBoxDirection::Normal => Keyword::Normal,
            structs::StyleBoxDirection::Reverse => Keyword::Reverse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_flex(&mut self, v: longhands::_moz_box_flex::computed_value::T) {
        self.gecko.mBoxFlex = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_flex_from(&mut self, other: &Self) {
        self.gecko.mBoxFlex = other.gecko.mBoxFlex;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_flex(&mut self, other: &Self) {
        self.copy__moz_box_flex_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_flex(&self) -> longhands::_moz_box_flex::computed_value::T {
        From::from(self.gecko.mBoxFlex)
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_orient(&mut self, v: longhands::_moz_box_orient::computed_value::T) {
        use crate::properties::longhands::_moz_box_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Horizontal =>
                    structs::StyleBoxOrient::Horizontal ,
                Keyword::Vertical =>
                    structs::StyleBoxOrient::Vertical ,
        };
        self.gecko.mBoxOrient = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_orient_from(&mut self, other: &Self) {
        self.gecko.mBoxOrient = other.gecko.mBoxOrient;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_orient(&mut self, other: &Self) {
        self.copy__moz_box_orient_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_box_orient(&self) -> longhands::_moz_box_orient::computed_value::T {
        use crate::properties::longhands::_moz_box_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxOrient {
            structs::StyleBoxOrient::Horizontal => Keyword::Horizontal,
            structs::StyleBoxOrient::Vertical => Keyword::Vertical,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_pack(&mut self, v: longhands::_moz_box_pack::computed_value::T) {
        use crate::properties::longhands::_moz_box_pack::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::StyleBoxPack::Start ,
                Keyword::Center =>
                    structs::StyleBoxPack::Center ,
                Keyword::End =>
                    structs::StyleBoxPack::End ,
                Keyword::Justify =>
                    structs::StyleBoxPack::Justify ,
        };
        self.gecko.mBoxPack = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_pack_from(&mut self, other: &Self) {
        self.gecko.mBoxPack = other.gecko.mBoxPack;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_pack(&mut self, other: &Self) {
        self.copy__moz_box_pack_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_box_pack(&self) -> longhands::_moz_box_pack::computed_value::T {
        use crate::properties::longhands::_moz_box_pack::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxPack {
            structs::StyleBoxPack::Start => Keyword::Start,
            structs::StyleBoxPack::Center => Keyword::Center,
            structs::StyleBoxPack::End => Keyword::End,
            structs::StyleBoxPack::Justify => Keyword::Justify,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_stack_sizing(&mut self, v: longhands::_moz_stack_sizing::computed_value::T) {
        use crate::properties::longhands::_moz_stack_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::StretchToFit =>
                    structs::StyleStackSizing::StretchToFit ,
                Keyword::Ignore =>
                    structs::StyleStackSizing::Ignore ,
                Keyword::IgnoreHorizontal =>
                    structs::StyleStackSizing::IgnoreHorizontal ,
                Keyword::IgnoreVertical =>
                    structs::StyleStackSizing::IgnoreVertical ,
        };
        self.gecko.mStackSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_stack_sizing_from(&mut self, other: &Self) {
        self.gecko.mStackSizing = other.gecko.mStackSizing;
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_stack_sizing(&mut self, other: &Self) {
        self.copy__moz_stack_sizing_from(other)
    }


    // FIXME: We introduced non_upper_case_globals for -moz-appearance only
    //        since the prefix of Gecko value starts with ThemeWidgetType_NS_THEME.
    //        We should remove this after fix bug 1371809.
    #[allow(non_snake_case, non_upper_case_globals)]
    pub fn clone__moz_stack_sizing(&self) -> longhands::_moz_stack_sizing::computed_value::T {
        use crate::properties::longhands::_moz_stack_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mStackSizing {
            structs::StyleStackSizing::StretchToFit => Keyword::StretchToFit,
            structs::StyleStackSizing::Ignore => Keyword::Ignore,
            structs::StyleStackSizing::IgnoreHorizontal => Keyword::IgnoreHorizontal,
            structs::StyleStackSizing::IgnoreVertical => Keyword::IgnoreVertical,
        }
    }


}



pub use crate::gecko_bindings::structs::mozilla::GeckoBackground as GeckoBackground;
impl GeckoBackground {
    pub fn gecko(&self) -> &nsStyleBackground {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleBackground {
        &mut self.gecko
    }
}


impl GeckoBackground {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoBackground { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleBackground(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleBackground {
        &self.gecko
    }
}
impl Drop for GeckoBackground {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleBackground(&mut self.gecko);
        }
    }
}
impl Clone for GeckoBackground {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoBackground { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleBackground(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoBorder as GeckoBorder;
impl GeckoBorder {
    pub fn gecko(&self) -> &nsStyleBorder {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleBorder {
        &mut self.gecko
    }
}


impl GeckoBorder {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoBorder { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleBorder(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleBorder {
        &self.gecko
    }
}
impl Drop for GeckoBorder {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleBorder(&mut self.gecko);
        }
    }
}
impl Clone for GeckoBorder {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoBorder { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleBorder(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoDisplay as GeckoBox;
impl GeckoBox {
    pub fn gecko(&self) -> &nsStyleDisplay {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleDisplay {
        &mut self.gecko
    }
}


impl GeckoBox {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoBox { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleDisplay(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleDisplay {
        &self.gecko
    }
}
impl Drop for GeckoBox {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleDisplay(&mut self.gecko);
        }
    }
}
impl Clone for GeckoBox {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoBox { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleDisplay(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoColor as GeckoColor;
impl GeckoColor {
    pub fn gecko(&self) -> &nsStyleColor {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleColor {
        &mut self.gecko
    }
}


impl GeckoColor {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoColor { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleColor(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleColor {
        &self.gecko
    }
}
impl Drop for GeckoColor {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleColor(&mut self.gecko);
        }
    }
}
impl Clone for GeckoColor {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoColor { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleColor(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoColumn as GeckoColumn;
impl GeckoColumn {
    pub fn gecko(&self) -> &nsStyleColumn {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleColumn {
        &mut self.gecko
    }
}


impl GeckoColumn {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoColumn { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleColumn(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleColumn {
        &self.gecko
    }
}
impl Drop for GeckoColumn {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleColumn(&mut self.gecko);
        }
    }
}
impl Clone for GeckoColumn {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoColumn { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleColumn(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoContent as GeckoCounters;
impl GeckoCounters {
    pub fn gecko(&self) -> &nsStyleContent {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleContent {
        &mut self.gecko
    }
}


impl GeckoCounters {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoCounters { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleContent(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleContent {
        &self.gecko
    }
}
impl Drop for GeckoCounters {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleContent(&mut self.gecko);
        }
    }
}
impl Clone for GeckoCounters {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoCounters { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleContent(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoEffects as GeckoEffects;
impl GeckoEffects {
    pub fn gecko(&self) -> &nsStyleEffects {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleEffects {
        &mut self.gecko
    }
}


impl GeckoEffects {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoEffects { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleEffects(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleEffects {
        &self.gecko
    }
}
impl Drop for GeckoEffects {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleEffects(&mut self.gecko);
        }
    }
}
impl Clone for GeckoEffects {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoEffects { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleEffects(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoFont as GeckoFont;
impl GeckoFont {
    pub fn gecko(&self) -> &nsStyleFont {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleFont {
        &mut self.gecko
    }
}


impl GeckoFont {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoFont { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleFont(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleFont {
        &self.gecko
    }
}
impl Drop for GeckoFont {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleFont(&mut self.gecko);
        }
    }
}
impl Clone for GeckoFont {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoFont { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleFont(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoVisibility as GeckoInheritedBox;
impl GeckoInheritedBox {
    pub fn gecko(&self) -> &nsStyleVisibility {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleVisibility {
        &mut self.gecko
    }
}


impl GeckoInheritedBox {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedBox { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleVisibility(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleVisibility {
        &self.gecko
    }
}
impl Drop for GeckoInheritedBox {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleVisibility(&mut self.gecko);
        }
    }
}
impl Clone for GeckoInheritedBox {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedBox { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleVisibility(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoTableBorder as GeckoInheritedTable;
impl GeckoInheritedTable {
    pub fn gecko(&self) -> &nsStyleTableBorder {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleTableBorder {
        &mut self.gecko
    }
}


impl GeckoInheritedTable {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedTable { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleTableBorder(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleTableBorder {
        &self.gecko
    }
}
impl Drop for GeckoInheritedTable {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTableBorder(&mut self.gecko);
        }
    }
}
impl Clone for GeckoInheritedTable {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedTable { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleTableBorder(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoText as GeckoInheritedText;
impl GeckoInheritedText {
    pub fn gecko(&self) -> &nsStyleText {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleText {
        &mut self.gecko
    }
}


impl GeckoInheritedText {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedText { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleText(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleText {
        &self.gecko
    }
}
impl Drop for GeckoInheritedText {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleText(&mut self.gecko);
        }
    }
}
impl Clone for GeckoInheritedText {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedText { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleText(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoUI as GeckoInheritedUI;
impl GeckoInheritedUI {
    pub fn gecko(&self) -> &nsStyleUI {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleUI {
        &mut self.gecko
    }
}


impl GeckoInheritedUI {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedUI { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleUI(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleUI {
        &self.gecko
    }
}
impl Drop for GeckoInheritedUI {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleUI(&mut self.gecko);
        }
    }
}
impl Clone for GeckoInheritedUI {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedUI { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleUI(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoSVG as GeckoInheritedSVG;
impl GeckoInheritedSVG {
    pub fn gecko(&self) -> &nsStyleSVG {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleSVG {
        &mut self.gecko
    }
}


impl GeckoInheritedSVG {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoInheritedSVG { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleSVG(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleSVG {
        &self.gecko
    }
}
impl Drop for GeckoInheritedSVG {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleSVG(&mut self.gecko);
        }
    }
}
impl Clone for GeckoInheritedSVG {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoInheritedSVG { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleSVG(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoList as GeckoList;
impl GeckoList {
    pub fn gecko(&self) -> &nsStyleList {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleList {
        &mut self.gecko
    }
}


impl GeckoList {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoList { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleList(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleList {
        &self.gecko
    }
}
impl Drop for GeckoList {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleList(&mut self.gecko);
        }
    }
}
impl Clone for GeckoList {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoList { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleList(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoMargin as GeckoMargin;
impl GeckoMargin {
    pub fn gecko(&self) -> &nsStyleMargin {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleMargin {
        &mut self.gecko
    }
}


impl GeckoMargin {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoMargin { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleMargin(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleMargin {
        &self.gecko
    }
}
impl Drop for GeckoMargin {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleMargin(&mut self.gecko);
        }
    }
}
impl Clone for GeckoMargin {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoMargin { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleMargin(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoOutline as GeckoOutline;
impl GeckoOutline {
    pub fn gecko(&self) -> &nsStyleOutline {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleOutline {
        &mut self.gecko
    }
}


impl GeckoOutline {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoOutline { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleOutline(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleOutline {
        &self.gecko
    }
}
impl Drop for GeckoOutline {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleOutline(&mut self.gecko);
        }
    }
}
impl Clone for GeckoOutline {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoOutline { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleOutline(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoPadding as GeckoPadding;
impl GeckoPadding {
    pub fn gecko(&self) -> &nsStylePadding {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStylePadding {
        &mut self.gecko
    }
}


impl GeckoPadding {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoPadding { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStylePadding(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStylePadding {
        &self.gecko
    }
}
impl Drop for GeckoPadding {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePadding(&mut self.gecko);
        }
    }
}
impl Clone for GeckoPadding {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoPadding { gecko: zeroed() };
            Gecko_CopyConstruct_nsStylePadding(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoPosition as GeckoPosition;
impl GeckoPosition {
    pub fn gecko(&self) -> &nsStylePosition {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStylePosition {
        &mut self.gecko
    }
}


impl GeckoPosition {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoPosition { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStylePosition(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStylePosition {
        &self.gecko
    }
}
impl Drop for GeckoPosition {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePosition(&mut self.gecko);
        }
    }
}
impl Clone for GeckoPosition {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoPosition { gecko: zeroed() };
            Gecko_CopyConstruct_nsStylePosition(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoTable as GeckoTable;
impl GeckoTable {
    pub fn gecko(&self) -> &nsStyleTable {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleTable {
        &mut self.gecko
    }
}


impl GeckoTable {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoTable { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleTable(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleTable {
        &self.gecko
    }
}
impl Drop for GeckoTable {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTable(&mut self.gecko);
        }
    }
}
impl Clone for GeckoTable {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoTable { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleTable(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoTextReset as GeckoText;
impl GeckoText {
    pub fn gecko(&self) -> &nsStyleTextReset {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleTextReset {
        &mut self.gecko
    }
}


impl GeckoText {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoText { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleTextReset(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleTextReset {
        &self.gecko
    }
}
impl Drop for GeckoText {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTextReset(&mut self.gecko);
        }
    }
}
impl Clone for GeckoText {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoText { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleTextReset(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoUIReset as GeckoUI;
impl GeckoUI {
    pub fn gecko(&self) -> &nsStyleUIReset {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleUIReset {
        &mut self.gecko
    }
}


impl GeckoUI {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoUI { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleUIReset(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleUIReset {
        &self.gecko
    }
}
impl Drop for GeckoUI {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleUIReset(&mut self.gecko);
        }
    }
}
impl Clone for GeckoUI {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoUI { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleUIReset(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoSVGReset as GeckoSVG;
impl GeckoSVG {
    pub fn gecko(&self) -> &nsStyleSVGReset {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleSVGReset {
        &mut self.gecko
    }
}


impl GeckoSVG {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoSVG { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleSVGReset(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleSVGReset {
        &self.gecko
    }
}
impl Drop for GeckoSVG {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleSVGReset(&mut self.gecko);
        }
    }
}
impl Clone for GeckoSVG {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoSVG { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleSVGReset(&mut result.gecko, &self.gecko);
            result
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoXUL as GeckoXUL;
impl GeckoXUL {
    pub fn gecko(&self) -> &nsStyleXUL {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleXUL {
        &mut self.gecko
    }
}


impl GeckoXUL {
    #[allow(dead_code, unused_variables)]
    pub fn default(pres_context: RawGeckoPresContextBorrowed) -> Arc<Self> {
        let mut result = Arc::new(GeckoXUL { gecko: unsafe { zeroed() } });
        unsafe {
            Gecko_Construct_Default_nsStyleXUL(&mut Arc::get_mut(&mut result).unwrap().gecko,
                                                                   pres_context);
        }
        result
    }
    pub fn get_gecko(&self) -> &nsStyleXUL {
        &self.gecko
    }
}
impl Drop for GeckoXUL {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleXUL(&mut self.gecko);
        }
    }
}
impl Clone for GeckoXUL {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = GeckoXUL { gecko: zeroed() };
            Gecko_CopyConstruct_nsStyleXUL(&mut result.gecko, &self.gecko);
            result
        }
    }
}


